/**
 *  Copyright (c) 2017 CentraleSupélec & EDF.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the RiseClipse tool
 *  
 *  Contributors:
 *      Computer Science Department, CentraleSupélec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@centralesupelec.fr
 * 
 */
package fr.centralesupelec.edf.riseclipse.iec61850.scl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface SclPackage extends EPackage {
    /**
	 * The package name.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    String eNAME = "scl";

    /**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    String eNS_URI = "http://www.iec.ch/61850/2003/SCL";

    /**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    String eNS_PREFIX = "scl";

    /**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    SclPackage eINSTANCE = fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl.init();

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclObjectImpl <em>Object</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclObjectImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSclObject()
	 * @generated
	 */
    int SCL_OBJECT = 142;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL_OBJECT__LINE_NUMBER = 0;

    /**
	 * The number of structural features of the '<em>Object</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL_OBJECT_FEATURE_COUNT = 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING = 0;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING = 1;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_ANY_NAME__STRING = 2;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING = 3;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = 4;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING = 5;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING = 6;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_CB_NAME__STRING = 7;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING = 8;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = 9;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DA_COUNT__STRING = 10;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DATA_NAME__STRING = 11;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING = 12;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING = 13;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = 14;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = 15;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = 16;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = 17;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = 18;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = 19;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = 20;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = 21;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = 22;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = 23;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = 24;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = 25;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = 26;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = 27;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = 28;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_EMPTY__STRING = 29;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = 30;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = 31;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = 32;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = 33;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = 34;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = 35;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = 36;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = 37;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING = 38;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = 39;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_IED_NAME__STRING = 40;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = 41;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_LD_INST__STRING = 42;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING = 43;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_LD_NAME__STRING = 44;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING = 45;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING = 46;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_LN_INST__STRING = 47;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING = 48;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING = 49;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING = 50;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_LOG_NAME__STRING = 51;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING = 52;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_NAME__STRING = 53;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING = 54;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = 55;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PADDR__STRING = 56;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING = 57;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = 58;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = 59;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = 60;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = 61;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = 62;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = 63;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = 64;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = 65;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = 66;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = 67;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = 68;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = 69;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PREFIX__STRING = 70;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING = 71;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING = 72;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING = 73;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_REF__STRING = 74;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER = 75;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING = 76;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING = 77;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_REVISION__STRING = 78;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING = 79;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING = 80;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING = 81;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = 82;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = 83;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_VERSION__STRING = 84;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = 85;

				/**
	 * The number of operations of the '<em>Object</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL_OBJECT_OPERATION_COUNT = 86;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AnyContentFromOtherNamespaceImpl <em>Any Content From Other Namespace</em>}' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AnyContentFromOtherNamespaceImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAnyContentFromOtherNamespace()
	 * @generated
	 */
    int ANY_CONTENT_FROM_OTHER_NAMESPACE = 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_CONTENT_FROM_OTHER_NAMESPACE__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Mixed</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_CONTENT_FROM_OTHER_NAMESPACE__MIXED = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Group</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_CONTENT_FROM_OTHER_NAMESPACE__GROUP = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_CONTENT_FROM_OTHER_NAMESPACE__ANY = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_CONTENT_FROM_OTHER_NAMESPACE__ANY_ATTRIBUTE = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Any Content From Other Namespace</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_CONTENT_FROM_OTHER_NAMESPACE_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Any Content From Other Namespace</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_CONTENT_FROM_OTHER_NAMESPACE_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ExplicitLinkResolverImpl <em>Explicit Link Resolver</em>}' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ExplicitLinkResolverImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getExplicitLinkResolver()
	 * @generated
	 */
    int EXPLICIT_LINK_RESOLVER = 139;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXPLICIT_LINK_RESOLVER__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The number of structural features of the '<em>Explicit Link Resolver</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXPLICIT_LINK_RESOLVER_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_LINK_RESOLVER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Explicit Link Resolver</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXPLICIT_LINK_RESOLVER_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.BaseElementImpl <em>Base Element</em>}' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.BaseElementImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getBaseElement()
	 * @generated
	 */
    int BASE_ELEMENT = 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BASE_ELEMENT__LINE_NUMBER = EXPLICIT_LINK_RESOLVER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BASE_ELEMENT__PRIVATE = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BASE_ELEMENT__TEXT = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BASE_ELEMENT__ANY = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BASE_ELEMENT__ANY_ATTRIBUTE = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Base Element</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BASE_ELEMENT_FEATURE_COUNT = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_ACCESS_POINT_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_ACSI_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_ANY_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_ASSOCIATION_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_CB_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DA_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DATA_SET_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_FULL_DO_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_LD_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_LD_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_LLN0_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_LN_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_LPHD_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_LINE_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_LOG_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_MESSAGE_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_NAMESPACE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PADDR__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PREFIX__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PROCESS_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_PROCESS_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_RED_PROT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_REF__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_RELEASE__BIGINTEGER = EXPLICIT_LINK_RESOLVER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_L__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_U__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_REVISION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_RIGHT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_SDO_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_SUB_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_VERSION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_ELEMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Base Element</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BASE_ELEMENT_OPERATION_COUNT = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.HeaderImpl <em>Header</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.HeaderImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getHeader()
	 * @generated
	 */
    int HEADER = 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER__ID = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Name Structure</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER__NAME_STRUCTURE = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Revision</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER__REVISION = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Tool ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER__TOOL_ID = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER__VERSION = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>SCL</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER__SCL = SCL_OBJECT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER__TEXT = SCL_OBJECT_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>History</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER__HISTORY = SCL_OBJECT_FEATURE_COUNT + 7;

    /**
	 * The number of structural features of the '<em>Header</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 8;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Header id required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALIDATE_HEADER_ID_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Header name Structure value IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HEADER___VALIDATE_HEADER_NAME_STRUCTURE_VALUE_IED_NAME__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Header</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HEADER_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 2;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.HistoryImpl <em>History</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.HistoryImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getHistory()
	 * @generated
	 */
    int HISTORY = 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HISTORY__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Header</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HISTORY__HEADER = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Hitem</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HISTORY__HITEM = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>History</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HISTORY_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate History at least one Hitem required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HISTORY___VALIDATE_HISTORY_AT_LEAST_ONE_HITEM_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>History</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HISTORY_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.HitemImpl <em>Hitem</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.HitemImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getHitem()
	 * @generated
	 */
    int HITEM = 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HITEM__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Revision</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HITEM__REVISION = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HITEM__VERSION = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>What</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HITEM__WHAT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>When</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HITEM__WHEN = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Who</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HITEM__WHO = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Why</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HITEM__WHY = SCL_OBJECT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>History</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HITEM__HISTORY = SCL_OBJECT_FEATURE_COUNT + 6;

    /**
	 * The number of structural features of the '<em>Hitem</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HITEM_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 7;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Hitem version required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALIDATE_HITEM_VERSION_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Hitem revision required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALIDATE_HITEM_REVISION_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Hitem when required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HITEM___VALIDATE_HITEM_WHEN_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>Hitem</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HITEM_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 3;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.IDNamingImpl <em>ID Naming</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.IDNamingImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getIDNaming()
	 * @generated
	 */
    int ID_NAMING = 5;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ID_NAMING__LINE_NUMBER = BASE_ELEMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ID_NAMING__PRIVATE = BASE_ELEMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ID_NAMING__TEXT = BASE_ELEMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ID_NAMING__ANY = BASE_ELEMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ID_NAMING__ANY_ATTRIBUTE = BASE_ELEMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ID_NAMING__ID = BASE_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ID_NAMING__DESC = BASE_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>ID Naming</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ID_NAMING_FEATURE_COUNT = BASE_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_ACSI_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_ANY_NAME__STRING = BASE_ELEMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_ASSOCIATION_ID__STRING = BASE_ELEMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING = BASE_ELEMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_CB_NAME__STRING = BASE_ELEMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DA_COUNT__STRING = BASE_ELEMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DATA_SET_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_FULL_DO_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_LD_INST__STRING = BASE_ELEMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_LD_NAME__STRING = BASE_ELEMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_LLN0_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_LN_INST__STRING = BASE_ELEMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_LPHD_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_LINE_TYPE__STRING = BASE_ELEMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_LOG_NAME__STRING = BASE_ELEMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_MESSAGE_ID__STRING = BASE_ELEMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_NAMESPACE_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PADDR__STRING = BASE_ELEMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = BASE_ELEMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PREFIX__STRING = BASE_ELEMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PROCESS_NAME__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_PROCESS_TYPE__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_RED_PROT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_REF__STRING = BASE_ELEMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_RELEASE__BIGINTEGER = BASE_ELEMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_REVISION__STRING = BASE_ELEMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_RIGHT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_SDO_COUNT__STRING = BASE_ELEMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_SUB_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = BASE_ELEMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = BASE_ELEMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_VERSION__STRING = BASE_ELEMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = BASE_ELEMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate ID Naming id required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALIDATE_ID_NAMING_ID_REQUIRED__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate ID Naming id valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ID_NAMING___VALIDATE_ID_NAMING_ID_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>ID Naming</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ID_NAMING_OPERATION_COUNT = BASE_ELEMENT_OPERATION_COUNT + 2;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.NamingImpl <em>Naming</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.NamingImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getNaming()
	 * @generated
	 */
    int NAMING = 7;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAMING__LINE_NUMBER = BASE_ELEMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAMING__PRIVATE = BASE_ELEMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAMING__TEXT = BASE_ELEMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAMING__ANY = BASE_ELEMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAMING__ANY_ATTRIBUTE = BASE_ELEMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAMING__NAME = BASE_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAMING__DESC = BASE_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Naming</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAMING_FEATURE_COUNT = BASE_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_ACSI_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_ANY_NAME__STRING = BASE_ELEMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_ASSOCIATION_ID__STRING = BASE_ELEMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING = BASE_ELEMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_CB_NAME__STRING = BASE_ELEMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DA_COUNT__STRING = BASE_ELEMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DATA_SET_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_FULL_DO_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_LD_INST__STRING = BASE_ELEMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_LD_NAME__STRING = BASE_ELEMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_LLN0_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_LN_INST__STRING = BASE_ELEMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_LPHD_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_LINE_TYPE__STRING = BASE_ELEMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_LOG_NAME__STRING = BASE_ELEMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_MESSAGE_ID__STRING = BASE_ELEMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_NAMESPACE_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PADDR__STRING = BASE_ELEMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = BASE_ELEMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PREFIX__STRING = BASE_ELEMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PROCESS_NAME__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_PROCESS_TYPE__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_RED_PROT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_REF__STRING = BASE_ELEMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_RELEASE__BIGINTEGER = BASE_ELEMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_REVISION__STRING = BASE_ELEMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_RIGHT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_SDO_COUNT__STRING = BASE_ELEMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_SUB_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = BASE_ELEMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = BASE_ELEMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_VERSION__STRING = BASE_ELEMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = BASE_ELEMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMING___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Naming</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAMING_OPERATION_COUNT = BASE_ELEMENT_OPERATION_COUNT + 2;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LNodeContainerImpl <em>LNode Container</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LNodeContainerImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getLNodeContainer()
	 * @generated
	 */
    int LNODE_CONTAINER = 127;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_CONTAINER__LINE_NUMBER = NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_CONTAINER__PRIVATE = NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_CONTAINER__TEXT = NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_CONTAINER__ANY = NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_CONTAINER__ANY_ATTRIBUTE = NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_CONTAINER__NAME = NAMING__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_CONTAINER__DESC = NAMING__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_CONTAINER__LNODE = NAMING_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>LNode Container</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_CONTAINER_FEATURE_COUNT = NAMING_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_ACCESS_POINT_NAME__STRING = NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_ACSI_NAME__STRING = NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_ANY_NAME__STRING = NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_ASSOCIATION_ID__STRING = NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_AUTHENTICATION_ENUM__STRING = NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_BASIC_TYPE_ENUM__STRING = NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_CB_NAME__STRING = NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_CDC_ENUM__STRING = NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DA_COUNT__STRING = NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DATA_NAME__STRING = NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DATA_SET_NAME__STRING = NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_ENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_EMPTY__STRING = NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_EXTENSION_CDC_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_FULL_DO_NAME__STRING = NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_IED_NAME__STRING = NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_LD_INST__STRING = NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_LD_INST_OR_EMPTY__STRING = NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_LD_NAME__STRING = NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_LLN0_ENUM__STRING = NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_LN_CLASS_ENUM__STRING = NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_LN_INST__STRING = NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_LN_INST_OR_EMPTY__STRING = NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_LPHD_ENUM__STRING = NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_LINE_TYPE__STRING = NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_LOG_NAME__STRING = NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_MESSAGE_ID__STRING = NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_NAME__STRING = NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_NAMESPACE_NAME__STRING = NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PADDR__STRING = NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PTYPE_ENUM__STRING = NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PREFIX__STRING = NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PROCESS_NAME__STRING = NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_PROCESS_TYPE__STRING = NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_RED_PROT_ENUM__STRING = NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_REF__STRING = NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_RELEASE__BIGINTEGER = NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_RESTR_NAME1ST_L__STRING = NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_RESTR_NAME1ST_U__STRING = NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_REVISION__STRING = NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_RIGHT_ENUM__STRING = NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_SDO_COUNT__STRING = NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_SUB_DATA_NAME__STRING = NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_VERSION__STRING = NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = NAMING___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = NAMING___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_CONTAINER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = NAMING_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>LNode Container</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_CONTAINER_OPERATION_COUNT = NAMING_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PowerSystemResourceImpl <em>Power System Resource</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PowerSystemResourceImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getPowerSystemResource()
	 * @generated
	 */
    int POWER_SYSTEM_RESOURCE = 129;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_SYSTEM_RESOURCE__LINE_NUMBER = LNODE_CONTAINER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_SYSTEM_RESOURCE__PRIVATE = LNODE_CONTAINER__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_SYSTEM_RESOURCE__TEXT = LNODE_CONTAINER__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_SYSTEM_RESOURCE__ANY = LNODE_CONTAINER__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_SYSTEM_RESOURCE__ANY_ATTRIBUTE = LNODE_CONTAINER__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_SYSTEM_RESOURCE__NAME = LNODE_CONTAINER__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_SYSTEM_RESOURCE__DESC = LNODE_CONTAINER__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_SYSTEM_RESOURCE__LNODE = LNODE_CONTAINER__LNODE;

    /**
	 * The number of structural features of the '<em>Power System Resource</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_SYSTEM_RESOURCE_FEATURE_COUNT = LNODE_CONTAINER_FEATURE_COUNT + 0;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_ACCESS_POINT_NAME__STRING = LNODE_CONTAINER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_ACSI_NAME__STRING = LNODE_CONTAINER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_ANY_NAME__STRING = LNODE_CONTAINER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_ASSOCIATION_ID__STRING = LNODE_CONTAINER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_AUTHENTICATION_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_BASIC_TYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_CB_NAME__STRING = LNODE_CONTAINER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_CDC_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DA_COUNT__STRING = LNODE_CONTAINER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_NAME__STRING = LNODE_CONTAINER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_SET_NAME__STRING = LNODE_CONTAINER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_EMPTY__STRING = LNODE_CONTAINER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = LNODE_CONTAINER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_DO_NAME__STRING = LNODE_CONTAINER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME__STRING = LNODE_CONTAINER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = LNODE_CONTAINER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST__STRING = LNODE_CONTAINER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST_OR_EMPTY__STRING = LNODE_CONTAINER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_LD_NAME__STRING = LNODE_CONTAINER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_LLN0_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_LN_CLASS_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST__STRING = LNODE_CONTAINER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST_OR_EMPTY__STRING = LNODE_CONTAINER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_LPHD_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_LINE_TYPE__STRING = LNODE_CONTAINER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_LOG_NAME__STRING = LNODE_CONTAINER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_MESSAGE_ID__STRING = LNODE_CONTAINER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_NAME__STRING = LNODE_CONTAINER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_NAMESPACE_NAME__STRING = LNODE_CONTAINER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = LNODE_CONTAINER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PADDR__STRING = LNODE_CONTAINER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PREFIX__STRING = LNODE_CONTAINER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_NAME__STRING = LNODE_CONTAINER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_TYPE__STRING = LNODE_CONTAINER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_RED_PROT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_REF__STRING = LNODE_CONTAINER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_RELEASE__BIGINTEGER = LNODE_CONTAINER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_L__STRING = LNODE_CONTAINER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_U__STRING = LNODE_CONTAINER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_REVISION__STRING = LNODE_CONTAINER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_RIGHT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_SDO_COUNT__STRING = LNODE_CONTAINER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_SUB_DATA_NAME__STRING = LNODE_CONTAINER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_VERSION__STRING = LNODE_CONTAINER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = LNODE_CONTAINER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = LNODE_CONTAINER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = LNODE_CONTAINER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = LNODE_CONTAINER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_SYSTEM_RESOURCE___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = LNODE_CONTAINER_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Power System Resource</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_SYSTEM_RESOURCE_OPERATION_COUNT = LNODE_CONTAINER_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GeneralEquipmentContainerImpl <em>General Equipment Container</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GeneralEquipmentContainerImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGeneralEquipmentContainer()
	 * @generated
	 */
    int GENERAL_EQUIPMENT_CONTAINER = 125;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER__LINE_NUMBER = POWER_SYSTEM_RESOURCE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER__PRIVATE = POWER_SYSTEM_RESOURCE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER__TEXT = POWER_SYSTEM_RESOURCE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER__ANY = POWER_SYSTEM_RESOURCE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER__ANY_ATTRIBUTE = POWER_SYSTEM_RESOURCE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER__DESC = POWER_SYSTEM_RESOURCE__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER__LNODE = POWER_SYSTEM_RESOURCE__LNODE;

    /**
	 * The feature id for the '<em><b>Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER__FUNCTION = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER__GENERAL_EQUIPMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>General Equipment Container</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ACCESS_POINT_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ACSI_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ANY_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ASSOCIATION_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_AUTHENTICATION_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_CB_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DA_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DATA_SET_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_FULL_DO_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LD_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LD_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LD_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LLN0_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LN_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LN_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LPHD_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LINE_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LOG_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_MESSAGE_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_NAMESPACE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PADDR__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREFIX__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RED_PROT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_REF__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RELEASE__BIGINTEGER = POWER_SYSTEM_RESOURCE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_L__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_U__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_REVISION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RIGHT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_SDO_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_SUB_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_VERSION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate General Equipment Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT_CONTAINER___VALIDATE_GENERAL_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>General Equipment Container</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_CONTAINER_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LineImpl <em>Line</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LineImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getLine()
	 * @generated
	 */
    int LINE = 6;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__LINE_NUMBER = GENERAL_EQUIPMENT_CONTAINER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__PRIVATE = GENERAL_EQUIPMENT_CONTAINER__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__TEXT = GENERAL_EQUIPMENT_CONTAINER__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__ANY = GENERAL_EQUIPMENT_CONTAINER__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__ANY_ATTRIBUTE = GENERAL_EQUIPMENT_CONTAINER__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__NAME = GENERAL_EQUIPMENT_CONTAINER__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__DESC = GENERAL_EQUIPMENT_CONTAINER__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__LNODE = GENERAL_EQUIPMENT_CONTAINER__LNODE;

    /**
	 * The feature id for the '<em><b>Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__FUNCTION = GENERAL_EQUIPMENT_CONTAINER__FUNCTION;

    /**
	 * The feature id for the '<em><b>General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__GENERAL_EQUIPMENT = GENERAL_EQUIPMENT_CONTAINER__GENERAL_EQUIPMENT;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__TYPE = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Process</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__PROCESS = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>SCL</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__SCL = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Connectivity Node</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__CONNECTIVITY_NODE = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Conducting Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE__CONDUCTING_EQUIPMENT = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Line</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE_FEATURE_COUNT = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_ACCESS_POINT_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_ACSI_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_ANY_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_ASSOCIATION_ID__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_AUTHENTICATION_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_BASIC_TYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_CB_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_CDC_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DA_COUNT__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DATA_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DATA_SET_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_EMPTY__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_FULL_DO_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_IED_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_LD_INST__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_LD_INST_OR_EMPTY__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_LD_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_LLN0_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_LN_CLASS_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_LN_INST__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_LN_INST_OR_EMPTY__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_LPHD_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_LINE_TYPE__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_LOG_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_MESSAGE_ID__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_NAMESPACE_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PADDR__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PTYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PREFIX__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PROCESS_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_PROCESS_TYPE__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_RED_PROT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_REF__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_RELEASE__BIGINTEGER = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_RESTR_NAME1ST_L__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_RESTR_NAME1ST_U__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_REVISION__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_RIGHT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_SDO_COUNT__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_SUB_DATA_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_VERSION__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate General Equipment Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALIDATE_GENERAL_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER___VALIDATE_GENERAL_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Line type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINE___VALIDATE_LINE_TYPE_VALID__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Line</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LINE_OPERATION_COUNT = GENERAL_EQUIPMENT_CONTAINER_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PrivateImpl <em>Private</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PrivateImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getPrivate()
	 * @generated
	 */
    int PRIVATE = 8;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PRIVATE__LINE_NUMBER = ANY_CONTENT_FROM_OTHER_NAMESPACE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Mixed</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PRIVATE__MIXED = ANY_CONTENT_FROM_OTHER_NAMESPACE__MIXED;

    /**
	 * The feature id for the '<em><b>Group</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PRIVATE__GROUP = ANY_CONTENT_FROM_OTHER_NAMESPACE__GROUP;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PRIVATE__ANY = ANY_CONTENT_FROM_OTHER_NAMESPACE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PRIVATE__ANY_ATTRIBUTE = ANY_CONTENT_FROM_OTHER_NAMESPACE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Source</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PRIVATE__SOURCE = ANY_CONTENT_FROM_OTHER_NAMESPACE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PRIVATE__TYPE = ANY_CONTENT_FROM_OTHER_NAMESPACE_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Base Element</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PRIVATE__BASE_ELEMENT = ANY_CONTENT_FROM_OTHER_NAMESPACE_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Private</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PRIVATE_FEATURE_COUNT = ANY_CONTENT_FROM_OTHER_NAMESPACE_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_ACCESS_POINT_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_ACSI_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_ANY_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_ASSOCIATION_ID__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_AUTHENTICATION_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_BASIC_TYPE_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_CB_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_CDC_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DA_COUNT__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DATA_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DATA_SET_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_EMPTY__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_FULL_DO_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_IED_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_LD_INST__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_LD_INST_OR_EMPTY__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_LD_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_LLN0_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_LN_CLASS_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_LN_INST__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_LN_INST_OR_EMPTY__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_LPHD_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_LINE_TYPE__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_LOG_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_MESSAGE_ID__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_NAMESPACE_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PADDR__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PTYPE_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PREFIX__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PROCESS_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_PROCESS_TYPE__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_RED_PROT_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_REF__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_RELEASE__BIGINTEGER = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_RESTR_NAME1ST_L__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_RESTR_NAME1ST_U__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_REVISION__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_RIGHT_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_SDO_COUNT__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_SUB_DATA_NAME__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_VERSION__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ANY_CONTENT_FROM_OTHER_NAMESPACE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Private type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALIDATE_PRIVATE_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = ANY_CONTENT_FROM_OTHER_NAMESPACE_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Private type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIVATE___VALIDATE_PRIVATE_TYPE_VALID__DIAGNOSTICCHAIN_MAP = ANY_CONTENT_FROM_OTHER_NAMESPACE_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Private</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PRIVATE_OPERATION_COUNT = ANY_CONTENT_FROM_OTHER_NAMESPACE_OPERATION_COUNT + 2;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ProcessImpl <em>Process</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ProcessImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getProcess()
	 * @generated
	 */
    int PROCESS = 9;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__LINE_NUMBER = GENERAL_EQUIPMENT_CONTAINER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__PRIVATE = GENERAL_EQUIPMENT_CONTAINER__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__TEXT = GENERAL_EQUIPMENT_CONTAINER__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__ANY = GENERAL_EQUIPMENT_CONTAINER__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__ANY_ATTRIBUTE = GENERAL_EQUIPMENT_CONTAINER__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__NAME = GENERAL_EQUIPMENT_CONTAINER__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__DESC = GENERAL_EQUIPMENT_CONTAINER__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__LNODE = GENERAL_EQUIPMENT_CONTAINER__LNODE;

    /**
	 * The feature id for the '<em><b>Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__FUNCTION = GENERAL_EQUIPMENT_CONTAINER__FUNCTION;

    /**
	 * The feature id for the '<em><b>General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__GENERAL_EQUIPMENT = GENERAL_EQUIPMENT_CONTAINER__GENERAL_EQUIPMENT;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__TYPE = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__LINE = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>SCL</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__SCL = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Conducting Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__CONDUCTING_EQUIPMENT = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Substation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__SUBSTATION = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Sub Processes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__SUB_PROCESSES = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Parent Process</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS__PARENT_PROCESS = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 6;

    /**
	 * The number of structural features of the '<em>Process</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS_FEATURE_COUNT = GENERAL_EQUIPMENT_CONTAINER_FEATURE_COUNT + 7;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_ACCESS_POINT_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_ACSI_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_ANY_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_ASSOCIATION_ID__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_AUTHENTICATION_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_BASIC_TYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_CB_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_CDC_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DA_COUNT__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DATA_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DATA_SET_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_EMPTY__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_FULL_DO_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_IED_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_LD_INST__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_LD_INST_OR_EMPTY__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_LD_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_LLN0_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_LN_CLASS_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_LN_INST__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_LN_INST_OR_EMPTY__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_LPHD_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_LINE_TYPE__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_LOG_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_MESSAGE_ID__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_NAMESPACE_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PADDR__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PTYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PREFIX__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PROCESS_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_PROCESS_TYPE__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_RED_PROT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_REF__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_RELEASE__BIGINTEGER = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_RESTR_NAME1ST_L__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_RESTR_NAME1ST_U__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_REVISION__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_RIGHT_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_SDO_COUNT__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_SUB_DATA_NAME__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_VERSION__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = GENERAL_EQUIPMENT_CONTAINER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate General Equipment Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALIDATE_GENERAL_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER___VALIDATE_GENERAL_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Process type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS___VALIDATE_PROCESS_TYPE_VALID__DIAGNOSTICCHAIN_MAP = GENERAL_EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Process</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROCESS_OPERATION_COUNT = GENERAL_EQUIPMENT_CONTAINER_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SCLImpl <em>SCL</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SCLImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSCL()
	 * @generated
	 */
    int SCL = 10;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__LINE_NUMBER = BASE_ELEMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__PRIVATE = BASE_ELEMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__TEXT = BASE_ELEMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__ANY = BASE_ELEMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__ANY_ATTRIBUTE = BASE_ELEMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Revision</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__REVISION = BASE_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__VERSION = BASE_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Header</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__HEADER = BASE_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__LINE = BASE_ELEMENT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Process</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__PROCESS = BASE_ELEMENT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>IED</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__IED = BASE_ELEMENT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Data Type Templates</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__DATA_TYPE_TEMPLATES = BASE_ELEMENT_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Communication</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__COMMUNICATION = BASE_ELEMENT_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Substation</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__SUBSTATION = BASE_ELEMENT_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>Release</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL__RELEASE = BASE_ELEMENT_FEATURE_COUNT + 9;

    /**
	 * The number of structural features of the '<em>SCL</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL_FEATURE_COUNT = BASE_ELEMENT_FEATURE_COUNT + 10;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_ACCESS_POINT_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_ACSI_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_ANY_NAME__STRING = BASE_ELEMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_ASSOCIATION_ID__STRING = BASE_ELEMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_AUTHENTICATION_ENUM__STRING = BASE_ELEMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_CB_NAME__STRING = BASE_ELEMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DA_COUNT__STRING = BASE_ELEMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DATA_SET_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_FULL_DO_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_LD_INST__STRING = BASE_ELEMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_LD_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_LD_NAME__STRING = BASE_ELEMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_LLN0_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_LN_INST__STRING = BASE_ELEMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_LN_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_LPHD_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_LINE_TYPE__STRING = BASE_ELEMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_LOG_NAME__STRING = BASE_ELEMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_MESSAGE_ID__STRING = BASE_ELEMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_NAMESPACE_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PADDR__STRING = BASE_ELEMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = BASE_ELEMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PREFIX__STRING = BASE_ELEMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PROCESS_NAME__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_PROCESS_TYPE__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_RED_PROT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_REF__STRING = BASE_ELEMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_RELEASE__BIGINTEGER = BASE_ELEMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_RESTR_NAME1ST_L__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_RESTR_NAME1ST_U__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_REVISION__STRING = BASE_ELEMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_RIGHT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_SDO_COUNT__STRING = BASE_ELEMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_SUB_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = BASE_ELEMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = BASE_ELEMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_VERSION__STRING = BASE_ELEMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = BASE_ELEMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate SCL version required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALIDATE_SCL_VERSION_REQUIRED__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate SCL version valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALIDATE_SCL_VERSION_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate SCL version value 2007</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALIDATE_SCL_VERSION_VALUE_2007__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate SCL revision required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALIDATE_SCL_REVISION_REQUIRED__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate SCL revision valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALIDATE_SCL_REVISION_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 4;

				/**
	 * The operation id for the '<em>Validate SCL revision value B</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALIDATE_SCL_REVISION_VALUE_B__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 5;

				/**
	 * The operation id for the '<em>Validate SCL release value 1</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALIDATE_SCL_RELEASE_VALUE_1__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 6;

				/**
	 * The operation id for the '<em>Validate SCL one Header required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCL___VALIDATE_SCL_ONE_HEADER_REQUIRED__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 7;

				/**
	 * The number of operations of the '<em>SCL</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SCL_OPERATION_COUNT = BASE_ELEMENT_OPERATION_COUNT + 8;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TextImpl <em>Text</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TextImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getText()
	 * @generated
	 */
    int TEXT = 11;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TEXT__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Source</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TEXT__SOURCE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Base Element</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TEXT__BASE_ELEMENT = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Header</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TEXT__HEADER = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TEXT__VALUE = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Text</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TEXT_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Text</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TEXT_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AddressImpl <em>Address</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AddressImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAddress()
	 * @generated
	 */
    int ADDRESS = 12;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADDRESS__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Connected AP</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADDRESS__CONNECTED_AP = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Control Block</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADDRESS__CONTROL_BLOCK = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>P</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADDRESS__P = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Address</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADDRESS_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Address nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALIDATE_ADDRESS_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Address at least one Prequired</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS___VALIDATE_ADDRESS_AT_LEAST_ONE_PREQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Address</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADDRESS_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 2;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.CommunicationImpl <em>Communication</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.CommunicationImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getCommunication()
	 * @generated
	 */
    int COMMUNICATION = 13;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConnectedAPImpl <em>Connected AP</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConnectedAPImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getConnectedAP()
	 * @generated
	 */
    int CONNECTED_AP = 14;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ControlBlockImpl <em>Control Block</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ControlBlockImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getControlBlock()
	 * @generated
	 */
    int CONTROL_BLOCK = 15;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GSEImpl <em>GSE</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GSEImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGSE()
	 * @generated
	 */
    int GSE = 16;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PAddrImpl <em>PAddr</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PAddrImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getPAddr()
	 * @generated
	 */
    int PADDR = 18;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PImpl <em>P</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getP()
	 * @generated
	 */
    int P = 17;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.P_PhysConnImpl <em>PPhys Conn</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.P_PhysConnImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getP_PhysConn()
	 * @generated
	 */
    int PPHYS_CONN = 19;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PhysConnImpl <em>Phys Conn</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PhysConnImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getPhysConn()
	 * @generated
	 */
    int PHYS_CONN = 20;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SMVImpl <em>SMV</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SMVImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSMV()
	 * @generated
	 */
    int SMV = 21;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SubNetworkImpl <em>Sub Network</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SubNetworkImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSubNetwork()
	 * @generated
	 */
    int SUB_NETWORK = 22;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AbstractDataAttributeImpl <em>Abstract Data Attribute</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AbstractDataAttributeImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAbstractDataAttribute()
	 * @generated
	 */
    int ABSTRACT_DATA_ATTRIBUTE = 23;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.BDAImpl <em>BDA</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.BDAImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getBDA()
	 * @generated
	 */
    int BDA = 24;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DAImpl <em>DA</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DAImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDA()
	 * @generated
	 */
    int DA = 25;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DATypeImpl <em>DA Type</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DATypeImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDAType()
	 * @generated
	 */
    int DA_TYPE = 26;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataObjectImpl <em>Data Object</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataObjectImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDataObject()
	 * @generated
	 */
    int DATA_OBJECT = 140;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DOImpl <em>DO</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DOImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDO()
	 * @generated
	 */
    int DO = 27;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DOTypeImpl <em>DO Type</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DOTypeImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDOType()
	 * @generated
	 */
    int DO_TYPE = 28;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataTypeTemplatesImpl <em>Data Type Templates</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataTypeTemplatesImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDataTypeTemplates()
	 * @generated
	 */
    int DATA_TYPE_TEMPLATES = 29;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EnumTypeImpl <em>Enum Type</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EnumTypeImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getEnumType()
	 * @generated
	 */
    int ENUM_TYPE = 30;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EnumValImpl <em>Enum Val</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EnumValImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getEnumVal()
	 * @generated
	 */
    int ENUM_VAL = 31;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LNodeTypeImpl <em>LNode Type</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LNodeTypeImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getLNodeType()
	 * @generated
	 */
    int LNODE_TYPE = 32;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ProtNsImpl <em>Prot Ns</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ProtNsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getProtNs()
	 * @generated
	 */
    int PROT_NS = 33;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SDOImpl <em>SDO</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SDOImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSDO()
	 * @generated
	 */
    int SDO = 34;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ValImpl <em>Val</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ValImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getVal()
	 * @generated
	 */
    int VAL = 35;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.BitRateInMbPerSecImpl <em>Bit Rate In Mb Per Sec</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.BitRateInMbPerSecImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getBitRateInMbPerSec()
	 * @generated
	 */
    int BIT_RATE_IN_MB_PER_SEC = 155;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DurationInMilliSecImpl <em>Duration In Milli Sec</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DurationInMilliSecImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDurationInMilliSec()
	 * @generated
	 */
    int DURATION_IN_MILLI_SEC = 154;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AccessControlImpl <em>Access Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AccessControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAccessControl()
	 * @generated
	 */
    int ACCESS_CONTROL = 36;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AccessPointImpl <em>Access Point</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AccessPointImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAccessPoint()
	 * @generated
	 */
    int ACCESS_POINT = 37;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AnyLNImpl <em>Any LN</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AnyLNImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAnyLN()
	 * @generated
	 */
    int ANY_LN = 38;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AssociationImpl <em>Association</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AssociationImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAssociation()
	 * @generated
	 */
    int ASSOCIATION = 39;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AuthenticationImpl <em>Authentication</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AuthenticationImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAuthentication()
	 * @generated
	 */
    int AUTHENTICATION = 40;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.CertificateImpl <em>Certificate</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.CertificateImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getCertificate()
	 * @generated
	 */
    int CERTIFICATE = 41;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ClientLNImpl <em>Client LN</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ClientLNImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getClientLN()
	 * @generated
	 */
    int CLIENT_LN = 42;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ClientServicesImpl <em>Client Services</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ClientServicesImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getClientServices()
	 * @generated
	 */
    int CLIENT_SERVICES = 43;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.CommProtImpl <em>Comm Prot</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.CommProtImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getCommProt()
	 * @generated
	 */
    int COMM_PROT = 44;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceWithMaxImpl <em>Service With Max</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceWithMaxImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceWithMax()
	 * @generated
	 */
    int SERVICE_WITH_MAX = 102;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfDataSetImpl <em>Conf Data Set</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfDataSetImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getConfDataSet()
	 * @generated
	 */
    int CONF_DATA_SET = 45;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfLNsImpl <em>Conf LNs</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfLNsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getConfLNs()
	 * @generated
	 */
    int CONF_LNS = 46;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfLdNameImpl <em>Conf Ld Name</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfLdNameImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getConfLdName()
	 * @generated
	 */
    int CONF_LD_NAME = 47;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfLogControlImpl <em>Conf Log Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfLogControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getConfLogControl()
	 * @generated
	 */
    int CONF_LOG_CONTROL = 48;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfReportControlImpl <em>Conf Report Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfReportControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getConfReportControl()
	 * @generated
	 */
    int CONF_REPORT_CONTROL = 49;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfSGImpl <em>Conf SG</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfSGImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getConfSG()
	 * @generated
	 */
    int CONF_SG = 50;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfSigRefImpl <em>Conf Sig Ref</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConfSigRefImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getConfSigRef()
	 * @generated
	 */
    int CONF_SIG_REF = 51;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ControlImpl <em>Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getControl()
	 * @generated
	 */
    int CONTROL = 52;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ControlWithIEDNameImpl <em>Control With IED Name</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ControlWithIEDNameImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getControlWithIEDName()
	 * @generated
	 */
    int CONTROL_WITH_IED_NAME = 53;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ControlWithTriggerOptImpl <em>Control With Trigger Opt</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ControlWithTriggerOptImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getControlWithTriggerOpt()
	 * @generated
	 */
    int CONTROL_WITH_TRIGGER_OPT = 54;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataAttributeImpl <em>Data Attribute</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataAttributeImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDataAttribute()
	 * @generated
	 */
    int DATA_ATTRIBUTE = 141;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DAIImpl <em>DAI</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DAIImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDAI()
	 * @generated
	 */
    int DAI = 55;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DOIImpl <em>DOI</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DOIImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDOI()
	 * @generated
	 */
    int DOI = 56;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataObjectDirectoryImpl <em>Data Object Directory</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataObjectDirectoryImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDataObjectDirectory()
	 * @generated
	 */
    int DATA_OBJECT_DIRECTORY = 57;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataSetImpl <em>Data Set</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataSetImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDataSet()
	 * @generated
	 */
    int DATA_SET = 58;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataSetDirectoryImpl <em>Data Set Directory</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DataSetDirectoryImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDataSetDirectory()
	 * @generated
	 */
    int DATA_SET_DIRECTORY = 59;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DynAssociationImpl <em>Dyn Association</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DynAssociationImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDynAssociation()
	 * @generated
	 */
    int DYN_ASSOCIATION = 60;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DynDataSetImpl <em>Dyn Data Set</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DynDataSetImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDynDataSet()
	 * @generated
	 */
    int DYN_DATA_SET = 61;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ExtRefImpl <em>Ext Ref</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ExtRefImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getExtRef()
	 * @generated
	 */
    int EXT_REF = 62;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.FCDAImpl <em>FCDA</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.FCDAImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getFCDA()
	 * @generated
	 */
    int FCDA = 63;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.FileHandlingImpl <em>File Handling</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.FileHandlingImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getFileHandling()
	 * @generated
	 */
    int FILE_HANDLING = 64;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GOOSEImpl <em>GOOSE</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GOOSEImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGOOSE()
	 * @generated
	 */
    int GOOSE = 65;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GOOSESecurityImpl <em>GOOSE Security</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GOOSESecurityImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGOOSESecurity()
	 * @generated
	 */
    int GOOSE_SECURITY = 66;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GSEControlImpl <em>GSE Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GSEControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGSEControl()
	 * @generated
	 */
    int GSE_CONTROL = 67;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GSEDirImpl <em>GSE Dir</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GSEDirImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGSEDir()
	 * @generated
	 */
    int GSE_DIR = 68;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceSettingsImpl <em>Service Settings</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceSettingsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceSettings()
	 * @generated
	 */
    int SERVICE_SETTINGS = 101;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GSESettingsImpl <em>GSE Settings</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GSESettingsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGSESettings()
	 * @generated
	 */
    int GSE_SETTINGS = 69;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GSSEImpl <em>GSSE</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GSSEImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGSSE()
	 * @generated
	 */
    int GSSE = 70;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GetCBValuesImpl <em>Get CB Values</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GetCBValuesImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGetCBValues()
	 * @generated
	 */
    int GET_CB_VALUES = 71;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GetDataObjectDefinitionImpl <em>Get Data Object Definition</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GetDataObjectDefinitionImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGetDataObjectDefinition()
	 * @generated
	 */
    int GET_DATA_OBJECT_DEFINITION = 72;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GetDataSetValueImpl <em>Get Data Set Value</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GetDataSetValueImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGetDataSetValue()
	 * @generated
	 */
    int GET_DATA_SET_VALUE = 73;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GetDirectoryImpl <em>Get Directory</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GetDirectoryImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGetDirectory()
	 * @generated
	 */
    int GET_DIRECTORY = 74;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.IEDImpl <em>IED</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.IEDImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getIED()
	 * @generated
	 */
    int IED = 75;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.IEDNameImpl <em>IED Name</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.IEDNameImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getIEDName()
	 * @generated
	 */
    int IED_NAME = 76;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.InputsImpl <em>Inputs</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.InputsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getInputs()
	 * @generated
	 */
    int INPUTS = 77;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.IssuerNameImpl <em>Issuer Name</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.IssuerNameImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getIssuerName()
	 * @generated
	 */
    int ISSUER_NAME = 78;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.KDCImpl <em>KDC</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.KDCImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getKDC()
	 * @generated
	 */
    int KDC = 79;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LDeviceImpl <em>LDevice</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LDeviceImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getLDevice()
	 * @generated
	 */
    int LDEVICE = 80;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LNImpl <em>LN</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LNImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getLN()
	 * @generated
	 */
    int LN = 81;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LN0Impl <em>LN0</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LN0Impl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getLN0()
	 * @generated
	 */
    int LN0 = 82;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LogImpl <em>Log</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LogImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getLog()
	 * @generated
	 */
    int LOG = 83;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LogControlImpl <em>Log Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LogControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getLogControl()
	 * @generated
	 */
    int LOG_CONTROL = 84;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LogSettingsImpl <em>Log Settings</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LogSettingsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getLogSettings()
	 * @generated
	 */
    int LOG_SETTINGS = 85;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.OptFieldsImpl <em>Opt Fields</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.OptFieldsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getOptFields()
	 * @generated
	 */
    int OPT_FIELDS = 86;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ProtocolImpl <em>Protocol</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ProtocolImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getProtocol()
	 * @generated
	 */
    int PROTOCOL = 87;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ReadWriteImpl <em>Read Write</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ReadWriteImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getReadWrite()
	 * @generated
	 */
    int READ_WRITE = 88;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.RedProtImpl <em>Red Prot</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.RedProtImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getRedProt()
	 * @generated
	 */
    int RED_PROT = 89;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ReportControlImpl <em>Report Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ReportControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getReportControl()
	 * @generated
	 */
    int REPORT_CONTROL = 90;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ReportSettingsImpl <em>Report Settings</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ReportSettingsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getReportSettings()
	 * @generated
	 */
    int REPORT_SETTINGS = 91;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.RptEnabledImpl <em>Rpt Enabled</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.RptEnabledImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getRptEnabled()
	 * @generated
	 */
    int RPT_ENABLED = 92;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SDIImpl <em>SDI</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SDIImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSDI()
	 * @generated
	 */
    int SDI = 93;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SGEditImpl <em>SG Edit</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SGEditImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSGEdit()
	 * @generated
	 */
    int SG_EDIT = 94;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SMVSecurityImpl <em>SMV Security</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SMVSecurityImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSMVSecurity()
	 * @generated
	 */
    int SMV_SECURITY = 95;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SMVSettingsImpl <em>SMV Settings</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SMVSettingsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSMVSettings()
	 * @generated
	 */
    int SMV_SETTINGS = 96;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SMVscImpl <em>SM Vsc</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SMVscImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSMVsc()
	 * @generated
	 */
    int SM_VSC = 97;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SampledValueControlImpl <em>Sampled Value Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SampledValueControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSampledValueControl()
	 * @generated
	 */
    int SAMPLED_VALUE_CONTROL = 98;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServerImpl <em>Server</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServerImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServer()
	 * @generated
	 */
    int SERVER = 99;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServerAtImpl <em>Server At</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServerAtImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServerAt()
	 * @generated
	 */
    int SERVER_AT = 100;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServicesImpl <em>Services</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServicesImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServices()
	 * @generated
	 */
    int SERVICES = 103;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SetDataSetValueImpl <em>Set Data Set Value</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SetDataSetValueImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSetDataSetValue()
	 * @generated
	 */
    int SET_DATA_SET_VALUE = 104;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SettingControlImpl <em>Setting Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SettingControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSettingControl()
	 * @generated
	 */
    int SETTING_CONTROL = 105;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SettingGroupsImpl <em>Setting Groups</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SettingGroupsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSettingGroups()
	 * @generated
	 */
    int SETTING_GROUPS = 106;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SmvOptsImpl <em>Smv Opts</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SmvOptsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSmvOpts()
	 * @generated
	 */
    int SMV_OPTS = 107;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SubjectImpl <em>Subject</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SubjectImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSubject()
	 * @generated
	 */
    int SUBJECT = 108;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SupSubscriptionImpl <em>Sup Subscription</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SupSubscriptionImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSupSubscription()
	 * @generated
	 */
    int SUP_SUBSCRIPTION = 109;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TimeSyncProtImpl <em>Time Sync Prot</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TimeSyncProtImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getTimeSyncProt()
	 * @generated
	 */
    int TIME_SYNC_PROT = 110;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TimerActivatedControlImpl <em>Timer Activated Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TimerActivatedControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getTimerActivatedControl()
	 * @generated
	 */
    int TIMER_ACTIVATED_CONTROL = 111;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TrgOpsImpl <em>Trg Ops</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TrgOpsImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getTrgOps()
	 * @generated
	 */
    int TRG_OPS = 112;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ValueHandlingImpl <em>Value Handling</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ValueHandlingImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getValueHandling()
	 * @generated
	 */
    int VALUE_HANDLING = 113;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EquipmentImpl <em>Equipment</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EquipmentImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getEquipment()
	 * @generated
	 */
    int EQUIPMENT = 121;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AbstractConductingEquipmentImpl <em>Abstract Conducting Equipment</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AbstractConductingEquipmentImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAbstractConductingEquipment()
	 * @generated
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT = 114;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AbstractEqFuncSubFuncImpl <em>Abstract Eq Func Sub Func</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.AbstractEqFuncSubFuncImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAbstractEqFuncSubFunc()
	 * @generated
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC = 115;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EquipmentContainerImpl <em>Equipment Container</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EquipmentContainerImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getEquipmentContainer()
	 * @generated
	 */
    int EQUIPMENT_CONTAINER = 122;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.BayImpl <em>Bay</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.BayImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getBay()
	 * @generated
	 */
    int BAY = 116;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConductingEquipmentImpl <em>Conducting Equipment</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConductingEquipmentImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getConductingEquipment()
	 * @generated
	 */
    int CONDUCTING_EQUIPMENT = 117;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConnectivityNodeImpl <em>Connectivity Node</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ConnectivityNodeImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getConnectivityNode()
	 * @generated
	 */
    int CONNECTIVITY_NODE = 118;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EqFunctionImpl <em>Eq Function</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EqFunctionImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getEqFunction()
	 * @generated
	 */
    int EQ_FUNCTION = 119;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EqSubFunctionImpl <em>Eq Sub Function</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.EqSubFunctionImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getEqSubFunction()
	 * @generated
	 */
    int EQ_SUB_FUNCTION = 120;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.FunctionImpl <em>Function</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.FunctionImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getFunction()
	 * @generated
	 */
    int FUNCTION = 123;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GeneralEquipmentImpl <em>General Equipment</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.GeneralEquipmentImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGeneralEquipment()
	 * @generated
	 */
    int GENERAL_EQUIPMENT = 124;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LNodeImpl <em>LNode</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.LNodeImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getLNode()
	 * @generated
	 */
    int LNODE = 126;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TerminalImpl <em>Terminal</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TerminalImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getTerminal()
	 * @generated
	 */
    int TERMINAL = 135;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.NeutralPointImpl <em>Neutral Point</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.NeutralPointImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getNeutralPoint()
	 * @generated
	 */
    int NEUTRAL_POINT = 128;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PowerTransformerImpl <em>Power Transformer</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.PowerTransformerImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getPowerTransformer()
	 * @generated
	 */
    int POWER_TRANSFORMER = 130;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SubEquipmentImpl <em>Sub Equipment</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SubEquipmentImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSubEquipment()
	 * @generated
	 */
    int SUB_EQUIPMENT = 131;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SubFunctionImpl <em>Sub Function</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SubFunctionImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSubFunction()
	 * @generated
	 */
    int SUB_FUNCTION = 132;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SubstationImpl <em>Substation</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SubstationImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSubstation()
	 * @generated
	 */
    int SUBSTATION = 133;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TapChangerImpl <em>Tap Changer</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TapChangerImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getTapChanger()
	 * @generated
	 */
    int TAP_CHANGER = 134;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TransformerWindingImpl <em>Transformer Winding</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.TransformerWindingImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getTransformerWinding()
	 * @generated
	 */
    int TRANSFORMER_WINDING = 136;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.VoltageImpl <em>Voltage</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.VoltageImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getVoltage()
	 * @generated
	 */
    int VOLTAGE = 137;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.VoltageLevelImpl <em>Voltage Level</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.VoltageLevelImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getVoltageLevel()
	 * @generated
	 */
    int VOLTAGE_LEVEL = 138;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.UnNamingImpl <em>Un Naming</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.UnNamingImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getUnNaming()
	 * @generated
	 */
    int UN_NAMING = 143;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int UN_NAMING__LINE_NUMBER = BASE_ELEMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int UN_NAMING__PRIVATE = BASE_ELEMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int UN_NAMING__TEXT = BASE_ELEMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int UN_NAMING__ANY = BASE_ELEMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int UN_NAMING__ANY_ATTRIBUTE = BASE_ELEMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int UN_NAMING__DESC = BASE_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Un Naming</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int UN_NAMING_FEATURE_COUNT = BASE_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_ACSI_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_ANY_NAME__STRING = BASE_ELEMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING = BASE_ELEMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING = BASE_ELEMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_CB_NAME__STRING = BASE_ELEMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DA_COUNT__STRING = BASE_ELEMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_LD_INST__STRING = BASE_ELEMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_LD_NAME__STRING = BASE_ELEMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_LLN0_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_LN_INST__STRING = BASE_ELEMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_LPHD_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_LINE_TYPE__STRING = BASE_ELEMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_LOG_NAME__STRING = BASE_ELEMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_MESSAGE_ID__STRING = BASE_ELEMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PADDR__STRING = BASE_ELEMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = BASE_ELEMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PREFIX__STRING = BASE_ELEMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PROCESS_NAME__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_REF__STRING = BASE_ELEMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER = BASE_ELEMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_REVISION__STRING = BASE_ELEMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_SDO_COUNT__STRING = BASE_ELEMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = BASE_ELEMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = BASE_ELEMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_VERSION__STRING = BASE_ELEMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = BASE_ELEMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Un Naming</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int UN_NAMING_OPERATION_COUNT = BASE_ELEMENT_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMMUNICATION__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMMUNICATION__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMMUNICATION__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMMUNICATION__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMMUNICATION__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMMUNICATION__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Sub Network</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMMUNICATION__SUB_NETWORK = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>SCL</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMMUNICATION__SCL = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Communication</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMMUNICATION_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Communication nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALIDATE_COMMUNICATION_NOTHING__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Communication at least one Sub Network required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION___VALIDATE_COMMUNICATION_AT_LEAST_ONE_SUB_NETWORK_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Communication</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMMUNICATION_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Ap Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__AP_NAME = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ied Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__IED_NAME = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Red Prot</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__RED_PROT = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Address</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__ADDRESS = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Sub Network</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__SUB_NETWORK = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Refers To Access Point</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__REFERS_TO_ACCESS_POINT = UN_NAMING_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Phys Conn</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__PHYS_CONN = UN_NAMING_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>GSE</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__GSE = UN_NAMING_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>SMV</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP__SMV = UN_NAMING_FEATURE_COUNT + 8;

    /**
	 * The number of structural features of the '<em>Connected AP</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 9;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Connected AP ied Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALIDATE_CONNECTED_AP_IED_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Connected AP ied Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALIDATE_CONNECTED_AP_IED_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Connected AP ap Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALIDATE_CONNECTED_AP_AP_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Connected AP ap Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALIDATE_CONNECTED_AP_AP_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate Connected AP red Prot valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALIDATE_CONNECTED_AP_RED_PROT_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 4;

				/**
	 * The operation id for the '<em>Validate Connected AP at most one Phys Conn Type Red Conn required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALIDATE_CONNECTED_AP_AT_MOST_ONE_PHYS_CONN_TYPE_RED_CONN_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 5;

				/**
	 * The operation id for the '<em>Validate Connected AP at most one Phys Conn Type Connection required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTED_AP___VALIDATE_CONNECTED_AP_AT_MOST_ONE_PHYS_CONN_TYPE_CONNECTION_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 6;

				/**
	 * The number of operations of the '<em>Connected AP</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTED_AP_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Cb Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__CB_NAME = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ld Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__LD_INST = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Address</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__ADDRESS = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Refers To LDevice</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__REFERS_TO_LDEVICE = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Refers To Control With IED Name</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK__REFERS_TO_CONTROL_WITH_IED_NAME = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Control Block</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Control Block ld Inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_LD_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Control Block ld Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_LD_INST_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Control Block cb Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_CB_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Control Block cb Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_CB_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>Control Block</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_BLOCK_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__LINE_NUMBER = CONTROL_BLOCK__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__PRIVATE = CONTROL_BLOCK__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__TEXT = CONTROL_BLOCK__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__ANY = CONTROL_BLOCK__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__ANY_ATTRIBUTE = CONTROL_BLOCK__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__DESC = CONTROL_BLOCK__DESC;

    /**
	 * The feature id for the '<em><b>Cb Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__CB_NAME = CONTROL_BLOCK__CB_NAME;

    /**
	 * The feature id for the '<em><b>Ld Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__LD_INST = CONTROL_BLOCK__LD_INST;

    /**
	 * The feature id for the '<em><b>Address</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__ADDRESS = CONTROL_BLOCK__ADDRESS;

    /**
	 * The feature id for the '<em><b>Refers To LDevice</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__REFERS_TO_LDEVICE = CONTROL_BLOCK__REFERS_TO_LDEVICE;

    /**
	 * The feature id for the '<em><b>Refers To Control With IED Name</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__REFERS_TO_CONTROL_WITH_IED_NAME = CONTROL_BLOCK__REFERS_TO_CONTROL_WITH_IED_NAME;

    /**
	 * The feature id for the '<em><b>Connected AP</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__CONNECTED_AP = CONTROL_BLOCK_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Min Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__MIN_TIME = CONTROL_BLOCK_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Max Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE__MAX_TIME = CONTROL_BLOCK_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>GSE</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_FEATURE_COUNT = CONTROL_BLOCK_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_ACCESS_POINT_NAME__STRING = CONTROL_BLOCK___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_ACSI_NAME__STRING = CONTROL_BLOCK___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_ANY_NAME__STRING = CONTROL_BLOCK___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_ASSOCIATION_ID__STRING = CONTROL_BLOCK___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_AUTHENTICATION_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_BASIC_TYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_CB_NAME__STRING = CONTROL_BLOCK___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_CDC_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DA_COUNT__STRING = CONTROL_BLOCK___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DATA_NAME__STRING = CONTROL_BLOCK___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DATA_SET_NAME__STRING = CONTROL_BLOCK___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_EMPTY__STRING = CONTROL_BLOCK___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CONTROL_BLOCK___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_FULL_DO_NAME__STRING = CONTROL_BLOCK___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_IED_NAME__STRING = CONTROL_BLOCK___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CONTROL_BLOCK___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_LD_INST__STRING = CONTROL_BLOCK___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_LD_INST_OR_EMPTY__STRING = CONTROL_BLOCK___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_LD_NAME__STRING = CONTROL_BLOCK___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_LLN0_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_LN_CLASS_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_LN_INST__STRING = CONTROL_BLOCK___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_LN_INST_OR_EMPTY__STRING = CONTROL_BLOCK___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_LPHD_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_LINE_TYPE__STRING = CONTROL_BLOCK___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_LOG_NAME__STRING = CONTROL_BLOCK___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_MESSAGE_ID__STRING = CONTROL_BLOCK___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_NAME__STRING = CONTROL_BLOCK___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_NAMESPACE_NAME__STRING = CONTROL_BLOCK___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CONTROL_BLOCK___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PADDR__STRING = CONTROL_BLOCK___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PTYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PREFIX__STRING = CONTROL_BLOCK___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PROCESS_NAME__STRING = CONTROL_BLOCK___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_PROCESS_TYPE__STRING = CONTROL_BLOCK___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_RED_PROT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_REF__STRING = CONTROL_BLOCK___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_RELEASE__BIGINTEGER = CONTROL_BLOCK___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_RESTR_NAME1ST_L__STRING = CONTROL_BLOCK___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_RESTR_NAME1ST_U__STRING = CONTROL_BLOCK___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_REVISION__STRING = CONTROL_BLOCK___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_RIGHT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_SDO_COUNT__STRING = CONTROL_BLOCK___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_SUB_DATA_NAME__STRING = CONTROL_BLOCK___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_VERSION__STRING = CONTROL_BLOCK___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CONTROL_BLOCK___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Control Block ld Inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALIDATE_CONTROL_BLOCK_LD_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_LD_INST_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control Block ld Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALIDATE_CONTROL_BLOCK_LD_INST_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_LD_INST_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control Block cb Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALIDATE_CONTROL_BLOCK_CB_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_CB_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control Block cb Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALIDATE_CONTROL_BLOCK_CB_NAME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_CB_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate GSE nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE___VALIDATE_GSE_NOTHING__DIAGNOSTICCHAIN_MAP = CONTROL_BLOCK_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>GSE</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_OPERATION_COUNT = CONTROL_BLOCK_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PADDR__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PADDR__TYPE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PADDR__VALUE = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>PAddr</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PADDR_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PADDR___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>PAddr</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PADDR_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int P__LINE_NUMBER = PADDR__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int P__TYPE = PADDR__TYPE;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int P__VALUE = PADDR__VALUE;

    /**
	 * The feature id for the '<em><b>Address</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int P__ADDRESS = PADDR_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>P</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int P_FEATURE_COUNT = PADDR_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_ACCESS_POINT_NAME__STRING = PADDR___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_ACSI_NAME__STRING = PADDR___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_ANY_NAME__STRING = PADDR___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_ASSOCIATION_ID__STRING = PADDR___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = PADDR___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_AUTHENTICATION_ENUM__STRING = PADDR___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_BASIC_TYPE_ENUM__STRING = PADDR___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_CB_NAME__STRING = PADDR___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_CDC_ENUM__STRING = PADDR___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DA_COUNT__STRING = PADDR___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DATA_NAME__STRING = PADDR___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DATA_SET_NAME__STRING = PADDR___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_ENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_EMPTY__STRING = PADDR___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_EXTENSION_CDC_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = PADDR___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_FULL_DO_NAME__STRING = PADDR___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_IED_NAME__STRING = PADDR___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = PADDR___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_LD_INST__STRING = PADDR___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_LD_INST_OR_EMPTY__STRING = PADDR___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_LD_NAME__STRING = PADDR___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_LLN0_ENUM__STRING = PADDR___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_LN_CLASS_ENUM__STRING = PADDR___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_LN_INST__STRING = PADDR___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_LN_INST_OR_EMPTY__STRING = PADDR___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_LPHD_ENUM__STRING = PADDR___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_LINE_TYPE__STRING = PADDR___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_LOG_NAME__STRING = PADDR___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_MESSAGE_ID__STRING = PADDR___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_NAME__STRING = PADDR___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_NAMESPACE_NAME__STRING = PADDR___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = PADDR___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PADDR__STRING = PADDR___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PTYPE_ENUM__STRING = PADDR___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = PADDR___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = PADDR___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = PADDR___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PREFIX__STRING = PADDR___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PROCESS_NAME__STRING = PADDR___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_PROCESS_TYPE__STRING = PADDR___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_RED_PROT_ENUM__STRING = PADDR___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_REF__STRING = PADDR___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_RELEASE__BIGINTEGER = PADDR___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_RESTR_NAME1ST_L__STRING = PADDR___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_RESTR_NAME1ST_U__STRING = PADDR___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_REVISION__STRING = PADDR___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_RIGHT_ENUM__STRING = PADDR___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_SDO_COUNT__STRING = PADDR___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_SUB_DATA_NAME__STRING = PADDR___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = PADDR___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = PADDR___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_VERSION__STRING = PADDR___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = PADDR___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Ptype required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALIDATE_PTYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = PADDR_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Ptype valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALIDATE_PTYPE_VALID__DIAGNOSTICCHAIN_MAP = PADDR_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Pvalue</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int P___VALIDATE_PVALUE__DIAGNOSTICCHAIN_MAP = PADDR_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>P</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int P_OPERATION_COUNT = PADDR_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PPHYS_CONN__LINE_NUMBER = PADDR__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PPHYS_CONN__TYPE = PADDR__TYPE;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PPHYS_CONN__VALUE = PADDR__VALUE;

    /**
	 * The feature id for the '<em><b>Phys Conn</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PPHYS_CONN__PHYS_CONN = PADDR_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>PPhys Conn</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PPHYS_CONN_FEATURE_COUNT = PADDR_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_ACCESS_POINT_NAME__STRING = PADDR___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_ACSI_NAME__STRING = PADDR___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_ANY_NAME__STRING = PADDR___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_ASSOCIATION_ID__STRING = PADDR___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = PADDR___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_AUTHENTICATION_ENUM__STRING = PADDR___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_BASIC_TYPE_ENUM__STRING = PADDR___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_CB_NAME__STRING = PADDR___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_CDC_ENUM__STRING = PADDR___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DA_COUNT__STRING = PADDR___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DATA_NAME__STRING = PADDR___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DATA_SET_NAME__STRING = PADDR___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_ENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = PADDR___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_EMPTY__STRING = PADDR___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_EXTENSION_CDC_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = PADDR___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = PADDR___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_FULL_DO_NAME__STRING = PADDR___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_IED_NAME__STRING = PADDR___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = PADDR___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_LD_INST__STRING = PADDR___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_LD_INST_OR_EMPTY__STRING = PADDR___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_LD_NAME__STRING = PADDR___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_LLN0_ENUM__STRING = PADDR___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_LN_CLASS_ENUM__STRING = PADDR___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_LN_INST__STRING = PADDR___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_LN_INST_OR_EMPTY__STRING = PADDR___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_LPHD_ENUM__STRING = PADDR___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_LINE_TYPE__STRING = PADDR___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_LOG_NAME__STRING = PADDR___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_MESSAGE_ID__STRING = PADDR___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_NAME__STRING = PADDR___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_NAMESPACE_NAME__STRING = PADDR___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = PADDR___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PADDR__STRING = PADDR___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PTYPE_ENUM__STRING = PADDR___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = PADDR___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = PADDR___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = PADDR___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = PADDR___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PREFIX__STRING = PADDR___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PROCESS_NAME__STRING = PADDR___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_PROCESS_TYPE__STRING = PADDR___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_RED_PROT_ENUM__STRING = PADDR___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_REF__STRING = PADDR___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_RELEASE__BIGINTEGER = PADDR___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_RESTR_NAME1ST_L__STRING = PADDR___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_RESTR_NAME1ST_U__STRING = PADDR___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_REVISION__STRING = PADDR___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_RIGHT_ENUM__STRING = PADDR___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_SDO_COUNT__STRING = PADDR___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_SUB_DATA_NAME__STRING = PADDR___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = PADDR___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = PADDR___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_VERSION__STRING = PADDR___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = PADDR___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate PPhys Conn type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALIDATE_PPHYS_CONN_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = PADDR_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate PPhys Conn type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PPHYS_CONN___VALIDATE_PPHYS_CONN_TYPE_VALID__DIAGNOSTICCHAIN_MAP = PADDR_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>PPhys Conn</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PPHYS_CONN_OPERATION_COUNT = PADDR_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN__TYPE = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Connected AP</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN__CONNECTED_AP = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>P</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN__P = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Phys Conn</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Phys Conn type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALIDATE_PHYS_CONN_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Phys Conn type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYS_CONN___VALIDATE_PHYS_CONN_TYPE_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Phys Conn</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PHYS_CONN_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__LINE_NUMBER = CONTROL_BLOCK__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__PRIVATE = CONTROL_BLOCK__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__TEXT = CONTROL_BLOCK__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__ANY = CONTROL_BLOCK__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__ANY_ATTRIBUTE = CONTROL_BLOCK__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__DESC = CONTROL_BLOCK__DESC;

    /**
	 * The feature id for the '<em><b>Cb Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__CB_NAME = CONTROL_BLOCK__CB_NAME;

    /**
	 * The feature id for the '<em><b>Ld Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__LD_INST = CONTROL_BLOCK__LD_INST;

    /**
	 * The feature id for the '<em><b>Address</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__ADDRESS = CONTROL_BLOCK__ADDRESS;

    /**
	 * The feature id for the '<em><b>Refers To LDevice</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__REFERS_TO_LDEVICE = CONTROL_BLOCK__REFERS_TO_LDEVICE;

    /**
	 * The feature id for the '<em><b>Refers To Control With IED Name</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__REFERS_TO_CONTROL_WITH_IED_NAME = CONTROL_BLOCK__REFERS_TO_CONTROL_WITH_IED_NAME;

    /**
	 * The feature id for the '<em><b>Connected AP</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV__CONNECTED_AP = CONTROL_BLOCK_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>SMV</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_FEATURE_COUNT = CONTROL_BLOCK_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_ACCESS_POINT_NAME__STRING = CONTROL_BLOCK___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_ACSI_NAME__STRING = CONTROL_BLOCK___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_ANY_NAME__STRING = CONTROL_BLOCK___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_ASSOCIATION_ID__STRING = CONTROL_BLOCK___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_AUTHENTICATION_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_BASIC_TYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_CB_NAME__STRING = CONTROL_BLOCK___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_CDC_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DA_COUNT__STRING = CONTROL_BLOCK___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DATA_NAME__STRING = CONTROL_BLOCK___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DATA_SET_NAME__STRING = CONTROL_BLOCK___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CONTROL_BLOCK___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_EMPTY__STRING = CONTROL_BLOCK___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CONTROL_BLOCK___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_FULL_DO_NAME__STRING = CONTROL_BLOCK___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_IED_NAME__STRING = CONTROL_BLOCK___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CONTROL_BLOCK___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_LD_INST__STRING = CONTROL_BLOCK___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_LD_INST_OR_EMPTY__STRING = CONTROL_BLOCK___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_LD_NAME__STRING = CONTROL_BLOCK___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_LLN0_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_LN_CLASS_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_LN_INST__STRING = CONTROL_BLOCK___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_LN_INST_OR_EMPTY__STRING = CONTROL_BLOCK___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_LPHD_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_LINE_TYPE__STRING = CONTROL_BLOCK___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_LOG_NAME__STRING = CONTROL_BLOCK___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_MESSAGE_ID__STRING = CONTROL_BLOCK___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_NAME__STRING = CONTROL_BLOCK___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_NAMESPACE_NAME__STRING = CONTROL_BLOCK___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CONTROL_BLOCK___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PADDR__STRING = CONTROL_BLOCK___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PTYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PREFIX__STRING = CONTROL_BLOCK___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PROCESS_NAME__STRING = CONTROL_BLOCK___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_PROCESS_TYPE__STRING = CONTROL_BLOCK___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_RED_PROT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_REF__STRING = CONTROL_BLOCK___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_RELEASE__BIGINTEGER = CONTROL_BLOCK___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_RESTR_NAME1ST_L__STRING = CONTROL_BLOCK___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_RESTR_NAME1ST_U__STRING = CONTROL_BLOCK___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_REVISION__STRING = CONTROL_BLOCK___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_RIGHT_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_SDO_COUNT__STRING = CONTROL_BLOCK___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_SUB_DATA_NAME__STRING = CONTROL_BLOCK___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CONTROL_BLOCK___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_VERSION__STRING = CONTROL_BLOCK___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CONTROL_BLOCK___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Control Block ld Inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALIDATE_CONTROL_BLOCK_LD_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_LD_INST_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control Block ld Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALIDATE_CONTROL_BLOCK_LD_INST_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_LD_INST_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control Block cb Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALIDATE_CONTROL_BLOCK_CB_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_CB_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control Block cb Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALIDATE_CONTROL_BLOCK_CB_NAME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_BLOCK___VALIDATE_CONTROL_BLOCK_CB_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate SMV nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV___VALIDATE_SMV_NOTHING__DIAGNOSTICCHAIN_MAP = CONTROL_BLOCK_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>SMV</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPERATION_COUNT = CONTROL_BLOCK_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__LINE_NUMBER = NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__PRIVATE = NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__TEXT = NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__ANY = NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__ANY_ATTRIBUTE = NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__NAME = NAMING__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__DESC = NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__TYPE = NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Bit Rate</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__BIT_RATE = NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Communication</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__COMMUNICATION = NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Connected AP</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK__CONNECTED_AP = NAMING_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Sub Network</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK_FEATURE_COUNT = NAMING_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_ACCESS_POINT_NAME__STRING = NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_ACSI_NAME__STRING = NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_ANY_NAME__STRING = NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_ASSOCIATION_ID__STRING = NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_AUTHENTICATION_ENUM__STRING = NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_BASIC_TYPE_ENUM__STRING = NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_CB_NAME__STRING = NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_CDC_ENUM__STRING = NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DA_COUNT__STRING = NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DATA_NAME__STRING = NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DATA_SET_NAME__STRING = NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_ENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_EMPTY__STRING = NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_EXTENSION_CDC_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_FULL_DO_NAME__STRING = NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_IED_NAME__STRING = NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_LD_INST__STRING = NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_LD_INST_OR_EMPTY__STRING = NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_LD_NAME__STRING = NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_LLN0_ENUM__STRING = NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_LN_CLASS_ENUM__STRING = NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_LN_INST__STRING = NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_LN_INST_OR_EMPTY__STRING = NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_LPHD_ENUM__STRING = NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_LINE_TYPE__STRING = NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_LOG_NAME__STRING = NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_MESSAGE_ID__STRING = NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_NAME__STRING = NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_NAMESPACE_NAME__STRING = NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PADDR__STRING = NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PTYPE_ENUM__STRING = NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PREFIX__STRING = NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PROCESS_NAME__STRING = NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_PROCESS_TYPE__STRING = NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_RED_PROT_ENUM__STRING = NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_REF__STRING = NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_RELEASE__BIGINTEGER = NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_RESTR_NAME1ST_L__STRING = NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_RESTR_NAME1ST_U__STRING = NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_REVISION__STRING = NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_RIGHT_ENUM__STRING = NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_SDO_COUNT__STRING = NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_SUB_DATA_NAME__STRING = NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_VERSION__STRING = NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = NAMING___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = NAMING___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Sub Network nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALIDATE_SUB_NETWORK_NOTHING__DIAGNOSTICCHAIN_MAP = NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Sub Network at least one Connected AP required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_NETWORK___VALIDATE_SUB_NETWORK_AT_LEAST_ONE_CONNECTED_AP_REQUIRED__DIAGNOSTICCHAIN_MAP = NAMING_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Sub Network</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_NETWORK_OPERATION_COUNT = NAMING_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE__REFERRED_BY_FCDA = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE__NAME = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE__REFERRED_BY_EXT_REF = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Data Attribute</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Attribute name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Data Attribute name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Data Attribute</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_ATTRIBUTE_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__LINE_NUMBER = DATA_ATTRIBUTE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__PRIVATE = DATA_ATTRIBUTE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__TEXT = DATA_ATTRIBUTE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__ANY = DATA_ATTRIBUTE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__ANY_ATTRIBUTE = DATA_ATTRIBUTE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__DESC = DATA_ATTRIBUTE__DESC;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__REFERRED_BY_FCDA = DATA_ATTRIBUTE__REFERRED_BY_FCDA;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__NAME = DATA_ATTRIBUTE__NAME;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__REFERRED_BY_EXT_REF = DATA_ATTRIBUTE__REFERRED_BY_EXT_REF;

    /**
	 * The feature id for the '<em><b>BType</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__BTYPE = DATA_ATTRIBUTE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__COUNT = DATA_ATTRIBUTE_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>SAddr</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__SADDR = DATA_ATTRIBUTE_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__TYPE = DATA_ATTRIBUTE_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Val Import</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__VAL_IMPORT = DATA_ATTRIBUTE_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Val Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__VAL_KIND = DATA_ATTRIBUTE_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Refers To Enum Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__REFERS_TO_ENUM_TYPE = DATA_ATTRIBUTE_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Val</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE__VAL = DATA_ATTRIBUTE_FEATURE_COUNT + 7;

    /**
	 * The number of structural features of the '<em>Abstract Data Attribute</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT = DATA_ATTRIBUTE_FEATURE_COUNT + 8;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ACCESS_POINT_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ACSI_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ANY_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ASSOCIATION_ID__STRING = DATA_ATTRIBUTE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_AUTHENTICATION_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_BASIC_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_CB_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_CDC_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DA_COUNT__STRING = DATA_ATTRIBUTE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DATA_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DATA_SET_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EMPTY__STRING = DATA_ATTRIBUTE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_FULL_DO_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_IED_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = DATA_ATTRIBUTE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LD_INST__STRING = DATA_ATTRIBUTE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LD_INST_OR_EMPTY__STRING = DATA_ATTRIBUTE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LD_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LLN0_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LN_CLASS_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LN_INST__STRING = DATA_ATTRIBUTE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LN_INST_OR_EMPTY__STRING = DATA_ATTRIBUTE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LPHD_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LINE_TYPE__STRING = DATA_ATTRIBUTE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LOG_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_MESSAGE_ID__STRING = DATA_ATTRIBUTE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_NAMESPACE_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PADDR__STRING = DATA_ATTRIBUTE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PTYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREFIX__STRING = DATA_ATTRIBUTE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PROCESS_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PROCESS_TYPE__STRING = DATA_ATTRIBUTE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RED_PROT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_REF__STRING = DATA_ATTRIBUTE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RELEASE__BIGINTEGER = DATA_ATTRIBUTE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_L__STRING = DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_U__STRING = DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_REVISION__STRING = DATA_ATTRIBUTE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RIGHT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_SDO_COUNT__STRING = DATA_ATTRIBUTE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_SUB_DATA_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_VERSION__STRING = DATA_ATTRIBUTE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = DATA_ATTRIBUTE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Attribute name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Data Attribute name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute bType required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_BTYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute bType valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_BTYPE_VALID__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_TYPE_VALID__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute count valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_COUNT_VALID__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>Abstract Data Attribute</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_DATA_ATTRIBUTE_OPERATION_COUNT = DATA_ATTRIBUTE_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__LINE_NUMBER = ABSTRACT_DATA_ATTRIBUTE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__PRIVATE = ABSTRACT_DATA_ATTRIBUTE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__TEXT = ABSTRACT_DATA_ATTRIBUTE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__ANY = ABSTRACT_DATA_ATTRIBUTE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__ANY_ATTRIBUTE = ABSTRACT_DATA_ATTRIBUTE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__DESC = ABSTRACT_DATA_ATTRIBUTE__DESC;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__REFERRED_BY_FCDA = ABSTRACT_DATA_ATTRIBUTE__REFERRED_BY_FCDA;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__NAME = ABSTRACT_DATA_ATTRIBUTE__NAME;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__REFERRED_BY_EXT_REF = ABSTRACT_DATA_ATTRIBUTE__REFERRED_BY_EXT_REF;

    /**
	 * The feature id for the '<em><b>BType</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__BTYPE = ABSTRACT_DATA_ATTRIBUTE__BTYPE;

    /**
	 * The feature id for the '<em><b>Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__COUNT = ABSTRACT_DATA_ATTRIBUTE__COUNT;

    /**
	 * The feature id for the '<em><b>SAddr</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__SADDR = ABSTRACT_DATA_ATTRIBUTE__SADDR;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__TYPE = ABSTRACT_DATA_ATTRIBUTE__TYPE;

    /**
	 * The feature id for the '<em><b>Val Import</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__VAL_IMPORT = ABSTRACT_DATA_ATTRIBUTE__VAL_IMPORT;

    /**
	 * The feature id for the '<em><b>Val Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__VAL_KIND = ABSTRACT_DATA_ATTRIBUTE__VAL_KIND;

    /**
	 * The feature id for the '<em><b>Refers To Enum Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__REFERS_TO_ENUM_TYPE = ABSTRACT_DATA_ATTRIBUTE__REFERS_TO_ENUM_TYPE;

    /**
	 * The feature id for the '<em><b>Val</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__VAL = ABSTRACT_DATA_ATTRIBUTE__VAL;

    /**
	 * The feature id for the '<em><b>DA Type</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA__DA_TYPE = ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>BDA</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA_FEATURE_COUNT = ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_ACCESS_POINT_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_ACSI_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_ANY_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_ASSOCIATION_ID__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_AUTHENTICATION_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_BASIC_TYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_CB_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_CDC_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DA_COUNT__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DATA_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DATA_SET_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_EMPTY__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_FULL_DO_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_IED_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_LD_INST__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_LD_INST_OR_EMPTY__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_LD_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_LLN0_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_LN_CLASS_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_LN_INST__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_LN_INST_OR_EMPTY__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_LPHD_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_LINE_TYPE__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_LOG_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_MESSAGE_ID__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_NAMESPACE_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PADDR__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PTYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PREFIX__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PROCESS_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_PROCESS_TYPE__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_RED_PROT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_REF__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_RELEASE__BIGINTEGER = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_RESTR_NAME1ST_L__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_RESTR_NAME1ST_U__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_REVISION__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_RIGHT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_SDO_COUNT__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_SUB_DATA_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_VERSION__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Attribute name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Data Attribute name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute bType required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_BTYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_BTYPE_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute bType valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_BTYPE_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_BTYPE_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_TYPE_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_TYPE_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute count valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_COUNT_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_COUNT_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate BDA nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BDA___VALIDATE_BDA_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>BDA</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BDA_OPERATION_COUNT = ABSTRACT_DATA_ATTRIBUTE_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__LINE_NUMBER = ABSTRACT_DATA_ATTRIBUTE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__PRIVATE = ABSTRACT_DATA_ATTRIBUTE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__TEXT = ABSTRACT_DATA_ATTRIBUTE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__ANY = ABSTRACT_DATA_ATTRIBUTE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__ANY_ATTRIBUTE = ABSTRACT_DATA_ATTRIBUTE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__DESC = ABSTRACT_DATA_ATTRIBUTE__DESC;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__REFERRED_BY_FCDA = ABSTRACT_DATA_ATTRIBUTE__REFERRED_BY_FCDA;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__NAME = ABSTRACT_DATA_ATTRIBUTE__NAME;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__REFERRED_BY_EXT_REF = ABSTRACT_DATA_ATTRIBUTE__REFERRED_BY_EXT_REF;

    /**
	 * The feature id for the '<em><b>BType</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__BTYPE = ABSTRACT_DATA_ATTRIBUTE__BTYPE;

    /**
	 * The feature id for the '<em><b>Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__COUNT = ABSTRACT_DATA_ATTRIBUTE__COUNT;

    /**
	 * The feature id for the '<em><b>SAddr</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__SADDR = ABSTRACT_DATA_ATTRIBUTE__SADDR;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__TYPE = ABSTRACT_DATA_ATTRIBUTE__TYPE;

    /**
	 * The feature id for the '<em><b>Val Import</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__VAL_IMPORT = ABSTRACT_DATA_ATTRIBUTE__VAL_IMPORT;

    /**
	 * The feature id for the '<em><b>Val Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__VAL_KIND = ABSTRACT_DATA_ATTRIBUTE__VAL_KIND;

    /**
	 * The feature id for the '<em><b>Refers To Enum Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__REFERS_TO_ENUM_TYPE = ABSTRACT_DATA_ATTRIBUTE__REFERS_TO_ENUM_TYPE;

    /**
	 * The feature id for the '<em><b>Val</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__VAL = ABSTRACT_DATA_ATTRIBUTE__VAL;

    /**
	 * The feature id for the '<em><b>Dchg</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__DCHG = ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Dupd</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__DUPD = ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Fc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__FC = ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Qchg</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__QCHG = ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Refers To DA Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__REFERS_TO_DA_TYPE = ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>DO Type</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__DO_TYPE = ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Prot Ns</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA__PROT_NS = ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT + 6;

    /**
	 * The number of structural features of the '<em>DA</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_FEATURE_COUNT = ABSTRACT_DATA_ATTRIBUTE_FEATURE_COUNT + 7;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_ACCESS_POINT_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_ACSI_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_ANY_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_ASSOCIATION_ID__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_AUTHENTICATION_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_BASIC_TYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_CB_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_CDC_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DA_COUNT__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DATA_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DATA_SET_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_EMPTY__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_FULL_DO_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_IED_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_LD_INST__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_LD_INST_OR_EMPTY__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_LD_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_LLN0_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_LN_CLASS_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_LN_INST__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_LN_INST_OR_EMPTY__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_LPHD_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_LINE_TYPE__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_LOG_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_MESSAGE_ID__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_NAMESPACE_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PADDR__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PTYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PREFIX__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PROCESS_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_PROCESS_TYPE__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_RED_PROT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_REF__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_RELEASE__BIGINTEGER = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_RESTR_NAME1ST_L__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_RESTR_NAME1ST_U__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_REVISION__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_RIGHT_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_SDO_COUNT__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_SUB_DATA_NAME__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_VERSION__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ABSTRACT_DATA_ATTRIBUTE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Attribute name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Data Attribute name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute bType required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_BTYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_BTYPE_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute bType valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_BTYPE_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_BTYPE_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_TYPE_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_TYPE_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Data Attribute count valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_COUNT_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE___VALIDATE_ABSTRACT_DATA_ATTRIBUTE_COUNT_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate DA fc required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA___VALIDATE_DA_FC_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_DATA_ATTRIBUTE_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>DA</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_OPERATION_COUNT = ABSTRACT_DATA_ATTRIBUTE_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__LINE_NUMBER = ID_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__PRIVATE = ID_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__TEXT = ID_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__ANY = ID_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__ANY_ATTRIBUTE = ID_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__ID = ID_NAMING__ID;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__DESC = ID_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Ied Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__IED_TYPE = ID_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>BDA</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__BDA = ID_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Referred By DA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__REFERRED_BY_DA = ID_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Data Type Templates</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__DATA_TYPE_TEMPLATES = ID_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Prot Ns</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE__PROT_NS = ID_NAMING_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>DA Type</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE_FEATURE_COUNT = ID_NAMING_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_ACCESS_POINT_NAME__STRING = ID_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_ACSI_NAME__STRING = ID_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_ANY_NAME__STRING = ID_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_ASSOCIATION_ID__STRING = ID_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_AUTHENTICATION_ENUM__STRING = ID_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_BASIC_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_CB_NAME__STRING = ID_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DA_COUNT__STRING = ID_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DATA_NAME__STRING = ID_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DATA_SET_NAME__STRING = ID_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_ENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_EMPTY__STRING = ID_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ID_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_FULL_DO_NAME__STRING = ID_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_IED_NAME__STRING = ID_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ID_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_LD_INST__STRING = ID_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_LD_INST_OR_EMPTY__STRING = ID_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_LD_NAME__STRING = ID_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_LLN0_ENUM__STRING = ID_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_LN_INST__STRING = ID_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_LN_INST_OR_EMPTY__STRING = ID_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_LPHD_ENUM__STRING = ID_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_LINE_TYPE__STRING = ID_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_LOG_NAME__STRING = ID_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_MESSAGE_ID__STRING = ID_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_NAME__STRING = ID_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_NAMESPACE_NAME__STRING = ID_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ID_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PADDR__STRING = ID_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ID_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ID_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PREFIX__STRING = ID_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PROCESS_NAME__STRING = ID_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_PROCESS_TYPE__STRING = ID_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_RED_PROT_ENUM__STRING = ID_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_REF__STRING = ID_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_RELEASE__BIGINTEGER = ID_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_RESTR_NAME1ST_L__STRING = ID_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_RESTR_NAME1ST_U__STRING = ID_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_REVISION__STRING = ID_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_RIGHT_ENUM__STRING = ID_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_SDO_COUNT__STRING = ID_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_SUB_DATA_NAME__STRING = ID_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ID_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ID_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_VERSION__STRING = ID_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ID_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate ID Naming id required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALIDATE_ID_NAMING_ID_REQUIRED__DIAGNOSTICCHAIN_MAP = ID_NAMING___VALIDATE_ID_NAMING_ID_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate ID Naming id valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALIDATE_ID_NAMING_ID_VALID__DIAGNOSTICCHAIN_MAP = ID_NAMING___VALIDATE_ID_NAMING_ID_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate DA Type nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALIDATE_DA_TYPE_NOTHING__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate DA Type at least one BDA required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DA_TYPE___VALIDATE_DA_TYPE_AT_LEAST_ONE_BDA_REQUIRED__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>DA Type</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DA_TYPE_OPERATION_COUNT = ID_NAMING_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Access Control</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT__ACCESS_CONTROL = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT__REFERRED_BY_FCDA = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT__NAME = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT__REFERRED_BY_EXT_REF = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Data Object</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Object name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALIDATE_DATA_OBJECT_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Data Object name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT___VALIDATE_DATA_OBJECT_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Data Object</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__LINE_NUMBER = DATA_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__PRIVATE = DATA_OBJECT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__TEXT = DATA_OBJECT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__ANY = DATA_OBJECT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__ANY_ATTRIBUTE = DATA_OBJECT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__DESC = DATA_OBJECT__DESC;

    /**
	 * The feature id for the '<em><b>Access Control</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__ACCESS_CONTROL = DATA_OBJECT__ACCESS_CONTROL;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__REFERRED_BY_FCDA = DATA_OBJECT__REFERRED_BY_FCDA;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__NAME = DATA_OBJECT__NAME;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__REFERRED_BY_EXT_REF = DATA_OBJECT__REFERRED_BY_EXT_REF;

    /**
	 * The feature id for the '<em><b>Transient</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__TRANSIENT = DATA_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__TYPE = DATA_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>LNode Type</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__LNODE_TYPE = DATA_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Refers To DO Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO__REFERS_TO_DO_TYPE = DATA_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>DO</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_FEATURE_COUNT = DATA_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_ACCESS_POINT_NAME__STRING = DATA_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_ACSI_NAME__STRING = DATA_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_ANY_NAME__STRING = DATA_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_ASSOCIATION_ID__STRING = DATA_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = DATA_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_AUTHENTICATION_ENUM__STRING = DATA_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_BASIC_TYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_CB_NAME__STRING = DATA_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_CDC_ENUM__STRING = DATA_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DA_COUNT__STRING = DATA_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DATA_NAME__STRING = DATA_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DATA_SET_NAME__STRING = DATA_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_ENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_EMPTY__STRING = DATA_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_EXTENSION_CDC_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = DATA_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_FULL_DO_NAME__STRING = DATA_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_IED_NAME__STRING = DATA_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = DATA_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_LD_INST__STRING = DATA_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_LD_INST_OR_EMPTY__STRING = DATA_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_LD_NAME__STRING = DATA_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_LLN0_ENUM__STRING = DATA_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_LN_CLASS_ENUM__STRING = DATA_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_LN_INST__STRING = DATA_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_LN_INST_OR_EMPTY__STRING = DATA_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_LPHD_ENUM__STRING = DATA_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_LINE_TYPE__STRING = DATA_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_LOG_NAME__STRING = DATA_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_MESSAGE_ID__STRING = DATA_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_NAME__STRING = DATA_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_NAMESPACE_NAME__STRING = DATA_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = DATA_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PADDR__STRING = DATA_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PTYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = DATA_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = DATA_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PREFIX__STRING = DATA_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PROCESS_NAME__STRING = DATA_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_PROCESS_TYPE__STRING = DATA_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_RED_PROT_ENUM__STRING = DATA_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_REF__STRING = DATA_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_RELEASE__BIGINTEGER = DATA_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_RESTR_NAME1ST_L__STRING = DATA_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_RESTR_NAME1ST_U__STRING = DATA_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_REVISION__STRING = DATA_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_RIGHT_ENUM__STRING = DATA_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_SDO_COUNT__STRING = DATA_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_SUB_DATA_NAME__STRING = DATA_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = DATA_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = DATA_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_VERSION__STRING = DATA_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = DATA_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Object name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALIDATE_DATA_OBJECT_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = DATA_OBJECT___VALIDATE_DATA_OBJECT_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Data Object name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALIDATE_DATA_OBJECT_NAME_VALID__DIAGNOSTICCHAIN_MAP = DATA_OBJECT___VALIDATE_DATA_OBJECT_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate DO type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALIDATE_DO_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = DATA_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate DO type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO___VALIDATE_DO_TYPE_VALID__DIAGNOSTICCHAIN_MAP = DATA_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>DO</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_OPERATION_COUNT = DATA_OBJECT_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__LINE_NUMBER = ID_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__PRIVATE = ID_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__TEXT = ID_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__ANY = ID_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__ANY_ATTRIBUTE = ID_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__ID = ID_NAMING__ID;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__DESC = ID_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Cdc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__CDC = ID_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ied Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__IED_TYPE = ID_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>DA</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__DA = ID_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Referred By DO</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__REFERRED_BY_DO = ID_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Data Type Templates</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__DATA_TYPE_TEMPLATES = ID_NAMING_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>SDO</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__SDO = ID_NAMING_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Referred By SDO</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE__REFERRED_BY_SDO = ID_NAMING_FEATURE_COUNT + 6;

    /**
	 * The number of structural features of the '<em>DO Type</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE_FEATURE_COUNT = ID_NAMING_FEATURE_COUNT + 7;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_ACCESS_POINT_NAME__STRING = ID_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_ACSI_NAME__STRING = ID_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_ANY_NAME__STRING = ID_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_ASSOCIATION_ID__STRING = ID_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_AUTHENTICATION_ENUM__STRING = ID_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_BASIC_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_CB_NAME__STRING = ID_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DA_COUNT__STRING = ID_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DATA_NAME__STRING = ID_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DATA_SET_NAME__STRING = ID_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_ENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_EMPTY__STRING = ID_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ID_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_FULL_DO_NAME__STRING = ID_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_IED_NAME__STRING = ID_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ID_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_LD_INST__STRING = ID_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_LD_INST_OR_EMPTY__STRING = ID_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_LD_NAME__STRING = ID_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_LLN0_ENUM__STRING = ID_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_LN_INST__STRING = ID_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_LN_INST_OR_EMPTY__STRING = ID_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_LPHD_ENUM__STRING = ID_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_LINE_TYPE__STRING = ID_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_LOG_NAME__STRING = ID_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_MESSAGE_ID__STRING = ID_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_NAME__STRING = ID_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_NAMESPACE_NAME__STRING = ID_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ID_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PADDR__STRING = ID_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ID_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ID_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PREFIX__STRING = ID_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PROCESS_NAME__STRING = ID_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_PROCESS_TYPE__STRING = ID_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_RED_PROT_ENUM__STRING = ID_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_REF__STRING = ID_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_RELEASE__BIGINTEGER = ID_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_RESTR_NAME1ST_L__STRING = ID_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_RESTR_NAME1ST_U__STRING = ID_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_REVISION__STRING = ID_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_RIGHT_ENUM__STRING = ID_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_SDO_COUNT__STRING = ID_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_SUB_DATA_NAME__STRING = ID_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ID_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ID_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_VERSION__STRING = ID_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ID_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate ID Naming id required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALIDATE_ID_NAMING_ID_REQUIRED__DIAGNOSTICCHAIN_MAP = ID_NAMING___VALIDATE_ID_NAMING_ID_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate ID Naming id valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALIDATE_ID_NAMING_ID_VALID__DIAGNOSTICCHAIN_MAP = ID_NAMING___VALIDATE_ID_NAMING_ID_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate DO Type cdc required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALIDATE_DO_TYPE_CDC_REQUIRED__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate DO Type cdc valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALIDATE_DO_TYPE_CDC_VALID__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate DO Type ied Type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALIDATE_DO_TYPE_IED_TYPE_VALID__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate DO Type at least one SDO or DA required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_TYPE___VALIDATE_DO_TYPE_AT_LEAST_ONE_SDO_OR_DA_REQUIRED__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>DO Type</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DO_TYPE_OPERATION_COUNT = ID_NAMING_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_TYPE_TEMPLATES__LINE_NUMBER = EXPLICIT_LINK_RESOLVER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>DA Type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_TYPE_TEMPLATES__DA_TYPE = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>DO Type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_TYPE_TEMPLATES__DO_TYPE = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Enum Type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_TYPE_TEMPLATES__ENUM_TYPE = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>LNode Type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_TYPE_TEMPLATES__LNODE_TYPE = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>SCL</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_TYPE_TEMPLATES__SCL = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Data Type Templates</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_TYPE_TEMPLATES_FEATURE_COUNT = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_ACCESS_POINT_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_ACSI_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_ANY_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_ASSOCIATION_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_AUTHENTICATION_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_CB_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DA_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DATA_SET_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_FULL_DO_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_LD_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_LD_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_LD_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_LLN0_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_LN_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_LN_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_LPHD_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_LINE_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_LOG_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_MESSAGE_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_NAMESPACE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PADDR__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PREFIX__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PROCESS_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_PROCESS_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_RED_PROT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_REF__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_RELEASE__BIGINTEGER = EXPLICIT_LINK_RESOLVER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_RESTR_NAME1ST_L__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_RESTR_NAME1ST_U__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_REVISION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_RIGHT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_SDO_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_SUB_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_VERSION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Type Templates nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALIDATE_DATA_TYPE_TEMPLATES_NOTHING__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Data Type Templates at least one LNode Type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALIDATE_DATA_TYPE_TEMPLATES_AT_LEAST_ONE_LNODE_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Data Type Templates at least one DO Type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_TEMPLATES___VALIDATE_DATA_TYPE_TEMPLATES_AT_LEAST_ONE_DO_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>Data Type Templates</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_TYPE_TEMPLATES_OPERATION_COUNT = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE__LINE_NUMBER = ID_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE__PRIVATE = ID_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE__TEXT = ID_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE__ANY = ID_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE__ANY_ATTRIBUTE = ID_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE__ID = ID_NAMING__ID;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE__DESC = ID_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Referred By Abstract Data Attribute</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE__REFERRED_BY_ABSTRACT_DATA_ATTRIBUTE = ID_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Data Type Templates</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE__DATA_TYPE_TEMPLATES = ID_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Enum Val</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE__ENUM_VAL = ID_NAMING_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Enum Type</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE_FEATURE_COUNT = ID_NAMING_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_ACCESS_POINT_NAME__STRING = ID_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_ACSI_NAME__STRING = ID_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_ANY_NAME__STRING = ID_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_ASSOCIATION_ID__STRING = ID_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_AUTHENTICATION_ENUM__STRING = ID_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_BASIC_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_CB_NAME__STRING = ID_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DA_COUNT__STRING = ID_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DATA_NAME__STRING = ID_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DATA_SET_NAME__STRING = ID_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_ENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_EMPTY__STRING = ID_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ID_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_FULL_DO_NAME__STRING = ID_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_IED_NAME__STRING = ID_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ID_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_LD_INST__STRING = ID_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_LD_INST_OR_EMPTY__STRING = ID_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_LD_NAME__STRING = ID_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_LLN0_ENUM__STRING = ID_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_LN_INST__STRING = ID_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_LN_INST_OR_EMPTY__STRING = ID_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_LPHD_ENUM__STRING = ID_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_LINE_TYPE__STRING = ID_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_LOG_NAME__STRING = ID_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_MESSAGE_ID__STRING = ID_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_NAME__STRING = ID_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_NAMESPACE_NAME__STRING = ID_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ID_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PADDR__STRING = ID_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ID_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ID_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PREFIX__STRING = ID_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PROCESS_NAME__STRING = ID_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_PROCESS_TYPE__STRING = ID_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_RED_PROT_ENUM__STRING = ID_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_REF__STRING = ID_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_RELEASE__BIGINTEGER = ID_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_RESTR_NAME1ST_L__STRING = ID_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_RESTR_NAME1ST_U__STRING = ID_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_REVISION__STRING = ID_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_RIGHT_ENUM__STRING = ID_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_SDO_COUNT__STRING = ID_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_SUB_DATA_NAME__STRING = ID_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ID_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ID_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_VERSION__STRING = ID_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ID_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate ID Naming id required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALIDATE_ID_NAMING_ID_REQUIRED__DIAGNOSTICCHAIN_MAP = ID_NAMING___VALIDATE_ID_NAMING_ID_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate ID Naming id valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALIDATE_ID_NAMING_ID_VALID__DIAGNOSTICCHAIN_MAP = ID_NAMING___VALIDATE_ID_NAMING_ID_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Enum Type nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALIDATE_ENUM_TYPE_NOTHING__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Enum Type at least one Enum Val required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_TYPE___VALIDATE_ENUM_TYPE_AT_LEAST_ONE_ENUM_VAL_REQUIRED__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Enum Type</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_TYPE_OPERATION_COUNT = ID_NAMING_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_VAL__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Ord</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_VAL__ORD = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Enum Type</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_VAL__ENUM_TYPE = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_VAL__VALUE = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_VAL__DESC = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Enum Val</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_VAL_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Enum Val ord required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_VAL___VALIDATE_ENUM_VAL_ORD_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Enum Val</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ENUM_VAL_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__LINE_NUMBER = ID_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__PRIVATE = ID_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__TEXT = ID_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__ANY = ID_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__ANY_ATTRIBUTE = ID_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__ID = ID_NAMING__ID;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__DESC = ID_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Ied Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__IED_TYPE = ID_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__LN_CLASS = ID_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>DO</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__DO = ID_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Data Type Templates</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__DATA_TYPE_TEMPLATES = ID_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Referred By Any LN</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE__REFERRED_BY_ANY_LN = ID_NAMING_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>LNode Type</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE_FEATURE_COUNT = ID_NAMING_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_ACCESS_POINT_NAME__STRING = ID_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_ACSI_NAME__STRING = ID_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_ANY_NAME__STRING = ID_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_ASSOCIATION_ID__STRING = ID_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_AUTHENTICATION_ENUM__STRING = ID_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_BASIC_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_CB_NAME__STRING = ID_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DA_COUNT__STRING = ID_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DATA_NAME__STRING = ID_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DATA_SET_NAME__STRING = ID_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_ENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ID_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_EMPTY__STRING = ID_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ID_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_FULL_DO_NAME__STRING = ID_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_IED_NAME__STRING = ID_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ID_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_LD_INST__STRING = ID_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_LD_INST_OR_EMPTY__STRING = ID_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_LD_NAME__STRING = ID_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_LLN0_ENUM__STRING = ID_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_LN_INST__STRING = ID_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_LN_INST_OR_EMPTY__STRING = ID_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_LPHD_ENUM__STRING = ID_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_LINE_TYPE__STRING = ID_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_LOG_NAME__STRING = ID_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_MESSAGE_ID__STRING = ID_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_NAME__STRING = ID_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_NAMESPACE_NAME__STRING = ID_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ID_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PADDR__STRING = ID_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ID_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ID_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ID_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PREFIX__STRING = ID_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PROCESS_NAME__STRING = ID_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_PROCESS_TYPE__STRING = ID_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_RED_PROT_ENUM__STRING = ID_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_REF__STRING = ID_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_RELEASE__BIGINTEGER = ID_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_RESTR_NAME1ST_L__STRING = ID_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_RESTR_NAME1ST_U__STRING = ID_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_REVISION__STRING = ID_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_RIGHT_ENUM__STRING = ID_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_SDO_COUNT__STRING = ID_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_SUB_DATA_NAME__STRING = ID_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ID_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ID_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_VERSION__STRING = ID_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ID_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate ID Naming id required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALIDATE_ID_NAMING_ID_REQUIRED__DIAGNOSTICCHAIN_MAP = ID_NAMING___VALIDATE_ID_NAMING_ID_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate ID Naming id valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALIDATE_ID_NAMING_ID_VALID__DIAGNOSTICCHAIN_MAP = ID_NAMING___VALIDATE_ID_NAMING_ID_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Type ln Class required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALIDATE_LNODE_TYPE_LN_CLASS_REQUIRED__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate LNode Type ln Class valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALIDATE_LNODE_TYPE_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate History at least one DO required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE_TYPE___VALIDATE_HISTORY_AT_LEAST_ONE_DO_REQUIRED__DIAGNOSTICCHAIN_MAP = ID_NAMING_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>LNode Type</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_TYPE_OPERATION_COUNT = ID_NAMING_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROT_NS__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROT_NS__TYPE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>DA</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROT_NS__DA = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>DA Type</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROT_NS__DA_TYPE = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROT_NS__VALUE = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Prot Ns</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROT_NS_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Prot Ns value required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALIDATE_PROT_NS_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Prot Ns value valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALIDATE_PROT_NS_VALUE_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Prot Ns type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROT_NS___VALIDATE_PROT_NS_TYPE_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>Prot Ns</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROT_NS_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__COUNT = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__TYPE = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>DO Type</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__DO_TYPE = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__NAME = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Refers To DO Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO__REFERS_TO_DO_TYPE = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>SDO</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate SDO name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALIDATE_SDO_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate SDO name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALIDATE_SDO_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate SDO type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALIDATE_SDO_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate SDO type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALIDATE_SDO_TYPE_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate SDO count valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDO___VALIDATE_SDO_COUNT_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 4;

				/**
	 * The number of operations of the '<em>SDO</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDO_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VAL__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>SGroup</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VAL__SGROUP = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Abstract Data Attribute</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VAL__ABSTRACT_DATA_ATTRIBUTE = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>DAI</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VAL__DAI = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VAL__VALUE = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Val</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VAL_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Val sGroup valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAL___VALIDATE_VAL_SGROUP_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Val</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VAL_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.MinTimeImpl <em>Min Time</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.MinTimeImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getMinTime()
	 * @generated
	 */
    int MIN_TIME = 156;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.MaxTimeImpl <em>Max Time</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.MaxTimeImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getMaxTime()
	 * @generated
	 */
    int MAX_TIME = 157;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_CONTROL__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>LDevice</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_CONTROL__LDEVICE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Access Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_CONTROL_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Access Control nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_CONTROL___VALIDATE_ACCESS_CONTROL_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Access Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_CONTROL_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Clock</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__CLOCK = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Kdc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__KDC = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Router</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__ROUTER = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>IED</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__IED = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>LN</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__LN = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>SMV Security</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__SMV_SECURITY = UN_NAMING_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Server At</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__SERVER_AT = UN_NAMING_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Server</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__SERVER = UN_NAMING_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Services</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__SERVICES = UN_NAMING_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>GOOSE Security</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__GOOSE_SECURITY = UN_NAMING_FEATURE_COUNT + 9;

    /**
	 * The feature id for the '<em><b>Referred By Server At</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__REFERRED_BY_SERVER_AT = UN_NAMING_FEATURE_COUNT + 10;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__NAME = UN_NAMING_FEATURE_COUNT + 11;

    /**
	 * The feature id for the '<em><b>Referred By Connected AP</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__REFERRED_BY_CONNECTED_AP = UN_NAMING_FEATURE_COUNT + 12;

    /**
	 * The feature id for the '<em><b>Referred By KDC</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT__REFERRED_BY_KDC = UN_NAMING_FEATURE_COUNT + 13;

    /**
	 * The number of structural features of the '<em>Access Point</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 14;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Access Point name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALIDATE_ACCESS_POINT_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Access Point name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALIDATE_ACCESS_POINT_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Access Point restriction on content</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALIDATE_ACCESS_POINT_RESTRICTION_ON_CONTENT__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Access Point at most securities</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALIDATE_ACCESS_POINT_AT_MOST_SECURITIES__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate Access Point securities allowed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCESS_POINT___VALIDATE_ACCESS_POINT_SECURITIES_ALLOWED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 4;

				/**
	 * The number of operations of the '<em>Access Point</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACCESS_POINT_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__INST = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__LN_CLASS = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Ln Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__LN_TYPE = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Refers To LNode Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__REFERS_TO_LNODE_TYPE = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Inputs</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__INPUTS = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Log</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__LOG = UN_NAMING_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>DOI</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__DOI = UN_NAMING_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Report Control</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__REPORT_CONTROL = UN_NAMING_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Log Control</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__LOG_CONTROL = UN_NAMING_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>Data Set</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__DATA_SET = UN_NAMING_FEATURE_COUNT + 9;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__REFERRED_BY_FCDA = UN_NAMING_FEATURE_COUNT + 10;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__REFERRED_BY_EXT_REF = UN_NAMING_FEATURE_COUNT + 11;

    /**
	 * The feature id for the '<em><b>Referred By Client LN</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__REFERRED_BY_CLIENT_LN = UN_NAMING_FEATURE_COUNT + 12;

    /**
	 * The feature id for the '<em><b>Referred By Log Control</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__REFERRED_BY_LOG_CONTROL = UN_NAMING_FEATURE_COUNT + 13;

    /**
	 * The feature id for the '<em><b>Referred By Association</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__REFERRED_BY_ASSOCIATION = UN_NAMING_FEATURE_COUNT + 14;

    /**
	 * The feature id for the '<em><b>Referred IED Name</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN__REFERRED_IED_NAME = UN_NAMING_FEATURE_COUNT + 15;

    /**
	 * The number of structural features of the '<em>Any LN</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 16;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate LN ln Class required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALIDATE_LN_LN_CLASS_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate LN ln Class valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALIDATE_LN_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate LN inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALIDATE_LN_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Any LN ln Type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALIDATE_ANY_LN_LN_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate Any LN ln Type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ANY_LN___VALIDATE_ANY_LN_LN_TYPE_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 4;

				/**
	 * The number of operations of the '<em>Any LN</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ANY_LN_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__LINE_NUMBER = BASE_ELEMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__PRIVATE = BASE_ELEMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__TEXT = BASE_ELEMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__ANY = BASE_ELEMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__ANY_ATTRIBUTE = BASE_ELEMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Association ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__ASSOCIATION_ID = BASE_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ied Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__IED_NAME = BASE_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__KIND = BASE_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Ld Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__LD_INST = BASE_ELEMENT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__LN_CLASS = BASE_ELEMENT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Ln Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__LN_INST = BASE_ELEMENT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__PREFIX = BASE_ELEMENT_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Server</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__SERVER = BASE_ELEMENT_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Refers To Any LN</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION__REFERS_TO_ANY_LN = BASE_ELEMENT_FEATURE_COUNT + 8;

    /**
	 * The number of structural features of the '<em>Association</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION_FEATURE_COUNT = BASE_ELEMENT_FEATURE_COUNT + 9;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_ACCESS_POINT_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_ACSI_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_ANY_NAME__STRING = BASE_ELEMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_ASSOCIATION_ID__STRING = BASE_ELEMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_AUTHENTICATION_ENUM__STRING = BASE_ELEMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_CB_NAME__STRING = BASE_ELEMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DA_COUNT__STRING = BASE_ELEMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DATA_SET_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_FULL_DO_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_LD_INST__STRING = BASE_ELEMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_LD_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_LD_NAME__STRING = BASE_ELEMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_LLN0_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_LN_INST__STRING = BASE_ELEMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_LN_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_LPHD_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_LINE_TYPE__STRING = BASE_ELEMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_LOG_NAME__STRING = BASE_ELEMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_MESSAGE_ID__STRING = BASE_ELEMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_NAMESPACE_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PADDR__STRING = BASE_ELEMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = BASE_ELEMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PREFIX__STRING = BASE_ELEMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PROCESS_NAME__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_PROCESS_TYPE__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_RED_PROT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_REF__STRING = BASE_ELEMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_RELEASE__BIGINTEGER = BASE_ELEMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_RESTR_NAME1ST_L__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_RESTR_NAME1ST_U__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_REVISION__STRING = BASE_ELEMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_RIGHT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_SDO_COUNT__STRING = BASE_ELEMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_SUB_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = BASE_ELEMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = BASE_ELEMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_VERSION__STRING = BASE_ELEMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = BASE_ELEMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Association kind required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALIDATE_ASSOCIATION_KIND_REQUIRED__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Association association ID valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION___VALIDATE_ASSOCIATION_ASSOCIATION_ID_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Association</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ASSOCIATION_OPERATION_COUNT = BASE_ELEMENT_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int AUTHENTICATION__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Certificate</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int AUTHENTICATION__CERTIFICATE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>None</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int AUTHENTICATION__NONE = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Password</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int AUTHENTICATION__PASSWORD = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Strong</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int AUTHENTICATION__STRONG = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Weak</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int AUTHENTICATION__WEAK = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Server</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int AUTHENTICATION__SERVER = SCL_OBJECT_FEATURE_COUNT + 5;

    /**
	 * The number of structural features of the '<em>Authentication</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int AUTHENTICATION_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 6;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AUTHENTICATION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Authentication</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int AUTHENTICATION_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__LINE_NUMBER = NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__PRIVATE = NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__TEXT = NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__ANY = NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__ANY_ATTRIBUTE = NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__NAME = NAMING__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__DESC = NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Serial Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__SERIAL_NUMBER = NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Xfer Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__XFER_NUMBER = NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Subject</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__SUBJECT = NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Issuer Name</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE__ISSUER_NAME = NAMING_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Certificate</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE_FEATURE_COUNT = NAMING_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_ACCESS_POINT_NAME__STRING = NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_ACSI_NAME__STRING = NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_ANY_NAME__STRING = NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_ASSOCIATION_ID__STRING = NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_AUTHENTICATION_ENUM__STRING = NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_BASIC_TYPE_ENUM__STRING = NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_CB_NAME__STRING = NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_CDC_ENUM__STRING = NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DA_COUNT__STRING = NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DATA_NAME__STRING = NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DATA_SET_NAME__STRING = NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_ENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_EMPTY__STRING = NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_FULL_DO_NAME__STRING = NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_IED_NAME__STRING = NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_LD_INST__STRING = NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_LD_INST_OR_EMPTY__STRING = NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_LD_NAME__STRING = NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_LLN0_ENUM__STRING = NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_LN_CLASS_ENUM__STRING = NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_LN_INST__STRING = NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_LN_INST_OR_EMPTY__STRING = NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_LPHD_ENUM__STRING = NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_LINE_TYPE__STRING = NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_LOG_NAME__STRING = NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_MESSAGE_ID__STRING = NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_NAME__STRING = NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_NAMESPACE_NAME__STRING = NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PADDR__STRING = NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PTYPE_ENUM__STRING = NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PREFIX__STRING = NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PROCESS_NAME__STRING = NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_PROCESS_TYPE__STRING = NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_RED_PROT_ENUM__STRING = NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_REF__STRING = NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_RELEASE__BIGINTEGER = NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_RESTR_NAME1ST_L__STRING = NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_RESTR_NAME1ST_U__STRING = NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_REVISION__STRING = NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_RIGHT_ENUM__STRING = NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_SDO_COUNT__STRING = NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_SUB_DATA_NAME__STRING = NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_VERSION__STRING = NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = NAMING___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = NAMING___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate serial Number required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALIDATE_CERTIFICATE_SERIAL_NUMBER_REQUIRED__DIAGNOSTICCHAIN_MAP = NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Certificate serial Number valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALIDATE_CERTIFICATE_SERIAL_NUMBER_VALID__DIAGNOSTICCHAIN_MAP = NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Certificate xfer Number valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALIDATE_CERTIFICATE_XFER_NUMBER_VALID__DIAGNOSTICCHAIN_MAP = NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Certificate one Subject required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALIDATE_CERTIFICATE_ONE_SUBJECT_REQUIRED__DIAGNOSTICCHAIN_MAP = NAMING_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate Certificate one Issuer Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERTIFICATE___VALIDATE_CERTIFICATE_ONE_ISSUER_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = NAMING_OPERATION_COUNT + 4;

				/**
	 * The number of operations of the '<em>Certificate</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERTIFICATE_OPERATION_COUNT = NAMING_OPERATION_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN__LINE_NUMBER = EXPLICIT_LINK_RESOLVER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Ap Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN__AP_REF = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ied Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN__IED_NAME = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Ld Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN__LD_INST = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN__LN_CLASS = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Ln Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN__LN_INST = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN__PREFIX = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Rpt Enabled</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN__RPT_ENABLED = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN__DESC = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Refers To Any LN</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN__REFERS_TO_ANY_LN = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 8;

    /**
	 * The number of structural features of the '<em>Client LN</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN_FEATURE_COUNT = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 9;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_ACCESS_POINT_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_ACSI_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_ANY_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_ASSOCIATION_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_AUTHENTICATION_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_CB_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DA_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DATA_SET_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_FULL_DO_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_LD_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_LD_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_LD_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_LLN0_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_LN_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_LN_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_LPHD_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_LINE_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_LOG_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_MESSAGE_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_NAMESPACE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PADDR__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PREFIX__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PROCESS_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_PROCESS_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_RED_PROT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_REF__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_RELEASE__BIGINTEGER = EXPLICIT_LINK_RESOLVER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_RESTR_NAME1ST_L__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_RESTR_NAME1ST_U__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_REVISION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_RIGHT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_SDO_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_SUB_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_VERSION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Client LN ap Ref valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_AP_REF_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Client LN ied Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_IED_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Client LN ied Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_IED_NAME_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Client LN ld Inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_LD_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate Client LN ld Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_LD_INST_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 4;

				/**
	 * The operation id for the '<em>Validate Client LN ln Class required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_LN_CLASS_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 5;

				/**
	 * The operation id for the '<em>Validate Client LN ln Class valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 6;

				/**
	 * The operation id for the '<em>Validate Client LN ln Inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_LN_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 7;

				/**
	 * The operation id for the '<em>Validate Client LN ln Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_LN_INST_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 8;

				/**
	 * The operation id for the '<em>Validate Client LN ln Inst empty for LLN0</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_LN_INST_EMPTY_FOR_LLN0__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 9;

				/**
	 * The operation id for the '<em>Validate Client LN prefix valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_LN___VALIDATE_CLIENT_LN_PREFIX_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 10;

				/**
	 * The number of operations of the '<em>Client LN</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_LN_OPERATION_COUNT = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 11;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Buf Report</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__BUF_REPORT = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Goose</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__GOOSE = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Gsse</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__GSSE = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Max Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__MAX_ATTRIBUTES = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Max GOOSE</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__MAX_GOOSE = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Max Reports</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__MAX_REPORTS = SCL_OBJECT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Max SMV</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__MAX_SMV = SCL_OBJECT_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Read Log</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__READ_LOG = SCL_OBJECT_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Supports Ld Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__SUPPORTS_LD_NAME = SCL_OBJECT_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>Sv</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__SV = SCL_OBJECT_FEATURE_COUNT + 9;

    /**
	 * The feature id for the '<em><b>Unbuf Report</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__UNBUF_REPORT = SCL_OBJECT_FEATURE_COUNT + 10;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__SERVICES = SCL_OBJECT_FEATURE_COUNT + 11;

    /**
	 * The feature id for the '<em><b>Time Sync Prot</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES__TIME_SYNC_PROT = SCL_OBJECT_FEATURE_COUNT + 12;

    /**
	 * The number of structural features of the '<em>Client Services</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 13;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Client Services max Attributes valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALIDATE_CLIENT_SERVICES_MAX_ATTRIBUTES_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Client Services max Reports valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALIDATE_CLIENT_SERVICES_MAX_REPORTS_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Client Services max GOOSE valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALIDATE_CLIENT_SERVICES_MAX_GOOSE_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Client Services max SMV valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLIENT_SERVICES___VALIDATE_CLIENT_SERVICES_MAX_SMV_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>Client Services</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CLIENT_SERVICES_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMM_PROT__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Ipv6</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMM_PROT__IPV6 = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMM_PROT__SERVICES = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Comm Prot</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMM_PROT_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Comm Prot nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMM_PROT___VALIDATE_COMM_PROT_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Comm Prot</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMM_PROT_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX__MAX = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Service With Max</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Service With Max</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 2;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceWithMaxAndMaxAttributesImpl <em>Service With Max And Max Attributes</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceWithMaxAndMaxAttributesImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceWithMaxAndMaxAttributes()
	 * @generated
	 */
    int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES = 148;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES__LINE_NUMBER = SERVICE_WITH_MAX__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES__MAX = SERVICE_WITH_MAX__MAX;

    /**
	 * The feature id for the '<em><b>Max Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES__MAX_ATTRIBUTES = SERVICE_WITH_MAX_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Service With Max And Max Attributes</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES_FEATURE_COUNT = SERVICE_WITH_MAX_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LD_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LN_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PADDR__STRING = SERVICE_WITH_MAX___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREFIX__STRING = SERVICE_WITH_MAX___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_REF__STRING = SERVICE_WITH_MAX___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_MAX___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_REVISION__STRING = SERVICE_WITH_MAX___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_VERSION__STRING = SERVICE_WITH_MAX___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_MAX___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max Attributes valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALIDATE_SERVICE_WITH_MAX_MAX_ATTRIBUTES_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Service With Max And Max Attributes</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES_OPERATION_COUNT = SERVICE_WITH_MAX_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceForConfDataSetImpl <em>Service For Conf Data Set</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceForConfDataSetImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceForConfDataSet()
	 * @generated
	 */
    int SERVICE_FOR_CONF_DATA_SET = 150;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_FOR_CONF_DATA_SET__LINE_NUMBER = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_FOR_CONF_DATA_SET__MAX = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES__MAX;

    /**
	 * The feature id for the '<em><b>Max Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_FOR_CONF_DATA_SET__MAX_ATTRIBUTES = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES__MAX_ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Modify</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_FOR_CONF_DATA_SET__MODIFY = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Service For Conf Data Set</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_FOR_CONF_DATA_SET_FEATURE_COUNT = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EMPTY__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LD_INST__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LN_INST__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PADDR__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREFIX__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_REF__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_REVISION__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_VERSION__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max Attributes valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_ATTRIBUTES_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALIDATE_SERVICE_WITH_MAX_MAX_ATTRIBUTES_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service For Conf Data Set nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FOR_CONF_DATA_SET___VALIDATE_SERVICE_FOR_CONF_DATA_SET_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Service For Conf Data Set</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_FOR_CONF_DATA_SET_OPERATION_COUNT = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_DATA_SET__LINE_NUMBER = SERVICE_FOR_CONF_DATA_SET__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_DATA_SET__MAX = SERVICE_FOR_CONF_DATA_SET__MAX;

    /**
	 * The feature id for the '<em><b>Max Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_DATA_SET__MAX_ATTRIBUTES = SERVICE_FOR_CONF_DATA_SET__MAX_ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Modify</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_DATA_SET__MODIFY = SERVICE_FOR_CONF_DATA_SET__MODIFY;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_DATA_SET__SERVICES = SERVICE_FOR_CONF_DATA_SET_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Conf Data Set</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_DATA_SET_FEATURE_COUNT = SERVICE_FOR_CONF_DATA_SET_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_ACSI_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_ANY_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_CB_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_CDC_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DA_COUNT__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DATA_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_EMPTY__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_IED_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_LD_INST__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_LD_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_LLN0_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_LN_INST__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_LPHD_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_LINE_TYPE__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_LOG_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_MESSAGE_ID__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PADDR__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PREFIX__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PROCESS_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_REF__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_REVISION__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_SDO_COUNT__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_VERSION__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_FOR_CONF_DATA_SET___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_FOR_CONF_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_FOR_CONF_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max Attributes valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_ATTRIBUTES_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_FOR_CONF_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_ATTRIBUTES_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service For Conf Data Set nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_DATA_SET___VALIDATE_SERVICE_FOR_CONF_DATA_SET_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_FOR_CONF_DATA_SET___VALIDATE_SERVICE_FOR_CONF_DATA_SET_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Conf Data Set</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_DATA_SET_OPERATION_COUNT = SERVICE_FOR_CONF_DATA_SET_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LNS__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Fix Ln Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LNS__FIX_LN_INST = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Fix Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LNS__FIX_PREFIX = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LNS__SERVICES = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Conf LNs</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LNS_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Conf LNs nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LNS___VALIDATE_CONF_LNS_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Conf LNs</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LNS_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceYesNoImpl <em>Service Yes No</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceYesNoImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceYesNo()
	 * @generated
	 */
    int SERVICE_YES_NO = 144;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_YES_NO__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The number of structural features of the '<em>Service Yes No</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_YES_NO_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Service Yes No</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_YES_NO_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LD_NAME__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LD_NAME__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Conf Ld Name</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LD_NAME_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LD_NAME___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Conf Ld Name</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LD_NAME_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceWithMaxNonZeroImpl <em>Service With Max Non Zero</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceWithMaxNonZeroImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceWithMaxNonZero()
	 * @generated
	 */
    int SERVICE_WITH_MAX_NON_ZERO = 146;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_NON_ZERO__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_NON_ZERO__MAX = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Service With Max Non Zero</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_NON_ZERO_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max Non Zero max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALIDATE_SERVICE_WITH_MAX_NON_ZERO_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Service With Max Non Zero max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_NON_ZERO___VALIDATE_SERVICE_WITH_MAX_NON_ZERO_MAX_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Service With Max Non Zero</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_NON_ZERO_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LOG_CONTROL__LINE_NUMBER = SERVICE_WITH_MAX_NON_ZERO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LOG_CONTROL__MAX = SERVICE_WITH_MAX_NON_ZERO__MAX;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LOG_CONTROL__SERVICES = SERVICE_WITH_MAX_NON_ZERO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Conf Log Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LOG_CONTROL_FEATURE_COUNT = SERVICE_WITH_MAX_NON_ZERO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_EMPTY__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_LD_INST__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_LN_INST__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PADDR__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PREFIX__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_REF__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_REVISION__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_VERSION__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max Non Zero max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALIDATE_SERVICE_WITH_MAX_NON_ZERO_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_NON_ZERO___VALIDATE_SERVICE_WITH_MAX_NON_ZERO_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max Non Zero max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_LOG_CONTROL___VALIDATE_SERVICE_WITH_MAX_NON_ZERO_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_NON_ZERO___VALIDATE_SERVICE_WITH_MAX_NON_ZERO_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Conf Log Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_LOG_CONTROL_OPERATION_COUNT = SERVICE_WITH_MAX_NON_ZERO_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceConfReportControlImpl <em>Service Conf Report Control</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceConfReportControlImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceConfReportControl()
	 * @generated
	 */
    int SERVICE_CONF_REPORT_CONTROL = 147;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_CONF_REPORT_CONTROL__LINE_NUMBER = SERVICE_WITH_MAX__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_CONF_REPORT_CONTROL__MAX = SERVICE_WITH_MAX__MAX;

    /**
	 * The feature id for the '<em><b>Buf Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_CONF_REPORT_CONTROL__BUF_MODE = SERVICE_WITH_MAX_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Buf Conf</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_CONF_REPORT_CONTROL__BUF_CONF = SERVICE_WITH_MAX_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Service Conf Report Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_CONF_REPORT_CONTROL_FEATURE_COUNT = SERVICE_WITH_MAX_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LD_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LN_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PADDR__STRING = SERVICE_WITH_MAX___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREFIX__STRING = SERVICE_WITH_MAX___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_REF__STRING = SERVICE_WITH_MAX___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_MAX___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_REVISION__STRING = SERVICE_WITH_MAX___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_VERSION__STRING = SERVICE_WITH_MAX___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_MAX___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service Conf Report Control nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_CONF_REPORT_CONTROL___VALIDATE_SERVICE_CONF_REPORT_CONTROL_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Service Conf Report Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_CONF_REPORT_CONTROL_OPERATION_COUNT = SERVICE_WITH_MAX_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_REPORT_CONTROL__LINE_NUMBER = SERVICE_CONF_REPORT_CONTROL__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_REPORT_CONTROL__MAX = SERVICE_CONF_REPORT_CONTROL__MAX;

    /**
	 * The feature id for the '<em><b>Buf Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_REPORT_CONTROL__BUF_MODE = SERVICE_CONF_REPORT_CONTROL__BUF_MODE;

    /**
	 * The feature id for the '<em><b>Buf Conf</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_REPORT_CONTROL__BUF_CONF = SERVICE_CONF_REPORT_CONTROL__BUF_CONF;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_REPORT_CONTROL__SERVICES = SERVICE_CONF_REPORT_CONTROL_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Conf Report Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_REPORT_CONTROL_FEATURE_COUNT = SERVICE_CONF_REPORT_CONTROL_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_ACSI_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_ANY_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_CB_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_CDC_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DA_COUNT__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DATA_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_EMPTY__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_IED_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_LD_INST__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_LD_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_LLN0_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_LN_INST__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_LPHD_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_LINE_TYPE__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_LOG_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_MESSAGE_ID__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PADDR__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PREFIX__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PROCESS_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_REF__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_REVISION__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_SDO_COUNT__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_VERSION__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_CONF_REPORT_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_CONF_REPORT_CONTROL___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_CONF_REPORT_CONTROL___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service Conf Report Control nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_REPORT_CONTROL___VALIDATE_SERVICE_CONF_REPORT_CONTROL_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_CONF_REPORT_CONTROL___VALIDATE_SERVICE_CONF_REPORT_CONTROL_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Conf Report Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_REPORT_CONTROL_OPERATION_COUNT = SERVICE_CONF_REPORT_CONTROL_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_SG__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Resv Tms</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_SG__RESV_TMS = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Setting Groups</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_SG__SETTING_GROUPS = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Conf SG</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_SG_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SG___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Conf SG</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_SG_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_SIG_REF__LINE_NUMBER = SERVICE_WITH_MAX_NON_ZERO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_SIG_REF__MAX = SERVICE_WITH_MAX_NON_ZERO__MAX;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_SIG_REF__SERVICES = SERVICE_WITH_MAX_NON_ZERO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Conf Sig Ref</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_SIG_REF_FEATURE_COUNT = SERVICE_WITH_MAX_NON_ZERO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_EMPTY__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_LD_INST__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_LN_INST__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PADDR__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PREFIX__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_REF__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_REVISION__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_VERSION__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_MAX_NON_ZERO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max Non Zero max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALIDATE_SERVICE_WITH_MAX_NON_ZERO_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_NON_ZERO___VALIDATE_SERVICE_WITH_MAX_NON_ZERO_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max Non Zero max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONF_SIG_REF___VALIDATE_SERVICE_WITH_MAX_NON_ZERO_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_NON_ZERO___VALIDATE_SERVICE_WITH_MAX_NON_ZERO_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Conf Sig Ref</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONF_SIG_REF_OPERATION_COUNT = SERVICE_WITH_MAX_NON_ZERO_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL__DAT_SET = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Refers To Data Set</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL__REFERS_TO_DATA_SET = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL__NAME = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Control name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Control name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Control dat Set valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__LINE_NUMBER = CONTROL__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__PRIVATE = CONTROL__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__TEXT = CONTROL__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__ANY = CONTROL__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__ANY_ATTRIBUTE = CONTROL__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__DESC = CONTROL__DESC;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__DAT_SET = CONTROL__DAT_SET;

    /**
	 * The feature id for the '<em><b>Refers To Data Set</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__REFERS_TO_DATA_SET = CONTROL__REFERS_TO_DATA_SET;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__NAME = CONTROL__NAME;

    /**
	 * The feature id for the '<em><b>Conf Rev</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__CONF_REV = CONTROL_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>IED Name</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__IED_NAME = CONTROL_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Referred By Control Block</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__REFERRED_BY_CONTROL_BLOCK = CONTROL_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Protocol</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME__PROTOCOL = CONTROL_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Control With IED Name</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME_FEATURE_COUNT = CONTROL_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_ACCESS_POINT_NAME__STRING = CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_ACSI_NAME__STRING = CONTROL___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_ANY_NAME__STRING = CONTROL___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_ASSOCIATION_ID__STRING = CONTROL___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_AUTHENTICATION_ENUM__STRING = CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_BASIC_TYPE_ENUM__STRING = CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_CB_NAME__STRING = CONTROL___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_CDC_ENUM__STRING = CONTROL___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DA_COUNT__STRING = CONTROL___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DATA_NAME__STRING = CONTROL___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DATA_SET_NAME__STRING = CONTROL___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_ENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_EMPTY__STRING = CONTROL___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_FULL_DO_NAME__STRING = CONTROL___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_IED_NAME__STRING = CONTROL___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_LD_INST__STRING = CONTROL___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_LD_INST_OR_EMPTY__STRING = CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_LD_NAME__STRING = CONTROL___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_LLN0_ENUM__STRING = CONTROL___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_LN_CLASS_ENUM__STRING = CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_LN_INST__STRING = CONTROL___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_LN_INST_OR_EMPTY__STRING = CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_LPHD_ENUM__STRING = CONTROL___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_LINE_TYPE__STRING = CONTROL___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_LOG_NAME__STRING = CONTROL___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_MESSAGE_ID__STRING = CONTROL___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_NAME__STRING = CONTROL___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_NAMESPACE_NAME__STRING = CONTROL___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PADDR__STRING = CONTROL___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PTYPE_ENUM__STRING = CONTROL___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PREFIX__STRING = CONTROL___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PROCESS_NAME__STRING = CONTROL___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_PROCESS_TYPE__STRING = CONTROL___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_RED_PROT_ENUM__STRING = CONTROL___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_REF__STRING = CONTROL___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_RELEASE__BIGINTEGER = CONTROL___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_RESTR_NAME1ST_L__STRING = CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_RESTR_NAME1ST_U__STRING = CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_REVISION__STRING = CONTROL___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_RIGHT_ENUM__STRING = CONTROL___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_SDO_COUNT__STRING = CONTROL___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_SUB_DATA_NAME__STRING = CONTROL___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_VERSION__STRING = CONTROL___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Control name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control dat Set valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP = CONTROL___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control With IED Name conf Rev unsigned Int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_WITH_IED_NAME_CONF_REV_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = CONTROL_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Control With IED Name</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_IED_NAME_OPERATION_COUNT = CONTROL_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__LINE_NUMBER = CONTROL__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__PRIVATE = CONTROL__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__TEXT = CONTROL__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__ANY = CONTROL__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__ANY_ATTRIBUTE = CONTROL__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__DESC = CONTROL__DESC;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__DAT_SET = CONTROL__DAT_SET;

    /**
	 * The feature id for the '<em><b>Refers To Data Set</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__REFERS_TO_DATA_SET = CONTROL__REFERS_TO_DATA_SET;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__NAME = CONTROL__NAME;

    /**
	 * The feature id for the '<em><b>Intg Pd</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__INTG_PD = CONTROL_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Trg Ops</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT__TRG_OPS = CONTROL_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Control With Trigger Opt</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT = CONTROL_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ACCESS_POINT_NAME__STRING = CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ACSI_NAME__STRING = CONTROL___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ANY_NAME__STRING = CONTROL___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ASSOCIATION_ID__STRING = CONTROL___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_AUTHENTICATION_ENUM__STRING = CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_BASIC_TYPE_ENUM__STRING = CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_CB_NAME__STRING = CONTROL___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_CDC_ENUM__STRING = CONTROL___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DA_COUNT__STRING = CONTROL___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DATA_NAME__STRING = CONTROL___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DATA_SET_NAME__STRING = CONTROL___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_ENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EMPTY__STRING = CONTROL___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_FULL_DO_NAME__STRING = CONTROL___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_IED_NAME__STRING = CONTROL___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LD_INST__STRING = CONTROL___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LD_INST_OR_EMPTY__STRING = CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LD_NAME__STRING = CONTROL___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LLN0_ENUM__STRING = CONTROL___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LN_CLASS_ENUM__STRING = CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LN_INST__STRING = CONTROL___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LN_INST_OR_EMPTY__STRING = CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LPHD_ENUM__STRING = CONTROL___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LINE_TYPE__STRING = CONTROL___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LOG_NAME__STRING = CONTROL___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_MESSAGE_ID__STRING = CONTROL___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_NAME__STRING = CONTROL___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_NAMESPACE_NAME__STRING = CONTROL___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PADDR__STRING = CONTROL___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PTYPE_ENUM__STRING = CONTROL___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREFIX__STRING = CONTROL___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PROCESS_NAME__STRING = CONTROL___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PROCESS_TYPE__STRING = CONTROL___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RED_PROT_ENUM__STRING = CONTROL___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_REF__STRING = CONTROL___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RELEASE__BIGINTEGER = CONTROL___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RESTR_NAME1ST_L__STRING = CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RESTR_NAME1ST_U__STRING = CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_REVISION__STRING = CONTROL___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RIGHT_ENUM__STRING = CONTROL___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_SDO_COUNT__STRING = CONTROL___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_SUB_DATA_NAME__STRING = CONTROL___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_VERSION__STRING = CONTROL___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Control name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control dat Set valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP = CONTROL___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control With Trigger Opt intg Pd unsigned int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_WITH_TRIGGER_OPT_INTG_PD_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = CONTROL_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Control With Trigger Opt</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT = CONTROL_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__LINE_NUMBER = DATA_ATTRIBUTE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__PRIVATE = DATA_ATTRIBUTE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__TEXT = DATA_ATTRIBUTE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__ANY = DATA_ATTRIBUTE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__ANY_ATTRIBUTE = DATA_ATTRIBUTE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__DESC = DATA_ATTRIBUTE__DESC;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__REFERRED_BY_FCDA = DATA_ATTRIBUTE__REFERRED_BY_FCDA;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__NAME = DATA_ATTRIBUTE__NAME;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__REFERRED_BY_EXT_REF = DATA_ATTRIBUTE__REFERRED_BY_EXT_REF;

    /**
	 * The feature id for the '<em><b>Ix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__IX = DATA_ATTRIBUTE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>SAddr</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__SADDR = DATA_ATTRIBUTE_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Val Import</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__VAL_IMPORT = DATA_ATTRIBUTE_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Val Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__VAL_KIND = DATA_ATTRIBUTE_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Val</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__VAL = DATA_ATTRIBUTE_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>DOI</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__DOI = DATA_ATTRIBUTE_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>SDI</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI__SDI = DATA_ATTRIBUTE_FEATURE_COUNT + 6;

    /**
	 * The number of structural features of the '<em>DAI</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI_FEATURE_COUNT = DATA_ATTRIBUTE_FEATURE_COUNT + 7;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_ACCESS_POINT_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_ACSI_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_ANY_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_ASSOCIATION_ID__STRING = DATA_ATTRIBUTE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_AUTHENTICATION_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_BASIC_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_CB_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_CDC_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DA_COUNT__STRING = DATA_ATTRIBUTE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DATA_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DATA_SET_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_EMPTY__STRING = DATA_ATTRIBUTE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_EXTENSION_CDC_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_FULL_DO_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_IED_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = DATA_ATTRIBUTE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_LD_INST__STRING = DATA_ATTRIBUTE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_LD_INST_OR_EMPTY__STRING = DATA_ATTRIBUTE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_LD_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_LLN0_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_LN_CLASS_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_LN_INST__STRING = DATA_ATTRIBUTE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_LN_INST_OR_EMPTY__STRING = DATA_ATTRIBUTE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_LPHD_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_LINE_TYPE__STRING = DATA_ATTRIBUTE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_LOG_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_MESSAGE_ID__STRING = DATA_ATTRIBUTE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_NAMESPACE_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PADDR__STRING = DATA_ATTRIBUTE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PTYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PREFIX__STRING = DATA_ATTRIBUTE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PROCESS_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_PROCESS_TYPE__STRING = DATA_ATTRIBUTE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_RED_PROT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_REF__STRING = DATA_ATTRIBUTE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_RELEASE__BIGINTEGER = DATA_ATTRIBUTE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_RESTR_NAME1ST_L__STRING = DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_RESTR_NAME1ST_U__STRING = DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_REVISION__STRING = DATA_ATTRIBUTE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_RIGHT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_SDO_COUNT__STRING = DATA_ATTRIBUTE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_SUB_DATA_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_VERSION__STRING = DATA_ATTRIBUTE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = DATA_ATTRIBUTE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Attribute name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Data Attribute name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate DAI name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALIDATE_DAI_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate DAI name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALIDATE_DAI_NAME_VALID__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate DAI ix valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DAI___VALIDATE_DAI_IX_VALID__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>DAI</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DAI_OPERATION_COUNT = DATA_ATTRIBUTE_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__LINE_NUMBER = DATA_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__PRIVATE = DATA_OBJECT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__TEXT = DATA_OBJECT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__ANY = DATA_OBJECT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__ANY_ATTRIBUTE = DATA_OBJECT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__DESC = DATA_OBJECT__DESC;

    /**
	 * The feature id for the '<em><b>Access Control</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__ACCESS_CONTROL = DATA_OBJECT__ACCESS_CONTROL;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__REFERRED_BY_FCDA = DATA_OBJECT__REFERRED_BY_FCDA;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__NAME = DATA_OBJECT__NAME;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__REFERRED_BY_EXT_REF = DATA_OBJECT__REFERRED_BY_EXT_REF;

    /**
	 * The feature id for the '<em><b>Ix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__IX = DATA_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Any LN</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__ANY_LN = DATA_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>DAI</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__DAI = DATA_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>SDI</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI__SDI = DATA_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>DOI</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI_FEATURE_COUNT = DATA_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_ACCESS_POINT_NAME__STRING = DATA_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_ACSI_NAME__STRING = DATA_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_ANY_NAME__STRING = DATA_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_ASSOCIATION_ID__STRING = DATA_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = DATA_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_AUTHENTICATION_ENUM__STRING = DATA_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_BASIC_TYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_CB_NAME__STRING = DATA_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_CDC_ENUM__STRING = DATA_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DA_COUNT__STRING = DATA_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DATA_NAME__STRING = DATA_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DATA_SET_NAME__STRING = DATA_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_ENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = DATA_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_EMPTY__STRING = DATA_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_EXTENSION_CDC_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = DATA_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_FULL_DO_NAME__STRING = DATA_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_IED_NAME__STRING = DATA_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = DATA_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_LD_INST__STRING = DATA_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_LD_INST_OR_EMPTY__STRING = DATA_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_LD_NAME__STRING = DATA_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_LLN0_ENUM__STRING = DATA_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_LN_CLASS_ENUM__STRING = DATA_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_LN_INST__STRING = DATA_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_LN_INST_OR_EMPTY__STRING = DATA_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_LPHD_ENUM__STRING = DATA_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_LINE_TYPE__STRING = DATA_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_LOG_NAME__STRING = DATA_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_MESSAGE_ID__STRING = DATA_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_NAME__STRING = DATA_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_NAMESPACE_NAME__STRING = DATA_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = DATA_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PADDR__STRING = DATA_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PTYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = DATA_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = DATA_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = DATA_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PREFIX__STRING = DATA_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PROCESS_NAME__STRING = DATA_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_PROCESS_TYPE__STRING = DATA_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_RED_PROT_ENUM__STRING = DATA_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_REF__STRING = DATA_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_RELEASE__BIGINTEGER = DATA_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_RESTR_NAME1ST_L__STRING = DATA_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_RESTR_NAME1ST_U__STRING = DATA_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_REVISION__STRING = DATA_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_RIGHT_ENUM__STRING = DATA_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_SDO_COUNT__STRING = DATA_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_SUB_DATA_NAME__STRING = DATA_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = DATA_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = DATA_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_VERSION__STRING = DATA_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = DATA_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Object name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALIDATE_DATA_OBJECT_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = DATA_OBJECT___VALIDATE_DATA_OBJECT_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Data Object name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALIDATE_DATA_OBJECT_NAME_VALID__DIAGNOSTICCHAIN_MAP = DATA_OBJECT___VALIDATE_DATA_OBJECT_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate DOI name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALIDATE_DOI_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = DATA_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate DOI name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALIDATE_DOI_NAME_VALID__DIAGNOSTICCHAIN_MAP = DATA_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate DOI ix valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOI___VALIDATE_DOI_IX_VALID__DIAGNOSTICCHAIN_MAP = DATA_OBJECT_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>DOI</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOI_OPERATION_COUNT = DATA_OBJECT_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT_DIRECTORY__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT_DIRECTORY__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Data Object Directory</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT_DIRECTORY_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_DIRECTORY___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Data Object Directory</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_OBJECT_DIRECTORY_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Any LN</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET__ANY_LN = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Referred By Control</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET__REFERRED_BY_CONTROL = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>FCDA</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET__FCDA = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET__NAME = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Data Set</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Set name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALIDATE_DATA_SET_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Data Set name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALIDATE_DATA_SET_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Data Set at least one FCDA required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET___VALIDATE_DATA_SET_AT_LEAST_ONE_FCDA_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>Data Set</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET_DIRECTORY__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET_DIRECTORY__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Data Set Directory</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET_DIRECTORY_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SET_DIRECTORY___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Data Set Directory</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DATA_SET_DIRECTORY_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceWithOptionalMaxImpl <em>Service With Optional Max</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceWithOptionalMaxImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceWithOptionalMax()
	 * @generated
	 */
    int SERVICE_WITH_OPTIONAL_MAX = 145;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_OPTIONAL_MAX__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_OPTIONAL_MAX__MAX = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Service With Optional Max</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_OPTIONAL_MAX_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Optional Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_OPTIONAL_MAX___VALIDATE_SERVICE_WITH_OPTIONAL_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Service With Optional Max</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_OPTIONAL_MAX_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_ASSOCIATION__LINE_NUMBER = SERVICE_WITH_OPTIONAL_MAX__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_ASSOCIATION__MAX = SERVICE_WITH_OPTIONAL_MAX__MAX;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_ASSOCIATION__SERVICES = SERVICE_WITH_OPTIONAL_MAX_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Dyn Association</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_ASSOCIATION_FEATURE_COUNT = SERVICE_WITH_OPTIONAL_MAX_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_EMPTY__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_LD_INST__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_LN_INST__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PADDR__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PREFIX__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_REF__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_REVISION__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_VERSION__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_OPTIONAL_MAX___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Optional Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_ASSOCIATION___VALIDATE_SERVICE_WITH_OPTIONAL_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_OPTIONAL_MAX___VALIDATE_SERVICE_WITH_OPTIONAL_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Dyn Association</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_ASSOCIATION_OPERATION_COUNT = SERVICE_WITH_OPTIONAL_MAX_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_DATA_SET__LINE_NUMBER = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_DATA_SET__MAX = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES__MAX;

    /**
	 * The feature id for the '<em><b>Max Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_DATA_SET__MAX_ATTRIBUTES = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES__MAX_ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_DATA_SET__SERVICES = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Dyn Data Set</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_DATA_SET_FEATURE_COUNT = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_EMPTY__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_LD_INST__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_LN_INST__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PADDR__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PREFIX__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_REF__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_REVISION__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_VERSION__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max Attributes valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYN_DATA_SET___VALIDATE_SERVICE_WITH_MAX_MAX_ATTRIBUTES_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES___VALIDATE_SERVICE_WITH_MAX_MAX_ATTRIBUTES_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Dyn Data Set</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DYN_DATA_SET_OPERATION_COUNT = SERVICE_WITH_MAX_AND_MAX_ATTRIBUTES_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__LINE_NUMBER = BASE_ELEMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__PRIVATE = BASE_ELEMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__TEXT = BASE_ELEMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__ANY = BASE_ELEMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__ANY_ATTRIBUTE = BASE_ELEMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Da Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__DA_NAME = BASE_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Do Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__DO_NAME = BASE_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Ied Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__IED_NAME = BASE_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Int Addr</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__INT_ADDR = BASE_ELEMENT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Ld Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__LD_INST = BASE_ELEMENT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__LN_CLASS = BASE_ELEMENT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Ln Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__LN_INST = BASE_ELEMENT_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__PREFIX = BASE_ELEMENT_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Service Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__SERVICE_TYPE = BASE_ELEMENT_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>Src CB Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__SRC_CB_NAME = BASE_ELEMENT_FEATURE_COUNT + 9;

    /**
	 * The feature id for the '<em><b>Src LD Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__SRC_LD_INST = BASE_ELEMENT_FEATURE_COUNT + 10;

    /**
	 * The feature id for the '<em><b>Src LN Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__SRC_LN_CLASS = BASE_ELEMENT_FEATURE_COUNT + 11;

    /**
	 * The feature id for the '<em><b>Src LN Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__SRC_LN_INST = BASE_ELEMENT_FEATURE_COUNT + 12;

    /**
	 * The feature id for the '<em><b>Src Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__SRC_PREFIX = BASE_ELEMENT_FEATURE_COUNT + 13;

    /**
	 * The feature id for the '<em><b>Inputs</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__INPUTS = BASE_ELEMENT_FEATURE_COUNT + 14;

    /**
	 * The feature id for the '<em><b>Refers To Any LN</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__REFERS_TO_ANY_LN = BASE_ELEMENT_FEATURE_COUNT + 15;

    /**
	 * The feature id for the '<em><b>Refers To Data Attribute</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__REFERS_TO_DATA_ATTRIBUTE = BASE_ELEMENT_FEATURE_COUNT + 16;

    /**
	 * The feature id for the '<em><b>Refers To Data Object</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__REFERS_TO_DATA_OBJECT = BASE_ELEMENT_FEATURE_COUNT + 17;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF__DESC = BASE_ELEMENT_FEATURE_COUNT + 18;

    /**
	 * The number of structural features of the '<em>Ext Ref</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF_FEATURE_COUNT = BASE_ELEMENT_FEATURE_COUNT + 19;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_ACCESS_POINT_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_ACSI_NAME__STRING = BASE_ELEMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_ANY_NAME__STRING = BASE_ELEMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_ASSOCIATION_ID__STRING = BASE_ELEMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_AUTHENTICATION_ENUM__STRING = BASE_ELEMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_CB_NAME__STRING = BASE_ELEMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DA_COUNT__STRING = BASE_ELEMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DATA_SET_NAME__STRING = BASE_ELEMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = BASE_ELEMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_EXTENSION_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_FULL_DO_NAME__STRING = BASE_ELEMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = BASE_ELEMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_LD_INST__STRING = BASE_ELEMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_LD_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_LD_NAME__STRING = BASE_ELEMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_LLN0_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_LN_INST__STRING = BASE_ELEMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_LN_INST_OR_EMPTY__STRING = BASE_ELEMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_LPHD_ENUM__STRING = BASE_ELEMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_LINE_TYPE__STRING = BASE_ELEMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_LOG_NAME__STRING = BASE_ELEMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_MESSAGE_ID__STRING = BASE_ELEMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_NAMESPACE_NAME__STRING = BASE_ELEMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = BASE_ELEMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PADDR__STRING = BASE_ELEMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = BASE_ELEMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = BASE_ELEMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PREFIX__STRING = BASE_ELEMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PROCESS_NAME__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_PROCESS_TYPE__STRING = BASE_ELEMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_RED_PROT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_REF__STRING = BASE_ELEMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_RELEASE__BIGINTEGER = BASE_ELEMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_RESTR_NAME1ST_L__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_RESTR_NAME1ST_U__STRING = BASE_ELEMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_REVISION__STRING = BASE_ELEMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_RIGHT_ENUM__STRING = BASE_ELEMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_SDO_COUNT__STRING = BASE_ELEMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_SUB_DATA_NAME__STRING = BASE_ELEMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = BASE_ELEMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = BASE_ELEMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_VERSION__STRING = BASE_ELEMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = BASE_ELEMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Ext Ref ied Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_EXT_REF_IED_NAME_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Ext Ref ld Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_EXT_REF_LD_INST_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Ext Ref prefix valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_EXT_REF_PREFIX_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Ext Ref ln Class valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_EXT_REF_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate Ext Ref ln Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_EXT_REF_LN_INST_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 4;

				/**
	 * The operation id for the '<em>Validate FCDA do Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_FCDA_DO_NAME_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 5;

				/**
	 * The operation id for the '<em>Validate FCDA da Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_FCDA_DA_NAME_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 6;

				/**
	 * The operation id for the '<em>Validate Ext Ref src LD Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_EXT_REF_SRC_LD_INST_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 7;

				/**
	 * The operation id for the '<em>Validate Ext Ref src Prefix valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_EXT_REF_SRC_PREFIX_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 8;

				/**
	 * The operation id for the '<em>Validate Ext Ref src LN Class valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_EXT_REF_SRC_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 9;

				/**
	 * The operation id for the '<em>Validate Ext Ref src LN Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_EXT_REF_SRC_LN_INST_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 10;

				/**
	 * The operation id for the '<em>Validate Ext Ref src CB Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXT_REF___VALIDATE_EXT_REF_SRC_CB_NAME_VALID__DIAGNOSTICCHAIN_MAP = BASE_ELEMENT_OPERATION_COUNT + 11;

				/**
	 * The number of operations of the '<em>Ext Ref</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EXT_REF_OPERATION_COUNT = BASE_ELEMENT_OPERATION_COUNT + 12;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__LINE_NUMBER = EXPLICIT_LINK_RESOLVER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Da Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__DA_NAME = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Do Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__DO_NAME = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Fc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__FC = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Ix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__IX = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Ld Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__LD_INST = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__LN_CLASS = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Ln Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__LN_INST = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__PREFIX = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Refers To Data Attribute</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__REFERS_TO_DATA_ATTRIBUTE = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>Refers To Data Object</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__REFERS_TO_DATA_OBJECT = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 9;

    /**
	 * The feature id for the '<em><b>Data Set</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__DATA_SET = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 10;

    /**
	 * The feature id for the '<em><b>Refers To Any LN</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA__REFERS_TO_ANY_LN = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 11;

    /**
	 * The number of structural features of the '<em>FCDA</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA_FEATURE_COUNT = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 12;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_ACCESS_POINT_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_ACSI_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_ANY_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_ASSOCIATION_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_AUTHENTICATION_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_CB_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DA_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DATA_SET_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_FULL_DO_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_LD_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_LD_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_LD_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_LLN0_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_LN_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_LN_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_LPHD_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_LINE_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_LOG_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_MESSAGE_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_NAMESPACE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PADDR__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PREFIX__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PROCESS_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_PROCESS_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_RED_PROT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_REF__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_RELEASE__BIGINTEGER = EXPLICIT_LINK_RESOLVER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_RESTR_NAME1ST_L__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_RESTR_NAME1ST_U__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_REVISION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_RIGHT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_SDO_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_SUB_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_VERSION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate FCDA fc required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_FC_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate FCDA ld Inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_LD_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate FCDA ln Class required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_LN_CLASS_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate FCDA ln Class valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate FCDA ln Inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_LN_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 4;

				/**
	 * The operation id for the '<em>Validate FCDA ln Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_LN_INST_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 5;

				/**
	 * The operation id for the '<em>Validate FCDA empty attributes only if GSSE</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_EMPTY_ATTRIBUTES_ONLY_IF_GSSE__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 6;

				/**
	 * The operation id for the '<em>Validate FCDA ld Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_LD_INST_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 7;

				/**
	 * The operation id for the '<em>Validate FCDA prefix valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_PREFIX_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 8;

				/**
	 * The operation id for the '<em>Validate FCDA do Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_DO_NAME_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 9;

				/**
	 * The operation id for the '<em>Validate FCDA da Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_DA_NAME_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 10;

				/**
	 * The operation id for the '<em>Validate FCDA ix valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FCDA___VALIDATE_FCDA_IX_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 11;

				/**
	 * The number of operations of the '<em>FCDA</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FCDA_OPERATION_COUNT = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 12;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FILE_HANDLING__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Ftp</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FILE_HANDLING__FTP = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ftps</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FILE_HANDLING__FTPS = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Mms</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FILE_HANDLING__MMS = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FILE_HANDLING__SERVICES = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>File Handling</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FILE_HANDLING_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate File Handling nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FILE_HANDLING___VALIDATE_FILE_HANDLING_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>File Handling</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FILE_HANDLING_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE__LINE_NUMBER = SERVICE_WITH_MAX__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE__MAX = SERVICE_WITH_MAX__MAX;

    /**
	 * The feature id for the '<em><b>Fixed Offs</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE__FIXED_OFFS = SERVICE_WITH_MAX_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE__SERVICES = SERVICE_WITH_MAX_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>GOOSE</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_FEATURE_COUNT = SERVICE_WITH_MAX_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_LD_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_LN_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PADDR__STRING = SERVICE_WITH_MAX___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PREFIX__STRING = SERVICE_WITH_MAX___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_REF__STRING = SERVICE_WITH_MAX___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_MAX___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_REVISION__STRING = SERVICE_WITH_MAX___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_VERSION__STRING = SERVICE_WITH_MAX___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_MAX___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate GOOSE nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE___VALIDATE_GOOSE_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>GOOSE</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_OPERATION_COUNT = SERVICE_WITH_MAX_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__LINE_NUMBER = CERTIFICATE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__PRIVATE = CERTIFICATE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__TEXT = CERTIFICATE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__ANY = CERTIFICATE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__ANY_ATTRIBUTE = CERTIFICATE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__NAME = CERTIFICATE__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__DESC = CERTIFICATE__DESC;

    /**
	 * The feature id for the '<em><b>Serial Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__SERIAL_NUMBER = CERTIFICATE__SERIAL_NUMBER;

    /**
	 * The feature id for the '<em><b>Xfer Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__XFER_NUMBER = CERTIFICATE__XFER_NUMBER;

    /**
	 * The feature id for the '<em><b>Subject</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__SUBJECT = CERTIFICATE__SUBJECT;

    /**
	 * The feature id for the '<em><b>Issuer Name</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__ISSUER_NAME = CERTIFICATE__ISSUER_NAME;

    /**
	 * The feature id for the '<em><b>Access Point</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY__ACCESS_POINT = CERTIFICATE_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>GOOSE Security</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY_FEATURE_COUNT = CERTIFICATE_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_ACCESS_POINT_NAME__STRING = CERTIFICATE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_ACSI_NAME__STRING = CERTIFICATE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_ANY_NAME__STRING = CERTIFICATE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_ASSOCIATION_ID__STRING = CERTIFICATE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CERTIFICATE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_AUTHENTICATION_ENUM__STRING = CERTIFICATE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_BASIC_TYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_CB_NAME__STRING = CERTIFICATE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_CDC_ENUM__STRING = CERTIFICATE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DA_COUNT__STRING = CERTIFICATE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DATA_NAME__STRING = CERTIFICATE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DATA_SET_NAME__STRING = CERTIFICATE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_ENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_EMPTY__STRING = CERTIFICATE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CERTIFICATE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_FULL_DO_NAME__STRING = CERTIFICATE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_IED_NAME__STRING = CERTIFICATE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CERTIFICATE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_LD_INST__STRING = CERTIFICATE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_LD_INST_OR_EMPTY__STRING = CERTIFICATE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_LD_NAME__STRING = CERTIFICATE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_LLN0_ENUM__STRING = CERTIFICATE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_LN_CLASS_ENUM__STRING = CERTIFICATE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_LN_INST__STRING = CERTIFICATE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_LN_INST_OR_EMPTY__STRING = CERTIFICATE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_LPHD_ENUM__STRING = CERTIFICATE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_LINE_TYPE__STRING = CERTIFICATE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_LOG_NAME__STRING = CERTIFICATE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_MESSAGE_ID__STRING = CERTIFICATE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_NAME__STRING = CERTIFICATE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_NAMESPACE_NAME__STRING = CERTIFICATE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CERTIFICATE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PADDR__STRING = CERTIFICATE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PTYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CERTIFICATE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CERTIFICATE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PREFIX__STRING = CERTIFICATE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PROCESS_NAME__STRING = CERTIFICATE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_PROCESS_TYPE__STRING = CERTIFICATE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_RED_PROT_ENUM__STRING = CERTIFICATE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_REF__STRING = CERTIFICATE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_RELEASE__BIGINTEGER = CERTIFICATE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_RESTR_NAME1ST_L__STRING = CERTIFICATE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_RESTR_NAME1ST_U__STRING = CERTIFICATE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_REVISION__STRING = CERTIFICATE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_RIGHT_ENUM__STRING = CERTIFICATE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_SDO_COUNT__STRING = CERTIFICATE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_SUB_DATA_NAME__STRING = CERTIFICATE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CERTIFICATE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CERTIFICATE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_VERSION__STRING = CERTIFICATE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CERTIFICATE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate serial Number required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALIDATE_CERTIFICATE_SERIAL_NUMBER_REQUIRED__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_CERTIFICATE_SERIAL_NUMBER_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate serial Number valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALIDATE_CERTIFICATE_SERIAL_NUMBER_VALID__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_CERTIFICATE_SERIAL_NUMBER_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate xfer Number valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALIDATE_CERTIFICATE_XFER_NUMBER_VALID__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_CERTIFICATE_XFER_NUMBER_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate one Subject required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALIDATE_CERTIFICATE_ONE_SUBJECT_REQUIRED__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_CERTIFICATE_ONE_SUBJECT_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate one Issuer Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOOSE_SECURITY___VALIDATE_CERTIFICATE_ONE_ISSUER_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_CERTIFICATE_ONE_ISSUER_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>GOOSE Security</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GOOSE_SECURITY_OPERATION_COUNT = CERTIFICATE_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__LINE_NUMBER = CONTROL_WITH_IED_NAME__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__PRIVATE = CONTROL_WITH_IED_NAME__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__TEXT = CONTROL_WITH_IED_NAME__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__ANY = CONTROL_WITH_IED_NAME__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__ANY_ATTRIBUTE = CONTROL_WITH_IED_NAME__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__DESC = CONTROL_WITH_IED_NAME__DESC;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__DAT_SET = CONTROL_WITH_IED_NAME__DAT_SET;

    /**
	 * The feature id for the '<em><b>Refers To Data Set</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__REFERS_TO_DATA_SET = CONTROL_WITH_IED_NAME__REFERS_TO_DATA_SET;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__NAME = CONTROL_WITH_IED_NAME__NAME;

    /**
	 * The feature id for the '<em><b>Conf Rev</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__CONF_REV = CONTROL_WITH_IED_NAME__CONF_REV;

    /**
	 * The feature id for the '<em><b>IED Name</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__IED_NAME = CONTROL_WITH_IED_NAME__IED_NAME;

    /**
	 * The feature id for the '<em><b>Referred By Control Block</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__REFERRED_BY_CONTROL_BLOCK = CONTROL_WITH_IED_NAME__REFERRED_BY_CONTROL_BLOCK;

    /**
	 * The feature id for the '<em><b>Protocol</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__PROTOCOL = CONTROL_WITH_IED_NAME__PROTOCOL;

    /**
	 * The feature id for the '<em><b>App ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__APP_ID = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Fixed Offs</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__FIXED_OFFS = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Security Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__SECURITY_ENABLE = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__TYPE = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>LN0</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL__LN0 = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>GSE Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL_FEATURE_COUNT = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_ACSI_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_ANY_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_CB_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_CDC_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DA_COUNT__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DATA_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DATA_SET_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_EMPTY__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_FULL_DO_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_IED_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_LD_INST__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_LD_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_LLN0_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_LN_INST__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_LPHD_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_LINE_TYPE__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_LOG_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_MESSAGE_ID__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PADDR__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PTYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PREFIX__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PROCESS_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_PROCESS_TYPE__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_REF__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_RELEASE__BIGINTEGER = CONTROL_WITH_IED_NAME___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_REVISION__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_RIGHT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_SDO_COUNT__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_VERSION__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Control name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control dat Set valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control With IED Name conf Rev unsigned Int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALIDATE_CONTROL_WITH_IED_NAME_CONF_REV_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_WITH_IED_NAME_CONF_REV_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate GSE Control app ID required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALIDATE_GSE_CONTROL_APP_ID_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate GSE Control app ID valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALIDATE_GSE_CONTROL_APP_ID_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate GSE Control conf Rev required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALIDATE_GSE_CONTROL_CONF_REV_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate GSE Control conf Rev unsigned Int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_CONTROL___VALIDATE_GSE_CONTROL_CONF_REV_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>GSE Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_CONTROL_OPERATION_COUNT = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_DIR__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_DIR__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>GSE Dir</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_DIR_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_DIR___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>GSE Dir</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_DIR_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_SETTINGS__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Cb Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_SETTINGS__CB_NAME = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_SETTINGS__DAT_SET = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Service Settings</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_SETTINGS_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Settings nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_SETTINGS___VALIDATE_SERVICE_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Service Settings</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_SETTINGS_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_SETTINGS__LINE_NUMBER = SERVICE_SETTINGS__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Cb Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_SETTINGS__CB_NAME = SERVICE_SETTINGS__CB_NAME;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_SETTINGS__DAT_SET = SERVICE_SETTINGS__DAT_SET;

    /**
	 * The feature id for the '<em><b>App ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_SETTINGS__APP_ID = SERVICE_SETTINGS_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Data Label</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_SETTINGS__DATA_LABEL = SERVICE_SETTINGS_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_SETTINGS__SERVICES = SERVICE_SETTINGS_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>GSE Settings</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_SETTINGS_FEATURE_COUNT = SERVICE_SETTINGS_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_ACSI_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_ANY_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_SETTINGS___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_CB_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DA_COUNT__STRING = SERVICE_SETTINGS___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DATA_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_IED_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_SETTINGS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_LD_INST__STRING = SERVICE_SETTINGS___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_LD_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_LLN0_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_LN_INST__STRING = SERVICE_SETTINGS___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_LPHD_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_LINE_TYPE__STRING = SERVICE_SETTINGS___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_LOG_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_MESSAGE_ID__STRING = SERVICE_SETTINGS___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PADDR__STRING = SERVICE_SETTINGS___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PREFIX__STRING = SERVICE_SETTINGS___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PROCESS_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_SETTINGS___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_REF__STRING = SERVICE_SETTINGS___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_SETTINGS___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_SETTINGS___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_SETTINGS___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_REVISION__STRING = SERVICE_SETTINGS___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_SDO_COUNT__STRING = SERVICE_SETTINGS___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_VERSION__STRING = SERVICE_SETTINGS___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_SETTINGS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Settings nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALIDATE_SERVICE_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_SETTINGS___VALIDATE_SERVICE_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate GSE Settings nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSE_SETTINGS___VALIDATE_GSE_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_SETTINGS_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>GSE Settings</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSE_SETTINGS_OPERATION_COUNT = SERVICE_SETTINGS_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSSE__LINE_NUMBER = SERVICE_WITH_MAX__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSSE__MAX = SERVICE_WITH_MAX__MAX;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSSE__SERVICES = SERVICE_WITH_MAX_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>GSSE</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSSE_FEATURE_COUNT = SERVICE_WITH_MAX_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_LD_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_LN_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PADDR__STRING = SERVICE_WITH_MAX___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PREFIX__STRING = SERVICE_WITH_MAX___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_REF__STRING = SERVICE_WITH_MAX___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_MAX___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_REVISION__STRING = SERVICE_WITH_MAX___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_VERSION__STRING = SERVICE_WITH_MAX___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_MAX___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GSSE___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>GSSE</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GSSE_OPERATION_COUNT = SERVICE_WITH_MAX_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_CB_VALUES__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_CB_VALUES__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Get CB Values</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_CB_VALUES_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_CB_VALUES___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Get CB Values</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_CB_VALUES_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DATA_OBJECT_DEFINITION__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DATA_OBJECT_DEFINITION__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Get Data Object Definition</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DATA_OBJECT_DEFINITION_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_OBJECT_DEFINITION___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Get Data Object Definition</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DATA_OBJECT_DEFINITION_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DATA_SET_VALUE__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DATA_SET_VALUE__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Get Data Set Value</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DATA_SET_VALUE_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DATA_SET_VALUE___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Get Data Set Value</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DATA_SET_VALUE_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DIRECTORY__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DIRECTORY__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Get Directory</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DIRECTORY_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GET_DIRECTORY___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Get Directory</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GET_DIRECTORY_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Config Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__CONFIG_VERSION = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Eng Right</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__ENG_RIGHT = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Manufacturer</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__MANUFACTURER = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Original Scl Revision</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__ORIGINAL_SCL_REVISION = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Original Scl Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__ORIGINAL_SCL_VERSION = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Owner</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__OWNER = UN_NAMING_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__TYPE = UN_NAMING_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Access Point</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__ACCESS_POINT = UN_NAMING_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__LNODE = UN_NAMING_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>KDC</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__KDC = UN_NAMING_FEATURE_COUNT + 9;

    /**
	 * The feature id for the '<em><b>Services</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__SERVICES = UN_NAMING_FEATURE_COUNT + 10;

    /**
	 * The feature id for the '<em><b>SCL</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__SCL = UN_NAMING_FEATURE_COUNT + 11;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__NAME = UN_NAMING_FEATURE_COUNT + 12;

    /**
	 * The feature id for the '<em><b>Original Scl Release</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED__ORIGINAL_SCL_RELEASE = UN_NAMING_FEATURE_COUNT + 13;

    /**
	 * The number of structural features of the '<em>IED</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 14;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate IED name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALIDATE_IED_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate IED name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALIDATE_IED_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate IED original Scl Version valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALIDATE_IED_ORIGINAL_SCL_VERSION_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate IED original Scl Revision valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALIDATE_IED_ORIGINAL_SCL_REVISION_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate IED original Scl Release valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALIDATE_IED_ORIGINAL_SCL_RELEASE_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 4;

				/**
	 * The operation id for the '<em>Validateeng Right valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALIDATEENG_RIGHT_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 5;

				/**
	 * The operation id for the '<em>Validate IED at least one Access Point required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED___VALIDATE_IED_AT_LEAST_ONE_ACCESS_POINT_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 6;

				/**
	 * The number of operations of the '<em>IED</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME__LINE_NUMBER = EXPLICIT_LINK_RESOLVER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Ap Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME__AP_REF = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ld Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME__LD_INST = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME__LN_CLASS = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Ln Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME__LN_INST = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME__PREFIX = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Control With IED Name</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME__CONTROL_WITH_IED_NAME = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Refers To Any LN</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME__REFERS_TO_ANY_LN = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME__VALUE = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 7;

    /**
	 * The number of structural features of the '<em>IED Name</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME_FEATURE_COUNT = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 8;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_ACCESS_POINT_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_ACSI_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_ANY_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_ASSOCIATION_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_AUTHENTICATION_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_CB_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DA_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DATA_SET_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_FULL_DO_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_LD_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_LD_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_LD_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_LLN0_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_LN_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_LN_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_LPHD_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_LINE_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_LOG_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_MESSAGE_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_NAMESPACE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PADDR__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PREFIX__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PROCESS_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_PROCESS_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_RED_PROT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_REF__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_RELEASE__BIGINTEGER = EXPLICIT_LINK_RESOLVER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_RESTR_NAME1ST_L__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_RESTR_NAME1ST_U__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_REVISION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_RIGHT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_SDO_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_SUB_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_VERSION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate IED Name value valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IED_NAME___VALIDATE_IED_NAME_VALUE_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>IED Name</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IED_NAME_OPERATION_COUNT = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int INPUTS__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int INPUTS__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int INPUTS__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int INPUTS__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int INPUTS__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int INPUTS__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Any LN</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int INPUTS__ANY_LN = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ext Ref</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int INPUTS__EXT_REF = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Inputs</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int INPUTS_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Inputs nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALIDATE_INPUTS_NOTHING__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Inputs at least one Ext Ref required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUTS___VALIDATE_INPUTS_AT_LEAST_ONE_EXT_REF_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Inputs</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int INPUTS_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 2;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.CertImpl <em>Cert</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.CertImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getCert()
	 * @generated
	 */
    int CERT = 151;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERT__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Common Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERT__COMMON_NAME = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Id Hierarchy</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERT__ID_HIERARCHY = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Cert</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERT_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Cert common Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALIDATE_CERT_COMMON_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Cert common Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALIDATE_CERT_COMMON_NAME_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Cert id Hierarchy required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALIDATE_CERT_ID_HIERARCHY_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Cert id Hierarchy valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CERT___VALIDATE_CERT_ID_HIERARCHY_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>Cert</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CERT_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ISSUER_NAME__LINE_NUMBER = CERT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Common Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ISSUER_NAME__COMMON_NAME = CERT__COMMON_NAME;

    /**
	 * The feature id for the '<em><b>Id Hierarchy</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ISSUER_NAME__ID_HIERARCHY = CERT__ID_HIERARCHY;

    /**
	 * The feature id for the '<em><b>Certificate</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ISSUER_NAME__CERTIFICATE = CERT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Issuer Name</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ISSUER_NAME_FEATURE_COUNT = CERT_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_ACCESS_POINT_NAME__STRING = CERT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_ACSI_NAME__STRING = CERT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_ANY_NAME__STRING = CERT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_ASSOCIATION_ID__STRING = CERT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CERT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_AUTHENTICATION_ENUM__STRING = CERT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_BASIC_TYPE_ENUM__STRING = CERT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_CB_NAME__STRING = CERT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_CDC_ENUM__STRING = CERT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DA_COUNT__STRING = CERT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DATA_NAME__STRING = CERT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DATA_SET_NAME__STRING = CERT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_ENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_EMPTY__STRING = CERT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CERT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CERT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CERT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CERT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CERT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CERT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_FULL_DO_NAME__STRING = CERT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_IED_NAME__STRING = CERT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CERT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_LD_INST__STRING = CERT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_LD_INST_OR_EMPTY__STRING = CERT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_LD_NAME__STRING = CERT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_LLN0_ENUM__STRING = CERT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_LN_CLASS_ENUM__STRING = CERT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_LN_INST__STRING = CERT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_LN_INST_OR_EMPTY__STRING = CERT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_LPHD_ENUM__STRING = CERT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_LINE_TYPE__STRING = CERT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_LOG_NAME__STRING = CERT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_MESSAGE_ID__STRING = CERT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_NAME__STRING = CERT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_NAMESPACE_NAME__STRING = CERT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CERT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PADDR__STRING = CERT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PTYPE_ENUM__STRING = CERT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CERT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CERT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CERT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PREFIX__STRING = CERT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PROCESS_NAME__STRING = CERT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_PROCESS_TYPE__STRING = CERT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_RED_PROT_ENUM__STRING = CERT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_REF__STRING = CERT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_RELEASE__BIGINTEGER = CERT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_RESTR_NAME1ST_L__STRING = CERT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_RESTR_NAME1ST_U__STRING = CERT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_REVISION__STRING = CERT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_RIGHT_ENUM__STRING = CERT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_SDO_COUNT__STRING = CERT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_SUB_DATA_NAME__STRING = CERT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CERT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CERT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_VERSION__STRING = CERT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CERT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Cert common Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALIDATE_CERT_COMMON_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CERT___VALIDATE_CERT_COMMON_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Cert common Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALIDATE_CERT_COMMON_NAME_VALID__DIAGNOSTICCHAIN_MAP = CERT___VALIDATE_CERT_COMMON_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Cert id Hierarchy required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALIDATE_CERT_ID_HIERARCHY_REQUIRED__DIAGNOSTICCHAIN_MAP = CERT___VALIDATE_CERT_ID_HIERARCHY_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Cert id Hierarchy valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ISSUER_NAME___VALIDATE_CERT_ID_HIERARCHY_VALID__DIAGNOSTICCHAIN_MAP = CERT___VALIDATE_CERT_ID_HIERARCHY_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Issuer Name</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ISSUER_NAME_OPERATION_COUNT = CERT_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int KDC__LINE_NUMBER = EXPLICIT_LINK_RESOLVER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Ap Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int KDC__AP_NAME = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ied Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int KDC__IED_NAME = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>IED</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int KDC__IED = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Refers To Access Point</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int KDC__REFERS_TO_ACCESS_POINT = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>KDC</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int KDC_FEATURE_COUNT = EXPLICIT_LINK_RESOLVER_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_ACCESS_POINT_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_ACSI_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_ANY_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_ASSOCIATION_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_AUTHENTICATION_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_CB_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DA_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DATA_SET_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_FULL_DO_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_LD_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_LD_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_LD_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_LLN0_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_LN_INST__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_LN_INST_OR_EMPTY__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_LPHD_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_LINE_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_LOG_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_MESSAGE_ID__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_NAMESPACE_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PADDR__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PREFIX__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PROCESS_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_PROCESS_TYPE__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_RED_PROT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_REF__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_RELEASE__BIGINTEGER = EXPLICIT_LINK_RESOLVER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_RESTR_NAME1ST_L__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_RESTR_NAME1ST_U__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_REVISION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_RIGHT_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_SDO_COUNT__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_SUB_DATA_NAME__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_VERSION__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EXPLICIT_LINK_RESOLVER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate KDC ied Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALIDATE_KDC_IED_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate KDC ied Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALIDATE_KDC_IED_NAME_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate KDC ap Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALIDATE_KDC_AP_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate KDC ap Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int KDC___VALIDATE_KDC_AP_NAME_VALID__DIAGNOSTICCHAIN_MAP = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>KDC</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int KDC_OPERATION_COUNT = EXPLICIT_LINK_RESOLVER_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__INST = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ld Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__LD_NAME = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Referred By Control Block</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__REFERRED_BY_CONTROL_BLOCK = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Access Control</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__ACCESS_CONTROL = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Server</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__SERVER = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__LNODE = UN_NAMING_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>LN</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__LN = UN_NAMING_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>LN0</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE__LN0 = UN_NAMING_FEATURE_COUNT + 7;

    /**
	 * The number of structural features of the '<em>LDevice</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 8;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate LDevice inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALIDATE_LDEVICE_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate LDevice inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALIDATE_LDEVICE_INST_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate LDevice ld Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALIDATE_LDEVICE_LD_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate LDevice one LN0 required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LDEVICE___VALIDATE_LDEVICE_ONE_LN0_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>LDevice</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LDEVICE_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__LINE_NUMBER = ANY_LN__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__PRIVATE = ANY_LN__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__TEXT = ANY_LN__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__ANY = ANY_LN__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__ANY_ATTRIBUTE = ANY_LN__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__DESC = ANY_LN__DESC;

    /**
	 * The feature id for the '<em><b>Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__INST = ANY_LN__INST;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__LN_CLASS = ANY_LN__LN_CLASS;

    /**
	 * The feature id for the '<em><b>Ln Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__LN_TYPE = ANY_LN__LN_TYPE;

    /**
	 * The feature id for the '<em><b>Refers To LNode Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__REFERS_TO_LNODE_TYPE = ANY_LN__REFERS_TO_LNODE_TYPE;

    /**
	 * The feature id for the '<em><b>Inputs</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__INPUTS = ANY_LN__INPUTS;

    /**
	 * The feature id for the '<em><b>Log</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__LOG = ANY_LN__LOG;

    /**
	 * The feature id for the '<em><b>DOI</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__DOI = ANY_LN__DOI;

    /**
	 * The feature id for the '<em><b>Report Control</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__REPORT_CONTROL = ANY_LN__REPORT_CONTROL;

    /**
	 * The feature id for the '<em><b>Log Control</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__LOG_CONTROL = ANY_LN__LOG_CONTROL;

    /**
	 * The feature id for the '<em><b>Data Set</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__DATA_SET = ANY_LN__DATA_SET;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__REFERRED_BY_FCDA = ANY_LN__REFERRED_BY_FCDA;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__REFERRED_BY_EXT_REF = ANY_LN__REFERRED_BY_EXT_REF;

    /**
	 * The feature id for the '<em><b>Referred By Client LN</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__REFERRED_BY_CLIENT_LN = ANY_LN__REFERRED_BY_CLIENT_LN;

    /**
	 * The feature id for the '<em><b>Referred By Log Control</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__REFERRED_BY_LOG_CONTROL = ANY_LN__REFERRED_BY_LOG_CONTROL;

    /**
	 * The feature id for the '<em><b>Referred By Association</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__REFERRED_BY_ASSOCIATION = ANY_LN__REFERRED_BY_ASSOCIATION;

    /**
	 * The feature id for the '<em><b>Referred IED Name</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__REFERRED_IED_NAME = ANY_LN__REFERRED_IED_NAME;

    /**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__PREFIX = ANY_LN_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Access Point</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__ACCESS_POINT = ANY_LN_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>LDevice</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__LDEVICE = ANY_LN_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN__LNODE = ANY_LN_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>LN</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN_FEATURE_COUNT = ANY_LN_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_ACCESS_POINT_NAME__STRING = ANY_LN___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_ACSI_NAME__STRING = ANY_LN___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_ANY_NAME__STRING = ANY_LN___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_ASSOCIATION_ID__STRING = ANY_LN___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ANY_LN___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_AUTHENTICATION_ENUM__STRING = ANY_LN___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_BASIC_TYPE_ENUM__STRING = ANY_LN___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_CB_NAME__STRING = ANY_LN___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_CDC_ENUM__STRING = ANY_LN___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DA_COUNT__STRING = ANY_LN___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DATA_NAME__STRING = ANY_LN___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DATA_SET_NAME__STRING = ANY_LN___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_ENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_EMPTY__STRING = ANY_LN___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ANY_LN___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_FULL_DO_NAME__STRING = ANY_LN___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_IED_NAME__STRING = ANY_LN___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ANY_LN___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_LD_INST__STRING = ANY_LN___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_LD_INST_OR_EMPTY__STRING = ANY_LN___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_LD_NAME__STRING = ANY_LN___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_LLN0_ENUM__STRING = ANY_LN___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_LN_CLASS_ENUM__STRING = ANY_LN___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_LN_INST__STRING = ANY_LN___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_LN_INST_OR_EMPTY__STRING = ANY_LN___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_LPHD_ENUM__STRING = ANY_LN___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_LINE_TYPE__STRING = ANY_LN___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_LOG_NAME__STRING = ANY_LN___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_MESSAGE_ID__STRING = ANY_LN___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_NAME__STRING = ANY_LN___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_NAMESPACE_NAME__STRING = ANY_LN___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ANY_LN___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PADDR__STRING = ANY_LN___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PTYPE_ENUM__STRING = ANY_LN___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ANY_LN___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ANY_LN___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ANY_LN___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PREFIX__STRING = ANY_LN___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PROCESS_NAME__STRING = ANY_LN___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_PROCESS_TYPE__STRING = ANY_LN___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_RED_PROT_ENUM__STRING = ANY_LN___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_REF__STRING = ANY_LN___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_RELEASE__BIGINTEGER = ANY_LN___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_RESTR_NAME1ST_L__STRING = ANY_LN___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_RESTR_NAME1ST_U__STRING = ANY_LN___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_REVISION__STRING = ANY_LN___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_RIGHT_ENUM__STRING = ANY_LN___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_SDO_COUNT__STRING = ANY_LN___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_SUB_DATA_NAME__STRING = ANY_LN___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ANY_LN___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ANY_LN___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_VERSION__STRING = ANY_LN___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ANY_LN___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate LN ln Class required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALIDATE_LN_LN_CLASS_REQUIRED__DIAGNOSTICCHAIN_MAP = ANY_LN___VALIDATE_LN_LN_CLASS_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LN ln Class valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALIDATE_LN_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP = ANY_LN___VALIDATE_LN_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LN inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALIDATE_LN_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = ANY_LN___VALIDATE_LN_INST_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Any LN ln Type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALIDATE_ANY_LN_LN_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = ANY_LN___VALIDATE_ANY_LN_LN_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Any LN ln Type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALIDATE_ANY_LN_LN_TYPE_VALID__DIAGNOSTICCHAIN_MAP = ANY_LN___VALIDATE_ANY_LN_LN_TYPE_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LN inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALIDATE_LN_INST_VALID__DIAGNOSTICCHAIN_MAP = ANY_LN_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate LN prefix valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN___VALIDATE_LN_PREFIX_VALID__DIAGNOSTICCHAIN_MAP = ANY_LN_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>LN</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN_OPERATION_COUNT = ANY_LN_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__LINE_NUMBER = ANY_LN__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__PRIVATE = ANY_LN__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__TEXT = ANY_LN__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__ANY = ANY_LN__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__ANY_ATTRIBUTE = ANY_LN__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__DESC = ANY_LN__DESC;

    /**
	 * The feature id for the '<em><b>Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__INST = ANY_LN__INST;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__LN_CLASS = ANY_LN__LN_CLASS;

    /**
	 * The feature id for the '<em><b>Ln Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__LN_TYPE = ANY_LN__LN_TYPE;

    /**
	 * The feature id for the '<em><b>Refers To LNode Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__REFERS_TO_LNODE_TYPE = ANY_LN__REFERS_TO_LNODE_TYPE;

    /**
	 * The feature id for the '<em><b>Inputs</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__INPUTS = ANY_LN__INPUTS;

    /**
	 * The feature id for the '<em><b>Log</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__LOG = ANY_LN__LOG;

    /**
	 * The feature id for the '<em><b>DOI</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__DOI = ANY_LN__DOI;

    /**
	 * The feature id for the '<em><b>Report Control</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__REPORT_CONTROL = ANY_LN__REPORT_CONTROL;

    /**
	 * The feature id for the '<em><b>Log Control</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__LOG_CONTROL = ANY_LN__LOG_CONTROL;

    /**
	 * The feature id for the '<em><b>Data Set</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__DATA_SET = ANY_LN__DATA_SET;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__REFERRED_BY_FCDA = ANY_LN__REFERRED_BY_FCDA;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__REFERRED_BY_EXT_REF = ANY_LN__REFERRED_BY_EXT_REF;

    /**
	 * The feature id for the '<em><b>Referred By Client LN</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__REFERRED_BY_CLIENT_LN = ANY_LN__REFERRED_BY_CLIENT_LN;

    /**
	 * The feature id for the '<em><b>Referred By Log Control</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__REFERRED_BY_LOG_CONTROL = ANY_LN__REFERRED_BY_LOG_CONTROL;

    /**
	 * The feature id for the '<em><b>Referred By Association</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__REFERRED_BY_ASSOCIATION = ANY_LN__REFERRED_BY_ASSOCIATION;

    /**
	 * The feature id for the '<em><b>Referred IED Name</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__REFERRED_IED_NAME = ANY_LN__REFERRED_IED_NAME;

    /**
	 * The feature id for the '<em><b>GSE Control</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__GSE_CONTROL = ANY_LN_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>LDevice</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__LDEVICE = ANY_LN_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Sampled Value Control</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__SAMPLED_VALUE_CONTROL = ANY_LN_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Setting Control</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0__SETTING_CONTROL = ANY_LN_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>LN0</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0_FEATURE_COUNT = ANY_LN_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_ACCESS_POINT_NAME__STRING = ANY_LN___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_ACSI_NAME__STRING = ANY_LN___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_ANY_NAME__STRING = ANY_LN___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_ASSOCIATION_ID__STRING = ANY_LN___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ANY_LN___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_AUTHENTICATION_ENUM__STRING = ANY_LN___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_BASIC_TYPE_ENUM__STRING = ANY_LN___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_CB_NAME__STRING = ANY_LN___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_CDC_ENUM__STRING = ANY_LN___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DA_COUNT__STRING = ANY_LN___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DATA_NAME__STRING = ANY_LN___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DATA_SET_NAME__STRING = ANY_LN___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_ENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ANY_LN___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_EMPTY__STRING = ANY_LN___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ANY_LN___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ANY_LN___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_FULL_DO_NAME__STRING = ANY_LN___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_IED_NAME__STRING = ANY_LN___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ANY_LN___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_LD_INST__STRING = ANY_LN___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_LD_INST_OR_EMPTY__STRING = ANY_LN___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_LD_NAME__STRING = ANY_LN___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_LLN0_ENUM__STRING = ANY_LN___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_LN_CLASS_ENUM__STRING = ANY_LN___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_LN_INST__STRING = ANY_LN___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_LN_INST_OR_EMPTY__STRING = ANY_LN___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_LPHD_ENUM__STRING = ANY_LN___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_LINE_TYPE__STRING = ANY_LN___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_LOG_NAME__STRING = ANY_LN___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_MESSAGE_ID__STRING = ANY_LN___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_NAME__STRING = ANY_LN___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_NAMESPACE_NAME__STRING = ANY_LN___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ANY_LN___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PADDR__STRING = ANY_LN___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PTYPE_ENUM__STRING = ANY_LN___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ANY_LN___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ANY_LN___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ANY_LN___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ANY_LN___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PREFIX__STRING = ANY_LN___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PROCESS_NAME__STRING = ANY_LN___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_PROCESS_TYPE__STRING = ANY_LN___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_RED_PROT_ENUM__STRING = ANY_LN___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_REF__STRING = ANY_LN___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_RELEASE__BIGINTEGER = ANY_LN___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_RESTR_NAME1ST_L__STRING = ANY_LN___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_RESTR_NAME1ST_U__STRING = ANY_LN___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_REVISION__STRING = ANY_LN___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_RIGHT_ENUM__STRING = ANY_LN___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_SDO_COUNT__STRING = ANY_LN___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_SUB_DATA_NAME__STRING = ANY_LN___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ANY_LN___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ANY_LN___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_VERSION__STRING = ANY_LN___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ANY_LN___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate LN ln Class required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALIDATE_LN_LN_CLASS_REQUIRED__DIAGNOSTICCHAIN_MAP = ANY_LN___VALIDATE_LN_LN_CLASS_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LN ln Class valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALIDATE_LN_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP = ANY_LN___VALIDATE_LN_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LN inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALIDATE_LN_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = ANY_LN___VALIDATE_LN_INST_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Any LN ln Type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALIDATE_ANY_LN_LN_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = ANY_LN___VALIDATE_ANY_LN_LN_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Any LN ln Type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALIDATE_ANY_LN_LN_TYPE_VALID__DIAGNOSTICCHAIN_MAP = ANY_LN___VALIDATE_ANY_LN_LN_TYPE_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LN0 ln Class value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALIDATE_LN0_LN_CLASS_VALUE__DIAGNOSTICCHAIN_MAP = ANY_LN_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate LN0 inst empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LN0___VALIDATE_LN0_INST_EMPTY__DIAGNOSTICCHAIN_MAP = ANY_LN_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>LN0</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LN0_OPERATION_COUNT = ANY_LN_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Any LN</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG__ANY_LN = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG__NAME = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Log</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Log name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG___VALIDATE_LOG_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Log</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__LINE_NUMBER = CONTROL_WITH_TRIGGER_OPT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__PRIVATE = CONTROL_WITH_TRIGGER_OPT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__TEXT = CONTROL_WITH_TRIGGER_OPT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__ANY = CONTROL_WITH_TRIGGER_OPT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__ANY_ATTRIBUTE = CONTROL_WITH_TRIGGER_OPT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__DESC = CONTROL_WITH_TRIGGER_OPT__DESC;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__DAT_SET = CONTROL_WITH_TRIGGER_OPT__DAT_SET;

    /**
	 * The feature id for the '<em><b>Refers To Data Set</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__REFERS_TO_DATA_SET = CONTROL_WITH_TRIGGER_OPT__REFERS_TO_DATA_SET;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__NAME = CONTROL_WITH_TRIGGER_OPT__NAME;

    /**
	 * The feature id for the '<em><b>Intg Pd</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__INTG_PD = CONTROL_WITH_TRIGGER_OPT__INTG_PD;

    /**
	 * The feature id for the '<em><b>Trg Ops</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__TRG_OPS = CONTROL_WITH_TRIGGER_OPT__TRG_OPS;

    /**
	 * The feature id for the '<em><b>Buf Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__BUF_TIME = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ld Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__LD_INST = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__LN_CLASS = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Ln Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__LN_INST = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Log Ena</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__LOG_ENA = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Log Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__LOG_NAME = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__PREFIX = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Reason Code</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__REASON_CODE = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Any LN</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__ANY_LN = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>Refers To Any LN</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL__REFERS_TO_ANY_LN = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 9;

    /**
	 * The number of structural features of the '<em>Log Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL_FEATURE_COUNT = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 10;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_ACSI_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_ANY_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_CB_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_CDC_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DA_COUNT__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DATA_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DATA_SET_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_EMPTY__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_FULL_DO_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_IED_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_LD_INST__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_LD_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_LLN0_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_LN_INST__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_LPHD_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_LINE_TYPE__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_LOG_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_MESSAGE_ID__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PADDR__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PTYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PREFIX__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PROCESS_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_PROCESS_TYPE__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_REF__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_RELEASE__BIGINTEGER = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_REVISION__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_RIGHT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_SDO_COUNT__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_VERSION__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Control name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control dat Set valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control With Trigger Opt intg Pd unsigned int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_CONTROL_WITH_TRIGGER_OPT_INTG_PD_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_WITH_TRIGGER_OPT_INTG_PD_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Log Control log Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_LOG_CONTROL_LOG_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Log Control log Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_LOG_CONTROL_LOG_NAME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Log Control ld Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_LOG_CONTROL_LD_INST_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Log Control prefix valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_LOG_CONTROL_PREFIX_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate Log Control ln Class valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_LOG_CONTROL_LN_CLASS_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 4;

				/**
	 * The operation id for the '<em>Validate Log Control ln Inst valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_LOG_CONTROL_LN_INST_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 5;

				/**
	 * The operation id for the '<em>Validate Log Control buf Time valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_CONTROL___VALIDATE_LOG_CONTROL_BUF_TIME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 6;

				/**
	 * The number of operations of the '<em>Log Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_CONTROL_OPERATION_COUNT = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_SETTINGS__LINE_NUMBER = SERVICE_SETTINGS__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Cb Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_SETTINGS__CB_NAME = SERVICE_SETTINGS__CB_NAME;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_SETTINGS__DAT_SET = SERVICE_SETTINGS__DAT_SET;

    /**
	 * The feature id for the '<em><b>Intg Pd</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_SETTINGS__INTG_PD = SERVICE_SETTINGS_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Log Ena</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_SETTINGS__LOG_ENA = SERVICE_SETTINGS_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Trg Ops</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_SETTINGS__TRG_OPS = SERVICE_SETTINGS_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_SETTINGS__SERVICES = SERVICE_SETTINGS_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Log Settings</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_SETTINGS_FEATURE_COUNT = SERVICE_SETTINGS_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_ACSI_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_ANY_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_SETTINGS___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_CB_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DA_COUNT__STRING = SERVICE_SETTINGS___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DATA_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_IED_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_SETTINGS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_LD_INST__STRING = SERVICE_SETTINGS___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_LD_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_LLN0_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_LN_INST__STRING = SERVICE_SETTINGS___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_LPHD_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_LINE_TYPE__STRING = SERVICE_SETTINGS___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_LOG_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_MESSAGE_ID__STRING = SERVICE_SETTINGS___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PADDR__STRING = SERVICE_SETTINGS___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PREFIX__STRING = SERVICE_SETTINGS___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PROCESS_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_SETTINGS___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_REF__STRING = SERVICE_SETTINGS___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_SETTINGS___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_SETTINGS___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_SETTINGS___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_REVISION__STRING = SERVICE_SETTINGS___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_SDO_COUNT__STRING = SERVICE_SETTINGS___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_VERSION__STRING = SERVICE_SETTINGS___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_SETTINGS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Settings nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALIDATE_SERVICE_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_SETTINGS___VALIDATE_SERVICE_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Log Settings nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOG_SETTINGS___VALIDATE_LOG_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_SETTINGS_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Log Settings</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOG_SETTINGS_OPERATION_COUNT = SERVICE_SETTINGS_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Buf Ovfl</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS__BUF_OVFL = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Config Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS__CONFIG_REF = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Data Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS__DATA_REF = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Data Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS__DATA_SET = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Entry ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS__ENTRY_ID = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Reason Code</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS__REASON_CODE = SCL_OBJECT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Seq Num</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS__SEQ_NUM = SCL_OBJECT_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Time Stamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS__TIME_STAMP = SCL_OBJECT_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Report Control</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS__REPORT_CONTROL = SCL_OBJECT_FEATURE_COUNT + 8;

    /**
	 * The number of structural features of the '<em>Opt Fields</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 9;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPT_FIELDS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Opt Fields</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OPT_FIELDS_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROTOCOL__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Must Understand</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROTOCOL__MUST_UNDERSTAND = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Control With IED Name</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROTOCOL__CONTROL_WITH_IED_NAME = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Protocol</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROTOCOL_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Voltage must Understand required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALIDATE_VOLTAGE_MUST_UNDERSTAND_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Voltage must Understand value fixed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL___VALIDATE_VOLTAGE_MUST_UNDERSTAND_VALUE_FIXED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Protocol</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROTOCOL_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int READ_WRITE__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int READ_WRITE__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Read Write</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int READ_WRITE_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int READ_WRITE___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Read Write</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int READ_WRITE_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RED_PROT__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Hsr</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RED_PROT__HSR = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Prp</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RED_PROT__PRP = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Rstp</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RED_PROT__RSTP = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RED_PROT__SERVICES = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Red Prot</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RED_PROT_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Red Prot nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RED_PROT___VALIDATE_RED_PROT_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Red Prot</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RED_PROT_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__LINE_NUMBER = CONTROL_WITH_TRIGGER_OPT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__PRIVATE = CONTROL_WITH_TRIGGER_OPT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__TEXT = CONTROL_WITH_TRIGGER_OPT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__ANY = CONTROL_WITH_TRIGGER_OPT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__ANY_ATTRIBUTE = CONTROL_WITH_TRIGGER_OPT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__DESC = CONTROL_WITH_TRIGGER_OPT__DESC;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__DAT_SET = CONTROL_WITH_TRIGGER_OPT__DAT_SET;

    /**
	 * The feature id for the '<em><b>Refers To Data Set</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__REFERS_TO_DATA_SET = CONTROL_WITH_TRIGGER_OPT__REFERS_TO_DATA_SET;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__NAME = CONTROL_WITH_TRIGGER_OPT__NAME;

    /**
	 * The feature id for the '<em><b>Intg Pd</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__INTG_PD = CONTROL_WITH_TRIGGER_OPT__INTG_PD;

    /**
	 * The feature id for the '<em><b>Trg Ops</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__TRG_OPS = CONTROL_WITH_TRIGGER_OPT__TRG_OPS;

    /**
	 * The feature id for the '<em><b>Buffered</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__BUFFERED = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Buf Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__BUF_TIME = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Conf Rev</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__CONF_REV = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Indexed</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__INDEXED = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Rpt ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__RPT_ID = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Any LN</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__ANY_LN = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Opt Fields</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__OPT_FIELDS = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Rpt Enabled</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL__RPT_ENABLED = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 7;

    /**
	 * The number of structural features of the '<em>Report Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL_FEATURE_COUNT = CONTROL_WITH_TRIGGER_OPT_FEATURE_COUNT + 8;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_ACSI_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_ANY_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_CB_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_CDC_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DA_COUNT__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DATA_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DATA_SET_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_EMPTY__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_FULL_DO_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_IED_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_LD_INST__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_LD_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_LLN0_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_LN_INST__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_LPHD_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_LINE_TYPE__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_LOG_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_MESSAGE_ID__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PADDR__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PTYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PREFIX__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PROCESS_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_PROCESS_TYPE__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_REF__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_RELEASE__BIGINTEGER = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_REVISION__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_RIGHT_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_SDO_COUNT__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_VERSION__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CONTROL_WITH_TRIGGER_OPT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Control name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control dat Set valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control With Trigger Opt intg Pd unsigned int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALIDATE_CONTROL_WITH_TRIGGER_OPT_INTG_PD_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT___VALIDATE_CONTROL_WITH_TRIGGER_OPT_INTG_PD_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Report Control conf Rev required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALIDATE_REPORT_CONTROL_CONF_REV_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Report Control conf Rev unsigned int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALIDATE_REPORT_CONTROL_CONF_REV_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Report Control rpt ID valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALIDATE_REPORT_CONTROL_RPT_ID_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Report Control buf Time valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALIDATE_REPORT_CONTROL_BUF_TIME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate Report Control one Opt Fields required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_CONTROL___VALIDATE_REPORT_CONTROL_ONE_OPT_FIELDS_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 4;

				/**
	 * The number of operations of the '<em>Report Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_CONTROL_OPERATION_COUNT = CONTROL_WITH_TRIGGER_OPT_OPERATION_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__LINE_NUMBER = SERVICE_SETTINGS__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Cb Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__CB_NAME = SERVICE_SETTINGS__CB_NAME;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__DAT_SET = SERVICE_SETTINGS__DAT_SET;

    /**
	 * The feature id for the '<em><b>Buf Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__BUF_TIME = SERVICE_SETTINGS_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Intg Pd</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__INTG_PD = SERVICE_SETTINGS_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Opt Fields</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__OPT_FIELDS = SERVICE_SETTINGS_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Owner</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__OWNER = SERVICE_SETTINGS_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Resv Tms</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__RESV_TMS = SERVICE_SETTINGS_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Rpt ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__RPT_ID = SERVICE_SETTINGS_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Trg Ops</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__TRG_OPS = SERVICE_SETTINGS_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS__SERVICES = SERVICE_SETTINGS_FEATURE_COUNT + 7;

    /**
	 * The number of structural features of the '<em>Report Settings</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS_FEATURE_COUNT = SERVICE_SETTINGS_FEATURE_COUNT + 8;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_ACSI_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_ANY_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_SETTINGS___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_CB_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DA_COUNT__STRING = SERVICE_SETTINGS___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DATA_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_IED_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_SETTINGS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_LD_INST__STRING = SERVICE_SETTINGS___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_LD_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_LLN0_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_LN_INST__STRING = SERVICE_SETTINGS___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_LPHD_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_LINE_TYPE__STRING = SERVICE_SETTINGS___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_LOG_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_MESSAGE_ID__STRING = SERVICE_SETTINGS___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PADDR__STRING = SERVICE_SETTINGS___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PREFIX__STRING = SERVICE_SETTINGS___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PROCESS_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_SETTINGS___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_REF__STRING = SERVICE_SETTINGS___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_SETTINGS___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_SETTINGS___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_SETTINGS___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_REVISION__STRING = SERVICE_SETTINGS___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_SDO_COUNT__STRING = SERVICE_SETTINGS___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_VERSION__STRING = SERVICE_SETTINGS___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_SETTINGS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Settings nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALIDATE_SERVICE_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_SETTINGS___VALIDATE_SERVICE_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Report Settings nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPORT_SETTINGS___VALIDATE_REPORT_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_SETTINGS_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Report Settings</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REPORT_SETTINGS_OPERATION_COUNT = SERVICE_SETTINGS_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED__MAX = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Client LN</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED__CLIENT_LN = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Report Control</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED__REPORT_CONTROL = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Rpt Enabled</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Rpt Enabled max unsigned int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPT_ENABLED___VALIDATE_RPT_ENABLED_MAX_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Rpt Enabled</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RPT_ENABLED_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__LINE_NUMBER = DATA_ATTRIBUTE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__PRIVATE = DATA_ATTRIBUTE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__TEXT = DATA_ATTRIBUTE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__ANY = DATA_ATTRIBUTE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__ANY_ATTRIBUTE = DATA_ATTRIBUTE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__DESC = DATA_ATTRIBUTE__DESC;

    /**
	 * The feature id for the '<em><b>Referred By FCDA</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__REFERRED_BY_FCDA = DATA_ATTRIBUTE__REFERRED_BY_FCDA;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__NAME = DATA_ATTRIBUTE__NAME;

    /**
	 * The feature id for the '<em><b>Referred By Ext Ref</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__REFERRED_BY_EXT_REF = DATA_ATTRIBUTE__REFERRED_BY_EXT_REF;

    /**
	 * The feature id for the '<em><b>Ix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__IX = DATA_ATTRIBUTE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>SAddr</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__SADDR = DATA_ATTRIBUTE_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>DAI</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__DAI = DATA_ATTRIBUTE_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>DOI</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__DOI = DATA_ATTRIBUTE_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Sub SDI</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__SUB_SDI = DATA_ATTRIBUTE_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Parent SDI</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI__PARENT_SDI = DATA_ATTRIBUTE_FEATURE_COUNT + 5;

    /**
	 * The number of structural features of the '<em>SDI</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI_FEATURE_COUNT = DATA_ATTRIBUTE_FEATURE_COUNT + 6;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_ACCESS_POINT_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_ACSI_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_ANY_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_ASSOCIATION_ID__STRING = DATA_ATTRIBUTE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_AUTHENTICATION_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_BASIC_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_CB_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_CDC_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DA_COUNT__STRING = DATA_ATTRIBUTE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DATA_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DATA_SET_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_EMPTY__STRING = DATA_ATTRIBUTE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_EXTENSION_CDC_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_FULL_DO_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_IED_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = DATA_ATTRIBUTE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_LD_INST__STRING = DATA_ATTRIBUTE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_LD_INST_OR_EMPTY__STRING = DATA_ATTRIBUTE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_LD_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_LLN0_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_LN_CLASS_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_LN_INST__STRING = DATA_ATTRIBUTE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_LN_INST_OR_EMPTY__STRING = DATA_ATTRIBUTE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_LPHD_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_LINE_TYPE__STRING = DATA_ATTRIBUTE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_LOG_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_MESSAGE_ID__STRING = DATA_ATTRIBUTE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_NAMESPACE_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PADDR__STRING = DATA_ATTRIBUTE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PTYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PREFIX__STRING = DATA_ATTRIBUTE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PROCESS_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_PROCESS_TYPE__STRING = DATA_ATTRIBUTE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_RED_PROT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_REF__STRING = DATA_ATTRIBUTE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_RELEASE__BIGINTEGER = DATA_ATTRIBUTE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_RESTR_NAME1ST_L__STRING = DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_RESTR_NAME1ST_U__STRING = DATA_ATTRIBUTE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_REVISION__STRING = DATA_ATTRIBUTE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_RIGHT_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_SDO_COUNT__STRING = DATA_ATTRIBUTE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_SUB_DATA_NAME__STRING = DATA_ATTRIBUTE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = DATA_ATTRIBUTE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_VERSION__STRING = DATA_ATTRIBUTE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = DATA_ATTRIBUTE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Data Attribute name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Data Attribute name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE___VALIDATE_DATA_ATTRIBUTE_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate SDI name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALIDATE_SDI_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate SDI name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALIDATE_SDI_NAME_VALID__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate SDI ix valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDI___VALIDATE_SDI_IX_VALID__DIAGNOSTICCHAIN_MAP = DATA_ATTRIBUTE_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>SDI</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SDI_OPERATION_COUNT = DATA_ATTRIBUTE_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SG_EDIT__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Resv Tms</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SG_EDIT__RESV_TMS = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Setting Groups</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SG_EDIT__SETTING_GROUPS = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>SG Edit</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SG_EDIT_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SG_EDIT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>SG Edit</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SG_EDIT_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__LINE_NUMBER = CERTIFICATE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__PRIVATE = CERTIFICATE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__TEXT = CERTIFICATE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__ANY = CERTIFICATE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__ANY_ATTRIBUTE = CERTIFICATE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__NAME = CERTIFICATE__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__DESC = CERTIFICATE__DESC;

    /**
	 * The feature id for the '<em><b>Serial Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__SERIAL_NUMBER = CERTIFICATE__SERIAL_NUMBER;

    /**
	 * The feature id for the '<em><b>Xfer Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__XFER_NUMBER = CERTIFICATE__XFER_NUMBER;

    /**
	 * The feature id for the '<em><b>Subject</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__SUBJECT = CERTIFICATE__SUBJECT;

    /**
	 * The feature id for the '<em><b>Issuer Name</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__ISSUER_NAME = CERTIFICATE__ISSUER_NAME;

    /**
	 * The feature id for the '<em><b>Access Point</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY__ACCESS_POINT = CERTIFICATE_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>SMV Security</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY_FEATURE_COUNT = CERTIFICATE_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_ACCESS_POINT_NAME__STRING = CERTIFICATE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_ACSI_NAME__STRING = CERTIFICATE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_ANY_NAME__STRING = CERTIFICATE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_ASSOCIATION_ID__STRING = CERTIFICATE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CERTIFICATE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_AUTHENTICATION_ENUM__STRING = CERTIFICATE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_BASIC_TYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_CB_NAME__STRING = CERTIFICATE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_CDC_ENUM__STRING = CERTIFICATE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DA_COUNT__STRING = CERTIFICATE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DATA_NAME__STRING = CERTIFICATE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DATA_SET_NAME__STRING = CERTIFICATE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_ENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CERTIFICATE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_EMPTY__STRING = CERTIFICATE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CERTIFICATE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_FULL_DO_NAME__STRING = CERTIFICATE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_IED_NAME__STRING = CERTIFICATE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CERTIFICATE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_LD_INST__STRING = CERTIFICATE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_LD_INST_OR_EMPTY__STRING = CERTIFICATE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_LD_NAME__STRING = CERTIFICATE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_LLN0_ENUM__STRING = CERTIFICATE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_LN_CLASS_ENUM__STRING = CERTIFICATE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_LN_INST__STRING = CERTIFICATE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_LN_INST_OR_EMPTY__STRING = CERTIFICATE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_LPHD_ENUM__STRING = CERTIFICATE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_LINE_TYPE__STRING = CERTIFICATE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_LOG_NAME__STRING = CERTIFICATE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_MESSAGE_ID__STRING = CERTIFICATE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_NAME__STRING = CERTIFICATE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_NAMESPACE_NAME__STRING = CERTIFICATE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CERTIFICATE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PADDR__STRING = CERTIFICATE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PTYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CERTIFICATE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CERTIFICATE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CERTIFICATE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PREFIX__STRING = CERTIFICATE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PROCESS_NAME__STRING = CERTIFICATE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_PROCESS_TYPE__STRING = CERTIFICATE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_RED_PROT_ENUM__STRING = CERTIFICATE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_REF__STRING = CERTIFICATE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_RELEASE__BIGINTEGER = CERTIFICATE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_RESTR_NAME1ST_L__STRING = CERTIFICATE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_RESTR_NAME1ST_U__STRING = CERTIFICATE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_REVISION__STRING = CERTIFICATE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_RIGHT_ENUM__STRING = CERTIFICATE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_SDO_COUNT__STRING = CERTIFICATE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_SUB_DATA_NAME__STRING = CERTIFICATE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CERTIFICATE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CERTIFICATE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_VERSION__STRING = CERTIFICATE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CERTIFICATE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate serial Number required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALIDATE_CERTIFICATE_SERIAL_NUMBER_REQUIRED__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_CERTIFICATE_SERIAL_NUMBER_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate serial Number valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALIDATE_CERTIFICATE_SERIAL_NUMBER_VALID__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_CERTIFICATE_SERIAL_NUMBER_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate xfer Number valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALIDATE_CERTIFICATE_XFER_NUMBER_VALID__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_CERTIFICATE_XFER_NUMBER_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate one Subject required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALIDATE_CERTIFICATE_ONE_SUBJECT_REQUIRED__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_CERTIFICATE_ONE_SUBJECT_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Certificate one Issuer Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SECURITY___VALIDATE_CERTIFICATE_ONE_ISSUER_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CERTIFICATE___VALIDATE_CERTIFICATE_ONE_ISSUER_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>SMV Security</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SECURITY_OPERATION_COUNT = CERTIFICATE_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__LINE_NUMBER = SERVICE_SETTINGS__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Cb Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__CB_NAME = SERVICE_SETTINGS__CB_NAME;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__DAT_SET = SERVICE_SETTINGS__DAT_SET;

    /**
	 * The feature id for the '<em><b>Sv ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__SV_ID = SERVICE_SETTINGS_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Opt Fields</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__OPT_FIELDS = SERVICE_SETTINGS_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Smp Rate Attribute</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__SMP_RATE_ATTRIBUTE = SERVICE_SETTINGS_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Samples Per Sec Attribute</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__SAMPLES_PER_SEC_ATTRIBUTE = SERVICE_SETTINGS_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Pdc Time Stamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__PDC_TIME_STAMP = SERVICE_SETTINGS_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Smp Rate</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__SMP_RATE = SERVICE_SETTINGS_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Samples Per Sec</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__SAMPLES_PER_SEC = SERVICE_SETTINGS_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Sec Per Samples</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS__SEC_PER_SAMPLES = SERVICE_SETTINGS_FEATURE_COUNT + 7;

    /**
	 * The number of structural features of the '<em>SMV Settings</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS_FEATURE_COUNT = SERVICE_SETTINGS_FEATURE_COUNT + 8;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_ACSI_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_ANY_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_SETTINGS___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_CB_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DA_COUNT__STRING = SERVICE_SETTINGS___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DATA_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_SETTINGS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_IED_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_SETTINGS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_LD_INST__STRING = SERVICE_SETTINGS___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_LD_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_LLN0_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_LN_INST__STRING = SERVICE_SETTINGS___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_SETTINGS___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_LPHD_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_LINE_TYPE__STRING = SERVICE_SETTINGS___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_LOG_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_MESSAGE_ID__STRING = SERVICE_SETTINGS___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PADDR__STRING = SERVICE_SETTINGS___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PREFIX__STRING = SERVICE_SETTINGS___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PROCESS_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_SETTINGS___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_REF__STRING = SERVICE_SETTINGS___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_SETTINGS___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_SETTINGS___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_SETTINGS___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_REVISION__STRING = SERVICE_SETTINGS___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_SDO_COUNT__STRING = SERVICE_SETTINGS___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_SETTINGS___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_SETTINGS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_VERSION__STRING = SERVICE_SETTINGS___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_SETTINGS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Settings nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALIDATE_SERVICE_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_SETTINGS___VALIDATE_SERVICE_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate SMV Settings nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_SETTINGS___VALIDATE_SMV_SETTINGS_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_SETTINGS_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>SMV Settings</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_SETTINGS_OPERATION_COUNT = SERVICE_SETTINGS_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SM_VSC__LINE_NUMBER = SERVICE_WITH_MAX__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SM_VSC__MAX = SERVICE_WITH_MAX__MAX;

    /**
	 * The feature id for the '<em><b>Delivery</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SM_VSC__DELIVERY = SERVICE_WITH_MAX_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Delivery Conf</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SM_VSC__DELIVERY_CONF = SERVICE_WITH_MAX_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SM_VSC__SERVICES = SERVICE_WITH_MAX_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>SM Vsc</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SM_VSC_FEATURE_COUNT = SERVICE_WITH_MAX_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_LD_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_LN_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PADDR__STRING = SERVICE_WITH_MAX___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PREFIX__STRING = SERVICE_WITH_MAX___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_REF__STRING = SERVICE_WITH_MAX___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_MAX___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_REVISION__STRING = SERVICE_WITH_MAX___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_VERSION__STRING = SERVICE_WITH_MAX___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_MAX___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate SM Vsc nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SM_VSC___VALIDATE_SM_VSC_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>SM Vsc</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SM_VSC_OPERATION_COUNT = SERVICE_WITH_MAX_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__LINE_NUMBER = CONTROL_WITH_IED_NAME__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__PRIVATE = CONTROL_WITH_IED_NAME__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__TEXT = CONTROL_WITH_IED_NAME__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__ANY = CONTROL_WITH_IED_NAME__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__ANY_ATTRIBUTE = CONTROL_WITH_IED_NAME__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__DESC = CONTROL_WITH_IED_NAME__DESC;

    /**
	 * The feature id for the '<em><b>Dat Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__DAT_SET = CONTROL_WITH_IED_NAME__DAT_SET;

    /**
	 * The feature id for the '<em><b>Refers To Data Set</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__REFERS_TO_DATA_SET = CONTROL_WITH_IED_NAME__REFERS_TO_DATA_SET;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__NAME = CONTROL_WITH_IED_NAME__NAME;

    /**
	 * The feature id for the '<em><b>Conf Rev</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__CONF_REV = CONTROL_WITH_IED_NAME__CONF_REV;

    /**
	 * The feature id for the '<em><b>IED Name</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__IED_NAME = CONTROL_WITH_IED_NAME__IED_NAME;

    /**
	 * The feature id for the '<em><b>Referred By Control Block</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__REFERRED_BY_CONTROL_BLOCK = CONTROL_WITH_IED_NAME__REFERRED_BY_CONTROL_BLOCK;

    /**
	 * The feature id for the '<em><b>Protocol</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__PROTOCOL = CONTROL_WITH_IED_NAME__PROTOCOL;

    /**
	 * The feature id for the '<em><b>Multicast</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__MULTICAST = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Nof ASDU</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__NOF_ASDU = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Security Enable</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__SECURITY_ENABLE = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Smp Mod</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__SMP_MOD = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Smp Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__SMP_RATE = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Smv ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__SMV_ID = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>LN0</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__LN0 = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Smv Opts</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL__SMV_OPTS = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 7;

    /**
	 * The number of structural features of the '<em>Sampled Value Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL_FEATURE_COUNT = CONTROL_WITH_IED_NAME_FEATURE_COUNT + 8;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_ACSI_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_ANY_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_CB_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_CDC_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DA_COUNT__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DATA_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DATA_SET_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_EMPTY__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_FULL_DO_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_IED_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_LD_INST__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_LD_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_LLN0_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_LN_INST__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_LPHD_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_LINE_TYPE__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_LOG_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_MESSAGE_ID__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PADDR__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PTYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PREFIX__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PROCESS_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_PROCESS_TYPE__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_REF__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_RELEASE__BIGINTEGER = CONTROL_WITH_IED_NAME___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_REVISION__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_RIGHT_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_SDO_COUNT__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_VERSION__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CONTROL_WITH_IED_NAME___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Control name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control dat Set valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_DAT_SET_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Control With IED Name conf Rev unsigned Int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_CONTROL_WITH_IED_NAME_CONF_REV_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME___VALIDATE_CONTROL_WITH_IED_NAME_CONF_REV_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Sampled Value Control smv ID required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_SAMPLED_VALUE_CONTROL_SMV_ID_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Sampled Value Control smv ID valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_SAMPLED_VALUE_CONTROL_SMV_ID_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Sampled Value Control smp Rate required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_SAMPLED_VALUE_CONTROL_SMP_RATE_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Sampled Value Control smp Rate valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_SAMPLED_VALUE_CONTROL_SMP_RATE_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate Sampled Value Control nof ASDU required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_SAMPLED_VALUE_CONTROL_NOF_ASDU_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 4;

				/**
	 * The operation id for the '<em>Validate Sampled Value Control nof ASDU valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_SAMPLED_VALUE_CONTROL_NOF_ASDU_VALID__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 5;

				/**
	 * The operation id for the '<em>Validate Sampled Value Control conf Rev required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_SAMPLED_VALUE_CONTROL_CONF_REV_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 6;

				/**
	 * The operation id for the '<em>Validate Sampled Value Control conf Rev unsigned Int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_SAMPLED_VALUE_CONTROL_CONF_REV_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 7;

				/**
	 * The operation id for the '<em>Validate Sampled Value Control one Smv Opts required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_SAMPLED_VALUE_CONTROL_ONE_SMV_OPTS_REQUIRED__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 8;

				/**
	 * The operation id for the '<em>Validate Sampled Value Control multicast</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLED_VALUE_CONTROL___VALIDATE_SAMPLED_VALUE_CONTROL_MULTICAST__DIAGNOSTICCHAIN_MAP = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 9;

				/**
	 * The number of operations of the '<em>Sampled Value Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLED_VALUE_CONTROL_OPERATION_COUNT = CONTROL_WITH_IED_NAME_OPERATION_COUNT + 10;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Timeout</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__TIMEOUT = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Access Point</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__ACCESS_POINT = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Association</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__ASSOCIATION = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Authentication</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__AUTHENTICATION = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>LDevice</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER__LDEVICE = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Server</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Server timeout unsigned int</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALIDATE_SERVER_TIMEOUT_UNSIGNED_INT__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Server one Authentication required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALIDATE_SERVER_ONE_AUTHENTICATION_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Server at least one LDevice required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER___VALIDATE_SERVER_AT_LEAST_ONE_LDEVICE_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>Server</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Ap Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT__AP_NAME = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Access Point</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT__ACCESS_POINT = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Refers To Access Point</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT__REFERS_TO_ACCESS_POINT = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Server At</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Server At ap Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALIDATE_SERVER_AT_AP_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Server At ap Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVER_AT___VALIDATE_SERVER_AT_AP_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Server At</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVER_AT_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Name Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__NAME_LENGTH = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Access Point</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__ACCESS_POINT = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Client Services</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__CLIENT_SERVICES = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Comm Prot</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__COMM_PROT = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Conf Data Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__CONF_DATA_SET = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Conf LNs</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__CONF_LNS = SCL_OBJECT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Conf Ld Name</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__CONF_LD_NAME = SCL_OBJECT_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Conf Log Control</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__CONF_LOG_CONTROL = SCL_OBJECT_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Conf Report Control</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__CONF_REPORT_CONTROL = SCL_OBJECT_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>Conf Sig Ref</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__CONF_SIG_REF = SCL_OBJECT_FEATURE_COUNT + 9;

    /**
	 * The feature id for the '<em><b>Data Object Directory</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__DATA_OBJECT_DIRECTORY = SCL_OBJECT_FEATURE_COUNT + 10;

    /**
	 * The feature id for the '<em><b>Data Set Directory</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__DATA_SET_DIRECTORY = SCL_OBJECT_FEATURE_COUNT + 11;

    /**
	 * The feature id for the '<em><b>Dyn Association</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__DYN_ASSOCIATION = SCL_OBJECT_FEATURE_COUNT + 12;

    /**
	 * The feature id for the '<em><b>Dyn Data Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__DYN_DATA_SET = SCL_OBJECT_FEATURE_COUNT + 13;

    /**
	 * The feature id for the '<em><b>File Handling</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__FILE_HANDLING = SCL_OBJECT_FEATURE_COUNT + 14;

    /**
	 * The feature id for the '<em><b>GOOSE</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__GOOSE = SCL_OBJECT_FEATURE_COUNT + 15;

    /**
	 * The feature id for the '<em><b>GSE Dir</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__GSE_DIR = SCL_OBJECT_FEATURE_COUNT + 16;

    /**
	 * The feature id for the '<em><b>GSE Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__GSE_SETTINGS = SCL_OBJECT_FEATURE_COUNT + 17;

    /**
	 * The feature id for the '<em><b>GSSE</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__GSSE = SCL_OBJECT_FEATURE_COUNT + 18;

    /**
	 * The feature id for the '<em><b>Get CB Values</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__GET_CB_VALUES = SCL_OBJECT_FEATURE_COUNT + 19;

    /**
	 * The feature id for the '<em><b>Get Data Object Definition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__GET_DATA_OBJECT_DEFINITION = SCL_OBJECT_FEATURE_COUNT + 20;

    /**
	 * The feature id for the '<em><b>Get Data Set Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__GET_DATA_SET_VALUE = SCL_OBJECT_FEATURE_COUNT + 21;

    /**
	 * The feature id for the '<em><b>Get Directory</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__GET_DIRECTORY = SCL_OBJECT_FEATURE_COUNT + 22;

    /**
	 * The feature id for the '<em><b>IED</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__IED = SCL_OBJECT_FEATURE_COUNT + 23;

    /**
	 * The feature id for the '<em><b>Log Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__LOG_SETTINGS = SCL_OBJECT_FEATURE_COUNT + 24;

    /**
	 * The feature id for the '<em><b>Read Write</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__READ_WRITE = SCL_OBJECT_FEATURE_COUNT + 25;

    /**
	 * The feature id for the '<em><b>Red Prot</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__RED_PROT = SCL_OBJECT_FEATURE_COUNT + 26;

    /**
	 * The feature id for the '<em><b>Report Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__REPORT_SETTINGS = SCL_OBJECT_FEATURE_COUNT + 27;

    /**
	 * The feature id for the '<em><b>SM Vsc</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__SM_VSC = SCL_OBJECT_FEATURE_COUNT + 28;

    /**
	 * The feature id for the '<em><b>Sup Subscription</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__SUP_SUBSCRIPTION = SCL_OBJECT_FEATURE_COUNT + 29;

    /**
	 * The feature id for the '<em><b>Value Handling</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__VALUE_HANDLING = SCL_OBJECT_FEATURE_COUNT + 30;

    /**
	 * The feature id for the '<em><b>Set Data Set Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__SET_DATA_SET_VALUE = SCL_OBJECT_FEATURE_COUNT + 31;

    /**
	 * The feature id for the '<em><b>Setting Groups</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__SETTING_GROUPS = SCL_OBJECT_FEATURE_COUNT + 32;

    /**
	 * The feature id for the '<em><b>Time Sync Prot</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__TIME_SYNC_PROT = SCL_OBJECT_FEATURE_COUNT + 33;

    /**
	 * The feature id for the '<em><b>Timer Activated Control</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES__TIMER_ACTIVATED_CONTROL = SCL_OBJECT_FEATURE_COUNT + 34;

    /**
	 * The number of structural features of the '<em>Services</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 35;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Services name Length valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICES___VALIDATE_SERVICES_NAME_LENGTH_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Services</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICES_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SET_DATA_SET_VALUE__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SET_DATA_SET_VALUE__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Set Data Set Value</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SET_DATA_SET_VALUE_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_DATA_SET_VALUE___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Set Data Set Value</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SET_DATA_SET_VALUE_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Act SG</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL__ACT_SG = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Num Of SGs</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL__NUM_OF_SGS = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Resv Tms</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL__RESV_TMS = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>LN0</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL__LN0 = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Setting Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Setting Control num Of SGs required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALIDATE_SETTING_CONTROL_NUM_OF_SGS_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Setting Control num Of SGs valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALIDATE_SETTING_CONTROL_NUM_OF_SGS_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Setting Control act SG valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALIDATE_SETTING_CONTROL_ACT_SG_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Setting Control resv Tms valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_CONTROL___VALIDATE_SETTING_CONTROL_RESV_TMS_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>Setting Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_CONTROL_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_GROUPS__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Conf SG</b></em>' containment reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_GROUPS__CONF_SG = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>SG Edit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_GROUPS__SG_EDIT = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_GROUPS__SERVICES = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Setting Groups</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_GROUPS_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Setting Groups nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTING_GROUPS___VALIDATE_SETTING_GROUPS_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Setting Groups</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SETTING_GROUPS_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPTS__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Data Set</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPTS__DATA_SET = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Refresh Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPTS__REFRESH_TIME = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Sample Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPTS__SAMPLE_RATE = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Sample Synchronized</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPTS__SAMPLE_SYNCHRONIZED = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Security</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPTS__SECURITY = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPTS__TIMESTAMP = SCL_OBJECT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Sampled Value Control</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPTS__SAMPLED_VALUE_CONTROL = SCL_OBJECT_FEATURE_COUNT + 6;

    /**
	 * The number of structural features of the '<em>Smv Opts</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPTS_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 7;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMV_OPTS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Smv Opts</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMV_OPTS_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBJECT__LINE_NUMBER = CERT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Common Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBJECT__COMMON_NAME = CERT__COMMON_NAME;

    /**
	 * The feature id for the '<em><b>Id Hierarchy</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBJECT__ID_HIERARCHY = CERT__ID_HIERARCHY;

    /**
	 * The feature id for the '<em><b>Certificate</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBJECT__CERTIFICATE = CERT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Subject</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBJECT_FEATURE_COUNT = CERT_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING = CERT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_ACSI_NAME__STRING = CERT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_ANY_NAME__STRING = CERT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_ASSOCIATION_ID__STRING = CERT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = CERT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING = CERT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING = CERT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_CB_NAME__STRING = CERT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_CDC_ENUM__STRING = CERT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DA_COUNT__STRING = CERT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DATA_NAME__STRING = CERT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DATA_SET_NAME__STRING = CERT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = CERT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_EMPTY__STRING = CERT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = CERT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = CERT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = CERT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = CERT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = CERT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = CERT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_FULL_DO_NAME__STRING = CERT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_IED_NAME__STRING = CERT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = CERT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_LD_INST__STRING = CERT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING = CERT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_LD_NAME__STRING = CERT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_LLN0_ENUM__STRING = CERT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_LN_CLASS_ENUM__STRING = CERT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_LN_INST__STRING = CERT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING = CERT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_LPHD_ENUM__STRING = CERT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_LINE_TYPE__STRING = CERT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_LOG_NAME__STRING = CERT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_MESSAGE_ID__STRING = CERT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_NAME__STRING = CERT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_NAMESPACE_NAME__STRING = CERT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = CERT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PADDR__STRING = CERT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PTYPE_ENUM__STRING = CERT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = CERT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = CERT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = CERT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = CERT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PREFIX__STRING = CERT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PROCESS_NAME__STRING = CERT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_PROCESS_TYPE__STRING = CERT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_RED_PROT_ENUM__STRING = CERT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_REF__STRING = CERT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_RELEASE__BIGINTEGER = CERT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING = CERT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING = CERT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_REVISION__STRING = CERT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_RIGHT_ENUM__STRING = CERT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_SDO_COUNT__STRING = CERT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_SUB_DATA_NAME__STRING = CERT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = CERT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = CERT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_VERSION__STRING = CERT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = CERT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Cert common Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALIDATE_CERT_COMMON_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = CERT___VALIDATE_CERT_COMMON_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Cert common Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALIDATE_CERT_COMMON_NAME_VALID__DIAGNOSTICCHAIN_MAP = CERT___VALIDATE_CERT_COMMON_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Cert id Hierarchy required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALIDATE_CERT_ID_HIERARCHY_REQUIRED__DIAGNOSTICCHAIN_MAP = CERT___VALIDATE_CERT_ID_HIERARCHY_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Cert id Hierarchy valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBJECT___VALIDATE_CERT_ID_HIERARCHY_VALID__DIAGNOSTICCHAIN_MAP = CERT___VALIDATE_CERT_ID_HIERARCHY_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Subject</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBJECT_OPERATION_COUNT = CERT_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUP_SUBSCRIPTION__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max Go</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUP_SUBSCRIPTION__MAX_GO = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Max Sv</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUP_SUBSCRIPTION__MAX_SV = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUP_SUBSCRIPTION__SERVICES = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Sup Subscription</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUP_SUBSCRIPTION_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Sup Subscription max Go required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALIDATE_SUP_SUBSCRIPTION_MAX_GO_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Sup Subscription max Go valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALIDATE_SUP_SUBSCRIPTION_MAX_GO_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Sup Subscription max Sv required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALIDATE_SUP_SUBSCRIPTION_MAX_SV_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Sup Subscription max Sv valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUP_SUBSCRIPTION___VALIDATE_SUP_SUBSCRIPTION_MAX_SV_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>Sup Subscription</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUP_SUBSCRIPTION_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIME_SYNC_PROT__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>C37 238</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIME_SYNC_PROT__C37_238 = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Other</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIME_SYNC_PROT__OTHER = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Sntp</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIME_SYNC_PROT__SNTP = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Client Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIME_SYNC_PROT__CLIENT_SERVICES = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIME_SYNC_PROT__SERVICES = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Time Sync Prot</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIME_SYNC_PROT_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Time Sync Prot nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_SYNC_PROT___VALIDATE_TIME_SYNC_PROT_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Time Sync Prot</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIME_SYNC_PROT_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIMER_ACTIVATED_CONTROL__LINE_NUMBER = SERVICE_YES_NO__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIMER_ACTIVATED_CONTROL__SERVICES = SERVICE_YES_NO_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Timer Activated Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIMER_ACTIVATED_CONTROL_FEATURE_COUNT = SERVICE_YES_NO_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_ACSI_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_ANY_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_YES_NO___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_CB_NAME__STRING = SERVICE_YES_NO___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DA_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_YES_NO___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_YES_NO___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_YES_NO___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_YES_NO___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_LD_INST__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_LD_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_LLN0_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_LN_INST__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_YES_NO___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_LPHD_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_LINE_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_LOG_NAME__STRING = SERVICE_YES_NO___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_MESSAGE_ID__STRING = SERVICE_YES_NO___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_YES_NO___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_YES_NO___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PADDR__STRING = SERVICE_YES_NO___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PREFIX__STRING = SERVICE_YES_NO___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PROCESS_NAME__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_YES_NO___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_REF__STRING = SERVICE_YES_NO___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_YES_NO___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_YES_NO___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_REVISION__STRING = SERVICE_YES_NO___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_SDO_COUNT__STRING = SERVICE_YES_NO___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_YES_NO___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_YES_NO___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_VERSION__STRING = SERVICE_YES_NO___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_YES_NO___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service Yes No nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_ACTIVATED_CONTROL___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_YES_NO___VALIDATE_SERVICE_YES_NO_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Timer Activated Control</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TIMER_ACTIVATED_CONTROL_OPERATION_COUNT = SERVICE_YES_NO_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRG_OPS__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Dchg</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRG_OPS__DCHG = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Dupd</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRG_OPS__DUPD = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Gi</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRG_OPS__GI = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRG_OPS__PERIOD = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Qchg</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRG_OPS__QCHG = SCL_OBJECT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Control With Trigger Opt</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRG_OPS__CONTROL_WITH_TRIGGER_OPT = SCL_OBJECT_FEATURE_COUNT + 5;

    /**
	 * The number of structural features of the '<em>Trg Ops</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRG_OPS_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 6;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Trg Ops nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRG_OPS___VALIDATE_TRG_OPS_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Trg Ops</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRG_OPS_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_HANDLING__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Set To RO</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_HANDLING__SET_TO_RO = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Services</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_HANDLING__SERVICES = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Value Handling</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_HANDLING_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Value Handling nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_HANDLING___VALIDATE_VALUE_HANDLING_NOTHING__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Value Handling</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_HANDLING_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT__LINE_NUMBER = POWER_SYSTEM_RESOURCE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT__PRIVATE = POWER_SYSTEM_RESOURCE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT__TEXT = POWER_SYSTEM_RESOURCE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT__ANY = POWER_SYSTEM_RESOURCE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT__ANY_ATTRIBUTE = POWER_SYSTEM_RESOURCE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT__DESC = POWER_SYSTEM_RESOURCE__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT__LNODE = POWER_SYSTEM_RESOURCE__LNODE;

    /**
	 * The feature id for the '<em><b>Virtual</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT__VIRTUAL = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Equipment</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_ACCESS_POINT_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_ACSI_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_ANY_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_ASSOCIATION_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_CB_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DA_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DATA_SET_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_FULL_DO_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_LD_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_LD_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_LLN0_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_LN_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_LPHD_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_LINE_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_LOG_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_MESSAGE_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_NAMESPACE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PADDR__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PREFIX__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PROCESS_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_PROCESS_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_RED_PROT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_REF__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_RELEASE__BIGINTEGER = POWER_SYSTEM_RESOURCE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_RESTR_NAME1ST_L__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_RESTR_NAME1ST_U__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_REVISION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_RIGHT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_SDO_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_SUB_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_VERSION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Equipment nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Equipment</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__LINE_NUMBER = EQUIPMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__PRIVATE = EQUIPMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__TEXT = EQUIPMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__ANY = EQUIPMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__ANY_ATTRIBUTE = EQUIPMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__NAME = EQUIPMENT__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__DESC = EQUIPMENT__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__LNODE = EQUIPMENT__LNODE;

    /**
	 * The feature id for the '<em><b>Virtual</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__VIRTUAL = EQUIPMENT__VIRTUAL;

    /**
	 * The feature id for the '<em><b>Sub Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__SUB_EQUIPMENT = EQUIPMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Terminal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT__TERMINAL = EQUIPMENT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Abstract Conducting Equipment</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ACCESS_POINT_NAME__STRING = EQUIPMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ACSI_NAME__STRING = EQUIPMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ANY_NAME__STRING = EQUIPMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ASSOCIATION_ID__STRING = EQUIPMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING = EQUIPMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_CB_NAME__STRING = EQUIPMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_CDC_ENUM__STRING = EQUIPMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DA_COUNT__STRING = EQUIPMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DATA_NAME__STRING = EQUIPMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DATA_SET_NAME__STRING = EQUIPMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EMPTY__STRING = EQUIPMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EQUIPMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_FULL_DO_NAME__STRING = EQUIPMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_IED_NAME__STRING = EQUIPMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EQUIPMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LD_INST__STRING = EQUIPMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING = EQUIPMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LD_NAME__STRING = EQUIPMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LLN0_ENUM__STRING = EQUIPMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LN_CLASS_ENUM__STRING = EQUIPMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LN_INST__STRING = EQUIPMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING = EQUIPMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LPHD_ENUM__STRING = EQUIPMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LINE_TYPE__STRING = EQUIPMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LOG_NAME__STRING = EQUIPMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_MESSAGE_ID__STRING = EQUIPMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_NAME__STRING = EQUIPMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_NAMESPACE_NAME__STRING = EQUIPMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EQUIPMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PADDR__STRING = EQUIPMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PTYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EQUIPMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREFIX__STRING = EQUIPMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PROCESS_NAME__STRING = EQUIPMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PROCESS_TYPE__STRING = EQUIPMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RED_PROT_ENUM__STRING = EQUIPMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_REF__STRING = EQUIPMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RELEASE__BIGINTEGER = EQUIPMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_L__STRING = EQUIPMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_U__STRING = EQUIPMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_REVISION__STRING = EQUIPMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RIGHT_ENUM__STRING = EQUIPMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_SDO_COUNT__STRING = EQUIPMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_SUB_DATA_NAME__STRING = EQUIPMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EQUIPMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EQUIPMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_VERSION__STRING = EQUIPMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EQUIPMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Equipment nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Abstract Conducting Equipment</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONDUCTING_EQUIPMENT_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__LINE_NUMBER = POWER_SYSTEM_RESOURCE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__PRIVATE = POWER_SYSTEM_RESOURCE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__TEXT = POWER_SYSTEM_RESOURCE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__ANY = POWER_SYSTEM_RESOURCE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__ANY_ATTRIBUTE = POWER_SYSTEM_RESOURCE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__DESC = POWER_SYSTEM_RESOURCE__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__LNODE = POWER_SYSTEM_RESOURCE__LNODE;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__TYPE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Eq Sub Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__EQ_SUB_FUNCTION = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Sub General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC__SUB_GENERAL_EQUIPMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Abstract Eq Func Sub Func</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ACCESS_POINT_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ACSI_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ANY_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ASSOCIATION_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_AUTHENTICATION_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_CB_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DA_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DATA_SET_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_FULL_DO_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LD_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LD_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LD_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LLN0_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LN_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LN_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LPHD_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LINE_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LOG_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_MESSAGE_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_NAMESPACE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PADDR__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREFIX__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PROCESS_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PROCESS_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RED_PROT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_REF__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RELEASE__BIGINTEGER = POWER_SYSTEM_RESOURCE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RESTR_NAME1ST_L__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RESTR_NAME1ST_U__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_REVISION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RIGHT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_SDO_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_SUB_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_VERSION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Eq Func Sub Func nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_ABSTRACT_EQ_FUNC_SUB_FUNC_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Abstract Eq Func Sub Func</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_EQ_FUNC_SUB_FUNC_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER__LINE_NUMBER = POWER_SYSTEM_RESOURCE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER__PRIVATE = POWER_SYSTEM_RESOURCE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER__TEXT = POWER_SYSTEM_RESOURCE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER__ANY = POWER_SYSTEM_RESOURCE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER__ANY_ATTRIBUTE = POWER_SYSTEM_RESOURCE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER__DESC = POWER_SYSTEM_RESOURCE__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER__LNODE = POWER_SYSTEM_RESOURCE__LNODE;

    /**
	 * The feature id for the '<em><b>Power Transformer</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER__POWER_TRANSFORMER = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER__GENERAL_EQUIPMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Equipment Container</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_ACCESS_POINT_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_ACSI_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_ANY_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_ASSOCIATION_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_AUTHENTICATION_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_CB_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DA_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DATA_SET_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_FULL_DO_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_LD_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_LD_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_LD_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_LLN0_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_LN_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_LN_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_LPHD_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_LINE_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_LOG_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_MESSAGE_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_NAMESPACE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PADDR__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PREFIX__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_RED_PROT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_REF__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_RELEASE__BIGINTEGER = POWER_SYSTEM_RESOURCE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_L__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_U__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_REVISION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_RIGHT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_SDO_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_SUB_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_VERSION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Equipment Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_CONTAINER___VALIDATE_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Equipment Container</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQUIPMENT_CONTAINER_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__LINE_NUMBER = EQUIPMENT_CONTAINER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__PRIVATE = EQUIPMENT_CONTAINER__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__TEXT = EQUIPMENT_CONTAINER__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__ANY = EQUIPMENT_CONTAINER__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__ANY_ATTRIBUTE = EQUIPMENT_CONTAINER__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__NAME = EQUIPMENT_CONTAINER__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__DESC = EQUIPMENT_CONTAINER__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__LNODE = EQUIPMENT_CONTAINER__LNODE;

    /**
	 * The feature id for the '<em><b>Power Transformer</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__POWER_TRANSFORMER = EQUIPMENT_CONTAINER__POWER_TRANSFORMER;

    /**
	 * The feature id for the '<em><b>General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__GENERAL_EQUIPMENT = EQUIPMENT_CONTAINER__GENERAL_EQUIPMENT;

    /**
	 * The feature id for the '<em><b>Voltage Level</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__VOLTAGE_LEVEL = EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__FUNCTION = EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Connectivity Node</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__CONNECTIVITY_NODE = EQUIPMENT_CONTAINER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Terminal</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__TERMINAL = EQUIPMENT_CONTAINER_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Conducting Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY__CONDUCTING_EQUIPMENT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Bay</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY_FEATURE_COUNT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_ACCESS_POINT_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_ACSI_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_ANY_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_ASSOCIATION_ID__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_AUTHENTICATION_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_BASIC_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_CB_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_CDC_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DA_COUNT__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DATA_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DATA_SET_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_EMPTY__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_FULL_DO_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_IED_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_LD_INST__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_LD_INST_OR_EMPTY__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_LD_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_LLN0_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_LN_CLASS_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_LN_INST__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_LN_INST_OR_EMPTY__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_LPHD_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_LINE_TYPE__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_LOG_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_MESSAGE_ID__STRING = EQUIPMENT_CONTAINER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_NAMESPACE_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PADDR__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PTYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PREFIX__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PROCESS_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_PROCESS_TYPE__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_RED_PROT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_REF__STRING = EQUIPMENT_CONTAINER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_RELEASE__BIGINTEGER = EQUIPMENT_CONTAINER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_RESTR_NAME1ST_L__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_RESTR_NAME1ST_U__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_REVISION__STRING = EQUIPMENT_CONTAINER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_RIGHT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_SDO_COUNT__STRING = EQUIPMENT_CONTAINER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_SUB_DATA_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_VERSION__STRING = EQUIPMENT_CONTAINER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EQUIPMENT_CONTAINER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Equipment Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALIDATE_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Bay nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BAY___VALIDATE_BAY_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Bay</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BAY_OPERATION_COUNT = EQUIPMENT_CONTAINER_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__LINE_NUMBER = ABSTRACT_CONDUCTING_EQUIPMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__PRIVATE = ABSTRACT_CONDUCTING_EQUIPMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__TEXT = ABSTRACT_CONDUCTING_EQUIPMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__ANY = ABSTRACT_CONDUCTING_EQUIPMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__ANY_ATTRIBUTE = ABSTRACT_CONDUCTING_EQUIPMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__NAME = ABSTRACT_CONDUCTING_EQUIPMENT__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__DESC = ABSTRACT_CONDUCTING_EQUIPMENT__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__LNODE = ABSTRACT_CONDUCTING_EQUIPMENT__LNODE;

    /**
	 * The feature id for the '<em><b>Virtual</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__VIRTUAL = ABSTRACT_CONDUCTING_EQUIPMENT__VIRTUAL;

    /**
	 * The feature id for the '<em><b>Sub Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__SUB_EQUIPMENT = ABSTRACT_CONDUCTING_EQUIPMENT__SUB_EQUIPMENT;

    /**
	 * The feature id for the '<em><b>Terminal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__TERMINAL = ABSTRACT_CONDUCTING_EQUIPMENT__TERMINAL;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__TYPE = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Bay</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__BAY = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Function</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__FUNCTION = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Sub Function</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__SUB_FUNCTION = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Eq Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__EQ_FUNCTION = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__LINE = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Process</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT__PROCESS = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 6;

    /**
	 * The number of structural features of the '<em>Conducting Equipment</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT_FEATURE_COUNT = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 7;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_ACCESS_POINT_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_ACSI_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_ANY_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_ASSOCIATION_ID__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_CB_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_CDC_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DA_COUNT__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DATA_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DATA_SET_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_EMPTY__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_FULL_DO_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_IED_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_LD_INST__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_LD_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_LLN0_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_LN_CLASS_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_LN_INST__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_LPHD_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_LINE_TYPE__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_LOG_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_MESSAGE_ID__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_NAMESPACE_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PADDR__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PTYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PREFIX__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PROCESS_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_PROCESS_TYPE__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_RED_PROT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_REF__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_RELEASE__BIGINTEGER = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_L__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_U__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_REVISION__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_RIGHT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_SDO_COUNT__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_SUB_DATA_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_VERSION__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Equipment nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Conducting Equipment type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALIDATE_CONDUCTING_EQUIPMENT_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Conducting Equipment type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDUCTING_EQUIPMENT___VALIDATE_CONDUCTING_EQUIPMENT_TYPE_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Conducting Equipment</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONDUCTING_EQUIPMENT_OPERATION_COUNT = ABSTRACT_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__LINE_NUMBER = LNODE_CONTAINER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__PRIVATE = LNODE_CONTAINER__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__TEXT = LNODE_CONTAINER__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__ANY = LNODE_CONTAINER__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__ANY_ATTRIBUTE = LNODE_CONTAINER__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__NAME = LNODE_CONTAINER__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__DESC = LNODE_CONTAINER__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__LNODE = LNODE_CONTAINER__LNODE;

    /**
	 * The feature id for the '<em><b>Path Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__PATH_NAME = LNODE_CONTAINER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Bay</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__BAY = LNODE_CONTAINER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Terminal</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__TERMINAL = LNODE_CONTAINER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE__LINE = LNODE_CONTAINER_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Connectivity Node</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE_FEATURE_COUNT = LNODE_CONTAINER_FEATURE_COUNT + 4;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_ACCESS_POINT_NAME__STRING = LNODE_CONTAINER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_ACSI_NAME__STRING = LNODE_CONTAINER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_ANY_NAME__STRING = LNODE_CONTAINER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_ASSOCIATION_ID__STRING = LNODE_CONTAINER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_AUTHENTICATION_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_BASIC_TYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_CB_NAME__STRING = LNODE_CONTAINER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_CDC_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DA_COUNT__STRING = LNODE_CONTAINER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DATA_NAME__STRING = LNODE_CONTAINER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DATA_SET_NAME__STRING = LNODE_CONTAINER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = LNODE_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_EMPTY__STRING = LNODE_CONTAINER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = LNODE_CONTAINER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_FULL_DO_NAME__STRING = LNODE_CONTAINER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_IED_NAME__STRING = LNODE_CONTAINER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = LNODE_CONTAINER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_LD_INST__STRING = LNODE_CONTAINER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_LD_INST_OR_EMPTY__STRING = LNODE_CONTAINER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_LD_NAME__STRING = LNODE_CONTAINER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_LLN0_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_LN_CLASS_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_LN_INST__STRING = LNODE_CONTAINER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_LN_INST_OR_EMPTY__STRING = LNODE_CONTAINER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_LPHD_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_LINE_TYPE__STRING = LNODE_CONTAINER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_LOG_NAME__STRING = LNODE_CONTAINER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_MESSAGE_ID__STRING = LNODE_CONTAINER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_NAME__STRING = LNODE_CONTAINER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_NAMESPACE_NAME__STRING = LNODE_CONTAINER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = LNODE_CONTAINER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PADDR__STRING = LNODE_CONTAINER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PTYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PREFIX__STRING = LNODE_CONTAINER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PROCESS_NAME__STRING = LNODE_CONTAINER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_PROCESS_TYPE__STRING = LNODE_CONTAINER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_RED_PROT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_REF__STRING = LNODE_CONTAINER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_RELEASE__BIGINTEGER = LNODE_CONTAINER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_RESTR_NAME1ST_L__STRING = LNODE_CONTAINER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_RESTR_NAME1ST_U__STRING = LNODE_CONTAINER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_REVISION__STRING = LNODE_CONTAINER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_RIGHT_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_SDO_COUNT__STRING = LNODE_CONTAINER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_SUB_DATA_NAME__STRING = LNODE_CONTAINER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = LNODE_CONTAINER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_VERSION__STRING = LNODE_CONTAINER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = LNODE_CONTAINER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = LNODE_CONTAINER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = LNODE_CONTAINER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = LNODE_CONTAINER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Connectivity Node path Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALIDATE_CONNECTIVITY_NODE_PATH_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = LNODE_CONTAINER_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Connectivity Node path Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALIDATE_CONNECTIVITY_NODE_PATH_NAME_VALID__DIAGNOSTICCHAIN_MAP = LNODE_CONTAINER_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Connectivity Node path Name value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTIVITY_NODE___VALIDATE_CONNECTIVITY_NODE_PATH_NAME_VALUE__DIAGNOSTICCHAIN_MAP = LNODE_CONTAINER_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>Connectivity Node</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int CONNECTIVITY_NODE_OPERATION_COUNT = LNODE_CONTAINER_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__LINE_NUMBER = ABSTRACT_EQ_FUNC_SUB_FUNC__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__PRIVATE = ABSTRACT_EQ_FUNC_SUB_FUNC__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__TEXT = ABSTRACT_EQ_FUNC_SUB_FUNC__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__ANY = ABSTRACT_EQ_FUNC_SUB_FUNC__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__ANY_ATTRIBUTE = ABSTRACT_EQ_FUNC_SUB_FUNC__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__NAME = ABSTRACT_EQ_FUNC_SUB_FUNC__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__DESC = ABSTRACT_EQ_FUNC_SUB_FUNC__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__LNODE = ABSTRACT_EQ_FUNC_SUB_FUNC__LNODE;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__TYPE = ABSTRACT_EQ_FUNC_SUB_FUNC__TYPE;

    /**
	 * The feature id for the '<em><b>Eq Sub Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__EQ_SUB_FUNCTION = ABSTRACT_EQ_FUNC_SUB_FUNC__EQ_SUB_FUNCTION;

    /**
	 * The feature id for the '<em><b>Sub General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__SUB_GENERAL_EQUIPMENT = ABSTRACT_EQ_FUNC_SUB_FUNC__SUB_GENERAL_EQUIPMENT;

    /**
	 * The feature id for the '<em><b>Conducting Equipment</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__CONDUCTING_EQUIPMENT = ABSTRACT_EQ_FUNC_SUB_FUNC_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>General Equipment</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__GENERAL_EQUIPMENT = ABSTRACT_EQ_FUNC_SUB_FUNC_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Power Transformer</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__POWER_TRANSFORMER = ABSTRACT_EQ_FUNC_SUB_FUNC_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Sub Equipment</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__SUB_EQUIPMENT = ABSTRACT_EQ_FUNC_SUB_FUNC_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Transformer Winding</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__TRANSFORMER_WINDING = ABSTRACT_EQ_FUNC_SUB_FUNC_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Tap Changer</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION__TAP_CHANGER = ABSTRACT_EQ_FUNC_SUB_FUNC_FEATURE_COUNT + 5;

    /**
	 * The number of structural features of the '<em>Eq Function</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION_FEATURE_COUNT = ABSTRACT_EQ_FUNC_SUB_FUNC_FEATURE_COUNT + 6;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_ACCESS_POINT_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_ACSI_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_ANY_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_ASSOCIATION_ID__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_AUTHENTICATION_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_BASIC_TYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_CB_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_CDC_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DA_COUNT__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DATA_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DATA_SET_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_EMPTY__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_FULL_DO_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_IED_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_LD_INST__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_LD_INST_OR_EMPTY__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_LD_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_LLN0_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_LN_CLASS_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_LN_INST__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_LN_INST_OR_EMPTY__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_LPHD_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_LINE_TYPE__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_LOG_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_MESSAGE_ID__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_NAMESPACE_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PADDR__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PTYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PREFIX__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PROCESS_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_PROCESS_TYPE__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_RED_PROT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_REF__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_RELEASE__BIGINTEGER = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_RESTR_NAME1ST_L__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_RESTR_NAME1ST_U__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_REVISION__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_RIGHT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_SDO_COUNT__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_SUB_DATA_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_VERSION__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Eq Func Sub Func nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALIDATE_ABSTRACT_EQ_FUNC_SUB_FUNC_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_ABSTRACT_EQ_FUNC_SUB_FUNC_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Eq Function nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FUNCTION___VALIDATE_EQ_FUNCTION_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Eq Function</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_FUNCTION_OPERATION_COUNT = ABSTRACT_EQ_FUNC_SUB_FUNC_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__LINE_NUMBER = ABSTRACT_EQ_FUNC_SUB_FUNC__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__PRIVATE = ABSTRACT_EQ_FUNC_SUB_FUNC__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__TEXT = ABSTRACT_EQ_FUNC_SUB_FUNC__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__ANY = ABSTRACT_EQ_FUNC_SUB_FUNC__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__ANY_ATTRIBUTE = ABSTRACT_EQ_FUNC_SUB_FUNC__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__NAME = ABSTRACT_EQ_FUNC_SUB_FUNC__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__DESC = ABSTRACT_EQ_FUNC_SUB_FUNC__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__LNODE = ABSTRACT_EQ_FUNC_SUB_FUNC__LNODE;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__TYPE = ABSTRACT_EQ_FUNC_SUB_FUNC__TYPE;

    /**
	 * The feature id for the '<em><b>Eq Sub Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__EQ_SUB_FUNCTION = ABSTRACT_EQ_FUNC_SUB_FUNC__EQ_SUB_FUNCTION;

    /**
	 * The feature id for the '<em><b>Sub General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__SUB_GENERAL_EQUIPMENT = ABSTRACT_EQ_FUNC_SUB_FUNC__SUB_GENERAL_EQUIPMENT;

    /**
	 * The feature id for the '<em><b>Abstract Eq Func Sub Func</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION__ABSTRACT_EQ_FUNC_SUB_FUNC = ABSTRACT_EQ_FUNC_SUB_FUNC_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Eq Sub Function</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION_FEATURE_COUNT = ABSTRACT_EQ_FUNC_SUB_FUNC_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_ACCESS_POINT_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_ACSI_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_ANY_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_ASSOCIATION_ID__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_AUTHENTICATION_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_BASIC_TYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_CB_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_CDC_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DA_COUNT__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DATA_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DATA_SET_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_EMPTY__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_FULL_DO_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_IED_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_LD_INST__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_LD_INST_OR_EMPTY__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_LD_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_LLN0_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_LN_CLASS_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_LN_INST__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_LN_INST_OR_EMPTY__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_LPHD_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_LINE_TYPE__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_LOG_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_MESSAGE_ID__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_NAMESPACE_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PADDR__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PTYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PREFIX__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PROCESS_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_PROCESS_TYPE__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_RED_PROT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_REF__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_RELEASE__BIGINTEGER = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_RESTR_NAME1ST_L__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_RESTR_NAME1ST_U__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_REVISION__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_RIGHT_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_SDO_COUNT__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_SUB_DATA_NAME__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_VERSION__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ABSTRACT_EQ_FUNC_SUB_FUNC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Abstract Eq Func Sub Func nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALIDATE_ABSTRACT_EQ_FUNC_SUB_FUNC_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC___VALIDATE_ABSTRACT_EQ_FUNC_SUB_FUNC_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Eq Sub Function nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_SUB_FUNCTION___VALIDATE_EQ_SUB_FUNCTION_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_EQ_FUNC_SUB_FUNC_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Eq Sub Function</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EQ_SUB_FUNCTION_OPERATION_COUNT = ABSTRACT_EQ_FUNC_SUB_FUNC_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__LINE_NUMBER = POWER_SYSTEM_RESOURCE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__PRIVATE = POWER_SYSTEM_RESOURCE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__TEXT = POWER_SYSTEM_RESOURCE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__ANY = POWER_SYSTEM_RESOURCE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__ANY_ATTRIBUTE = POWER_SYSTEM_RESOURCE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__DESC = POWER_SYSTEM_RESOURCE__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__LNODE = POWER_SYSTEM_RESOURCE__LNODE;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__TYPE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Bay</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__BAY = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Conducting Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__CONDUCTING_EQUIPMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>General Equipment Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__GENERAL_EQUIPMENT_CONTAINER = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Substation</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__SUBSTATION = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Voltage Level</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__VOLTAGE_LEVEL = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Sub Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__SUB_FUNCTION = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION__GENERAL_EQUIPMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 7;

    /**
	 * The number of structural features of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 8;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_ACCESS_POINT_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_ACSI_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_ANY_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_ASSOCIATION_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_AUTHENTICATION_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_CB_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DA_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DATA_SET_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_FULL_DO_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_LD_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_LD_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_LD_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_LLN0_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_LN_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_LN_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_LPHD_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_LINE_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_LOG_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_MESSAGE_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_NAMESPACE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PADDR__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PREFIX__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PROCESS_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_PROCESS_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_RED_PROT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_REF__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_RELEASE__BIGINTEGER = POWER_SYSTEM_RESOURCE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_RESTR_NAME1ST_L__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_RESTR_NAME1ST_U__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_REVISION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_RIGHT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_SDO_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_SUB_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_VERSION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Function nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___VALIDATE_FUNCTION_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int FUNCTION_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__LINE_NUMBER = EQUIPMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__PRIVATE = EQUIPMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__TEXT = EQUIPMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__ANY = EQUIPMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__ANY_ATTRIBUTE = EQUIPMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__NAME = EQUIPMENT__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__DESC = EQUIPMENT__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__LNODE = EQUIPMENT__LNODE;

    /**
	 * The feature id for the '<em><b>Virtual</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__VIRTUAL = EQUIPMENT__VIRTUAL;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__TYPE = EQUIPMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Abstract Eq Func Sub Func</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__ABSTRACT_EQ_FUNC_SUB_FUNC = EQUIPMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Eq Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__EQ_FUNCTION = EQUIPMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Equipment Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__EQUIPMENT_CONTAINER = EQUIPMENT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Function</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__FUNCTION = EQUIPMENT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>General Equipment Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__GENERAL_EQUIPMENT_CONTAINER = EQUIPMENT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Sub Function</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT__SUB_FUNCTION = EQUIPMENT_FEATURE_COUNT + 6;

    /**
	 * The number of structural features of the '<em>General Equipment</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 7;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_ACCESS_POINT_NAME__STRING = EQUIPMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_ACSI_NAME__STRING = EQUIPMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_ANY_NAME__STRING = EQUIPMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_ASSOCIATION_ID__STRING = EQUIPMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING = EQUIPMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_CB_NAME__STRING = EQUIPMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_CDC_ENUM__STRING = EQUIPMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DA_COUNT__STRING = EQUIPMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DATA_NAME__STRING = EQUIPMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DATA_SET_NAME__STRING = EQUIPMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_EMPTY__STRING = EQUIPMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EQUIPMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_FULL_DO_NAME__STRING = EQUIPMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_IED_NAME__STRING = EQUIPMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EQUIPMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_LD_INST__STRING = EQUIPMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING = EQUIPMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_LD_NAME__STRING = EQUIPMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_LLN0_ENUM__STRING = EQUIPMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_LN_CLASS_ENUM__STRING = EQUIPMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_LN_INST__STRING = EQUIPMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING = EQUIPMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_LPHD_ENUM__STRING = EQUIPMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_LINE_TYPE__STRING = EQUIPMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_LOG_NAME__STRING = EQUIPMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_MESSAGE_ID__STRING = EQUIPMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_NAME__STRING = EQUIPMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_NAMESPACE_NAME__STRING = EQUIPMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EQUIPMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PADDR__STRING = EQUIPMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PTYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EQUIPMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PREFIX__STRING = EQUIPMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PROCESS_NAME__STRING = EQUIPMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_PROCESS_TYPE__STRING = EQUIPMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_RED_PROT_ENUM__STRING = EQUIPMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_REF__STRING = EQUIPMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_RELEASE__BIGINTEGER = EQUIPMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_L__STRING = EQUIPMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_U__STRING = EQUIPMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_REVISION__STRING = EQUIPMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_RIGHT_ENUM__STRING = EQUIPMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_SDO_COUNT__STRING = EQUIPMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_SUB_DATA_NAME__STRING = EQUIPMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EQUIPMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EQUIPMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_VERSION__STRING = EQUIPMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EQUIPMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Equipment nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate General Equipment type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALIDATE_GENERAL_EQUIPMENT_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = EQUIPMENT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate General Equipment type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_EQUIPMENT___VALIDATE_GENERAL_EQUIPMENT_TYPE_VALID__DIAGNOSTICCHAIN_MAP = EQUIPMENT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>General Equipment</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int GENERAL_EQUIPMENT_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Ied Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__IED_NAME = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Ld Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__LD_INST = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Ln Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__LN_CLASS = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Ln Inst</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__LN_INST = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Ln Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__LN_TYPE = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__PREFIX = UN_NAMING_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>IED</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__IED = UN_NAMING_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>LDevice</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__LDEVICE = UN_NAMING_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>LN</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__LN = UN_NAMING_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>LNode Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE__LNODE_CONTAINER = UN_NAMING_FEATURE_COUNT + 9;

    /**
	 * The number of structural features of the '<em>LNode</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 10;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate LNode ln Class required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALIDATE_LNODE_LN_CLASS_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate LNode ln Class value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALIDATE_LNODE_LN_CLASS_VALUE__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate LNode ln Inst required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALIDATE_LNODE_LN_INST_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate LNode ied Name value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALIDATE_LNODE_IED_NAME_VALUE__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate LNode ld Inst value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALIDATE_LNODE_LD_INST_VALUE__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 4;

				/**
	 * The operation id for the '<em>Validate LNode prefix value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALIDATE_LNODE_PREFIX_VALUE__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 5;

				/**
	 * The operation id for the '<em>Validate LNode ln Inst value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALIDATE_LNODE_LN_INST_VALUE__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 6;

				/**
	 * The operation id for the '<em>Validate LNode ln Type value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LNODE___VALIDATE_LNODE_LN_TYPE_VALUE__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 7;

				/**
	 * The number of operations of the '<em>LNode</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LNODE_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 8;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__LINE_NUMBER = UN_NAMING__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__PRIVATE = UN_NAMING__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__TEXT = UN_NAMING__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__ANY = UN_NAMING__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__ANY_ATTRIBUTE = UN_NAMING__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__DESC = UN_NAMING__DESC;

    /**
	 * The feature id for the '<em><b>Bay Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__BAY_NAME = UN_NAMING_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>CNode Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__CNODE_NAME = UN_NAMING_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Connectivity Node</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__CONNECTIVITY_NODE = UN_NAMING_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Process Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__PROCESS_NAME = UN_NAMING_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Substation Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__SUBSTATION_NAME = UN_NAMING_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Voltage Level Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__VOLTAGE_LEVEL_NAME = UN_NAMING_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Abstract Conducting Equipment</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__ABSTRACT_CONDUCTING_EQUIPMENT = UN_NAMING_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Bay</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__BAY = UN_NAMING_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>CNode</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__CNODE = UN_NAMING_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>Substation</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__SUBSTATION = UN_NAMING_FEATURE_COUNT + 9;

    /**
	 * The feature id for the '<em><b>Voltage Level</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__VOLTAGE_LEVEL = UN_NAMING_FEATURE_COUNT + 10;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL__NAME = UN_NAMING_FEATURE_COUNT + 11;

    /**
	 * The number of structural features of the '<em>Terminal</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL_FEATURE_COUNT = UN_NAMING_FEATURE_COUNT + 12;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_ACCESS_POINT_NAME__STRING = UN_NAMING___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_ACSI_NAME__STRING = UN_NAMING___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_ANY_NAME__STRING = UN_NAMING___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_ASSOCIATION_ID__STRING = UN_NAMING___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_AUTHENTICATION_ENUM__STRING = UN_NAMING___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_CB_NAME__STRING = UN_NAMING___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DA_COUNT__STRING = UN_NAMING___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DATA_NAME__STRING = UN_NAMING___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DATA_SET_NAME__STRING = UN_NAMING___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_ENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = UN_NAMING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_EMPTY__STRING = UN_NAMING___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = UN_NAMING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_FULL_DO_NAME__STRING = UN_NAMING___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_IED_NAME__STRING = UN_NAMING___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = UN_NAMING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_LD_INST__STRING = UN_NAMING___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_LD_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_LD_NAME__STRING = UN_NAMING___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_LLN0_ENUM__STRING = UN_NAMING___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_LN_INST__STRING = UN_NAMING___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_LN_INST_OR_EMPTY__STRING = UN_NAMING___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_LPHD_ENUM__STRING = UN_NAMING___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_LINE_TYPE__STRING = UN_NAMING___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_LOG_NAME__STRING = UN_NAMING___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_MESSAGE_ID__STRING = UN_NAMING___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_NAME__STRING = UN_NAMING___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_NAMESPACE_NAME__STRING = UN_NAMING___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = UN_NAMING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PADDR__STRING = UN_NAMING___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = UN_NAMING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = UN_NAMING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PREFIX__STRING = UN_NAMING___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PROCESS_NAME__STRING = UN_NAMING___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_PROCESS_TYPE__STRING = UN_NAMING___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_RED_PROT_ENUM__STRING = UN_NAMING___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_REF__STRING = UN_NAMING___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_RELEASE__BIGINTEGER = UN_NAMING___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_RESTR_NAME1ST_L__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_RESTR_NAME1ST_U__STRING = UN_NAMING___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_REVISION__STRING = UN_NAMING___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_RIGHT_ENUM__STRING = UN_NAMING___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_SDO_COUNT__STRING = UN_NAMING___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_SUB_DATA_NAME__STRING = UN_NAMING___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = UN_NAMING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = UN_NAMING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_VERSION__STRING = UN_NAMING___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = UN_NAMING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Terminal connectivity Node required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_CONNECTIVITY_NODE_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Terminal connectivity Node valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_CONNECTIVITY_NODE_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Terminal connectivity Node value shall be pathname</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_CONNECTIVITY_NODE_VALUE_SHALL_BE_PATHNAME__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Terminal substation Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_SUBSTATION_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 3;

				/**
	 * The operation id for the '<em>Validate Terminal substation Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_SUBSTATION_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 4;

				/**
	 * The operation id for the '<em>Validate Terminal voltage Level Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_VOLTAGE_LEVEL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 5;

				/**
	 * The operation id for the '<em>Validate Terminal voltage Level Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_VOLTAGE_LEVEL_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 6;

				/**
	 * The operation id for the '<em>Validate Terminal bay Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_BAY_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 7;

				/**
	 * The operation id for the '<em>Validate Terminal bay Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_BAY_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 8;

				/**
	 * The operation id for the '<em>Validate Terminal cNode Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_CNODE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 9;

				/**
	 * The operation id for the '<em>Validate Terminal cNode Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_CNODE_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 10;

				/**
	 * The operation id for the '<em>Validate Terminal process Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERMINAL___VALIDATE_TERMINAL_PROCESS_NAME_VALID__DIAGNOSTICCHAIN_MAP = UN_NAMING_OPERATION_COUNT + 11;

				/**
	 * The number of operations of the '<em>Terminal</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TERMINAL_OPERATION_COUNT = UN_NAMING_OPERATION_COUNT + 12;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__LINE_NUMBER = TERMINAL__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__PRIVATE = TERMINAL__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__TEXT = TERMINAL__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__ANY = TERMINAL__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__ANY_ATTRIBUTE = TERMINAL__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__DESC = TERMINAL__DESC;

    /**
	 * The feature id for the '<em><b>Bay Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__BAY_NAME = TERMINAL__BAY_NAME;

    /**
	 * The feature id for the '<em><b>CNode Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__CNODE_NAME = TERMINAL__CNODE_NAME;

    /**
	 * The feature id for the '<em><b>Connectivity Node</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__CONNECTIVITY_NODE = TERMINAL__CONNECTIVITY_NODE;

    /**
	 * The feature id for the '<em><b>Process Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__PROCESS_NAME = TERMINAL__PROCESS_NAME;

    /**
	 * The feature id for the '<em><b>Substation Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__SUBSTATION_NAME = TERMINAL__SUBSTATION_NAME;

    /**
	 * The feature id for the '<em><b>Voltage Level Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__VOLTAGE_LEVEL_NAME = TERMINAL__VOLTAGE_LEVEL_NAME;

    /**
	 * The feature id for the '<em><b>Abstract Conducting Equipment</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__ABSTRACT_CONDUCTING_EQUIPMENT = TERMINAL__ABSTRACT_CONDUCTING_EQUIPMENT;

    /**
	 * The feature id for the '<em><b>Bay</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__BAY = TERMINAL__BAY;

    /**
	 * The feature id for the '<em><b>CNode</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__CNODE = TERMINAL__CNODE;

    /**
	 * The feature id for the '<em><b>Substation</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__SUBSTATION = TERMINAL__SUBSTATION;

    /**
	 * The feature id for the '<em><b>Voltage Level</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__VOLTAGE_LEVEL = TERMINAL__VOLTAGE_LEVEL;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__NAME = TERMINAL__NAME;

    /**
	 * The feature id for the '<em><b>Transformer Winding</b></em>' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT__TRANSFORMER_WINDING = TERMINAL_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Neutral Point</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT_FEATURE_COUNT = TERMINAL_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_ACCESS_POINT_NAME__STRING = TERMINAL___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_ACSI_NAME__STRING = TERMINAL___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_ANY_NAME__STRING = TERMINAL___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_ASSOCIATION_ID__STRING = TERMINAL___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = TERMINAL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_AUTHENTICATION_ENUM__STRING = TERMINAL___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_BASIC_TYPE_ENUM__STRING = TERMINAL___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_CB_NAME__STRING = TERMINAL___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_CDC_ENUM__STRING = TERMINAL___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = TERMINAL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DA_COUNT__STRING = TERMINAL___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DATA_NAME__STRING = TERMINAL___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DATA_SET_NAME__STRING = TERMINAL___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_ENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = TERMINAL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_EMPTY__STRING = TERMINAL___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = TERMINAL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = TERMINAL___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = TERMINAL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = TERMINAL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = TERMINAL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = TERMINAL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = TERMINAL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = TERMINAL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_FULL_DO_NAME__STRING = TERMINAL___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = TERMINAL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_IED_NAME__STRING = TERMINAL___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = TERMINAL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_LD_INST__STRING = TERMINAL___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_LD_INST_OR_EMPTY__STRING = TERMINAL___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_LD_NAME__STRING = TERMINAL___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_LLN0_ENUM__STRING = TERMINAL___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_LN_CLASS_ENUM__STRING = TERMINAL___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_LN_INST__STRING = TERMINAL___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_LN_INST_OR_EMPTY__STRING = TERMINAL___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_LPHD_ENUM__STRING = TERMINAL___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_LINE_TYPE__STRING = TERMINAL___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_LOG_NAME__STRING = TERMINAL___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_MESSAGE_ID__STRING = TERMINAL___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_NAME__STRING = TERMINAL___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_NAMESPACE_NAME__STRING = TERMINAL___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = TERMINAL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PADDR__STRING = TERMINAL___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PTYPE_ENUM__STRING = TERMINAL___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = TERMINAL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = TERMINAL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = TERMINAL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = TERMINAL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = TERMINAL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = TERMINAL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = TERMINAL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = TERMINAL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = TERMINAL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = TERMINAL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = TERMINAL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = TERMINAL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PREFIX__STRING = TERMINAL___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PROCESS_NAME__STRING = TERMINAL___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_PROCESS_TYPE__STRING = TERMINAL___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_RED_PROT_ENUM__STRING = TERMINAL___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_REF__STRING = TERMINAL___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_RELEASE__BIGINTEGER = TERMINAL___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_RESTR_NAME1ST_L__STRING = TERMINAL___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_RESTR_NAME1ST_U__STRING = TERMINAL___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_REVISION__STRING = TERMINAL___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_RIGHT_ENUM__STRING = TERMINAL___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_SDO_COUNT__STRING = TERMINAL___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_SUB_DATA_NAME__STRING = TERMINAL___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = TERMINAL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = TERMINAL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_VERSION__STRING = TERMINAL___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = TERMINAL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Terminal connectivity Node required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_CONNECTIVITY_NODE_REQUIRED__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_CONNECTIVITY_NODE_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal connectivity Node valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_CONNECTIVITY_NODE_VALID__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_CONNECTIVITY_NODE_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal connectivity Node value shall be pathname</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_CONNECTIVITY_NODE_VALUE_SHALL_BE_PATHNAME__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_CONNECTIVITY_NODE_VALUE_SHALL_BE_PATHNAME__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal substation Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_SUBSTATION_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_SUBSTATION_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal substation Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_SUBSTATION_NAME_VALID__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_SUBSTATION_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal voltage Level Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_VOLTAGE_LEVEL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_VOLTAGE_LEVEL_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal voltage Level Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_VOLTAGE_LEVEL_NAME_VALID__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_VOLTAGE_LEVEL_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal bay Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_BAY_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_BAY_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal bay Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_BAY_NAME_VALID__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_BAY_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal cNode Name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_CNODE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_CNODE_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal cNode Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_CNODE_NAME_VALID__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_CNODE_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Terminal process Name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEUTRAL_POINT___VALIDATE_TERMINAL_PROCESS_NAME_VALID__DIAGNOSTICCHAIN_MAP = TERMINAL___VALIDATE_TERMINAL_PROCESS_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Neutral Point</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NEUTRAL_POINT_OPERATION_COUNT = TERMINAL_OPERATION_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__LINE_NUMBER = EQUIPMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__PRIVATE = EQUIPMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__TEXT = EQUIPMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__ANY = EQUIPMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__ANY_ATTRIBUTE = EQUIPMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__NAME = EQUIPMENT__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__DESC = EQUIPMENT__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__LNODE = EQUIPMENT__LNODE;

    /**
	 * The feature id for the '<em><b>Virtual</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__VIRTUAL = EQUIPMENT__VIRTUAL;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__TYPE = EQUIPMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Eq Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__EQ_FUNCTION = EQUIPMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Equipment Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__EQUIPMENT_CONTAINER = EQUIPMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Sub Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__SUB_EQUIPMENT = EQUIPMENT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Transformer Winding</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER__TRANSFORMER_WINDING = EQUIPMENT_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Power Transformer</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER_FEATURE_COUNT = EQUIPMENT_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_ACCESS_POINT_NAME__STRING = EQUIPMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_ACSI_NAME__STRING = EQUIPMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_ANY_NAME__STRING = EQUIPMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_ASSOCIATION_ID__STRING = EQUIPMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_AUTHENTICATION_ENUM__STRING = EQUIPMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_BASIC_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_CB_NAME__STRING = EQUIPMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_CDC_ENUM__STRING = EQUIPMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DA_COUNT__STRING = EQUIPMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DATA_NAME__STRING = EQUIPMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DATA_SET_NAME__STRING = EQUIPMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_ENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_EMPTY__STRING = EQUIPMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EQUIPMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_FULL_DO_NAME__STRING = EQUIPMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_IED_NAME__STRING = EQUIPMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EQUIPMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_LD_INST__STRING = EQUIPMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_LD_INST_OR_EMPTY__STRING = EQUIPMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_LD_NAME__STRING = EQUIPMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_LLN0_ENUM__STRING = EQUIPMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_LN_CLASS_ENUM__STRING = EQUIPMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_LN_INST__STRING = EQUIPMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_LN_INST_OR_EMPTY__STRING = EQUIPMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_LPHD_ENUM__STRING = EQUIPMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_LINE_TYPE__STRING = EQUIPMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_LOG_NAME__STRING = EQUIPMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_MESSAGE_ID__STRING = EQUIPMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_NAME__STRING = EQUIPMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_NAMESPACE_NAME__STRING = EQUIPMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EQUIPMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PADDR__STRING = EQUIPMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PTYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EQUIPMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PREFIX__STRING = EQUIPMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PROCESS_NAME__STRING = EQUIPMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_PROCESS_TYPE__STRING = EQUIPMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_RED_PROT_ENUM__STRING = EQUIPMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_REF__STRING = EQUIPMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_RELEASE__BIGINTEGER = EQUIPMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_RESTR_NAME1ST_L__STRING = EQUIPMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_RESTR_NAME1ST_U__STRING = EQUIPMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_REVISION__STRING = EQUIPMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_RIGHT_ENUM__STRING = EQUIPMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_SDO_COUNT__STRING = EQUIPMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_SUB_DATA_NAME__STRING = EQUIPMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EQUIPMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EQUIPMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_VERSION__STRING = EQUIPMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EQUIPMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Equipment nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power Transformer type value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALIDATE_POWER_TRANSFORMER_TYPE_VALUE__DIAGNOSTICCHAIN_MAP = EQUIPMENT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Power Transformer at least one Transformer Winding required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_TRANSFORMER___VALIDATE_POWER_TRANSFORMER_AT_LEAST_ONE_TRANSFORMER_WINDING_REQUIRED__DIAGNOSTICCHAIN_MAP = EQUIPMENT_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Power Transformer</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int POWER_TRANSFORMER_OPERATION_COUNT = EQUIPMENT_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__LINE_NUMBER = POWER_SYSTEM_RESOURCE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__PRIVATE = POWER_SYSTEM_RESOURCE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__TEXT = POWER_SYSTEM_RESOURCE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__ANY = POWER_SYSTEM_RESOURCE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__ANY_ATTRIBUTE = POWER_SYSTEM_RESOURCE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__DESC = POWER_SYSTEM_RESOURCE__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__LNODE = POWER_SYSTEM_RESOURCE__LNODE;

    /**
	 * The feature id for the '<em><b>Phase</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__PHASE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Virtual</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__VIRTUAL = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Abstract Conducting Equipment</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__ABSTRACT_CONDUCTING_EQUIPMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Eq Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__EQ_FUNCTION = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Power Transformer</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__POWER_TRANSFORMER = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Tap Changer</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT__TAP_CHANGER = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
	 * The number of structural features of the '<em>Sub Equipment</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 6;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_ACCESS_POINT_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_ACSI_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_ANY_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_ASSOCIATION_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_CB_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DA_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DATA_SET_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_FULL_DO_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_LD_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_LD_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_LLN0_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_LN_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_LPHD_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_LINE_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_LOG_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_MESSAGE_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_NAMESPACE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PADDR__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PREFIX__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PROCESS_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_PROCESS_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_RED_PROT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_REF__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_RELEASE__BIGINTEGER = POWER_SYSTEM_RESOURCE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_L__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_U__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_REVISION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_RIGHT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_SDO_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_SUB_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_VERSION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Sub Equipment nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_EQUIPMENT___VALIDATE_SUB_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Sub Equipment</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_EQUIPMENT_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__LINE_NUMBER = POWER_SYSTEM_RESOURCE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__PRIVATE = POWER_SYSTEM_RESOURCE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__TEXT = POWER_SYSTEM_RESOURCE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__ANY = POWER_SYSTEM_RESOURCE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__ANY_ATTRIBUTE = POWER_SYSTEM_RESOURCE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__DESC = POWER_SYSTEM_RESOURCE__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__LNODE = POWER_SYSTEM_RESOURCE__LNODE;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__TYPE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Conducting Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__CONDUCTING_EQUIPMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Function</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__FUNCTION = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__GENERAL_EQUIPMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Sub Sub Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION__SUB_SUB_FUNCTIONS = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Sub Function</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_ACCESS_POINT_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_ACSI_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_ANY_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_ASSOCIATION_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_AUTHENTICATION_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_CB_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DA_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DATA_SET_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_FULL_DO_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_LD_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_LD_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_LD_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_LLN0_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_LN_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_LN_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_LPHD_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_LINE_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_LOG_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_MESSAGE_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_NAMESPACE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PADDR__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PREFIX__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PROCESS_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_PROCESS_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_RED_PROT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_REF__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_RELEASE__BIGINTEGER = POWER_SYSTEM_RESOURCE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_RESTR_NAME1ST_L__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_RESTR_NAME1ST_U__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_REVISION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_RIGHT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_SDO_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_SUB_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_VERSION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Sub Function nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FUNCTION___VALIDATE_SUB_FUNCTION_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Sub Function</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUB_FUNCTION_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__LINE_NUMBER = EQUIPMENT_CONTAINER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__PRIVATE = EQUIPMENT_CONTAINER__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__TEXT = EQUIPMENT_CONTAINER__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__ANY = EQUIPMENT_CONTAINER__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__ANY_ATTRIBUTE = EQUIPMENT_CONTAINER__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__NAME = EQUIPMENT_CONTAINER__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__DESC = EQUIPMENT_CONTAINER__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__LNODE = EQUIPMENT_CONTAINER__LNODE;

    /**
	 * The feature id for the '<em><b>Power Transformer</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__POWER_TRANSFORMER = EQUIPMENT_CONTAINER__POWER_TRANSFORMER;

    /**
	 * The feature id for the '<em><b>General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__GENERAL_EQUIPMENT = EQUIPMENT_CONTAINER__GENERAL_EQUIPMENT;

    /**
	 * The feature id for the '<em><b>Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__FUNCTION = EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Voltage Level</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__VOLTAGE_LEVEL = EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Terminal</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__TERMINAL = EQUIPMENT_CONTAINER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Process</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__PROCESS = EQUIPMENT_CONTAINER_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>SCL</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION__SCL = EQUIPMENT_CONTAINER_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Substation</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION_FEATURE_COUNT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_ACCESS_POINT_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_ACSI_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_ANY_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_ASSOCIATION_ID__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_AUTHENTICATION_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_BASIC_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_CB_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_CDC_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DA_COUNT__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DATA_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DATA_SET_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_EMPTY__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_FULL_DO_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_IED_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_LD_INST__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_LD_INST_OR_EMPTY__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_LD_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_LLN0_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_LN_CLASS_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_LN_INST__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_LN_INST_OR_EMPTY__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_LPHD_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_LINE_TYPE__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_LOG_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_MESSAGE_ID__STRING = EQUIPMENT_CONTAINER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_NAMESPACE_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PADDR__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PTYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PREFIX__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PROCESS_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_PROCESS_TYPE__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_RED_PROT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_REF__STRING = EQUIPMENT_CONTAINER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_RELEASE__BIGINTEGER = EQUIPMENT_CONTAINER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_RESTR_NAME1ST_L__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_RESTR_NAME1ST_U__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_REVISION__STRING = EQUIPMENT_CONTAINER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_RIGHT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_SDO_COUNT__STRING = EQUIPMENT_CONTAINER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_SUB_DATA_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_VERSION__STRING = EQUIPMENT_CONTAINER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EQUIPMENT_CONTAINER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Equipment Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALIDATE_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Substation nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALIDATE_SUBSTATION_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Substation at least one Voltage Level required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTATION___VALIDATE_SUBSTATION_AT_LEAST_ONE_VOLTAGE_LEVEL_REQUIRED__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER_OPERATION_COUNT + 1;

				/**
	 * The number of operations of the '<em>Substation</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SUBSTATION_OPERATION_COUNT = EQUIPMENT_CONTAINER_OPERATION_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__LINE_NUMBER = POWER_SYSTEM_RESOURCE__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__PRIVATE = POWER_SYSTEM_RESOURCE__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__TEXT = POWER_SYSTEM_RESOURCE__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__ANY = POWER_SYSTEM_RESOURCE__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__ANY_ATTRIBUTE = POWER_SYSTEM_RESOURCE__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__NAME = POWER_SYSTEM_RESOURCE__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__DESC = POWER_SYSTEM_RESOURCE__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__LNODE = POWER_SYSTEM_RESOURCE__LNODE;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__TYPE = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Virtual</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__VIRTUAL = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Eq Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__EQ_FUNCTION = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Sub Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__SUB_EQUIPMENT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Transformer Winding</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER__TRANSFORMER_WINDING = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Tap Changer</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER_FEATURE_COUNT = POWER_SYSTEM_RESOURCE_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_ACCESS_POINT_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_ACSI_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_ANY_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_ASSOCIATION_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_AUTHENTICATION_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_CB_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DA_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DATA_SET_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_EXTENSION_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_FULL_DO_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_LD_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_LD_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_LD_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_LLN0_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_LN_INST__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_LN_INST_OR_EMPTY__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_LPHD_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_LINE_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_LOG_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_MESSAGE_ID__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_NAMESPACE_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PADDR__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PREFIX__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PROCESS_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_PROCESS_TYPE__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_RED_PROT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_REF__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_RELEASE__BIGINTEGER = POWER_SYSTEM_RESOURCE___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_RESTR_NAME1ST_L__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_RESTR_NAME1ST_U__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_REVISION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_RIGHT_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_SDO_COUNT__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_SUB_DATA_NAME__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_VERSION__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = POWER_SYSTEM_RESOURCE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Tap Changer type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALIDATE_TAP_CHANGER_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Tap Changer type valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALIDATE_TAP_CHANGER_TYPE_VALID__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Tap Changer type value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_CHANGER___VALIDATE_TAP_CHANGER_TYPE_VALUE__DIAGNOSTICCHAIN_MAP = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>Tap Changer</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TAP_CHANGER_OPERATION_COUNT = POWER_SYSTEM_RESOURCE_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__LINE_NUMBER = ABSTRACT_CONDUCTING_EQUIPMENT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__PRIVATE = ABSTRACT_CONDUCTING_EQUIPMENT__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__TEXT = ABSTRACT_CONDUCTING_EQUIPMENT__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__ANY = ABSTRACT_CONDUCTING_EQUIPMENT__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__ANY_ATTRIBUTE = ABSTRACT_CONDUCTING_EQUIPMENT__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__NAME = ABSTRACT_CONDUCTING_EQUIPMENT__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__DESC = ABSTRACT_CONDUCTING_EQUIPMENT__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__LNODE = ABSTRACT_CONDUCTING_EQUIPMENT__LNODE;

    /**
	 * The feature id for the '<em><b>Virtual</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__VIRTUAL = ABSTRACT_CONDUCTING_EQUIPMENT__VIRTUAL;

    /**
	 * The feature id for the '<em><b>Sub Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__SUB_EQUIPMENT = ABSTRACT_CONDUCTING_EQUIPMENT__SUB_EQUIPMENT;

    /**
	 * The feature id for the '<em><b>Terminal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__TERMINAL = ABSTRACT_CONDUCTING_EQUIPMENT__TERMINAL;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__TYPE = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Eq Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__EQ_FUNCTION = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Neutral Point</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__NEUTRAL_POINT = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Power Transformer</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__POWER_TRANSFORMER = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Tap Changer</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING__TAP_CHANGER = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Transformer Winding</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING_FEATURE_COUNT = ABSTRACT_CONDUCTING_EQUIPMENT_FEATURE_COUNT + 5;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_ACCESS_POINT_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_ACSI_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_ANY_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_ASSOCIATION_ID__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_AUTHENTICATION_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_BASIC_TYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_CB_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_CDC_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DA_COUNT__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DATA_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DATA_SET_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_EMPTY__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_EXTENSION_CDC_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_FULL_DO_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_IED_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_LD_INST__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_LD_INST_OR_EMPTY__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_LD_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_LLN0_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_LN_CLASS_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_LN_INST__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_LN_INST_OR_EMPTY__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_LPHD_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_LINE_TYPE__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_LOG_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_MESSAGE_ID__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_NAMESPACE_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PADDR__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PTYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PREFIX__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PROCESS_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_PROCESS_TYPE__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_RED_PROT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_REF__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_RELEASE__BIGINTEGER = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_RESTR_NAME1ST_L__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_RESTR_NAME1ST_U__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_REVISION__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_RIGHT_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_SDO_COUNT__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_SUB_DATA_NAME__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_VERSION__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = ABSTRACT_CONDUCTING_EQUIPMENT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Equipment nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT___VALIDATE_EQUIPMENT_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Transformer Winding type required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMER_WINDING___VALIDATE_TRANSFORMER_WINDING_TYPE_REQUIRED__DIAGNOSTICCHAIN_MAP = ABSTRACT_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Transformer Winding</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TRANSFORMER_WINDING_OPERATION_COUNT = ABSTRACT_CONDUCTING_EQUIPMENT_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ValueWithUnitImpl <em>Value With Unit</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ValueWithUnitImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getValueWithUnit()
	 * @generated
	 */
    int VALUE_WITH_UNIT = 152;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_WITH_UNIT__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_WITH_UNIT__VALUE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Multiplier</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_WITH_UNIT__MULTIPLIER = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_WITH_UNIT__UNIT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Value With Unit</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_WITH_UNIT_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Value With Unit value required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALIDATE_VALUE_WITH_UNIT_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Value With Unit unit required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALIDATE_VALUE_WITH_UNIT_UNIT_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Value With Unit unit valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_WITH_UNIT___VALIDATE_VALUE_WITH_UNIT_UNIT_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>Value With Unit</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VALUE_WITH_UNIT_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE__LINE_NUMBER = VALUE_WITH_UNIT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE__VALUE = VALUE_WITH_UNIT__VALUE;

    /**
	 * The feature id for the '<em><b>Multiplier</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE__MULTIPLIER = VALUE_WITH_UNIT__MULTIPLIER;

    /**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE__UNIT = VALUE_WITH_UNIT__UNIT;

    /**
	 * The number of structural features of the '<em>Voltage</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_FEATURE_COUNT = VALUE_WITH_UNIT_FEATURE_COUNT + 0;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_ACCESS_POINT_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_ACSI_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_ANY_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_ASSOCIATION_ID__STRING = VALUE_WITH_UNIT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_AUTHENTICATION_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_BASIC_TYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_CB_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_CDC_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DA_COUNT__STRING = VALUE_WITH_UNIT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DATA_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DATA_SET_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_EMPTY__STRING = VALUE_WITH_UNIT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_FULL_DO_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_IED_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = VALUE_WITH_UNIT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_LD_INST__STRING = VALUE_WITH_UNIT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_LD_INST_OR_EMPTY__STRING = VALUE_WITH_UNIT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_LD_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_LLN0_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_LN_CLASS_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_LN_INST__STRING = VALUE_WITH_UNIT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_LN_INST_OR_EMPTY__STRING = VALUE_WITH_UNIT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_LPHD_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_LINE_TYPE__STRING = VALUE_WITH_UNIT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_LOG_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_MESSAGE_ID__STRING = VALUE_WITH_UNIT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_NAMESPACE_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PADDR__STRING = VALUE_WITH_UNIT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PTYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PREFIX__STRING = VALUE_WITH_UNIT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PROCESS_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_PROCESS_TYPE__STRING = VALUE_WITH_UNIT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_RED_PROT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_REF__STRING = VALUE_WITH_UNIT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_RELEASE__BIGINTEGER = VALUE_WITH_UNIT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_RESTR_NAME1ST_L__STRING = VALUE_WITH_UNIT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_RESTR_NAME1ST_U__STRING = VALUE_WITH_UNIT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_REVISION__STRING = VALUE_WITH_UNIT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_RIGHT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_SDO_COUNT__STRING = VALUE_WITH_UNIT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_SUB_DATA_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_VERSION__STRING = VALUE_WITH_UNIT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = VALUE_WITH_UNIT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Value With Unit value required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALIDATE_VALUE_WITH_UNIT_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP = VALUE_WITH_UNIT___VALIDATE_VALUE_WITH_UNIT_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Value With Unit unit required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALIDATE_VALUE_WITH_UNIT_UNIT_REQUIRED__DIAGNOSTICCHAIN_MAP = VALUE_WITH_UNIT___VALIDATE_VALUE_WITH_UNIT_UNIT_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Value With Unit unit valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALIDATE_VALUE_WITH_UNIT_UNIT_VALID__DIAGNOSTICCHAIN_MAP = VALUE_WITH_UNIT___VALIDATE_VALUE_WITH_UNIT_UNIT_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Voltage unit value fixed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE___VALIDATE_VOLTAGE_UNIT_VALUE_FIXED__DIAGNOSTICCHAIN_MAP = VALUE_WITH_UNIT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Voltage</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_OPERATION_COUNT = VALUE_WITH_UNIT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__LINE_NUMBER = EQUIPMENT_CONTAINER__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Private</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__PRIVATE = EQUIPMENT_CONTAINER__PRIVATE;

    /**
	 * The feature id for the '<em><b>Text</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__TEXT = EQUIPMENT_CONTAINER__TEXT;

    /**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__ANY = EQUIPMENT_CONTAINER__ANY;

    /**
	 * The feature id for the '<em><b>Any Attribute</b></em>' attribute list.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__ANY_ATTRIBUTE = EQUIPMENT_CONTAINER__ANY_ATTRIBUTE;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__NAME = EQUIPMENT_CONTAINER__NAME;

    /**
	 * The feature id for the '<em><b>Desc</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__DESC = EQUIPMENT_CONTAINER__DESC;

    /**
	 * The feature id for the '<em><b>LNode</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__LNODE = EQUIPMENT_CONTAINER__LNODE;

    /**
	 * The feature id for the '<em><b>Power Transformer</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__POWER_TRANSFORMER = EQUIPMENT_CONTAINER__POWER_TRANSFORMER;

    /**
	 * The feature id for the '<em><b>General Equipment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__GENERAL_EQUIPMENT = EQUIPMENT_CONTAINER__GENERAL_EQUIPMENT;

    /**
	 * The feature id for the '<em><b>Nom Freq</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__NOM_FREQ = EQUIPMENT_CONTAINER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Num Phases</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__NUM_PHASES = EQUIPMENT_CONTAINER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Bay</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__BAY = EQUIPMENT_CONTAINER_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Function</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__FUNCTION = EQUIPMENT_CONTAINER_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Substation</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__SUBSTATION = EQUIPMENT_CONTAINER_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Voltage</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__VOLTAGE = EQUIPMENT_CONTAINER_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Terminal</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL__TERMINAL = EQUIPMENT_CONTAINER_FEATURE_COUNT + 6;

    /**
	 * The number of structural features of the '<em>Voltage Level</em>' class.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL_FEATURE_COUNT = EQUIPMENT_CONTAINER_FEATURE_COUNT + 7;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_ACCESS_POINT_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_ACSI_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_ANY_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_ASSOCIATION_ID__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_AUTHENTICATION_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_BASIC_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_CB_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_CDC_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DA_COUNT__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DATA_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DATA_SET_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_EMPTY__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_EXTENSION_CDC_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_FULL_DO_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_IED_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = EQUIPMENT_CONTAINER___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_LD_INST__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_LD_INST_OR_EMPTY__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_LD_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_LLN0_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_LN_CLASS_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_LN_INST__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_LN_INST_OR_EMPTY__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_LPHD_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_LINE_TYPE__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_LOG_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_MESSAGE_ID__STRING = EQUIPMENT_CONTAINER___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_NAMESPACE_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PADDR__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PTYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PREFIX__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PROCESS_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_PROCESS_TYPE__STRING = EQUIPMENT_CONTAINER___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_RED_PROT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_REF__STRING = EQUIPMENT_CONTAINER___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_RELEASE__BIGINTEGER = EQUIPMENT_CONTAINER___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_RESTR_NAME1ST_L__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_RESTR_NAME1ST_U__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_REVISION__STRING = EQUIPMENT_CONTAINER___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_RIGHT_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_SDO_COUNT__STRING = EQUIPMENT_CONTAINER___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_SUB_DATA_NAME__STRING = EQUIPMENT_CONTAINER___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = EQUIPMENT_CONTAINER___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_VERSION__STRING = EQUIPMENT_CONTAINER___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = EQUIPMENT_CONTAINER___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Naming name required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Naming name valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_NAMING_NAME_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate LNode Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_LNODE_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Power System Resource nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_POWER_SYSTEM_RESOURCE_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Equipment Container nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALIDATE_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER___VALIDATE_EQUIPMENT_CONTAINER_NOTHING__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Voltage Level nom Freq value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALIDATE_VOLTAGE_LEVEL_NOM_FREQ_VALUE__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Voltage Level num Phases value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALIDATE_VOLTAGE_LEVEL_NUM_PHASES_VALUE__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Voltage Level at least one Bay required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOLTAGE_LEVEL___VALIDATE_VOLTAGE_LEVEL_AT_LEAST_ONE_BAY_REQUIRED__DIAGNOSTICCHAIN_MAP = EQUIPMENT_CONTAINER_OPERATION_COUNT + 2;

				/**
	 * The number of operations of the '<em>Voltage Level</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int VOLTAGE_LEVEL_OPERATION_COUNT = EQUIPMENT_CONTAINER_OPERATION_COUNT + 3;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceWithMaxAndModifyImpl <em>Service With Max And Modify</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.ServiceWithMaxAndModifyImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceWithMaxAndModify()
	 * @generated
	 */
    int SERVICE_WITH_MAX_AND_MODIFY = 149;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_AND_MODIFY__LINE_NUMBER = SERVICE_WITH_MAX__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_AND_MODIFY__MAX = SERVICE_WITH_MAX__MAX;

    /**
	 * The feature id for the '<em><b>Modify</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_AND_MODIFY__MODIFY = SERVICE_WITH_MAX_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Service With Max And Modify</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_AND_MODIFY_FEATURE_COUNT = SERVICE_WITH_MAX_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_ACCESS_POINT_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_ACSI_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_ANY_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_ASSOCIATION_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_AUTHENTICATION_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_CB_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DA_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DATA_SET_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_FULL_DO_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SERVICE_WITH_MAX___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_LD_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_LD_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_LD_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_LLN0_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_LN_INST__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_LN_INST_OR_EMPTY__STRING = SERVICE_WITH_MAX___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_LPHD_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_LINE_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_LOG_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_MESSAGE_ID__STRING = SERVICE_WITH_MAX___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_NAMESPACE_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PADDR__STRING = SERVICE_WITH_MAX___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PREFIX__STRING = SERVICE_WITH_MAX___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PROCESS_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_PROCESS_TYPE__STRING = SERVICE_WITH_MAX___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_RED_PROT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_REF__STRING = SERVICE_WITH_MAX___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_RELEASE__BIGINTEGER = SERVICE_WITH_MAX___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_RESTR_NAME1ST_L__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_RESTR_NAME1ST_U__STRING = SERVICE_WITH_MAX___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_REVISION__STRING = SERVICE_WITH_MAX___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_RIGHT_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_SDO_COUNT__STRING = SERVICE_WITH_MAX___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_SUB_DATA_NAME__STRING = SERVICE_WITH_MAX___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SERVICE_WITH_MAX___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_VERSION__STRING = SERVICE_WITH_MAX___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SERVICE_WITH_MAX___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Service With Max max required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max max valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX___VALIDATE_SERVICE_WITH_MAX_MAX_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Service With Max And Modify nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_WITH_MAX_AND_MODIFY___VALIDATE_SERVICE_WITH_MAX_AND_MODIFY_NOTHING__DIAGNOSTICCHAIN_MAP = SERVICE_WITH_MAX_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Service With Max And Modify</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SERVICE_WITH_MAX_AND_MODIFY_OPERATION_COUNT = SERVICE_WITH_MAX_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DurationInSecImpl <em>Duration In Sec</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.DurationInSecImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getDurationInSec()
	 * @generated
	 */
    int DURATION_IN_SEC = 153;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_SEC__LINE_NUMBER = VALUE_WITH_UNIT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_SEC__VALUE = VALUE_WITH_UNIT__VALUE;

    /**
	 * The feature id for the '<em><b>Multiplier</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_SEC__MULTIPLIER = VALUE_WITH_UNIT__MULTIPLIER;

    /**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_SEC__UNIT = VALUE_WITH_UNIT__UNIT;

    /**
	 * The number of structural features of the '<em>Duration In Sec</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_SEC_FEATURE_COUNT = VALUE_WITH_UNIT_FEATURE_COUNT + 0;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_ACCESS_POINT_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_ACSI_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_ANY_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_ASSOCIATION_ID__STRING = VALUE_WITH_UNIT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_AUTHENTICATION_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_BASIC_TYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_CB_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_CDC_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DA_COUNT__STRING = VALUE_WITH_UNIT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DATA_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DATA_SET_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_EMPTY__STRING = VALUE_WITH_UNIT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_EXTENSION_CDC_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_FULL_DO_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_IED_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = VALUE_WITH_UNIT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_LD_INST__STRING = VALUE_WITH_UNIT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_LD_INST_OR_EMPTY__STRING = VALUE_WITH_UNIT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_LD_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_LLN0_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_LN_CLASS_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_LN_INST__STRING = VALUE_WITH_UNIT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_LN_INST_OR_EMPTY__STRING = VALUE_WITH_UNIT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_LPHD_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_LINE_TYPE__STRING = VALUE_WITH_UNIT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_LOG_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_MESSAGE_ID__STRING = VALUE_WITH_UNIT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_NAMESPACE_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PADDR__STRING = VALUE_WITH_UNIT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PTYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PREFIX__STRING = VALUE_WITH_UNIT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PROCESS_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_PROCESS_TYPE__STRING = VALUE_WITH_UNIT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_RED_PROT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_REF__STRING = VALUE_WITH_UNIT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_RELEASE__BIGINTEGER = VALUE_WITH_UNIT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_RESTR_NAME1ST_L__STRING = VALUE_WITH_UNIT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_RESTR_NAME1ST_U__STRING = VALUE_WITH_UNIT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_REVISION__STRING = VALUE_WITH_UNIT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_RIGHT_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_SDO_COUNT__STRING = VALUE_WITH_UNIT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_SUB_DATA_NAME__STRING = VALUE_WITH_UNIT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = VALUE_WITH_UNIT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_VERSION__STRING = VALUE_WITH_UNIT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = VALUE_WITH_UNIT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Value With Unit value required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALIDATE_VALUE_WITH_UNIT_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP = VALUE_WITH_UNIT___VALIDATE_VALUE_WITH_UNIT_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Value With Unit unit required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALIDATE_VALUE_WITH_UNIT_UNIT_REQUIRED__DIAGNOSTICCHAIN_MAP = VALUE_WITH_UNIT___VALIDATE_VALUE_WITH_UNIT_UNIT_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Value With Unit unit valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALIDATE_VALUE_WITH_UNIT_UNIT_VALID__DIAGNOSTICCHAIN_MAP = VALUE_WITH_UNIT___VALIDATE_VALUE_WITH_UNIT_UNIT_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Duration In Sec unit value fixed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_SEC___VALIDATE_DURATION_IN_SEC_UNIT_VALUE_FIXED__DIAGNOSTICCHAIN_MAP = VALUE_WITH_UNIT_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Duration In Sec</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_SEC_OPERATION_COUNT = VALUE_WITH_UNIT_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_MILLI_SEC__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_MILLI_SEC__VALUE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Multiplier</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_MILLI_SEC__MULTIPLIER = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_MILLI_SEC__UNIT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Duration In Milli Sec</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_MILLI_SEC_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec value required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec value valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_VALUE_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec unit value fixed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_UNIT_VALUE_FIXED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec multiplier value fixed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_MULTIPLIER_VALUE_FIXED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>Duration In Milli Sec</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DURATION_IN_MILLI_SEC_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE_IN_MB_PER_SEC__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE_IN_MB_PER_SEC__VALUE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Multiplier</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE_IN_MB_PER_SEC__MULTIPLIER = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE_IN_MB_PER_SEC__UNIT = SCL_OBJECT_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Bit Rate In Mb Per Sec</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE_IN_MB_PER_SEC_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 3;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Bit Rate In Mb Per Sec value required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALIDATE_BIT_RATE_IN_MB_PER_SEC_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 0;

				/**
	 * The operation id for the '<em>Validate Bit Rate In Mb Per Sec value valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALIDATE_BIT_RATE_IN_MB_PER_SEC_VALUE_VALID__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 1;

				/**
	 * The operation id for the '<em>Validate Bit Rate In Mb Per Sec unit value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALIDATE_BIT_RATE_IN_MB_PER_SEC_UNIT_VALUE__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 2;

				/**
	 * The operation id for the '<em>Validate Bit Rate In Mb Per Sec multiplier value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE_IN_MB_PER_SEC___VALIDATE_BIT_RATE_IN_MB_PER_SEC_MULTIPLIER_VALUE__DIAGNOSTICCHAIN_MAP = SCL_OBJECT_OPERATION_COUNT + 3;

				/**
	 * The number of operations of the '<em>Bit Rate In Mb Per Sec</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE_IN_MB_PER_SEC_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MIN_TIME__LINE_NUMBER = DURATION_IN_MILLI_SEC__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MIN_TIME__VALUE = DURATION_IN_MILLI_SEC__VALUE;

    /**
	 * The feature id for the '<em><b>Multiplier</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MIN_TIME__MULTIPLIER = DURATION_IN_MILLI_SEC__MULTIPLIER;

    /**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MIN_TIME__UNIT = DURATION_IN_MILLI_SEC__UNIT;

    /**
	 * The number of structural features of the '<em>Min Time</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MIN_TIME_FEATURE_COUNT = DURATION_IN_MILLI_SEC_FEATURE_COUNT + 0;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_ACCESS_POINT_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_ACSI_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_ANY_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_ASSOCIATION_ID__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_AUTHENTICATION_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_BASIC_TYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_CB_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_CDC_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DA_COUNT__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DATA_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DATA_SET_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_EMPTY__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_EXTENSION_CDC_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_FULL_DO_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_IED_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_LD_INST__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_LD_INST_OR_EMPTY__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_LD_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_LLN0_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_LN_CLASS_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_LN_INST__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_LN_INST_OR_EMPTY__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_LPHD_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_LINE_TYPE__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_LOG_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_MESSAGE_ID__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_NAMESPACE_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PADDR__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PTYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PREFIX__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PROCESS_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_PROCESS_TYPE__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_RED_PROT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_REF__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_RELEASE__BIGINTEGER = DURATION_IN_MILLI_SEC___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_RESTR_NAME1ST_L__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_RESTR_NAME1ST_U__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_REVISION__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_RIGHT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_SDO_COUNT__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_SUB_DATA_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_VERSION__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec value required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALIDATE_DURATION_IN_MILLI_SEC_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP = DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec value valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALIDATE_DURATION_IN_MILLI_SEC_VALUE_VALID__DIAGNOSTICCHAIN_MAP = DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_VALUE_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec unit value fixed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALIDATE_DURATION_IN_MILLI_SEC_UNIT_VALUE_FIXED__DIAGNOSTICCHAIN_MAP = DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_UNIT_VALUE_FIXED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec multiplier value fixed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALIDATE_DURATION_IN_MILLI_SEC_MULTIPLIER_VALUE_FIXED__DIAGNOSTICCHAIN_MAP = DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_MULTIPLIER_VALUE_FIXED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Min Time nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MIN_TIME___VALIDATE_MIN_TIME_NOTHING__DIAGNOSTICCHAIN_MAP = DURATION_IN_MILLI_SEC_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Min Time</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MIN_TIME_OPERATION_COUNT = DURATION_IN_MILLI_SEC_OPERATION_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MAX_TIME__LINE_NUMBER = DURATION_IN_MILLI_SEC__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MAX_TIME__VALUE = DURATION_IN_MILLI_SEC__VALUE;

    /**
	 * The feature id for the '<em><b>Multiplier</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MAX_TIME__MULTIPLIER = DURATION_IN_MILLI_SEC__MULTIPLIER;

    /**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MAX_TIME__UNIT = DURATION_IN_MILLI_SEC__UNIT;

    /**
	 * The number of structural features of the '<em>Max Time</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MAX_TIME_FEATURE_COUNT = DURATION_IN_MILLI_SEC_FEATURE_COUNT + 0;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_ACCESS_POINT_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_ACSI_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_ANY_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_ASSOCIATION_ID__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_AUTHENTICATION_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_BASIC_TYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_CB_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_CDC_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DA_COUNT__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DATA_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DATA_SET_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_EMPTY__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_EXTENSION_CDC_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_FULL_DO_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_IED_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_LD_INST__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_LD_INST_OR_EMPTY__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_LD_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_LLN0_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_LN_CLASS_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_LN_INST__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_LN_INST_OR_EMPTY__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_LPHD_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_LINE_TYPE__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_LOG_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_MESSAGE_ID__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_NAMESPACE_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PADDR__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PTYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PREFIX__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PROCESS_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_PROCESS_TYPE__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_RED_PROT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_REF__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_RELEASE__BIGINTEGER = DURATION_IN_MILLI_SEC___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_RESTR_NAME1ST_L__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_RESTR_NAME1ST_U__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_REVISION__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_RIGHT_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_SDO_COUNT__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_SUB_DATA_NAME__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_VERSION__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = DURATION_IN_MILLI_SEC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec value required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALIDATE_DURATION_IN_MILLI_SEC_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP = DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec value valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALIDATE_DURATION_IN_MILLI_SEC_VALUE_VALID__DIAGNOSTICCHAIN_MAP = DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_VALUE_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec unit value fixed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALIDATE_DURATION_IN_MILLI_SEC_UNIT_VALUE_FIXED__DIAGNOSTICCHAIN_MAP = DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_UNIT_VALUE_FIXED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Duration In Milli Sec multiplier value fixed</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALIDATE_DURATION_IN_MILLI_SEC_MULTIPLIER_VALUE_FIXED__DIAGNOSTICCHAIN_MAP = DURATION_IN_MILLI_SEC___VALIDATE_DURATION_IN_MILLI_SEC_MULTIPLIER_VALUE_FIXED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Max Time nothing</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAX_TIME___VALIDATE_MAX_TIME_NOTHING__DIAGNOSTICCHAIN_MAP = DURATION_IN_MILLI_SEC_OPERATION_COUNT + 0;

				/**
	 * The number of operations of the '<em>Max Time</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int MAX_TIME_OPERATION_COUNT = DURATION_IN_MILLI_SEC_OPERATION_COUNT + 1;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.BitRateImpl <em>Bit Rate</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.BitRateImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getBitRate()
	 * @generated
	 */
    int BIT_RATE = 158;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE__LINE_NUMBER = BIT_RATE_IN_MB_PER_SEC__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE__VALUE = BIT_RATE_IN_MB_PER_SEC__VALUE;

    /**
	 * The feature id for the '<em><b>Multiplier</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE__MULTIPLIER = BIT_RATE_IN_MB_PER_SEC__MULTIPLIER;

    /**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE__UNIT = BIT_RATE_IN_MB_PER_SEC__UNIT;

    /**
	 * The number of structural features of the '<em>Bit Rate</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE_FEATURE_COUNT = BIT_RATE_IN_MB_PER_SEC_FEATURE_COUNT + 0;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_ACCESS_POINT_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_ACSI_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_ANY_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_ASSOCIATION_ID__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_AUTHENTICATION_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_BASIC_TYPE_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_CB_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_CDC_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DA_COUNT__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DATA_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DATA_SET_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_EMPTY__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_FULL_DO_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_IED_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_LD_INST__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_LD_INST_OR_EMPTY__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_LD_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_LLN0_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_LN_CLASS_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_LN_INST__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_LN_INST_OR_EMPTY__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_LPHD_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_LINE_TYPE__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_LOG_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_MESSAGE_ID__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_NAMESPACE_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PADDR__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PTYPE_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PREFIX__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PROCESS_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_PROCESS_TYPE__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_RED_PROT_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_REF__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_RELEASE__BIGINTEGER = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_RESTR_NAME1ST_L__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_RESTR_NAME1ST_U__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_REVISION__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_RIGHT_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_SDO_COUNT__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_SUB_DATA_NAME__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_VERSION__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = BIT_RATE_IN_MB_PER_SEC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The operation id for the '<em>Validate Bit Rate In Mb Per Sec value required</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALIDATE_BIT_RATE_IN_MB_PER_SEC_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP = BIT_RATE_IN_MB_PER_SEC___VALIDATE_BIT_RATE_IN_MB_PER_SEC_VALUE_REQUIRED__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Bit Rate In Mb Per Sec value valid</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALIDATE_BIT_RATE_IN_MB_PER_SEC_VALUE_VALID__DIAGNOSTICCHAIN_MAP = BIT_RATE_IN_MB_PER_SEC___VALIDATE_BIT_RATE_IN_MB_PER_SEC_VALUE_VALID__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Bit Rate In Mb Per Sec unit value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALIDATE_BIT_RATE_IN_MB_PER_SEC_UNIT_VALUE__DIAGNOSTICCHAIN_MAP = BIT_RATE_IN_MB_PER_SEC___VALIDATE_BIT_RATE_IN_MB_PER_SEC_UNIT_VALUE__DIAGNOSTICCHAIN_MAP;

				/**
	 * The operation id for the '<em>Validate Bit Rate In Mb Per Sec multiplier value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BIT_RATE___VALIDATE_BIT_RATE_IN_MB_PER_SEC_MULTIPLIER_VALUE__DIAGNOSTICCHAIN_MAP = BIT_RATE_IN_MB_PER_SEC___VALIDATE_BIT_RATE_IN_MB_PER_SEC_MULTIPLIER_VALUE__DIAGNOSTICCHAIN_MAP;

				/**
	 * The number of operations of the '<em>Bit Rate</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BIT_RATE_OPERATION_COUNT = BIT_RATE_IN_MB_PER_SEC_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SmpRateImpl <em>Smp Rate</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SmpRateImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSmpRate()
	 * @generated
	 */
    int SMP_RATE = 159;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMP_RATE__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMP_RATE__VALUE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Smp Rate</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMP_RATE_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SMP_RATE___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Smp Rate</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SMP_RATE_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SamplesPerSecImpl <em>Samples Per Sec</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SamplesPerSecImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSamplesPerSec()
	 * @generated
	 */
    int SAMPLES_PER_SEC = 160;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLES_PER_SEC__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLES_PER_SEC__VALUE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Samples Per Sec</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLES_PER_SEC_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLES_PER_SEC___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Samples Per Sec</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SAMPLES_PER_SEC_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SecPerSamplesImpl <em>Sec Per Samples</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SecPerSamplesImpl
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSecPerSamples()
	 * @generated
	 */
    int SEC_PER_SAMPLES = 161;

    /**
	 * The feature id for the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SEC_PER_SAMPLES__LINE_NUMBER = SCL_OBJECT__LINE_NUMBER;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SEC_PER_SAMPLES__VALUE = SCL_OBJECT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Sec Per Samples</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SEC_PER_SAMPLES_FEATURE_COUNT = SCL_OBJECT_FEATURE_COUNT + 1;

    /**
	 * The operation id for the '<em>Valid Scl Access Point Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_ACCESS_POINT_NAME__STRING = SCL_OBJECT___VALID_SCL_ACCESS_POINT_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Acsi Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_ACSI_NAME__STRING = SCL_OBJECT___VALID_SCL_ACSI_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Any Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_ANY_NAME__STRING = SCL_OBJECT___VALID_SCL_ANY_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Association ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_ASSOCIATION_ID__STRING = SCL_OBJECT___VALID_SCL_ASSOCIATION_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_AUTHENTICATION_ENUM__STRING = SCL_OBJECT___VALID_SCL_AUTHENTICATION_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CB Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_CB_NAME__STRING = SCL_OBJECT___VALID_SCL_CB_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl DA Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DA_COUNT__STRING = SCL_OBJECT___VALID_SCL_DA_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Data Set Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DATA_SET_NAME__STRING = SCL_OBJECT___VALID_SCL_DATA_SET_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_ENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_AENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_CENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_FENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_GENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_IENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_KENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_MENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_PENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_QENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_RENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_SENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_TENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_XENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_YENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING = SCL_OBJECT___VALID_SCL_DOMAIN_LN_GROUP_ZENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_EMPTY__STRING = SCL_OBJECT___VALID_SCL_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_EXTENSION_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_EXTENSION_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_ATTRIBUTE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Full DO Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_FULL_DO_NAME__STRING = SCL_OBJECT___VALID_SCL_FULL_DO_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_IED_NAME_OR_RELATIVE__STRING = SCL_OBJECT___VALID_SCL_IED_NAME_OR_RELATIVE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_LD_INST__STRING = SCL_OBJECT___VALID_SCL_LD_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_LD_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LD_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LD Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_LD_NAME__STRING = SCL_OBJECT___VALID_SCL_LD_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_LLN0_ENUM__STRING = SCL_OBJECT___VALID_SCL_LLN0_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_LN_INST__STRING = SCL_OBJECT___VALID_SCL_LN_INST__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_LN_INST_OR_EMPTY__STRING = SCL_OBJECT___VALID_SCL_LN_INST_OR_EMPTY__STRING;

				/**
	 * The operation id for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_LPHD_ENUM__STRING = SCL_OBJECT___VALID_SCL_LPHD_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Line Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_LINE_TYPE__STRING = SCL_OBJECT___VALID_SCL_LINE_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Log Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_LOG_NAME__STRING = SCL_OBJECT___VALID_SCL_LOG_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Message ID</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_MESSAGE_ID__STRING = SCL_OBJECT___VALID_SCL_MESSAGE_ID__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_NAME__STRING = SCL_OBJECT___VALID_SCL_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Namespace Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_NAMESPACE_NAME__STRING = SCL_OBJECT___VALID_SCL_NAMESPACE_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING = SCL_OBJECT___VALID_SCL_ONLY_RELATIVE_IED_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PAddr</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PADDR__STRING = SCL_OBJECT___VALID_SCL_PADDR__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING = SCL_OBJECT___VALID_SCL_POWER_TRANSFORMER_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_ATTRIBUTE_NAME_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_BASIC_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PREDEFINED_CDC_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_CDC_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_COMMON_CONDUCTING_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_GENERAL_EQUIPMENT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_LN_CLASS_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PTYPE_PHYS_CONN_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING = SCL_OBJECT___VALID_SCL_PREDEFINED_PHYS_CONN_TYPE_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Prefix</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PREFIX__STRING = SCL_OBJECT___VALID_SCL_PREFIX__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PROCESS_NAME__STRING = SCL_OBJECT___VALID_SCL_PROCESS_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Process Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_PROCESS_TYPE__STRING = SCL_OBJECT___VALID_SCL_PROCESS_TYPE__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_RED_PROT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RED_PROT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Ref</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_REF__STRING = SCL_OBJECT___VALID_SCL_REF__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Release</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_RELEASE__BIGINTEGER = SCL_OBJECT___VALID_SCL_RELEASE__BIGINTEGER;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_RESTR_NAME1ST_L__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_L__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_RESTR_NAME1ST_U__STRING = SCL_OBJECT___VALID_SCL_RESTR_NAME1ST_U__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Revision</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_REVISION__STRING = SCL_OBJECT___VALID_SCL_REVISION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Right Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_RIGHT_ENUM__STRING = SCL_OBJECT___VALID_SCL_RIGHT_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl SDO Count</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_SDO_COUNT__STRING = SCL_OBJECT___VALID_SCL_SDO_COUNT__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_SUB_DATA_NAME__STRING = SCL_OBJECT___VALID_SCL_SUB_DATA_NAME__STRING;

				/**
	 * The operation id for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING = SCL_OBJECT___VALID_SCL_SYSTEM_LN_GROUP_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING = SCL_OBJECT___VALID_SCL_TRANSFORMER_WINDING_ENUM__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Version</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_VERSION__STRING = SCL_OBJECT___VALID_SCL_VERSION__STRING;

				/**
	 * The operation id for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEC_PER_SAMPLES___VALID_SCL_VISIBLE_BASIC_LATIN__STRING = SCL_OBJECT___VALID_SCL_VISIBLE_BASIC_LATIN__STRING;

				/**
	 * The number of operations of the '<em>Sec Per Samples</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SEC_PER_SAMPLES_OPERATION_COUNT = SCL_OBJECT_OPERATION_COUNT + 0;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AssociationKindEnum <em>Association Kind Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AssociationKindEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getAssociationKindEnum()
	 * @generated
	 */
    int ASSOCIATION_KIND_ENUM = 162;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCEnum <em>FC Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getFCEnum()
	 * @generated
	 */
    int FC_ENUM = 163;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControlTypeEnum <em>GSE Control Type Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControlTypeEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getGSEControlTypeEnum()
	 * @generated
	 */
    int GSE_CONTROL_TYPE_ENUM = 164;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PhaseEnum <em>Phase Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PhaseEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getPhaseEnum()
	 * @generated
	 */
    int PHASE_ENUM = 165;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PredefinedTypeOfSecurityEnum <em>Predefined Type Of Security Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PredefinedTypeOfSecurityEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getPredefinedTypeOfSecurityEnum()
	 * @generated
	 */
    int PREDEFINED_TYPE_OF_SECURITY_ENUM = 166;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVDeliveryEnum <em>SMV Delivery Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVDeliveryEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSMVDeliveryEnum()
	 * @generated
	 */
    int SMV_DELIVERY_ENUM = 167;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettingsEnum <em>Service Settings Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettingsEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceSettingsEnum()
	 * @generated
	 */
    int SERVICE_SETTINGS_ENUM = 168;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettingsNoDynEnum <em>Service Settings No Dyn Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettingsNoDynEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceSettingsNoDynEnum()
	 * @generated
	 */
    int SERVICE_SETTINGS_NO_DYN_ENUM = 169;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceType <em>Service Type</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceType
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getServiceType()
	 * @generated
	 */
    int SERVICE_TYPE = 170;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmpMod <em>Smp Mod</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmpMod
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getSmpMod()
	 * @generated
	 */
    int SMP_MOD = 171;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.UnitMultiplierEnum <em>Unit Multiplier Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.UnitMultiplierEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getUnitMultiplierEnum()
	 * @generated
	 */
    int UNIT_MULTIPLIER_ENUM = 172;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValKindEnum <em>Val Kind Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValKindEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getValKindEnum()
	 * @generated
	 */
    int VAL_KIND_ENUM = 173;

    /**
	 * The meta object id for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.bufModeEnum <em>buf Mode Enum</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.bufModeEnum
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.impl.SclPackageImpl#getbufModeEnum()
	 * @generated
	 */
    int BUF_MODE_ENUM = 174;

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyContentFromOtherNamespace <em>Any Content From Other Namespace</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Any Content From Other Namespace</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyContentFromOtherNamespace
	 * @generated
	 */
    EClass getAnyContentFromOtherNamespace();

    /**
	 * Returns the meta object for the attribute list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyContentFromOtherNamespace#getMixed <em>Mixed</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Mixed</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyContentFromOtherNamespace#getMixed()
	 * @see #getAnyContentFromOtherNamespace()
	 * @generated
	 */
    EAttribute getAnyContentFromOtherNamespace_Mixed();

    /**
	 * Returns the meta object for the attribute list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyContentFromOtherNamespace#getGroup <em>Group</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Group</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyContentFromOtherNamespace#getGroup()
	 * @see #getAnyContentFromOtherNamespace()
	 * @generated
	 */
    EAttribute getAnyContentFromOtherNamespace_Group();

    /**
	 * Returns the meta object for the attribute list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyContentFromOtherNamespace#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyContentFromOtherNamespace#getAny()
	 * @see #getAnyContentFromOtherNamespace()
	 * @generated
	 */
    EAttribute getAnyContentFromOtherNamespace_Any();

    /**
	 * Returns the meta object for the attribute list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyContentFromOtherNamespace#getAnyAttribute <em>Any Attribute</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any Attribute</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyContentFromOtherNamespace#getAnyAttribute()
	 * @see #getAnyContentFromOtherNamespace()
	 * @generated
	 */
    EAttribute getAnyContentFromOtherNamespace_AnyAttribute();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BaseElement <em>Base Element</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Base Element</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BaseElement
	 * @generated
	 */
    EClass getBaseElement();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BaseElement#getPrivate <em>Private</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Private</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BaseElement#getPrivate()
	 * @see #getBaseElement()
	 * @generated
	 */
    EReference getBaseElement_Private();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BaseElement#getText <em>Text</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Text</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BaseElement#getText()
	 * @see #getBaseElement()
	 * @generated
	 */
    EReference getBaseElement_Text();

    /**
	 * Returns the meta object for the attribute list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BaseElement#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BaseElement#getAny()
	 * @see #getBaseElement()
	 * @generated
	 */
    EAttribute getBaseElement_Any();

    /**
	 * Returns the meta object for the attribute list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BaseElement#getAnyAttribute <em>Any Attribute</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any Attribute</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BaseElement#getAnyAttribute()
	 * @see #getBaseElement()
	 * @generated
	 */
    EAttribute getBaseElement_AnyAttribute();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header <em>Header</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Header</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header
	 * @generated
	 */
    EClass getHeader();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getId()
	 * @see #getHeader()
	 * @generated
	 */
    EAttribute getHeader_Id();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getNameStructure <em>Name Structure</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name Structure</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getNameStructure()
	 * @see #getHeader()
	 * @generated
	 */
    EAttribute getHeader_NameStructure();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getRevision <em>Revision</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Revision</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getRevision()
	 * @see #getHeader()
	 * @generated
	 */
    EAttribute getHeader_Revision();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getToolID <em>Tool ID</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tool ID</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getToolID()
	 * @see #getHeader()
	 * @generated
	 */
    EAttribute getHeader_ToolID();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getVersion <em>Version</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Version</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getVersion()
	 * @see #getHeader()
	 * @generated
	 */
    EAttribute getHeader_Version();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getSCL <em>SCL</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>SCL</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getSCL()
	 * @see #getHeader()
	 * @generated
	 */
    EReference getHeader_SCL();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getText <em>Text</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Text</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getText()
	 * @see #getHeader()
	 * @generated
	 */
    EReference getHeader_Text();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getHistory <em>History</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>History</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#getHistory()
	 * @see #getHeader()
	 * @generated
	 */
    EReference getHeader_History();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#validateHeader_id_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Header id required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Header id required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#validateHeader_id_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getHeader__ValidateHeader_id_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#validateHeader_nameStructure_value_IEDName(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Header name Structure value IED Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Header name Structure value IED Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Header#validateHeader_nameStructure_value_IEDName(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getHeader__ValidateHeader_nameStructure_value_IEDName__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.History <em>History</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>History</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.History
	 * @generated
	 */
    EClass getHistory();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.History#getHeader <em>Header</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Header</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.History#getHeader()
	 * @see #getHistory()
	 * @generated
	 */
    EReference getHistory_Header();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.History#getHitem <em>Hitem</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Hitem</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.History#getHitem()
	 * @see #getHistory()
	 * @generated
	 */
    EReference getHistory_Hitem();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.History#validateHistory_at_least_one_Hitem_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate History at least one Hitem required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate History at least one Hitem required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.History#validateHistory_at_least_one_Hitem_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getHistory__ValidateHistory_at_least_one_Hitem_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem <em>Hitem</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hitem</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem
	 * @generated
	 */
    EClass getHitem();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getRevision <em>Revision</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Revision</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getRevision()
	 * @see #getHitem()
	 * @generated
	 */
    EAttribute getHitem_Revision();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getVersion <em>Version</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Version</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getVersion()
	 * @see #getHitem()
	 * @generated
	 */
    EAttribute getHitem_Version();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getWhat <em>What</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>What</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getWhat()
	 * @see #getHitem()
	 * @generated
	 */
    EAttribute getHitem_What();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getWhen <em>When</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>When</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getWhen()
	 * @see #getHitem()
	 * @generated
	 */
    EAttribute getHitem_When();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getWho <em>Who</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Who</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getWho()
	 * @see #getHitem()
	 * @generated
	 */
    EAttribute getHitem_Who();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getWhy <em>Why</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Why</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getWhy()
	 * @see #getHitem()
	 * @generated
	 */
    EAttribute getHitem_Why();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getHistory <em>History</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>History</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#getHistory()
	 * @see #getHitem()
	 * @generated
	 */
    EReference getHitem_History();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#validateHitem_version_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Hitem version required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Hitem version required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#validateHitem_version_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getHitem__ValidateHitem_version_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#validateHitem_revision_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Hitem revision required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Hitem revision required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#validateHitem_revision_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getHitem__ValidateHitem_revision_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#validateHitem_when_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Hitem when required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Hitem when required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Hitem#validateHitem_when_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getHitem__ValidateHitem_when_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IDNaming <em>ID Naming</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>ID Naming</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IDNaming
	 * @generated
	 */
    EClass getIDNaming();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IDNaming#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IDNaming#getId()
	 * @see #getIDNaming()
	 * @generated
	 */
    EAttribute getIDNaming_Id();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IDNaming#getDesc <em>Desc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Desc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IDNaming#getDesc()
	 * @see #getIDNaming()
	 * @generated
	 */
    EAttribute getIDNaming_Desc();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IDNaming#validateIDNaming_id_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate ID Naming id required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate ID Naming id required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IDNaming#validateIDNaming_id_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getIDNaming__ValidateIDNaming_id_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IDNaming#validateIDNaming_id_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate ID Naming id valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate ID Naming id valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IDNaming#validateIDNaming_id_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getIDNaming__ValidateIDNaming_id_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Line <em>Line</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Line</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Line
	 * @generated
	 */
    EClass getLine();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#getType()
	 * @see #getLine()
	 * @generated
	 */
    EAttribute getLine_Type();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#getProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Process</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#getProcess()
	 * @see #getLine()
	 * @generated
	 */
    EReference getLine_Process();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#getSCL <em>SCL</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>SCL</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#getSCL()
	 * @see #getLine()
	 * @generated
	 */
    EReference getLine_SCL();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#getConnectivityNode <em>Connectivity Node</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Connectivity Node</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#getConnectivityNode()
	 * @see #getLine()
	 * @generated
	 */
    EReference getLine_ConnectivityNode();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#getConductingEquipment <em>Conducting Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Conducting Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#getConductingEquipment()
	 * @see #getLine()
	 * @generated
	 */
    EReference getLine_ConductingEquipment();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#validateLine_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Line type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Line type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Line#validateLine_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLine__ValidateLine_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Naming <em>Naming</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Naming</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Naming
	 * @generated
	 */
    EClass getNaming();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Naming#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Naming#getName()
	 * @see #getNaming()
	 * @generated
	 */
    EAttribute getNaming_Name();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Naming#getDesc <em>Desc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Desc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Naming#getDesc()
	 * @see #getNaming()
	 * @generated
	 */
    EAttribute getNaming_Desc();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Naming#validateNaming_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Naming name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Naming name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Naming#validateNaming_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getNaming__ValidateNaming_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Naming#validateNaming_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Naming name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Naming name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Naming#validateNaming_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getNaming__ValidateNaming_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Private <em>Private</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Private</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Private
	 * @generated
	 */
    EClass getPrivate();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Private#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Private#getSource()
	 * @see #getPrivate()
	 * @generated
	 */
    EAttribute getPrivate_Source();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Private#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Private#getType()
	 * @see #getPrivate()
	 * @generated
	 */
    EAttribute getPrivate_Type();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Private#getBaseElement <em>Base Element</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Base Element</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Private#getBaseElement()
	 * @see #getPrivate()
	 * @generated
	 */
    EReference getPrivate_BaseElement();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Private#validatePrivate_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Private type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Private type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Private#validatePrivate_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getPrivate__ValidatePrivate_type_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Private#validatePrivate_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Private type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Private type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Private#validatePrivate_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getPrivate__ValidatePrivate_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Process <em>Process</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Process
	 * @generated
	 */
    EClass getProcess();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getType()
	 * @see #getProcess()
	 * @generated
	 */
    EAttribute getProcess_Type();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getLine <em>Line</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Line</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getLine()
	 * @see #getProcess()
	 * @generated
	 */
    EReference getProcess_Line();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getSCL <em>SCL</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>SCL</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getSCL()
	 * @see #getProcess()
	 * @generated
	 */
    EReference getProcess_SCL();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getConductingEquipment <em>Conducting Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Conducting Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getConductingEquipment()
	 * @see #getProcess()
	 * @generated
	 */
    EReference getProcess_ConductingEquipment();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getSubstation <em>Substation</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Substation</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getSubstation()
	 * @see #getProcess()
	 * @generated
	 */
    EReference getProcess_Substation();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getSubProcesses <em>Sub Processes</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub Processes</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getSubProcesses()
	 * @see #getProcess()
	 * @generated
	 */
    EReference getProcess_SubProcesses();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getParentProcess <em>Parent Process</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent Process</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#getParentProcess()
	 * @see #getProcess()
	 * @generated
	 */
    EReference getProcess_ParentProcess();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#validateProcess_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Process type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Process type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Process#validateProcess_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getProcess__ValidateProcess_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL <em>SCL</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SCL</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL
	 * @generated
	 */
    EClass getSCL();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getRevision <em>Revision</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Revision</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getRevision()
	 * @see #getSCL()
	 * @generated
	 */
    EAttribute getSCL_Revision();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getVersion <em>Version</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Version</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getVersion()
	 * @see #getSCL()
	 * @generated
	 */
    EAttribute getSCL_Version();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getHeader <em>Header</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Header</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getHeader()
	 * @see #getSCL()
	 * @generated
	 */
    EReference getSCL_Header();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getLine <em>Line</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Line</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getLine()
	 * @see #getSCL()
	 * @generated
	 */
    EReference getSCL_Line();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Process</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getProcess()
	 * @see #getSCL()
	 * @generated
	 */
    EReference getSCL_Process();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getIED <em>IED</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>IED</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getIED()
	 * @see #getSCL()
	 * @generated
	 */
    EReference getSCL_IED();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getDataTypeTemplates <em>Data Type Templates</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Data Type Templates</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getDataTypeTemplates()
	 * @see #getSCL()
	 * @generated
	 */
    EReference getSCL_DataTypeTemplates();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getCommunication <em>Communication</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Communication</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getCommunication()
	 * @see #getSCL()
	 * @generated
	 */
    EReference getSCL_Communication();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getSubstation <em>Substation</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Substation</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getSubstation()
	 * @see #getSCL()
	 * @generated
	 */
    EReference getSCL_Substation();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getRelease <em>Release</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Release</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#getRelease()
	 * @see #getSCL()
	 * @generated
	 */
    EAttribute getSCL_Release();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_version_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SCL version required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SCL version required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_version_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSCL__ValidateSCL_version_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_version_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SCL version valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SCL version valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_version_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSCL__ValidateSCL_version_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_version_value_2007(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SCL version value 2007</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SCL version value 2007</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_version_value_2007(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSCL__ValidateSCL_version_value_2007__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_revision_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SCL revision required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SCL revision required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_revision_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSCL__ValidateSCL_revision_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_revision_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SCL revision valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SCL revision valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_revision_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSCL__ValidateSCL_revision_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_revision_value_B(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SCL revision value B</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SCL revision value B</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_revision_value_B(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSCL__ValidateSCL_revision_value_B__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_release_value_1(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SCL release value 1</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SCL release value 1</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_release_value_1(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSCL__ValidateSCL_release_value_1__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_one_Header_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SCL one Header required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SCL one Header required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SCL#validateSCL_one_Header_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSCL__ValidateSCL_one_Header_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Text <em>Text</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Text</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Text
	 * @generated
	 */
    EClass getText();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Text#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Text#getSource()
	 * @see #getText()
	 * @generated
	 */
    EAttribute getText_Source();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Text#getBaseElement <em>Base Element</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Base Element</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Text#getBaseElement()
	 * @see #getText()
	 * @generated
	 */
    EReference getText_BaseElement();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Text#getHeader <em>Header</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Header</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Text#getHeader()
	 * @see #getText()
	 * @generated
	 */
    EReference getText_Header();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Text#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Text#getValue()
	 * @see #getText()
	 * @generated
	 */
    EAttribute getText_Value();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Address <em>Address</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Address</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Address
	 * @generated
	 */
    EClass getAddress();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Address#getConnectedAP <em>Connected AP</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Connected AP</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Address#getConnectedAP()
	 * @see #getAddress()
	 * @generated
	 */
    EReference getAddress_ConnectedAP();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Address#getControlBlock <em>Control Block</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Control Block</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Address#getControlBlock()
	 * @see #getAddress()
	 * @generated
	 */
    EReference getAddress_ControlBlock();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Address#getP <em>P</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>P</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Address#getP()
	 * @see #getAddress()
	 * @generated
	 */
    EReference getAddress_P();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Address#validateAddress_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Address nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Address nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Address#validateAddress_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAddress__ValidateAddress_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Address#validateAddress_at_least_one_P_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Address at least one Prequired</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Address at least one Prequired</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Address#validateAddress_at_least_one_P_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAddress__ValidateAddress_at_least_one_P_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Communication <em>Communication</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Communication</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Communication
	 * @generated
	 */
    EClass getCommunication();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Communication#getSubNetwork <em>Sub Network</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub Network</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Communication#getSubNetwork()
	 * @see #getCommunication()
	 * @generated
	 */
    EReference getCommunication_SubNetwork();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Communication#getSCL <em>SCL</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>SCL</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Communication#getSCL()
	 * @see #getCommunication()
	 * @generated
	 */
    EReference getCommunication_SCL();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Communication#validateCommunication_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Communication nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Communication nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Communication#validateCommunication_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCommunication__ValidateCommunication_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Communication#validateCommunication_at_least_one_SubNetwork_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Communication at least one Sub Network required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Communication at least one Sub Network required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Communication#validateCommunication_at_least_one_SubNetwork_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCommunication__ValidateCommunication_at_least_one_SubNetwork_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP <em>Connected AP</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connected AP</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP
	 * @generated
	 */
    EClass getConnectedAP();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getApName <em>Ap Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ap Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getApName()
	 * @see #getConnectedAP()
	 * @generated
	 */
    EAttribute getConnectedAP_ApName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getIedName <em>Ied Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ied Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getIedName()
	 * @see #getConnectedAP()
	 * @generated
	 */
    EAttribute getConnectedAP_IedName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getRedProt <em>Red Prot</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Red Prot</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getRedProt()
	 * @see #getConnectedAP()
	 * @generated
	 */
    EAttribute getConnectedAP_RedProt();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getAddress <em>Address</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Address</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getAddress()
	 * @see #getConnectedAP()
	 * @generated
	 */
    EReference getConnectedAP_Address();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getSubNetwork <em>Sub Network</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Sub Network</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getSubNetwork()
	 * @see #getConnectedAP()
	 * @generated
	 */
    EReference getConnectedAP_SubNetwork();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getRefersToAccessPoint <em>Refers To Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getRefersToAccessPoint()
	 * @see #getConnectedAP()
	 * @generated
	 */
    EReference getConnectedAP_RefersToAccessPoint();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getPhysConn <em>Phys Conn</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Phys Conn</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getPhysConn()
	 * @see #getConnectedAP()
	 * @generated
	 */
    EReference getConnectedAP_PhysConn();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getGSE <em>GSE</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>GSE</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getGSE()
	 * @see #getConnectedAP()
	 * @generated
	 */
    EReference getConnectedAP_GSE();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getSMV <em>SMV</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>SMV</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#getSMV()
	 * @see #getConnectedAP()
	 * @generated
	 */
    EReference getConnectedAP_SMV();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_iedName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Connected AP ied Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Connected AP ied Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_iedName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConnectedAP__ValidateConnectedAP_iedName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_iedName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Connected AP ied Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Connected AP ied Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_iedName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConnectedAP__ValidateConnectedAP_iedName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_apName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Connected AP ap Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Connected AP ap Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_apName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConnectedAP__ValidateConnectedAP_apName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_apName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Connected AP ap Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Connected AP ap Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_apName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConnectedAP__ValidateConnectedAP_apName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_redProt_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Connected AP red Prot valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Connected AP red Prot valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_redProt_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConnectedAP__ValidateConnectedAP_redProt_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_at_most_one_PhysConnTypeRedConn_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Connected AP at most one Phys Conn Type Red Conn required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Connected AP at most one Phys Conn Type Red Conn required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_at_most_one_PhysConnTypeRedConn_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConnectedAP__ValidateConnectedAP_at_most_one_PhysConnTypeRedConn_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_at_most_one_PhysConnTypeConnection_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Connected AP at most one Phys Conn Type Connection required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Connected AP at most one Phys Conn Type Connection required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectedAP#validateConnectedAP_at_most_one_PhysConnTypeConnection_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConnectedAP__ValidateConnectedAP_at_most_one_PhysConnTypeConnection_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock <em>Control Block</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Control Block</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock
	 * @generated
	 */
    EClass getControlBlock();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#getCbName <em>Cb Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cb Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#getCbName()
	 * @see #getControlBlock()
	 * @generated
	 */
    EAttribute getControlBlock_CbName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#getLdInst <em>Ld Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ld Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#getLdInst()
	 * @see #getControlBlock()
	 * @generated
	 */
    EAttribute getControlBlock_LdInst();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#getAddress <em>Address</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Address</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#getAddress()
	 * @see #getControlBlock()
	 * @generated
	 */
    EReference getControlBlock_Address();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#getRefersToLDevice <em>Refers To LDevice</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To LDevice</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#getRefersToLDevice()
	 * @see #getControlBlock()
	 * @generated
	 */
    EReference getControlBlock_RefersToLDevice();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#getRefersToControlWithIEDName <em>Refers To Control With IED Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Control With IED Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#getRefersToControlWithIEDName()
	 * @see #getControlBlock()
	 * @generated
	 */
    EReference getControlBlock_RefersToControlWithIEDName();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#validateControlBlock_ldInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Control Block ld Inst required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Control Block ld Inst required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#validateControlBlock_ldInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getControlBlock__ValidateControlBlock_ldInst_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#validateControlBlock_ldInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Control Block ld Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Control Block ld Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#validateControlBlock_ldInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getControlBlock__ValidateControlBlock_ldInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#validateControlBlock_cbName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Control Block cb Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Control Block cb Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#validateControlBlock_cbName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getControlBlock__ValidateControlBlock_cbName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#validateControlBlock_cbName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Control Block cb Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Control Block cb Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlBlock#validateControlBlock_cbName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getControlBlock__ValidateControlBlock_cbName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSE <em>GSE</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GSE</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSE
	 * @generated
	 */
    EClass getGSE();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSE#getMaxTime <em>Max Time</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Max Time</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSE#getMaxTime()
	 * @see #getGSE()
	 * @generated
	 */
    EReference getGSE_MaxTime();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSE#validateGSE_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate GSE nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate GSE nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSE#validateGSE_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getGSE__ValidateGSE_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSE#getMinTime <em>Min Time</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Min Time</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSE#getMinTime()
	 * @see #getGSE()
	 * @generated
	 */
    EReference getGSE_MinTime();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSE#getConnectedAP <em>Connected AP</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Connected AP</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSE#getConnectedAP()
	 * @see #getGSE()
	 * @generated
	 */
    EReference getGSE_ConnectedAP();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.P <em>P</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>P</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.P
	 * @generated
	 */
    EClass getP();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.P#getAddress <em>Address</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Address</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.P#getAddress()
	 * @see #getP()
	 * @generated
	 */
    EReference getP_Address();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.P#validateP_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ptype required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ptype required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.P#validateP_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getP__ValidateP_type_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.P#validateP_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ptype valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ptype valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.P#validateP_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getP__ValidateP_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.P#validateP_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Pvalue</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Pvalue</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.P#validateP_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getP__ValidateP_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PAddr <em>PAddr</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>PAddr</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PAddr
	 * @generated
	 */
    EClass getPAddr();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PAddr#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PAddr#getType()
	 * @see #getPAddr()
	 * @generated
	 */
    EAttribute getPAddr_Type();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PAddr#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PAddr#getValue()
	 * @see #getPAddr()
	 * @generated
	 */
    EAttribute getPAddr_Value();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.P_PhysConn <em>PPhys Conn</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>PPhys Conn</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.P_PhysConn
	 * @generated
	 */
    EClass getP_PhysConn();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.P_PhysConn#getPhysConn <em>Phys Conn</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Phys Conn</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.P_PhysConn#getPhysConn()
	 * @see #getP_PhysConn()
	 * @generated
	 */
    EReference getP_PhysConn_PhysConn();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.P_PhysConn#validateP_PhysConn_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate PPhys Conn type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate PPhys Conn type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.P_PhysConn#validateP_PhysConn_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getP_PhysConn__ValidateP_PhysConn_type_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.P_PhysConn#validateP_PhysConn_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate PPhys Conn type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate PPhys Conn type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.P_PhysConn#validateP_PhysConn_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getP_PhysConn__ValidateP_PhysConn_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn <em>Phys Conn</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Phys Conn</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn
	 * @generated
	 */
    EClass getPhysConn();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn#getType()
	 * @see #getPhysConn()
	 * @generated
	 */
    EAttribute getPhysConn_Type();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn#getConnectedAP <em>Connected AP</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Connected AP</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn#getConnectedAP()
	 * @see #getPhysConn()
	 * @generated
	 */
    EReference getPhysConn_ConnectedAP();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn#getP <em>P</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>P</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn#getP()
	 * @see #getPhysConn()
	 * @generated
	 */
    EReference getPhysConn_P();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn#validatePhysConn_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Phys Conn type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Phys Conn type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn#validatePhysConn_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getPhysConn__ValidatePhysConn_type_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn#validatePhysConn_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Phys Conn type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Phys Conn type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PhysConn#validatePhysConn_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getPhysConn__ValidatePhysConn_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMV <em>SMV</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SMV</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMV
	 * @generated
	 */
    EClass getSMV();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMV#getConnectedAP <em>Connected AP</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Connected AP</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMV#getConnectedAP()
	 * @see #getSMV()
	 * @generated
	 */
    EReference getSMV_ConnectedAP();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMV#validateSMV_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SMV nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SMV nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMV#validateSMV_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSMV__ValidateSMV_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork <em>Sub Network</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sub Network</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork
	 * @generated
	 */
    EClass getSubNetwork();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#getType()
	 * @see #getSubNetwork()
	 * @generated
	 */
    EAttribute getSubNetwork_Type();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#getBitRate <em>Bit Rate</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Bit Rate</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#getBitRate()
	 * @see #getSubNetwork()
	 * @generated
	 */
    EReference getSubNetwork_BitRate();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#getCommunication <em>Communication</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Communication</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#getCommunication()
	 * @see #getSubNetwork()
	 * @generated
	 */
    EReference getSubNetwork_Communication();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#getConnectedAP <em>Connected AP</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Connected AP</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#getConnectedAP()
	 * @see #getSubNetwork()
	 * @generated
	 */
    EReference getSubNetwork_ConnectedAP();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#validateSubNetwork_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sub Network nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sub Network nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#validateSubNetwork_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSubNetwork__ValidateSubNetwork_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#validateSubNetwork_at_least_one_ConnectedAP_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sub Network at least one Connected AP required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sub Network at least one Connected AP required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubNetwork#validateSubNetwork_at_least_one_ConnectedAP_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSubNetwork__ValidateSubNetwork_at_least_one_ConnectedAP_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute <em>Abstract Data Attribute</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Data Attribute</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute
	 * @generated
	 */
    EClass getAbstractDataAttribute();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getBType <em>BType</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>BType</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getBType()
	 * @see #getAbstractDataAttribute()
	 * @generated
	 */
    EAttribute getAbstractDataAttribute_BType();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getCount <em>Count</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Count</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getCount()
	 * @see #getAbstractDataAttribute()
	 * @generated
	 */
    EAttribute getAbstractDataAttribute_Count();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getSAddr <em>SAddr</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SAddr</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getSAddr()
	 * @see #getAbstractDataAttribute()
	 * @generated
	 */
    EAttribute getAbstractDataAttribute_SAddr();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getType()
	 * @see #getAbstractDataAttribute()
	 * @generated
	 */
    EAttribute getAbstractDataAttribute_Type();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getValImport <em>Val Import</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Val Import</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getValImport()
	 * @see #getAbstractDataAttribute()
	 * @generated
	 */
    EAttribute getAbstractDataAttribute_ValImport();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getValKind <em>Val Kind</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Val Kind</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getValKind()
	 * @see #getAbstractDataAttribute()
	 * @generated
	 */
    EAttribute getAbstractDataAttribute_ValKind();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getRefersToEnumType <em>Refers To Enum Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Enum Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getRefersToEnumType()
	 * @see #getAbstractDataAttribute()
	 * @generated
	 */
    EReference getAbstractDataAttribute_RefersToEnumType();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getVal <em>Val</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Val</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#getVal()
	 * @see #getAbstractDataAttribute()
	 * @generated
	 */
    EReference getAbstractDataAttribute_Val();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#validateAbstractDataAttribute_bType_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Abstract Data Attribute bType required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Abstract Data Attribute bType required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#validateAbstractDataAttribute_bType_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractDataAttribute__ValidateAbstractDataAttribute_bType_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#validateAbstractDataAttribute_bType_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Abstract Data Attribute bType valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Abstract Data Attribute bType valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#validateAbstractDataAttribute_bType_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractDataAttribute__ValidateAbstractDataAttribute_bType_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#validateAbstractDataAttribute_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Abstract Data Attribute type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Abstract Data Attribute type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#validateAbstractDataAttribute_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractDataAttribute__ValidateAbstractDataAttribute_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#validateAbstractDataAttribute_count_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Abstract Data Attribute count valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Abstract Data Attribute count valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractDataAttribute#validateAbstractDataAttribute_count_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractDataAttribute__ValidateAbstractDataAttribute_count_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BDA <em>BDA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>BDA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BDA
	 * @generated
	 */
    EClass getBDA();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BDA#getDAType <em>DA Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>DA Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BDA#getDAType()
	 * @see #getBDA()
	 * @generated
	 */
    EReference getBDA_DAType();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BDA#validateBDA_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate BDA nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate BDA nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BDA#validateBDA_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getBDA__ValidateBDA_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DA <em>DA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>DA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DA
	 * @generated
	 */
    EClass getDA();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getDchg <em>Dchg</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dchg</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getDchg()
	 * @see #getDA()
	 * @generated
	 */
    EAttribute getDA_Dchg();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getDupd <em>Dupd</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dupd</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getDupd()
	 * @see #getDA()
	 * @generated
	 */
    EAttribute getDA_Dupd();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getFc <em>Fc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getFc()
	 * @see #getDA()
	 * @generated
	 */
    EAttribute getDA_Fc();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getQchg <em>Qchg</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Qchg</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getQchg()
	 * @see #getDA()
	 * @generated
	 */
    EAttribute getDA_Qchg();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getRefersToDAType <em>Refers To DA Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To DA Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getRefersToDAType()
	 * @see #getDA()
	 * @generated
	 */
    EReference getDA_RefersToDAType();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getDOType <em>DO Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>DO Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getDOType()
	 * @see #getDA()
	 * @generated
	 */
    EReference getDA_DOType();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getProtNs <em>Prot Ns</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Prot Ns</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#getProtNs()
	 * @see #getDA()
	 * @generated
	 */
    EReference getDA_ProtNs();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#validateDA_fc_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DA fc required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DA fc required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DA#validateDA_fc_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDA__ValidateDA_fc_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType <em>DA Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>DA Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType
	 * @generated
	 */
    EClass getDAType();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#getIedType <em>Ied Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ied Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#getIedType()
	 * @see #getDAType()
	 * @generated
	 */
    EAttribute getDAType_IedType();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#getBDA <em>BDA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>BDA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#getBDA()
	 * @see #getDAType()
	 * @generated
	 */
    EReference getDAType_BDA();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#getReferredByDA <em>Referred By DA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By DA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#getReferredByDA()
	 * @see #getDAType()
	 * @generated
	 */
    EReference getDAType_ReferredByDA();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#getDataTypeTemplates <em>Data Type Templates</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Data Type Templates</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#getDataTypeTemplates()
	 * @see #getDAType()
	 * @generated
	 */
    EReference getDAType_DataTypeTemplates();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#getProtNs <em>Prot Ns</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Prot Ns</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#getProtNs()
	 * @see #getDAType()
	 * @generated
	 */
    EReference getDAType_ProtNs();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#validateDAType_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DA Type nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DA Type nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#validateDAType_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDAType__ValidateDAType_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#validateDAType_at_least_one_BDA_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DA Type at least one BDA required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DA Type at least one BDA required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAType#validateDAType_at_least_one_BDA_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDAType__ValidateDAType_at_least_one_BDA_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DO <em>DO</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>DO</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DO
	 * @generated
	 */
    EClass getDO();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#getTransient <em>Transient</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Transient</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#getTransient()
	 * @see #getDO()
	 * @generated
	 */
    EAttribute getDO_Transient();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#getType()
	 * @see #getDO()
	 * @generated
	 */
    EAttribute getDO_Type();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#getLNodeType <em>LNode Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>LNode Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#getLNodeType()
	 * @see #getDO()
	 * @generated
	 */
    EReference getDO_LNodeType();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#getRefersToDOType <em>Refers To DO Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To DO Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#getRefersToDOType()
	 * @see #getDO()
	 * @generated
	 */
    EReference getDO_RefersToDOType();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#validateDO_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DO type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DO type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#validateDO_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDO__ValidateDO_type_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#validateDO_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DO type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DO type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DO#validateDO_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDO__ValidateDO_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType <em>DO Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>DO Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType
	 * @generated
	 */
    EClass getDOType();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getCdc <em>Cdc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cdc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getCdc()
	 * @see #getDOType()
	 * @generated
	 */
    EAttribute getDOType_Cdc();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getIedType <em>Ied Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ied Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getIedType()
	 * @see #getDOType()
	 * @generated
	 */
    EAttribute getDOType_IedType();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getDA <em>DA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>DA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getDA()
	 * @see #getDOType()
	 * @generated
	 */
    EReference getDOType_DA();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getReferredByDO <em>Referred By DO</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By DO</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getReferredByDO()
	 * @see #getDOType()
	 * @generated
	 */
    EReference getDOType_ReferredByDO();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getDataTypeTemplates <em>Data Type Templates</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Data Type Templates</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getDataTypeTemplates()
	 * @see #getDOType()
	 * @generated
	 */
    EReference getDOType_DataTypeTemplates();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getSDO <em>SDO</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>SDO</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getSDO()
	 * @see #getDOType()
	 * @generated
	 */
    EReference getDOType_SDO();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getReferredBySDO <em>Referred By SDO</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By SDO</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#getReferredBySDO()
	 * @see #getDOType()
	 * @generated
	 */
    EReference getDOType_ReferredBySDO();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#validateDOType_cdc_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DO Type cdc required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DO Type cdc required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#validateDOType_cdc_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDOType__ValidateDOType_cdc_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#validateDOType_cdc_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DO Type cdc valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DO Type cdc valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#validateDOType_cdc_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDOType__ValidateDOType_cdc_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#validateDOType_iedType_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DO Type ied Type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DO Type ied Type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#validateDOType_iedType_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDOType__ValidateDOType_iedType_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#validateDOType_at_least_one_SDO_or_DA_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DO Type at least one SDO or DA required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DO Type at least one SDO or DA required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOType#validateDOType_at_least_one_SDO_or_DA_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDOType__ValidateDOType_at_least_one_SDO_or_DA_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates <em>Data Type Templates</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Type Templates</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates
	 * @generated
	 */
    EClass getDataTypeTemplates();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#getDAType <em>DA Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>DA Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#getDAType()
	 * @see #getDataTypeTemplates()
	 * @generated
	 */
    EReference getDataTypeTemplates_DAType();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#getDOType <em>DO Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>DO Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#getDOType()
	 * @see #getDataTypeTemplates()
	 * @generated
	 */
    EReference getDataTypeTemplates_DOType();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#getEnumType <em>Enum Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Enum Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#getEnumType()
	 * @see #getDataTypeTemplates()
	 * @generated
	 */
    EReference getDataTypeTemplates_EnumType();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#getLNodeType <em>LNode Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>LNode Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#getLNodeType()
	 * @see #getDataTypeTemplates()
	 * @generated
	 */
    EReference getDataTypeTemplates_LNodeType();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#getSCL <em>SCL</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>SCL</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#getSCL()
	 * @see #getDataTypeTemplates()
	 * @generated
	 */
    EReference getDataTypeTemplates_SCL();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#validateDataTypeTemplates_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Data Type Templates nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Data Type Templates nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#validateDataTypeTemplates_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDataTypeTemplates__ValidateDataTypeTemplates_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#validateDataTypeTemplates_at_least_one_LNodeType_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Data Type Templates at least one LNode Type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Data Type Templates at least one LNode Type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#validateDataTypeTemplates_at_least_one_LNodeType_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDataTypeTemplates__ValidateDataTypeTemplates_at_least_one_LNodeType_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#validateDataTypeTemplates_at_least_one_DOType_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Data Type Templates at least one DO Type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Data Type Templates at least one DO Type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataTypeTemplates#validateDataTypeTemplates_at_least_one_DOType_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDataTypeTemplates__ValidateDataTypeTemplates_at_least_one_DOType_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType <em>Enum Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enum Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType
	 * @generated
	 */
    EClass getEnumType();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType#getReferredByAbstractDataAttribute <em>Referred By Abstract Data Attribute</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Abstract Data Attribute</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType#getReferredByAbstractDataAttribute()
	 * @see #getEnumType()
	 * @generated
	 */
    EReference getEnumType_ReferredByAbstractDataAttribute();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType#getDataTypeTemplates <em>Data Type Templates</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Data Type Templates</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType#getDataTypeTemplates()
	 * @see #getEnumType()
	 * @generated
	 */
    EReference getEnumType_DataTypeTemplates();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType#getEnumVal <em>Enum Val</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Enum Val</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType#getEnumVal()
	 * @see #getEnumType()
	 * @generated
	 */
    EReference getEnumType_EnumVal();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType#validateEnumType_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Enum Type nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Enum Type nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType#validateEnumType_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getEnumType__ValidateEnumType_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType#validateEnumType_at_least_one_EnumVal_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Enum Type at least one Enum Val required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Enum Type at least one Enum Val required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumType#validateEnumType_at_least_one_EnumVal_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getEnumType__ValidateEnumType_at_least_one_EnumVal_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal <em>Enum Val</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enum Val</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal
	 * @generated
	 */
    EClass getEnumVal();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal#getOrd <em>Ord</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ord</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal#getOrd()
	 * @see #getEnumVal()
	 * @generated
	 */
    EAttribute getEnumVal_Ord();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal#getEnumType <em>Enum Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Enum Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal#getEnumType()
	 * @see #getEnumVal()
	 * @generated
	 */
    EReference getEnumVal_EnumType();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal#getValue()
	 * @see #getEnumVal()
	 * @generated
	 */
    EAttribute getEnumVal_Value();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal#getDesc <em>Desc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Desc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal#getDesc()
	 * @see #getEnumVal()
	 * @generated
	 */
    EAttribute getEnumVal_Desc();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal#validateEnumVal_ord_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Enum Val ord required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Enum Val ord required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EnumVal#validateEnumVal_ord_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getEnumVal__ValidateEnumVal_ord_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType <em>LNode Type</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for class '<em>LNode Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType
	 * @generated
	 */
    EClass getLNodeType();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#getIedType <em>Ied Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ied Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#getIedType()
	 * @see #getLNodeType()
	 * @generated
	 */
    EAttribute getLNodeType_IedType();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#getLnClass <em>Ln Class</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Class</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#getLnClass()
	 * @see #getLNodeType()
	 * @generated
	 */
    EAttribute getLNodeType_LnClass();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#getDO <em>DO</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>DO</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#getDO()
	 * @see #getLNodeType()
	 * @generated
	 */
    EReference getLNodeType_DO();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#getDataTypeTemplates <em>Data Type Templates</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Data Type Templates</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#getDataTypeTemplates()
	 * @see #getLNodeType()
	 * @generated
	 */
    EReference getLNodeType_DataTypeTemplates();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#getReferredByAnyLN <em>Referred By Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#getReferredByAnyLN()
	 * @see #getLNodeType()
	 * @generated
	 */
    EReference getLNodeType_ReferredByAnyLN();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#validateLNodeType_lnClass_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode Type ln Class required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode Type ln Class required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#validateLNodeType_lnClass_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNodeType__ValidateLNodeType_lnClass_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#validateLNodeType_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode Type ln Class valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode Type ln Class valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#validateLNodeType_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNodeType__ValidateLNodeType_lnClass_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#validateHistory_at_least_one_DO_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate History at least one DO required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate History at least one DO required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeType#validateHistory_at_least_one_DO_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNodeType__ValidateHistory_at_least_one_DO_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs <em>Prot Ns</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Prot Ns</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs
	 * @generated
	 */
    EClass getProtNs();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#getType()
	 * @see #getProtNs()
	 * @generated
	 */
    EAttribute getProtNs_Type();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#getDA <em>DA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>DA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#getDA()
	 * @see #getProtNs()
	 * @generated
	 */
    EReference getProtNs_DA();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#getDAType <em>DA Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>DA Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#getDAType()
	 * @see #getProtNs()
	 * @generated
	 */
    EReference getProtNs_DAType();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#getValue()
	 * @see #getProtNs()
	 * @generated
	 */
    EAttribute getProtNs_Value();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#validateProtNs_value_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Prot Ns value required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Prot Ns value required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#validateProtNs_value_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getProtNs__ValidateProtNs_value_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#validateProtNs_value_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Prot Ns value valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Prot Ns value valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#validateProtNs_value_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getProtNs__ValidateProtNs_value_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#validateProtNs_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Prot Ns type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Prot Ns type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ProtNs#validateProtNs_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getProtNs__ValidateProtNs_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO <em>SDO</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SDO</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO
	 * @generated
	 */
    EClass getSDO();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#getCount <em>Count</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Count</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#getCount()
	 * @see #getSDO()
	 * @generated
	 */
    EAttribute getSDO_Count();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#getType()
	 * @see #getSDO()
	 * @generated
	 */
    EAttribute getSDO_Type();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#getDOType <em>DO Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>DO Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#getDOType()
	 * @see #getSDO()
	 * @generated
	 */
    EReference getSDO_DOType();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#getName()
	 * @see #getSDO()
	 * @generated
	 */
    EAttribute getSDO_Name();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#getRefersToDOType <em>Refers To DO Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To DO Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#getRefersToDOType()
	 * @see #getSDO()
	 * @generated
	 */
    EReference getSDO_RefersToDOType();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#validateSDO_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SDO name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SDO name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#validateSDO_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSDO__ValidateSDO_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#validateSDO_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SDO name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SDO name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#validateSDO_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSDO__ValidateSDO_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#validateSDO_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SDO type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SDO type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#validateSDO_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSDO__ValidateSDO_type_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#validateSDO_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SDO type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SDO type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#validateSDO_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSDO__ValidateSDO_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#validateSDO_count_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SDO count valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SDO count valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDO#validateSDO_count_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSDO__ValidateSDO_count_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Val <em>Val</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Val</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Val
	 * @generated
	 */
    EClass getVal();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Val#getSGroup <em>SGroup</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SGroup</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Val#getSGroup()
	 * @see #getVal()
	 * @generated
	 */
    EAttribute getVal_SGroup();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Val#getAbstractDataAttribute <em>Abstract Data Attribute</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Abstract Data Attribute</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Val#getAbstractDataAttribute()
	 * @see #getVal()
	 * @generated
	 */
    EReference getVal_AbstractDataAttribute();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Val#getDAI <em>DAI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>DAI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Val#getDAI()
	 * @see #getVal()
	 * @generated
	 */
    EReference getVal_DAI();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Val#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Val#getValue()
	 * @see #getVal()
	 * @generated
	 */
    EAttribute getVal_Value();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Val#validateVal_sGroup_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Val sGroup valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Val sGroup valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Val#validateVal_sGroup_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getVal__ValidateVal_sGroup_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec <em>Bit Rate In Mb Per Sec</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bit Rate In Mb Per Sec</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec
	 * @generated
	 */
    EClass getBitRateInMbPerSec();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#getValue()
	 * @see #getBitRateInMbPerSec()
	 * @generated
	 */
    EAttribute getBitRateInMbPerSec_Value();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#getMultiplier <em>Multiplier</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Multiplier</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#getMultiplier()
	 * @see #getBitRateInMbPerSec()
	 * @generated
	 */
    EAttribute getBitRateInMbPerSec_Multiplier();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unit</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#getUnit()
	 * @see #getBitRateInMbPerSec()
	 * @generated
	 */
    EAttribute getBitRateInMbPerSec_Unit();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#validateBitRateInMbPerSec_value_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Bit Rate In Mb Per Sec value required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Bit Rate In Mb Per Sec value required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#validateBitRateInMbPerSec_value_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getBitRateInMbPerSec__ValidateBitRateInMbPerSec_value_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#validateBitRateInMbPerSec_value_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Bit Rate In Mb Per Sec value valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Bit Rate In Mb Per Sec value valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#validateBitRateInMbPerSec_value_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getBitRateInMbPerSec__ValidateBitRateInMbPerSec_value_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#validateBitRateInMbPerSec_unit_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Bit Rate In Mb Per Sec unit value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Bit Rate In Mb Per Sec unit value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#validateBitRateInMbPerSec_unit_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getBitRateInMbPerSec__ValidateBitRateInMbPerSec_unit_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#validateBitRateInMbPerSec_multiplier_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Bit Rate In Mb Per Sec multiplier value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Bit Rate In Mb Per Sec multiplier value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRateInMbPerSec#validateBitRateInMbPerSec_multiplier_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getBitRateInMbPerSec__ValidateBitRateInMbPerSec_multiplier_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.MinTime <em>Min Time</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Min Time</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.MinTime
	 * @generated
	 */
    EClass getMinTime();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.MinTime#validateMinTime_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Min Time nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Min Time nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.MinTime#validateMinTime_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getMinTime__ValidateMinTime_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.MaxTime <em>Max Time</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Max Time</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.MaxTime
	 * @generated
	 */
    EClass getMaxTime();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.MaxTime#validateMaxTime_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Max Time nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Max Time nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.MaxTime#validateMaxTime_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getMaxTime__ValidateMaxTime_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRate <em>Bit Rate</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bit Rate</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.BitRate
	 * @generated
	 */
    EClass getBitRate();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmpRate <em>Smp Rate</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Smp Rate</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmpRate
	 * @generated
	 */
    EClass getSmpRate();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmpRate#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmpRate#getValue()
	 * @see #getSmpRate()
	 * @generated
	 */
    EAttribute getSmpRate_Value();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SamplesPerSec <em>Samples Per Sec</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Samples Per Sec</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SamplesPerSec
	 * @generated
	 */
    EClass getSamplesPerSec();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SamplesPerSec#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SamplesPerSec#getValue()
	 * @see #getSamplesPerSec()
	 * @generated
	 */
    EAttribute getSamplesPerSec_Value();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SecPerSamples <em>Sec Per Samples</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sec Per Samples</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SecPerSamples
	 * @generated
	 */
    EClass getSecPerSamples();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SecPerSamples#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SecPerSamples#getValue()
	 * @see #getSecPerSamples()
	 * @generated
	 */
    EAttribute getSecPerSamples_Value();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec <em>Duration In Milli Sec</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Duration In Milli Sec</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec
	 * @generated
	 */
    EClass getDurationInMilliSec();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#getValue()
	 * @see #getDurationInMilliSec()
	 * @generated
	 */
    EAttribute getDurationInMilliSec_Value();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#getMultiplier <em>Multiplier</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Multiplier</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#getMultiplier()
	 * @see #getDurationInMilliSec()
	 * @generated
	 */
    EAttribute getDurationInMilliSec_Multiplier();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unit</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#getUnit()
	 * @see #getDurationInMilliSec()
	 * @generated
	 */
    EAttribute getDurationInMilliSec_Unit();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#validateDurationInMilliSec_value_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Duration In Milli Sec value required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Duration In Milli Sec value required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#validateDurationInMilliSec_value_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDurationInMilliSec__ValidateDurationInMilliSec_value_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#validateDurationInMilliSec_value_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Duration In Milli Sec value valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Duration In Milli Sec value valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#validateDurationInMilliSec_value_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDurationInMilliSec__ValidateDurationInMilliSec_value_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#validateDurationInMilliSec_unit_value_fixed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Duration In Milli Sec unit value fixed</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Duration In Milli Sec unit value fixed</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#validateDurationInMilliSec_unit_value_fixed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDurationInMilliSec__ValidateDurationInMilliSec_unit_value_fixed__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#validateDurationInMilliSec_multiplier_value_fixed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Duration In Milli Sec multiplier value fixed</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Duration In Milli Sec multiplier value fixed</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInMilliSec#validateDurationInMilliSec_multiplier_value_fixed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDurationInMilliSec__ValidateDurationInMilliSec_multiplier_value_fixed__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessControl <em>Access Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Access Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessControl
	 * @generated
	 */
    EClass getAccessControl();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessControl#getLDevice <em>LDevice</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>LDevice</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessControl#getLDevice()
	 * @see #getAccessControl()
	 * @generated
	 */
    EReference getAccessControl_LDevice();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessControl#validateAccessControl_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Access Control nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Access Control nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessControl#validateAccessControl_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAccessControl__ValidateAccessControl_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint <em>Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint
	 * @generated
	 */
    EClass getAccessPoint();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getClock <em>Clock</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Clock</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getClock()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EAttribute getAccessPoint_Clock();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getKdc <em>Kdc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kdc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getKdc()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EAttribute getAccessPoint_Kdc();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getRouter <em>Router</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Router</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getRouter()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EAttribute getAccessPoint_Router();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getIED <em>IED</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>IED</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getIED()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EReference getAccessPoint_IED();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getLN <em>LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getLN()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EReference getAccessPoint_LN();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getSMVSecurity <em>SMV Security</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>SMV Security</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getSMVSecurity()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EReference getAccessPoint_SMVSecurity();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getServerAt <em>Server At</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Server At</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getServerAt()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EReference getAccessPoint_ServerAt();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getServer <em>Server</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Server</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getServer()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EReference getAccessPoint_Server();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getServices()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EReference getAccessPoint_Services();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getGOOSESecurity <em>GOOSE Security</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>GOOSE Security</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getGOOSESecurity()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EReference getAccessPoint_GOOSESecurity();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getReferredByServerAt <em>Referred By Server At</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Server At</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getReferredByServerAt()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EReference getAccessPoint_ReferredByServerAt();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getName()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EAttribute getAccessPoint_Name();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getReferredByConnectedAP <em>Referred By Connected AP</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Connected AP</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getReferredByConnectedAP()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EReference getAccessPoint_ReferredByConnectedAP();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getReferredByKDC <em>Referred By KDC</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By KDC</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#getReferredByKDC()
	 * @see #getAccessPoint()
	 * @generated
	 */
    EReference getAccessPoint_ReferredByKDC();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#validateAccessPoint_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Access Point name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Access Point name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#validateAccessPoint_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAccessPoint__ValidateAccessPoint_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#validateAccessPoint_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Access Point name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Access Point name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#validateAccessPoint_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAccessPoint__ValidateAccessPoint_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#validateAccessPoint_restriction_on_content(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Access Point restriction on content</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Access Point restriction on content</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#validateAccessPoint_restriction_on_content(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAccessPoint__ValidateAccessPoint_restriction_on_content__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#validateAccessPoint_at_most_securities(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Access Point at most securities</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Access Point at most securities</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#validateAccessPoint_at_most_securities(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAccessPoint__ValidateAccessPoint_at_most_securities__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#validateAccessPoint_securities_allowed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Access Point securities allowed</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Access Point securities allowed</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AccessPoint#validateAccessPoint_securities_allowed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAccessPoint__ValidateAccessPoint_securities_allowed__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN <em>Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN
	 * @generated
	 */
    EClass getAnyLN();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getInst <em>Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getInst()
	 * @see #getAnyLN()
	 * @generated
	 */
    EAttribute getAnyLN_Inst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getLnClass <em>Ln Class</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Class</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getLnClass()
	 * @see #getAnyLN()
	 * @generated
	 */
    EAttribute getAnyLN_LnClass();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getLnType <em>Ln Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getLnType()
	 * @see #getAnyLN()
	 * @generated
	 */
    EAttribute getAnyLN_LnType();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getRefersToLNodeType <em>Refers To LNode Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To LNode Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getRefersToLNodeType()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_RefersToLNodeType();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getInputs <em>Inputs</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Inputs</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getInputs()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_Inputs();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getLog <em>Log</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Log</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getLog()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_Log();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getDOI <em>DOI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>DOI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getDOI()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_DOI();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReportControl <em>Report Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Report Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReportControl()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_ReportControl();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getLogControl <em>Log Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Log Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getLogControl()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_LogControl();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getDataSet <em>Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getDataSet()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_DataSet();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredByFCDA <em>Referred By FCDA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By FCDA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredByFCDA()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_ReferredByFCDA();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredByExtRef <em>Referred By Ext Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Ext Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredByExtRef()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_ReferredByExtRef();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredByClientLN <em>Referred By Client LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Client LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredByClientLN()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_ReferredByClientLN();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredByLogControl <em>Referred By Log Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Log Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredByLogControl()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_ReferredByLogControl();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredByAssociation <em>Referred By Association</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Association</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredByAssociation()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_ReferredByAssociation();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredIEDName <em>Referred IED Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred IED Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#getReferredIEDName()
	 * @see #getAnyLN()
	 * @generated
	 */
    EReference getAnyLN_ReferredIEDName();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#validateLN_lnClass_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LN ln Class required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LN ln Class required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#validateLN_lnClass_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAnyLN__ValidateLN_lnClass_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#validateLN_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LN ln Class valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LN ln Class valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#validateLN_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAnyLN__ValidateLN_lnClass_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#validateLN_inst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LN inst required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LN inst required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#validateLN_inst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAnyLN__ValidateLN_inst_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#validateAnyLN_lnType_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Any LN ln Type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Any LN ln Type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#validateAnyLN_lnType_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAnyLN__ValidateAnyLN_lnType_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#validateAnyLN_lnType_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Any LN ln Type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Any LN ln Type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AnyLN#validateAnyLN_lnType_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAnyLN__ValidateAnyLN_lnType_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association <em>Association</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Association</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association
	 * @generated
	 */
    EClass getAssociation();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getAssociationID <em>Association ID</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Association ID</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getAssociationID()
	 * @see #getAssociation()
	 * @generated
	 */
    EAttribute getAssociation_AssociationID();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getIedName <em>Ied Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ied Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getIedName()
	 * @see #getAssociation()
	 * @generated
	 */
    EAttribute getAssociation_IedName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getKind <em>Kind</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getKind()
	 * @see #getAssociation()
	 * @generated
	 */
    EAttribute getAssociation_Kind();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getLdInst <em>Ld Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ld Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getLdInst()
	 * @see #getAssociation()
	 * @generated
	 */
    EAttribute getAssociation_LdInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getLnClass <em>Ln Class</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Class</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getLnClass()
	 * @see #getAssociation()
	 * @generated
	 */
    EAttribute getAssociation_LnClass();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getLnInst <em>Ln Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getLnInst()
	 * @see #getAssociation()
	 * @generated
	 */
    EAttribute getAssociation_LnInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getPrefix()
	 * @see #getAssociation()
	 * @generated
	 */
    EAttribute getAssociation_Prefix();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getServer <em>Server</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Server</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getServer()
	 * @see #getAssociation()
	 * @generated
	 */
    EReference getAssociation_Server();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getRefersToAnyLN <em>Refers To Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#getRefersToAnyLN()
	 * @see #getAssociation()
	 * @generated
	 */
    EReference getAssociation_RefersToAnyLN();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#validateAssociation_kind_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Association kind required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Association kind required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#validateAssociation_kind_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAssociation__ValidateAssociation_kind_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#validateAssociation_associationID_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Association association ID valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Association association ID valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Association#validateAssociation_associationID_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAssociation__ValidateAssociation_associationID_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication <em>Authentication</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Authentication</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication
	 * @generated
	 */
    EClass getAuthentication();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getCertificate <em>Certificate</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Certificate</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getCertificate()
	 * @see #getAuthentication()
	 * @generated
	 */
    EAttribute getAuthentication_Certificate();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getNone <em>None</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>None</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getNone()
	 * @see #getAuthentication()
	 * @generated
	 */
    EAttribute getAuthentication_None();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getPassword <em>Password</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Password</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getPassword()
	 * @see #getAuthentication()
	 * @generated
	 */
    EAttribute getAuthentication_Password();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getStrong <em>Strong</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Strong</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getStrong()
	 * @see #getAuthentication()
	 * @generated
	 */
    EAttribute getAuthentication_Strong();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getWeak <em>Weak</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Weak</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getWeak()
	 * @see #getAuthentication()
	 * @generated
	 */
    EAttribute getAuthentication_Weak();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getServer <em>Server</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Server</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Authentication#getServer()
	 * @see #getAuthentication()
	 * @generated
	 */
    EReference getAuthentication_Server();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate <em>Certificate</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Certificate</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate
	 * @generated
	 */
    EClass getCertificate();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#getSerialNumber <em>Serial Number</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Serial Number</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#getSerialNumber()
	 * @see #getCertificate()
	 * @generated
	 */
    EAttribute getCertificate_SerialNumber();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#getXferNumber <em>Xfer Number</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Xfer Number</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#getXferNumber()
	 * @see #getCertificate()
	 * @generated
	 */
    EAttribute getCertificate_XferNumber();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#getSubject <em>Subject</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Subject</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#getSubject()
	 * @see #getCertificate()
	 * @generated
	 */
    EReference getCertificate_Subject();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#getIssuerName <em>Issuer Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Issuer Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#getIssuerName()
	 * @see #getCertificate()
	 * @generated
	 */
    EReference getCertificate_IssuerName();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#validateCertificate_serialNumber_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Certificate serial Number required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Certificate serial Number required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#validateCertificate_serialNumber_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCertificate__ValidateCertificate_serialNumber_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#validateCertificate_serialNumber_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Certificate serial Number valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Certificate serial Number valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#validateCertificate_serialNumber_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCertificate__ValidateCertificate_serialNumber_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#validateCertificate_xferNumber_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Certificate xfer Number valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Certificate xfer Number valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#validateCertificate_xferNumber_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCertificate__ValidateCertificate_xferNumber_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#validateCertificate_one_Subject_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Certificate one Subject required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Certificate one Subject required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#validateCertificate_one_Subject_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCertificate__ValidateCertificate_one_Subject_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#validateCertificate_one_IssuerName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Certificate one Issuer Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Certificate one Issuer Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Certificate#validateCertificate_one_IssuerName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCertificate__ValidateCertificate_one_IssuerName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN <em>Client LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Client LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN
	 * @generated
	 */
    EClass getClientLN();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getApRef <em>Ap Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ap Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getApRef()
	 * @see #getClientLN()
	 * @generated
	 */
    EAttribute getClientLN_ApRef();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getIedName <em>Ied Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ied Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getIedName()
	 * @see #getClientLN()
	 * @generated
	 */
    EAttribute getClientLN_IedName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getLdInst <em>Ld Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ld Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getLdInst()
	 * @see #getClientLN()
	 * @generated
	 */
    EAttribute getClientLN_LdInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getLnClass <em>Ln Class</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Class</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getLnClass()
	 * @see #getClientLN()
	 * @generated
	 */
    EAttribute getClientLN_LnClass();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getLnInst <em>Ln Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getLnInst()
	 * @see #getClientLN()
	 * @generated
	 */
    EAttribute getClientLN_LnInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getPrefix()
	 * @see #getClientLN()
	 * @generated
	 */
    EAttribute getClientLN_Prefix();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getRptEnabled <em>Rpt Enabled</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Rpt Enabled</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getRptEnabled()
	 * @see #getClientLN()
	 * @generated
	 */
    EReference getClientLN_RptEnabled();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getDesc <em>Desc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Desc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getDesc()
	 * @see #getClientLN()
	 * @generated
	 */
    EAttribute getClientLN_Desc();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getRefersToAnyLN <em>Refers To Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#getRefersToAnyLN()
	 * @see #getClientLN()
	 * @generated
	 */
    EReference getClientLN_RefersToAnyLN();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_apRef_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN ap Ref valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN ap Ref valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_apRef_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_apRef_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_iedName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN ied Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN ied Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_iedName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_iedName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_iedName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN ied Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN ied Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_iedName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_iedName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_ldInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN ld Inst required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN ld Inst required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_ldInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_ldInst_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_ldInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN ld Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN ld Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_ldInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_ldInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_lnClass_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN ln Class required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN ln Class required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_lnClass_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_lnClass_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN ln Class valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN ln Class valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_lnClass_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_lnInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN ln Inst required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN ln Inst required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_lnInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_lnInst_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_lnInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN ln Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN ln Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_lnInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_lnInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_lnInst_empty_for_LLN0(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN ln Inst empty for LLN0</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN ln Inst empty for LLN0</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_lnInst_empty_for_LLN0(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_lnInst_empty_for_LLN0__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_prefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client LN prefix valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client LN prefix valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientLN#validateClientLN_prefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientLN__ValidateClientLN_prefix_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices <em>Client Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Client Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices
	 * @generated
	 */
    EClass getClientServices();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getBufReport <em>Buf Report</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Buf Report</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getBufReport()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_BufReport();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getGoose <em>Goose</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Goose</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getGoose()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_Goose();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getGsse <em>Gsse</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gsse</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getGsse()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_Gsse();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getMaxAttributes <em>Max Attributes</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Attributes</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getMaxAttributes()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_MaxAttributes();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getMaxGOOSE <em>Max GOOSE</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max GOOSE</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getMaxGOOSE()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_MaxGOOSE();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getMaxReports <em>Max Reports</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Reports</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getMaxReports()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_MaxReports();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getMaxSMV <em>Max SMV</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max SMV</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getMaxSMV()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_MaxSMV();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getReadLog <em>Read Log</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Read Log</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getReadLog()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_ReadLog();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getSupportsLdName <em>Supports Ld Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Supports Ld Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getSupportsLdName()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_SupportsLdName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getSv <em>Sv</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sv</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getSv()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_Sv();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getUnbufReport <em>Unbuf Report</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unbuf Report</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getUnbufReport()
	 * @see #getClientServices()
	 * @generated
	 */
    EAttribute getClientServices_UnbufReport();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getServices()
	 * @see #getClientServices()
	 * @generated
	 */
    EReference getClientServices_Services();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getTimeSyncProt <em>Time Sync Prot</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Time Sync Prot</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#getTimeSyncProt()
	 * @see #getClientServices()
	 * @generated
	 */
    EReference getClientServices_TimeSyncProt();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#validateClientServices_maxAttributes_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client Services max Attributes valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client Services max Attributes valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#validateClientServices_maxAttributes_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientServices__ValidateClientServices_maxAttributes_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#validateClientServices_maxReports_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client Services max Reports valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client Services max Reports valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#validateClientServices_maxReports_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientServices__ValidateClientServices_maxReports_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#validateClientServices_maxGOOSE_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client Services max GOOSE valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client Services max GOOSE valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#validateClientServices_maxGOOSE_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientServices__ValidateClientServices_maxGOOSE_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#validateClientServices_maxSMV_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Client Services max SMV valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Client Services max SMV valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ClientServices#validateClientServices_maxSMV_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getClientServices__ValidateClientServices_maxSMV_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.CommProt <em>Comm Prot</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Comm Prot</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.CommProt
	 * @generated
	 */
    EClass getCommProt();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.CommProt#getIpv6 <em>Ipv6</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ipv6</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.CommProt#getIpv6()
	 * @see #getCommProt()
	 * @generated
	 */
    EAttribute getCommProt_Ipv6();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.CommProt#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.CommProt#getServices()
	 * @see #getCommProt()
	 * @generated
	 */
    EReference getCommProt_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.CommProt#validateCommProt_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Comm Prot nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Comm Prot nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.CommProt#validateCommProt_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCommProt__ValidateCommProt_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfDataSet <em>Conf Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conf Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfDataSet
	 * @generated
	 */
    EClass getConfDataSet();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfDataSet#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfDataSet#getServices()
	 * @see #getConfDataSet()
	 * @generated
	 */
    EReference getConfDataSet_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs <em>Conf LNs</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conf LNs</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs
	 * @generated
	 */
    EClass getConfLNs();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs#getFixLnInst <em>Fix Ln Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fix Ln Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs#getFixLnInst()
	 * @see #getConfLNs()
	 * @generated
	 */
    EAttribute getConfLNs_FixLnInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs#getFixPrefix <em>Fix Prefix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fix Prefix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs#getFixPrefix()
	 * @see #getConfLNs()
	 * @generated
	 */
    EAttribute getConfLNs_FixPrefix();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs#getServices()
	 * @see #getConfLNs()
	 * @generated
	 */
    EReference getConfLNs_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs#validateConfLNs_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Conf LNs nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Conf LNs nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLNs#validateConfLNs_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConfLNs__ValidateConfLNs_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLdName <em>Conf Ld Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conf Ld Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLdName
	 * @generated
	 */
    EClass getConfLdName();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLdName#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLdName#getServices()
	 * @see #getConfLdName()
	 * @generated
	 */
    EReference getConfLdName_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLogControl <em>Conf Log Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conf Log Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLogControl
	 * @generated
	 */
    EClass getConfLogControl();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLogControl#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfLogControl#getServices()
	 * @see #getConfLogControl()
	 * @generated
	 */
    EReference getConfLogControl_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfReportControl <em>Conf Report Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conf Report Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfReportControl
	 * @generated
	 */
    EClass getConfReportControl();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfReportControl#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfReportControl#getServices()
	 * @see #getConfReportControl()
	 * @generated
	 */
    EReference getConfReportControl_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSG <em>Conf SG</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conf SG</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSG
	 * @generated
	 */
    EClass getConfSG();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSG#getResvTms <em>Resv Tms</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Resv Tms</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSG#getResvTms()
	 * @see #getConfSG()
	 * @generated
	 */
    EAttribute getConfSG_ResvTms();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSG#getSettingGroups <em>Setting Groups</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Setting Groups</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSG#getSettingGroups()
	 * @see #getConfSG()
	 * @generated
	 */
    EReference getConfSG_SettingGroups();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSigRef <em>Conf Sig Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conf Sig Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSigRef
	 * @generated
	 */
    EClass getConfSigRef();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSigRef#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConfSigRef#getServices()
	 * @see #getConfSigRef()
	 * @generated
	 */
    EReference getConfSigRef_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Control <em>Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Control
	 * @generated
	 */
    EClass getControl();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#getDatSet <em>Dat Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dat Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#getDatSet()
	 * @see #getControl()
	 * @generated
	 */
    EAttribute getControl_DatSet();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#getRefersToDataSet <em>Refers To Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#getRefersToDataSet()
	 * @see #getControl()
	 * @generated
	 */
    EReference getControl_RefersToDataSet();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#getName()
	 * @see #getControl()
	 * @generated
	 */
    EAttribute getControl_Name();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#validateControl_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Control name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Control name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#validateControl_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getControl__ValidateControl_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#validateControl_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Control name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Control name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#validateControl_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getControl__ValidateControl_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#validateControl_datSet_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Control dat Set valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Control dat Set valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Control#validateControl_datSet_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getControl__ValidateControl_datSet_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName <em>Control With IED Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Control With IED Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName
	 * @generated
	 */
    EClass getControlWithIEDName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName#getConfRev <em>Conf Rev</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Conf Rev</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName#getConfRev()
	 * @see #getControlWithIEDName()
	 * @generated
	 */
    EAttribute getControlWithIEDName_ConfRev();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName#getIEDName <em>IED Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>IED Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName#getIEDName()
	 * @see #getControlWithIEDName()
	 * @generated
	 */
    EReference getControlWithIEDName_IEDName();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName#getReferredByControlBlock <em>Referred By Control Block</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Control Block</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName#getReferredByControlBlock()
	 * @see #getControlWithIEDName()
	 * @generated
	 */
    EReference getControlWithIEDName_ReferredByControlBlock();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName#getProtocol <em>Protocol</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Protocol</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName#getProtocol()
	 * @see #getControlWithIEDName()
	 * @generated
	 */
    EReference getControlWithIEDName_Protocol();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName#validateControlWithIEDName_confRev_unsignedInt(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Control With IED Name conf Rev unsigned Int</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Control With IED Name conf Rev unsigned Int</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithIEDName#validateControlWithIEDName_confRev_unsignedInt(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getControlWithIEDName__ValidateControlWithIEDName_confRev_unsignedInt__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithTriggerOpt <em>Control With Trigger Opt</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Control With Trigger Opt</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithTriggerOpt
	 * @generated
	 */
    EClass getControlWithTriggerOpt();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithTriggerOpt#getIntgPd <em>Intg Pd</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Intg Pd</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithTriggerOpt#getIntgPd()
	 * @see #getControlWithTriggerOpt()
	 * @generated
	 */
    EAttribute getControlWithTriggerOpt_IntgPd();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithTriggerOpt#getTrgOps <em>Trg Ops</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Trg Ops</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithTriggerOpt#getTrgOps()
	 * @see #getControlWithTriggerOpt()
	 * @generated
	 */
    EReference getControlWithTriggerOpt_TrgOps();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithTriggerOpt#validateControlWithTriggerOpt_intgPd_unsigned_int(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Control With Trigger Opt intg Pd unsigned int</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Control With Trigger Opt intg Pd unsigned int</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ControlWithTriggerOpt#validateControlWithTriggerOpt_intgPd_unsigned_int(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getControlWithTriggerOpt__ValidateControlWithTriggerOpt_intgPd_unsigned_int__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI <em>DAI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>DAI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI
	 * @generated
	 */
    EClass getDAI();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getIx <em>Ix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getIx()
	 * @see #getDAI()
	 * @generated
	 */
    EAttribute getDAI_Ix();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getSAddr <em>SAddr</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SAddr</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getSAddr()
	 * @see #getDAI()
	 * @generated
	 */
    EAttribute getDAI_SAddr();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getValImport <em>Val Import</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Val Import</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getValImport()
	 * @see #getDAI()
	 * @generated
	 */
    EAttribute getDAI_ValImport();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getValKind <em>Val Kind</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Val Kind</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getValKind()
	 * @see #getDAI()
	 * @generated
	 */
    EAttribute getDAI_ValKind();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getVal <em>Val</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Val</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getVal()
	 * @see #getDAI()
	 * @generated
	 */
    EReference getDAI_Val();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getDOI <em>DOI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>DOI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getDOI()
	 * @see #getDAI()
	 * @generated
	 */
    EReference getDAI_DOI();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getSDI <em>SDI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>SDI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#getSDI()
	 * @see #getDAI()
	 * @generated
	 */
    EReference getDAI_SDI();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#validateDAI_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DAI name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DAI name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#validateDAI_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDAI__ValidateDAI_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#validateDAI_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DAI name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DAI name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#validateDAI_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDAI__ValidateDAI_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#validateDAI_ix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DAI ix valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DAI ix valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DAI#validateDAI_ix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDAI__ValidateDAI_ix_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI <em>DOI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>DOI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI
	 * @generated
	 */
    EClass getDOI();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#getIx <em>Ix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#getIx()
	 * @see #getDOI()
	 * @generated
	 */
    EAttribute getDOI_Ix();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#getAnyLN <em>Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#getAnyLN()
	 * @see #getDOI()
	 * @generated
	 */
    EReference getDOI_AnyLN();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#getDAI <em>DAI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>DAI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#getDAI()
	 * @see #getDOI()
	 * @generated
	 */
    EReference getDOI_DAI();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#getSDI <em>SDI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>SDI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#getSDI()
	 * @see #getDOI()
	 * @generated
	 */
    EReference getDOI_SDI();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#validateDOI_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DOI name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DOI name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#validateDOI_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDOI__ValidateDOI_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#validateDOI_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DOI name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DOI name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#validateDOI_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDOI__ValidateDOI_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#validateDOI_ix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate DOI ix valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate DOI ix valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DOI#validateDOI_ix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDOI__ValidateDOI_ix_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObjectDirectory <em>Data Object Directory</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Object Directory</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObjectDirectory
	 * @generated
	 */
    EClass getDataObjectDirectory();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObjectDirectory#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObjectDirectory#getServices()
	 * @see #getDataObjectDirectory()
	 * @generated
	 */
    EReference getDataObjectDirectory_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet <em>Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet
	 * @generated
	 */
    EClass getDataSet();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#getAnyLN <em>Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#getAnyLN()
	 * @see #getDataSet()
	 * @generated
	 */
    EReference getDataSet_AnyLN();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#getReferredByControl <em>Referred By Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#getReferredByControl()
	 * @see #getDataSet()
	 * @generated
	 */
    EReference getDataSet_ReferredByControl();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#getFCDA <em>FCDA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>FCDA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#getFCDA()
	 * @see #getDataSet()
	 * @generated
	 */
    EReference getDataSet_FCDA();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#getName()
	 * @see #getDataSet()
	 * @generated
	 */
    EAttribute getDataSet_Name();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#validateDataSet_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Data Set name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Data Set name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#validateDataSet_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDataSet__ValidateDataSet_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#validateDataSet_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Data Set name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Data Set name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#validateDataSet_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDataSet__ValidateDataSet_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#validateDataSet_at_least_one_FCDA_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Data Set at least one FCDA required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Data Set at least one FCDA required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSet#validateDataSet_at_least_one_FCDA_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDataSet__ValidateDataSet_at_least_one_FCDA_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSetDirectory <em>Data Set Directory</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Set Directory</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSetDirectory
	 * @generated
	 */
    EClass getDataSetDirectory();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSetDirectory#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataSetDirectory#getServices()
	 * @see #getDataSetDirectory()
	 * @generated
	 */
    EReference getDataSetDirectory_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DynAssociation <em>Dyn Association</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dyn Association</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DynAssociation
	 * @generated
	 */
    EClass getDynAssociation();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DynAssociation#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DynAssociation#getServices()
	 * @see #getDynAssociation()
	 * @generated
	 */
    EReference getDynAssociation_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DynDataSet <em>Dyn Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dyn Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DynDataSet
	 * @generated
	 */
    EClass getDynDataSet();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DynDataSet#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DynDataSet#getServices()
	 * @see #getDynDataSet()
	 * @generated
	 */
    EReference getDynDataSet_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef <em>Ext Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ext Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef
	 * @generated
	 */
    EClass getExtRef();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getDaName <em>Da Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Da Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getDaName()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_DaName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getDoName <em>Do Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Do Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getDoName()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_DoName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getIedName <em>Ied Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ied Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getIedName()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_IedName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getIntAddr <em>Int Addr</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Int Addr</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getIntAddr()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_IntAddr();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getLdInst <em>Ld Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ld Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getLdInst()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_LdInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getLnClass <em>Ln Class</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Class</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getLnClass()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_LnClass();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getLnInst <em>Ln Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getLnInst()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_LnInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getPrefix()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_Prefix();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getServiceType <em>Service Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Service Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getServiceType()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_ServiceType();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getSrcCBName <em>Src CB Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Src CB Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getSrcCBName()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_SrcCBName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getSrcLDInst <em>Src LD Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Src LD Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getSrcLDInst()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_SrcLDInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getSrcLNClass <em>Src LN Class</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Src LN Class</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getSrcLNClass()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_SrcLNClass();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getSrcLNInst <em>Src LN Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Src LN Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getSrcLNInst()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_SrcLNInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getSrcPrefix <em>Src Prefix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Src Prefix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getSrcPrefix()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_SrcPrefix();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getInputs <em>Inputs</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Inputs</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getInputs()
	 * @see #getExtRef()
	 * @generated
	 */
    EReference getExtRef_Inputs();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getRefersToAnyLN <em>Refers To Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getRefersToAnyLN()
	 * @see #getExtRef()
	 * @generated
	 */
    EReference getExtRef_RefersToAnyLN();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getRefersToDataAttribute <em>Refers To Data Attribute</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Data Attribute</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getRefersToDataAttribute()
	 * @see #getExtRef()
	 * @generated
	 */
    EReference getExtRef_RefersToDataAttribute();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getRefersToDataObject <em>Refers To Data Object</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Data Object</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getRefersToDataObject()
	 * @see #getExtRef()
	 * @generated
	 */
    EReference getExtRef_RefersToDataObject();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getDesc <em>Desc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Desc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#getDesc()
	 * @see #getExtRef()
	 * @generated
	 */
    EAttribute getExtRef_Desc();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_iedName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ext Ref ied Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ext Ref ied Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_iedName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateExtRef_iedName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_ldInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ext Ref ld Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ext Ref ld Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_ldInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateExtRef_ldInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_prefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ext Ref prefix valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ext Ref prefix valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_prefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateExtRef_prefix_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ext Ref ln Class valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ext Ref ln Class valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateExtRef_lnClass_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_lnInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ext Ref ln Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ext Ref ln Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_lnInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateExtRef_lnInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateFCDA_doName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA do Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA do Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateFCDA_doName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateFCDA_doName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateFCDA_daName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA da Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA da Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateFCDA_daName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateFCDA_daName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_srcLDInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ext Ref src LD Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ext Ref src LD Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_srcLDInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateExtRef_srcLDInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_srcPrefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ext Ref src Prefix valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ext Ref src Prefix valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_srcPrefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateExtRef_srcPrefix_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_srcLNClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ext Ref src LN Class valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ext Ref src LN Class valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_srcLNClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateExtRef_srcLNClass_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_srcLNInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ext Ref src LN Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ext Ref src LN Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_srcLNInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateExtRef_srcLNInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_srcCBName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Ext Ref src CB Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Ext Ref src CB Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExtRef#validateExtRef_srcCBName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExtRef__ValidateExtRef_srcCBName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA <em>FCDA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>FCDA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA
	 * @generated
	 */
    EClass getFCDA();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getDaName <em>Da Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Da Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getDaName()
	 * @see #getFCDA()
	 * @generated
	 */
    EAttribute getFCDA_DaName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getDoName <em>Do Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Do Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getDoName()
	 * @see #getFCDA()
	 * @generated
	 */
    EAttribute getFCDA_DoName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getFc <em>Fc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getFc()
	 * @see #getFCDA()
	 * @generated
	 */
    EAttribute getFCDA_Fc();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getIx <em>Ix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getIx()
	 * @see #getFCDA()
	 * @generated
	 */
    EAttribute getFCDA_Ix();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getLdInst <em>Ld Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ld Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getLdInst()
	 * @see #getFCDA()
	 * @generated
	 */
    EAttribute getFCDA_LdInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getLnClass <em>Ln Class</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Class</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getLnClass()
	 * @see #getFCDA()
	 * @generated
	 */
    EAttribute getFCDA_LnClass();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getLnInst <em>Ln Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getLnInst()
	 * @see #getFCDA()
	 * @generated
	 */
    EAttribute getFCDA_LnInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getPrefix()
	 * @see #getFCDA()
	 * @generated
	 */
    EAttribute getFCDA_Prefix();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getRefersToDataAttribute <em>Refers To Data Attribute</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Data Attribute</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getRefersToDataAttribute()
	 * @see #getFCDA()
	 * @generated
	 */
    EReference getFCDA_RefersToDataAttribute();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getRefersToDataObject <em>Refers To Data Object</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Data Object</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getRefersToDataObject()
	 * @see #getFCDA()
	 * @generated
	 */
    EReference getFCDA_RefersToDataObject();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getDataSet <em>Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getDataSet()
	 * @see #getFCDA()
	 * @generated
	 */
    EReference getFCDA_DataSet();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getRefersToAnyLN <em>Refers To Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#getRefersToAnyLN()
	 * @see #getFCDA()
	 * @generated
	 */
    EReference getFCDA_RefersToAnyLN();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_fc_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA fc required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA fc required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_fc_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_fc_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_ldInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA ld Inst required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA ld Inst required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_ldInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_ldInst_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_lnClass_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA ln Class required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA ln Class required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_lnClass_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_lnClass_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA ln Class valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA ln Class valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_lnClass_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_lnInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA ln Inst required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA ln Inst required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_lnInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_lnInst_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_lnInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA ln Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA ln Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_lnInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_lnInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_empty_attributes_only_if_GSSE(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA empty attributes only if GSSE</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA empty attributes only if GSSE</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_empty_attributes_only_if_GSSE(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_empty_attributes_only_if_GSSE__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_ldInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA ld Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA ld Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_ldInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_ldInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_prefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA prefix valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA prefix valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_prefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_prefix_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_doName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA do Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA do Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_doName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_doName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_daName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA da Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA da Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_daName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_daName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_ix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate FCDA ix valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate FCDA ix valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCDA#validateFCDA_ix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFCDA__ValidateFCDA_ix_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling <em>File Handling</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>File Handling</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling
	 * @generated
	 */
    EClass getFileHandling();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#getFtp <em>Ftp</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ftp</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#getFtp()
	 * @see #getFileHandling()
	 * @generated
	 */
    EAttribute getFileHandling_Ftp();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#getFtps <em>Ftps</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ftps</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#getFtps()
	 * @see #getFileHandling()
	 * @generated
	 */
    EAttribute getFileHandling_Ftps();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#getMms <em>Mms</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mms</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#getMms()
	 * @see #getFileHandling()
	 * @generated
	 */
    EAttribute getFileHandling_Mms();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#getServices()
	 * @see #getFileHandling()
	 * @generated
	 */
    EReference getFileHandling_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#validateFileHandling_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate File Handling nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate File Handling nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FileHandling#validateFileHandling_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFileHandling__ValidateFileHandling_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSE <em>GOOSE</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GOOSE</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSE
	 * @generated
	 */
    EClass getGOOSE();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSE#getFixedOffs <em>Fixed Offs</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fixed Offs</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSE#getFixedOffs()
	 * @see #getGOOSE()
	 * @generated
	 */
    EAttribute getGOOSE_FixedOffs();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSE#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSE#getServices()
	 * @see #getGOOSE()
	 * @generated
	 */
    EReference getGOOSE_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSE#validateGOOSE_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate GOOSE nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate GOOSE nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSE#validateGOOSE_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getGOOSE__ValidateGOOSE_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSESecurity <em>GOOSE Security</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GOOSE Security</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSESecurity
	 * @generated
	 */
    EClass getGOOSESecurity();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSESecurity#getAccessPoint <em>Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GOOSESecurity#getAccessPoint()
	 * @see #getGOOSESecurity()
	 * @generated
	 */
    EReference getGOOSESecurity_AccessPoint();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl <em>GSE Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GSE Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl
	 * @generated
	 */
    EClass getGSEControl();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#getAppID <em>App ID</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>App ID</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#getAppID()
	 * @see #getGSEControl()
	 * @generated
	 */
    EAttribute getGSEControl_AppID();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#getFixedOffs <em>Fixed Offs</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fixed Offs</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#getFixedOffs()
	 * @see #getGSEControl()
	 * @generated
	 */
    EAttribute getGSEControl_FixedOffs();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#getSecurityEnable <em>Security Enable</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Security Enable</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#getSecurityEnable()
	 * @see #getGSEControl()
	 * @generated
	 */
    EAttribute getGSEControl_SecurityEnable();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#getType()
	 * @see #getGSEControl()
	 * @generated
	 */
    EAttribute getGSEControl_Type();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#getLN0 <em>LN0</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>LN0</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#getLN0()
	 * @see #getGSEControl()
	 * @generated
	 */
    EReference getGSEControl_LN0();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#validateGSEControl_appID_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate GSE Control app ID required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate GSE Control app ID required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#validateGSEControl_appID_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getGSEControl__ValidateGSEControl_appID_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#validateGSEControl_appID_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate GSE Control app ID valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate GSE Control app ID valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#validateGSEControl_appID_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getGSEControl__ValidateGSEControl_appID_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#validateGSEControl_confRev_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate GSE Control conf Rev required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate GSE Control conf Rev required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#validateGSEControl_confRev_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getGSEControl__ValidateGSEControl_confRev_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#validateGSEControl_confRev_unsignedInt(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate GSE Control conf Rev unsigned Int</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate GSE Control conf Rev unsigned Int</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControl#validateGSEControl_confRev_unsignedInt(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getGSEControl__ValidateGSEControl_confRev_unsignedInt__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEDir <em>GSE Dir</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GSE Dir</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEDir
	 * @generated
	 */
    EClass getGSEDir();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEDir#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEDir#getServices()
	 * @see #getGSEDir()
	 * @generated
	 */
    EReference getGSEDir_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings <em>GSE Settings</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GSE Settings</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings
	 * @generated
	 */
    EClass getGSESettings();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings#getAppID <em>App ID</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>App ID</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings#getAppID()
	 * @see #getGSESettings()
	 * @generated
	 */
    EAttribute getGSESettings_AppID();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings#getDataLabel <em>Data Label</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Label</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings#getDataLabel()
	 * @see #getGSESettings()
	 * @generated
	 */
    EAttribute getGSESettings_DataLabel();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings#getServices()
	 * @see #getGSESettings()
	 * @generated
	 */
    EReference getGSESettings_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings#validateGSESettings_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate GSE Settings nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate GSE Settings nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSESettings#validateGSESettings_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getGSESettings__ValidateGSESettings_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSSE <em>GSSE</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GSSE</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSSE
	 * @generated
	 */
    EClass getGSSE();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSSE#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSSE#getServices()
	 * @see #getGSSE()
	 * @generated
	 */
    EReference getGSSE_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetCBValues <em>Get CB Values</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Get CB Values</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetCBValues
	 * @generated
	 */
    EClass getGetCBValues();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetCBValues#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetCBValues#getServices()
	 * @see #getGetCBValues()
	 * @generated
	 */
    EReference getGetCBValues_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataObjectDefinition <em>Get Data Object Definition</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Get Data Object Definition</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataObjectDefinition
	 * @generated
	 */
    EClass getGetDataObjectDefinition();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataObjectDefinition#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataObjectDefinition#getServices()
	 * @see #getGetDataObjectDefinition()
	 * @generated
	 */
    EReference getGetDataObjectDefinition_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataSetValue <em>Get Data Set Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Get Data Set Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataSetValue
	 * @generated
	 */
    EClass getGetDataSetValue();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataSetValue#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDataSetValue#getServices()
	 * @see #getGetDataSetValue()
	 * @generated
	 */
    EReference getGetDataSetValue_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDirectory <em>Get Directory</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Get Directory</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDirectory
	 * @generated
	 */
    EClass getGetDirectory();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDirectory#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GetDirectory#getServices()
	 * @see #getGetDirectory()
	 * @generated
	 */
    EReference getGetDirectory_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED <em>IED</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IED</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED
	 * @generated
	 */
    EClass getIED();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getConfigVersion <em>Config Version</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Config Version</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getConfigVersion()
	 * @see #getIED()
	 * @generated
	 */
    EAttribute getIED_ConfigVersion();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getEngRight <em>Eng Right</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Eng Right</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getEngRight()
	 * @see #getIED()
	 * @generated
	 */
    EAttribute getIED_EngRight();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getManufacturer <em>Manufacturer</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Manufacturer</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getManufacturer()
	 * @see #getIED()
	 * @generated
	 */
    EAttribute getIED_Manufacturer();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getOriginalSclRevision <em>Original Scl Revision</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Original Scl Revision</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getOriginalSclRevision()
	 * @see #getIED()
	 * @generated
	 */
    EAttribute getIED_OriginalSclRevision();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getOriginalSclVersion <em>Original Scl Version</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Original Scl Version</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getOriginalSclVersion()
	 * @see #getIED()
	 * @generated
	 */
    EAttribute getIED_OriginalSclVersion();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getOwner <em>Owner</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Owner</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getOwner()
	 * @see #getIED()
	 * @generated
	 */
    EAttribute getIED_Owner();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getType()
	 * @see #getIED()
	 * @generated
	 */
    EAttribute getIED_Type();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getAccessPoint <em>Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getAccessPoint()
	 * @see #getIED()
	 * @generated
	 */
    EReference getIED_AccessPoint();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getLNode <em>LNode</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>LNode</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getLNode()
	 * @see #getIED()
	 * @generated
	 */
    EReference getIED_LNode();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getKDC <em>KDC</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>KDC</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getKDC()
	 * @see #getIED()
	 * @generated
	 */
    EReference getIED_KDC();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getServices()
	 * @see #getIED()
	 * @generated
	 */
    EReference getIED_Services();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getSCL <em>SCL</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>SCL</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getSCL()
	 * @see #getIED()
	 * @generated
	 */
    EReference getIED_SCL();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getName()
	 * @see #getIED()
	 * @generated
	 */
    EAttribute getIED_Name();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getOriginalSclRelease <em>Original Scl Release</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Original Scl Release</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#getOriginalSclRelease()
	 * @see #getIED()
	 * @generated
	 */
    EAttribute getIED_OriginalSclRelease();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate IED name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate IED name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getIED__ValidateIED_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate IED name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate IED name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getIED__ValidateIED_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_originalSclVersion_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate IED original Scl Version valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate IED original Scl Version valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_originalSclVersion_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getIED__ValidateIED_originalSclVersion_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_originalSclRevision_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate IED original Scl Revision valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate IED original Scl Revision valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_originalSclRevision_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getIED__ValidateIED_originalSclRevision_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_originalSclRelease_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate IED original Scl Release valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate IED original Scl Release valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_originalSclRelease_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getIED__ValidateIED_originalSclRelease_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateengRight_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validateeng Right valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validateeng Right valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateengRight_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getIED__ValidateengRight_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_at_least_one_AccessPoint_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate IED at least one Access Point required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate IED at least one Access Point required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IED#validateIED_at_least_one_AccessPoint_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getIED__ValidateIED_at_least_one_AccessPoint_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName <em>IED Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IED Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName
	 * @generated
	 */
    EClass getIEDName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getApRef <em>Ap Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ap Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getApRef()
	 * @see #getIEDName()
	 * @generated
	 */
    EAttribute getIEDName_ApRef();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getLdInst <em>Ld Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ld Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getLdInst()
	 * @see #getIEDName()
	 * @generated
	 */
    EAttribute getIEDName_LdInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getLnClass <em>Ln Class</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Class</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getLnClass()
	 * @see #getIEDName()
	 * @generated
	 */
    EAttribute getIEDName_LnClass();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getLnInst <em>Ln Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getLnInst()
	 * @see #getIEDName()
	 * @generated
	 */
    EAttribute getIEDName_LnInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getPrefix()
	 * @see #getIEDName()
	 * @generated
	 */
    EAttribute getIEDName_Prefix();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getControlWithIEDName <em>Control With IED Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Control With IED Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getControlWithIEDName()
	 * @see #getIEDName()
	 * @generated
	 */
    EReference getIEDName_ControlWithIEDName();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getRefersToAnyLN <em>Refers To Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getRefersToAnyLN()
	 * @see #getIEDName()
	 * @generated
	 */
    EReference getIEDName_RefersToAnyLN();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#getValue()
	 * @see #getIEDName()
	 * @generated
	 */
    EAttribute getIEDName_Value();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#validateIEDName_value_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate IED Name value valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate IED Name value valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IEDName#validateIEDName_value_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getIEDName__ValidateIEDName_value_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Inputs <em>Inputs</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Inputs</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Inputs
	 * @generated
	 */
    EClass getInputs();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Inputs#getAnyLN <em>Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Inputs#getAnyLN()
	 * @see #getInputs()
	 * @generated
	 */
    EReference getInputs_AnyLN();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Inputs#getExtRef <em>Ext Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Ext Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Inputs#getExtRef()
	 * @see #getInputs()
	 * @generated
	 */
    EReference getInputs_ExtRef();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Inputs#validateInputs_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Inputs nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Inputs nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Inputs#validateInputs_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getInputs__ValidateInputs_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Inputs#validateInputs_at_least_one_ExtRef_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Inputs at least one Ext Ref required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Inputs at least one Ext Ref required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Inputs#validateInputs_at_least_one_ExtRef_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getInputs__ValidateInputs_at_least_one_ExtRef_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IssuerName <em>Issuer Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Issuer Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IssuerName
	 * @generated
	 */
    EClass getIssuerName();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.IssuerName#getCertificate <em>Certificate</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Certificate</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.IssuerName#getCertificate()
	 * @see #getIssuerName()
	 * @generated
	 */
    EReference getIssuerName_Certificate();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC <em>KDC</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>KDC</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC
	 * @generated
	 */
    EClass getKDC();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#getApName <em>Ap Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ap Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#getApName()
	 * @see #getKDC()
	 * @generated
	 */
    EAttribute getKDC_ApName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#getIedName <em>Ied Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ied Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#getIedName()
	 * @see #getKDC()
	 * @generated
	 */
    EAttribute getKDC_IedName();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#getIED <em>IED</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>IED</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#getIED()
	 * @see #getKDC()
	 * @generated
	 */
    EReference getKDC_IED();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#getRefersToAccessPoint <em>Refers To Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#getRefersToAccessPoint()
	 * @see #getKDC()
	 * @generated
	 */
    EReference getKDC_RefersToAccessPoint();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#validateKDC_iedName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate KDC ied Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate KDC ied Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#validateKDC_iedName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getKDC__ValidateKDC_iedName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#validateKDC_iedName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate KDC ied Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate KDC ied Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#validateKDC_iedName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getKDC__ValidateKDC_iedName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#validateKDC_apName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate KDC ap Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate KDC ap Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#validateKDC_apName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getKDC__ValidateKDC_apName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#validateKDC_apName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate KDC ap Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate KDC ap Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.KDC#validateKDC_apName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getKDC__ValidateKDC_apName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice <em>LDevice</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>LDevice</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice
	 * @generated
	 */
    EClass getLDevice();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getInst <em>Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getInst()
	 * @see #getLDevice()
	 * @generated
	 */
    EAttribute getLDevice_Inst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getLdName <em>Ld Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ld Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getLdName()
	 * @see #getLDevice()
	 * @generated
	 */
    EAttribute getLDevice_LdName();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getReferredByControlBlock <em>Referred By Control Block</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Control Block</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getReferredByControlBlock()
	 * @see #getLDevice()
	 * @generated
	 */
    EReference getLDevice_ReferredByControlBlock();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getAccessControl <em>Access Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Access Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getAccessControl()
	 * @see #getLDevice()
	 * @generated
	 */
    EReference getLDevice_AccessControl();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getServer <em>Server</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Server</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getServer()
	 * @see #getLDevice()
	 * @generated
	 */
    EReference getLDevice_Server();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getLNode <em>LNode</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>LNode</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getLNode()
	 * @see #getLDevice()
	 * @generated
	 */
    EReference getLDevice_LNode();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getLN <em>LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getLN()
	 * @see #getLDevice()
	 * @generated
	 */
    EReference getLDevice_LN();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getLN0 <em>LN0</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>LN0</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#getLN0()
	 * @see #getLDevice()
	 * @generated
	 */
    EReference getLDevice_LN0();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#validateLDevice_inst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LDevice inst required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LDevice inst required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#validateLDevice_inst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLDevice__ValidateLDevice_inst_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#validateLDevice_inst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LDevice inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LDevice inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#validateLDevice_inst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLDevice__ValidateLDevice_inst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#validateLDevice_ldName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LDevice ld Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LDevice ld Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#validateLDevice_ldName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLDevice__ValidateLDevice_ldName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#validateLDevice_one_LN0_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LDevice one LN0 required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LDevice one LN0 required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LDevice#validateLDevice_one_LN0_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLDevice__ValidateLDevice_one_LN0_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN <em>LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN
	 * @generated
	 */
    EClass getLN();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#getPrefix()
	 * @see #getLN()
	 * @generated
	 */
    EAttribute getLN_Prefix();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#getAccessPoint <em>Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#getAccessPoint()
	 * @see #getLN()
	 * @generated
	 */
    EReference getLN_AccessPoint();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#getLDevice <em>LDevice</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>LDevice</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#getLDevice()
	 * @see #getLN()
	 * @generated
	 */
    EReference getLN_LDevice();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#getLNode <em>LNode</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>LNode</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#getLNode()
	 * @see #getLN()
	 * @generated
	 */
    EReference getLN_LNode();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#validateLN_inst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LN inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LN inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#validateLN_inst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLN__ValidateLN_inst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#validateLN_prefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LN prefix valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LN prefix valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN#validateLN_prefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLN__ValidateLN_prefix_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0 <em>LN0</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>LN0</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0
	 * @generated
	 */
    EClass getLN0();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#getGSEControl <em>GSE Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>GSE Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#getGSEControl()
	 * @see #getLN0()
	 * @generated
	 */
    EReference getLN0_GSEControl();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#getLDevice <em>LDevice</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>LDevice</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#getLDevice()
	 * @see #getLN0()
	 * @generated
	 */
    EReference getLN0_LDevice();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#getSampledValueControl <em>Sampled Value Control</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sampled Value Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#getSampledValueControl()
	 * @see #getLN0()
	 * @generated
	 */
    EReference getLN0_SampledValueControl();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#getSettingControl <em>Setting Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Setting Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#getSettingControl()
	 * @see #getLN0()
	 * @generated
	 */
    EReference getLN0_SettingControl();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#validateLN0_lnClass_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LN0 ln Class value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LN0 ln Class value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#validateLN0_lnClass_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLN0__ValidateLN0_lnClass_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#validateLN0_inst_empty(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LN0 inst empty</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LN0 inst empty</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LN0#validateLN0_inst_empty(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLN0__ValidateLN0_inst_empty__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Log <em>Log</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Log</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Log
	 * @generated
	 */
    EClass getLog();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Log#getAnyLN <em>Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Log#getAnyLN()
	 * @see #getLog()
	 * @generated
	 */
    EReference getLog_AnyLN();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Log#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Log#getName()
	 * @see #getLog()
	 * @generated
	 */
    EAttribute getLog_Name();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Log#validateLog_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Log name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Log name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Log#validateLog_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLog__ValidateLog_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl <em>Log Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Log Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl
	 * @generated
	 */
    EClass getLogControl();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getBufTime <em>Buf Time</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Buf Time</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getBufTime()
	 * @see #getLogControl()
	 * @generated
	 */
    EAttribute getLogControl_BufTime();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getLdInst <em>Ld Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ld Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getLdInst()
	 * @see #getLogControl()
	 * @generated
	 */
    EAttribute getLogControl_LdInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getLnClass <em>Ln Class</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Class</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getLnClass()
	 * @see #getLogControl()
	 * @generated
	 */
    EAttribute getLogControl_LnClass();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getLnInst <em>Ln Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getLnInst()
	 * @see #getLogControl()
	 * @generated
	 */
    EAttribute getLogControl_LnInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getLogEna <em>Log Ena</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Log Ena</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getLogEna()
	 * @see #getLogControl()
	 * @generated
	 */
    EAttribute getLogControl_LogEna();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getLogName <em>Log Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Log Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getLogName()
	 * @see #getLogControl()
	 * @generated
	 */
    EAttribute getLogControl_LogName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getPrefix()
	 * @see #getLogControl()
	 * @generated
	 */
    EAttribute getLogControl_Prefix();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getReasonCode <em>Reason Code</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Reason Code</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getReasonCode()
	 * @see #getLogControl()
	 * @generated
	 */
    EAttribute getLogControl_ReasonCode();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getAnyLN <em>Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getAnyLN()
	 * @see #getLogControl()
	 * @generated
	 */
    EReference getLogControl_AnyLN();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getRefersToAnyLN <em>Refers To Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#getRefersToAnyLN()
	 * @see #getLogControl()
	 * @generated
	 */
    EReference getLogControl_RefersToAnyLN();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_logName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Log Control log Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Log Control log Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_logName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLogControl__ValidateLogControl_logName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_logName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Log Control log Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Log Control log Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_logName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLogControl__ValidateLogControl_logName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_ldInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Log Control ld Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Log Control ld Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_ldInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLogControl__ValidateLogControl_ldInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_prefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Log Control prefix valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Log Control prefix valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_prefix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLogControl__ValidateLogControl_prefix_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Log Control ln Class valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Log Control ln Class valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_lnClass_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLogControl__ValidateLogControl_lnClass_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_lnInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Log Control ln Inst valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Log Control ln Inst valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_lnInst_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLogControl__ValidateLogControl_lnInst_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_bufTime_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Log Control buf Time valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Log Control buf Time valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogControl#validateLogControl_bufTime_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLogControl__ValidateLogControl_bufTime_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings <em>Log Settings</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Log Settings</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings
	 * @generated
	 */
    EClass getLogSettings();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#getIntgPd <em>Intg Pd</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Intg Pd</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#getIntgPd()
	 * @see #getLogSettings()
	 * @generated
	 */
    EAttribute getLogSettings_IntgPd();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#getLogEna <em>Log Ena</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Log Ena</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#getLogEna()
	 * @see #getLogSettings()
	 * @generated
	 */
    EAttribute getLogSettings_LogEna();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#getTrgOps <em>Trg Ops</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Trg Ops</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#getTrgOps()
	 * @see #getLogSettings()
	 * @generated
	 */
    EAttribute getLogSettings_TrgOps();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#getServices()
	 * @see #getLogSettings()
	 * @generated
	 */
    EReference getLogSettings_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#validateLogSettings_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Log Settings nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Log Settings nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LogSettings#validateLogSettings_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLogSettings__ValidateLogSettings_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields <em>Opt Fields</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Opt Fields</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields
	 * @generated
	 */
    EClass getOptFields();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getBufOvfl <em>Buf Ovfl</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Buf Ovfl</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getBufOvfl()
	 * @see #getOptFields()
	 * @generated
	 */
    EAttribute getOptFields_BufOvfl();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getConfigRef <em>Config Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Config Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getConfigRef()
	 * @see #getOptFields()
	 * @generated
	 */
    EAttribute getOptFields_ConfigRef();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getDataRef <em>Data Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getDataRef()
	 * @see #getOptFields()
	 * @generated
	 */
    EAttribute getOptFields_DataRef();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getDataSet <em>Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getDataSet()
	 * @see #getOptFields()
	 * @generated
	 */
    EAttribute getOptFields_DataSet();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getEntryID <em>Entry ID</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Entry ID</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getEntryID()
	 * @see #getOptFields()
	 * @generated
	 */
    EAttribute getOptFields_EntryID();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getReasonCode <em>Reason Code</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Reason Code</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getReasonCode()
	 * @see #getOptFields()
	 * @generated
	 */
    EAttribute getOptFields_ReasonCode();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getSeqNum <em>Seq Num</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Seq Num</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getSeqNum()
	 * @see #getOptFields()
	 * @generated
	 */
    EAttribute getOptFields_SeqNum();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getTimeStamp <em>Time Stamp</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Time Stamp</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getTimeStamp()
	 * @see #getOptFields()
	 * @generated
	 */
    EAttribute getOptFields_TimeStamp();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getReportControl <em>Report Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Report Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.OptFields#getReportControl()
	 * @see #getOptFields()
	 * @generated
	 */
    EReference getOptFields_ReportControl();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Protocol <em>Protocol</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Protocol</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Protocol
	 * @generated
	 */
    EClass getProtocol();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Protocol#getMustUnderstand <em>Must Understand</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Must Understand</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Protocol#getMustUnderstand()
	 * @see #getProtocol()
	 * @generated
	 */
    EAttribute getProtocol_MustUnderstand();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Protocol#getControlWithIEDName <em>Control With IED Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Control With IED Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Protocol#getControlWithIEDName()
	 * @see #getProtocol()
	 * @generated
	 */
    EReference getProtocol_ControlWithIEDName();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Protocol#validateVoltage_mustUnderstand_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Voltage must Understand required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Voltage must Understand required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Protocol#validateVoltage_mustUnderstand_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getProtocol__ValidateVoltage_mustUnderstand_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Protocol#validateVoltage_mustUnderstand_value_fixed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Voltage must Understand value fixed</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Voltage must Understand value fixed</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Protocol#validateVoltage_mustUnderstand_value_fixed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getProtocol__ValidateVoltage_mustUnderstand_value_fixed__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReadWrite <em>Read Write</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Read Write</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReadWrite
	 * @generated
	 */
    EClass getReadWrite();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReadWrite#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReadWrite#getServices()
	 * @see #getReadWrite()
	 * @generated
	 */
    EReference getReadWrite_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt <em>Red Prot</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Red Prot</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt
	 * @generated
	 */
    EClass getRedProt();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#getHsr <em>Hsr</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Hsr</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#getHsr()
	 * @see #getRedProt()
	 * @generated
	 */
    EAttribute getRedProt_Hsr();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#getPrp <em>Prp</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prp</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#getPrp()
	 * @see #getRedProt()
	 * @generated
	 */
    EAttribute getRedProt_Prp();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#getRstp <em>Rstp</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rstp</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#getRstp()
	 * @see #getRedProt()
	 * @generated
	 */
    EAttribute getRedProt_Rstp();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#getServices()
	 * @see #getRedProt()
	 * @generated
	 */
    EReference getRedProt_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#validateRedProt_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Red Prot nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Red Prot nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RedProt#validateRedProt_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getRedProt__ValidateRedProt_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl <em>Report Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Report Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl
	 * @generated
	 */
    EClass getReportControl();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getBuffered <em>Buffered</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Buffered</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getBuffered()
	 * @see #getReportControl()
	 * @generated
	 */
    EAttribute getReportControl_Buffered();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getBufTime <em>Buf Time</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Buf Time</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getBufTime()
	 * @see #getReportControl()
	 * @generated
	 */
    EAttribute getReportControl_BufTime();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getConfRev <em>Conf Rev</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Conf Rev</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getConfRev()
	 * @see #getReportControl()
	 * @generated
	 */
    EAttribute getReportControl_ConfRev();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getIndexed <em>Indexed</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Indexed</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getIndexed()
	 * @see #getReportControl()
	 * @generated
	 */
    EAttribute getReportControl_Indexed();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getRptID <em>Rpt ID</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rpt ID</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getRptID()
	 * @see #getReportControl()
	 * @generated
	 */
    EAttribute getReportControl_RptID();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getAnyLN <em>Any LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Any LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getAnyLN()
	 * @see #getReportControl()
	 * @generated
	 */
    EReference getReportControl_AnyLN();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getOptFields <em>Opt Fields</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Opt Fields</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getOptFields()
	 * @see #getReportControl()
	 * @generated
	 */
    EReference getReportControl_OptFields();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getRptEnabled <em>Rpt Enabled</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Rpt Enabled</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#getRptEnabled()
	 * @see #getReportControl()
	 * @generated
	 */
    EReference getReportControl_RptEnabled();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#validateReportControl_confRev_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Report Control conf Rev required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Report Control conf Rev required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#validateReportControl_confRev_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getReportControl__ValidateReportControl_confRev_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#validateReportControl_confRev_unsigned_int(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Report Control conf Rev unsigned int</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Report Control conf Rev unsigned int</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#validateReportControl_confRev_unsigned_int(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getReportControl__ValidateReportControl_confRev_unsigned_int__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#validateReportControl_rptID_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Report Control rpt ID valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Report Control rpt ID valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#validateReportControl_rptID_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getReportControl__ValidateReportControl_rptID_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#validateReportControl_bufTime_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Report Control buf Time valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Report Control buf Time valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#validateReportControl_bufTime_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getReportControl__ValidateReportControl_bufTime_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#validateReportControl_one_OptFields_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Report Control one Opt Fields required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Report Control one Opt Fields required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportControl#validateReportControl_one_OptFields_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getReportControl__ValidateReportControl_one_OptFields_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings <em>Report Settings</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Report Settings</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings
	 * @generated
	 */
    EClass getReportSettings();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getBufTime <em>Buf Time</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Buf Time</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getBufTime()
	 * @see #getReportSettings()
	 * @generated
	 */
    EAttribute getReportSettings_BufTime();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getIntgPd <em>Intg Pd</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Intg Pd</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getIntgPd()
	 * @see #getReportSettings()
	 * @generated
	 */
    EAttribute getReportSettings_IntgPd();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getOptFields <em>Opt Fields</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Opt Fields</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getOptFields()
	 * @see #getReportSettings()
	 * @generated
	 */
    EAttribute getReportSettings_OptFields();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getOwner <em>Owner</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Owner</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getOwner()
	 * @see #getReportSettings()
	 * @generated
	 */
    EAttribute getReportSettings_Owner();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getResvTms <em>Resv Tms</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Resv Tms</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getResvTms()
	 * @see #getReportSettings()
	 * @generated
	 */
    EAttribute getReportSettings_ResvTms();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getRptID <em>Rpt ID</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rpt ID</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getRptID()
	 * @see #getReportSettings()
	 * @generated
	 */
    EAttribute getReportSettings_RptID();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getTrgOps <em>Trg Ops</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Trg Ops</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getTrgOps()
	 * @see #getReportSettings()
	 * @generated
	 */
    EAttribute getReportSettings_TrgOps();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#getServices()
	 * @see #getReportSettings()
	 * @generated
	 */
    EReference getReportSettings_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#validateReportSettings_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Report Settings nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Report Settings nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ReportSettings#validateReportSettings_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getReportSettings__ValidateReportSettings_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RptEnabled <em>Rpt Enabled</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rpt Enabled</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RptEnabled
	 * @generated
	 */
    EClass getRptEnabled();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RptEnabled#getMax <em>Max</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RptEnabled#getMax()
	 * @see #getRptEnabled()
	 * @generated
	 */
    EAttribute getRptEnabled_Max();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RptEnabled#getClientLN <em>Client LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Client LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RptEnabled#getClientLN()
	 * @see #getRptEnabled()
	 * @generated
	 */
    EReference getRptEnabled_ClientLN();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RptEnabled#getReportControl <em>Report Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Report Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RptEnabled#getReportControl()
	 * @see #getRptEnabled()
	 * @generated
	 */
    EReference getRptEnabled_ReportControl();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.RptEnabled#validateRptEnabled_max_unsigned_int(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Rpt Enabled max unsigned int</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Rpt Enabled max unsigned int</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.RptEnabled#validateRptEnabled_max_unsigned_int(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getRptEnabled__ValidateRptEnabled_max_unsigned_int__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI <em>SDI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SDI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI
	 * @generated
	 */
    EClass getSDI();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getIx <em>Ix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getIx()
	 * @see #getSDI()
	 * @generated
	 */
    EAttribute getSDI_Ix();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getSAddr <em>SAddr</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SAddr</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getSAddr()
	 * @see #getSDI()
	 * @generated
	 */
    EAttribute getSDI_SAddr();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getDAI <em>DAI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>DAI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getDAI()
	 * @see #getSDI()
	 * @generated
	 */
    EReference getSDI_DAI();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getDOI <em>DOI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>DOI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getDOI()
	 * @see #getSDI()
	 * @generated
	 */
    EReference getSDI_DOI();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getSubSDI <em>Sub SDI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub SDI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getSubSDI()
	 * @see #getSDI()
	 * @generated
	 */
    EReference getSDI_SubSDI();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getParentSDI <em>Parent SDI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent SDI</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#getParentSDI()
	 * @see #getSDI()
	 * @generated
	 */
    EReference getSDI_ParentSDI();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#validateSDI_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SDI name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SDI name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#validateSDI_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSDI__ValidateSDI_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#validateSDI_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SDI name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SDI name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#validateSDI_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSDI__ValidateSDI_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#validateSDI_ix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SDI ix valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SDI ix valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SDI#validateSDI_ix_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSDI__ValidateSDI_ix_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SGEdit <em>SG Edit</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SG Edit</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SGEdit
	 * @generated
	 */
    EClass getSGEdit();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SGEdit#getResvTms <em>Resv Tms</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Resv Tms</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SGEdit#getResvTms()
	 * @see #getSGEdit()
	 * @generated
	 */
    EAttribute getSGEdit_ResvTms();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SGEdit#getSettingGroups <em>Setting Groups</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Setting Groups</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SGEdit#getSettingGroups()
	 * @see #getSGEdit()
	 * @generated
	 */
    EReference getSGEdit_SettingGroups();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSecurity <em>SMV Security</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SMV Security</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSecurity
	 * @generated
	 */
    EClass getSMVSecurity();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSecurity#getAccessPoint <em>Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSecurity#getAccessPoint()
	 * @see #getSMVSecurity()
	 * @generated
	 */
    EReference getSMVSecurity_AccessPoint();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings <em>SMV Settings</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SMV Settings</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings
	 * @generated
	 */
    EClass getSMVSettings();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getSvID <em>Sv ID</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sv ID</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getSvID()
	 * @see #getSMVSettings()
	 * @generated
	 */
    EAttribute getSMVSettings_SvID();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getOptFields <em>Opt Fields</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Opt Fields</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getOptFields()
	 * @see #getSMVSettings()
	 * @generated
	 */
    EAttribute getSMVSettings_OptFields();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getSmpRateAttribute <em>Smp Rate Attribute</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Smp Rate Attribute</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getSmpRateAttribute()
	 * @see #getSMVSettings()
	 * @generated
	 */
    EAttribute getSMVSettings_SmpRateAttribute();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#isSamplesPerSecAttribute <em>Samples Per Sec Attribute</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Samples Per Sec Attribute</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#isSamplesPerSecAttribute()
	 * @see #getSMVSettings()
	 * @generated
	 */
    EAttribute getSMVSettings_SamplesPerSecAttribute();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#isPdcTimeStamp <em>Pdc Time Stamp</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Pdc Time Stamp</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#isPdcTimeStamp()
	 * @see #getSMVSettings()
	 * @generated
	 */
    EAttribute getSMVSettings_PdcTimeStamp();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getSmpRate <em>Smp Rate</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Smp Rate</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getSmpRate()
	 * @see #getSMVSettings()
	 * @generated
	 */
    EReference getSMVSettings_SmpRate();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getSamplesPerSec <em>Samples Per Sec</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Samples Per Sec</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getSamplesPerSec()
	 * @see #getSMVSettings()
	 * @generated
	 */
    EReference getSMVSettings_SamplesPerSec();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getSecPerSamples <em>Sec Per Samples</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sec Per Samples</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#getSecPerSamples()
	 * @see #getSMVSettings()
	 * @generated
	 */
    EReference getSMVSettings_SecPerSamples();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#validateSMVSettings_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SMV Settings nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SMV Settings nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVSettings#validateSMVSettings_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSMVSettings__ValidateSMVSettings_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc <em>SM Vsc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SM Vsc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc
	 * @generated
	 */
    EClass getSMVsc();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc#getDelivery <em>Delivery</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Delivery</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc#getDelivery()
	 * @see #getSMVsc()
	 * @generated
	 */
    EAttribute getSMVsc_Delivery();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc#getDeliveryConf <em>Delivery Conf</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Delivery Conf</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc#getDeliveryConf()
	 * @see #getSMVsc()
	 * @generated
	 */
    EAttribute getSMVsc_DeliveryConf();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc#getServices()
	 * @see #getSMVsc()
	 * @generated
	 */
    EReference getSMVsc_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc#validateSMVsc_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate SM Vsc nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate SM Vsc nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVsc#validateSMVsc_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSMVsc__ValidateSMVsc_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl <em>Sampled Value Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sampled Value Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl
	 * @generated
	 */
    EClass getSampledValueControl();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getMulticast <em>Multicast</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Multicast</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getMulticast()
	 * @see #getSampledValueControl()
	 * @generated
	 */
    EAttribute getSampledValueControl_Multicast();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getNofASDU <em>Nof ASDU</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Nof ASDU</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getNofASDU()
	 * @see #getSampledValueControl()
	 * @generated
	 */
    EAttribute getSampledValueControl_NofASDU();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getSecurityEnable <em>Security Enable</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Security Enable</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getSecurityEnable()
	 * @see #getSampledValueControl()
	 * @generated
	 */
    EAttribute getSampledValueControl_SecurityEnable();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getSmpMod <em>Smp Mod</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Smp Mod</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getSmpMod()
	 * @see #getSampledValueControl()
	 * @generated
	 */
    EAttribute getSampledValueControl_SmpMod();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getSmpRate <em>Smp Rate</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Smp Rate</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getSmpRate()
	 * @see #getSampledValueControl()
	 * @generated
	 */
    EAttribute getSampledValueControl_SmpRate();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getSmvID <em>Smv ID</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Smv ID</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getSmvID()
	 * @see #getSampledValueControl()
	 * @generated
	 */
    EAttribute getSampledValueControl_SmvID();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getLN0 <em>LN0</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>LN0</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getLN0()
	 * @see #getSampledValueControl()
	 * @generated
	 */
    EReference getSampledValueControl_LN0();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getSmvOpts <em>Smv Opts</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Smv Opts</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#getSmvOpts()
	 * @see #getSampledValueControl()
	 * @generated
	 */
    EReference getSampledValueControl_SmvOpts();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_smvID_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sampled Value Control smv ID required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sampled Value Control smv ID required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_smvID_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSampledValueControl__ValidateSampledValueControl_smvID_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_smvID_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sampled Value Control smv ID valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sampled Value Control smv ID valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_smvID_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSampledValueControl__ValidateSampledValueControl_smvID_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_smpRate_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sampled Value Control smp Rate required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sampled Value Control smp Rate required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_smpRate_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSampledValueControl__ValidateSampledValueControl_smpRate_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_smpRate_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sampled Value Control smp Rate valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sampled Value Control smp Rate valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_smpRate_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSampledValueControl__ValidateSampledValueControl_smpRate_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_nofASDU_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sampled Value Control nof ASDU required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sampled Value Control nof ASDU required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_nofASDU_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSampledValueControl__ValidateSampledValueControl_nofASDU_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_nofASDU_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sampled Value Control nof ASDU valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sampled Value Control nof ASDU valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_nofASDU_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSampledValueControl__ValidateSampledValueControl_nofASDU_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_confRev_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sampled Value Control conf Rev required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sampled Value Control conf Rev required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_confRev_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSampledValueControl__ValidateSampledValueControl_confRev_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_confRev_unsignedInt(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sampled Value Control conf Rev unsigned Int</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sampled Value Control conf Rev unsigned Int</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_confRev_unsignedInt(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSampledValueControl__ValidateSampledValueControl_confRev_unsignedInt__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_one_SmvOpts_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sampled Value Control one Smv Opts required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sampled Value Control one Smv Opts required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_one_SmvOpts_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSampledValueControl__ValidateSampledValueControl_one_SmvOpts_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_multicast(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sampled Value Control multicast</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sampled Value Control multicast</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SampledValueControl#validateSampledValueControl_multicast(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSampledValueControl__ValidateSampledValueControl_multicast__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Server <em>Server</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Server</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Server
	 * @generated
	 */
    EClass getServer();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#getTimeout <em>Timeout</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Timeout</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#getTimeout()
	 * @see #getServer()
	 * @generated
	 */
    EAttribute getServer_Timeout();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#getAccessPoint <em>Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#getAccessPoint()
	 * @see #getServer()
	 * @generated
	 */
    EReference getServer_AccessPoint();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#getAssociation <em>Association</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Association</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#getAssociation()
	 * @see #getServer()
	 * @generated
	 */
    EReference getServer_Association();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#getAuthentication <em>Authentication</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Authentication</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#getAuthentication()
	 * @see #getServer()
	 * @generated
	 */
    EReference getServer_Authentication();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#getLDevice <em>LDevice</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>LDevice</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#getLDevice()
	 * @see #getServer()
	 * @generated
	 */
    EReference getServer_LDevice();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#validateServer_timeout_unsigned_int(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Server timeout unsigned int</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Server timeout unsigned int</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#validateServer_timeout_unsigned_int(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServer__ValidateServer_timeout_unsigned_int__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#validateServer_one_Authentication_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Server one Authentication required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Server one Authentication required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#validateServer_one_Authentication_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServer__ValidateServer_one_Authentication_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#validateServer_at_least_one_LDevice_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Server at least one LDevice required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Server at least one LDevice required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Server#validateServer_at_least_one_LDevice_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServer__ValidateServer_at_least_one_LDevice_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt <em>Server At</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Server At</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt
	 * @generated
	 */
    EClass getServerAt();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt#getApName <em>Ap Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ap Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt#getApName()
	 * @see #getServerAt()
	 * @generated
	 */
    EAttribute getServerAt_ApName();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt#getAccessPoint <em>Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt#getAccessPoint()
	 * @see #getServerAt()
	 * @generated
	 */
    EReference getServerAt_AccessPoint();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt#getRefersToAccessPoint <em>Refers To Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt#getRefersToAccessPoint()
	 * @see #getServerAt()
	 * @generated
	 */
    EReference getServerAt_RefersToAccessPoint();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt#validateServerAt_apName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Server At ap Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Server At ap Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt#validateServerAt_apName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServerAt__ValidateServerAt_apName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt#validateServerAt_apName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Server At ap Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Server At ap Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServerAt#validateServerAt_apName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServerAt__ValidateServerAt_apName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettings <em>Service Settings</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service Settings</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettings
	 * @generated
	 */
    EClass getServiceSettings();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettings#getCbName <em>Cb Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cb Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettings#getCbName()
	 * @see #getServiceSettings()
	 * @generated
	 */
    EAttribute getServiceSettings_CbName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettings#getDatSet <em>Dat Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dat Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettings#getDatSet()
	 * @see #getServiceSettings()
	 * @generated
	 */
    EAttribute getServiceSettings_DatSet();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettings#validateServiceSettings_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service Settings nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service Settings nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettings#validateServiceSettings_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceSettings__ValidateServiceSettings_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMax <em>Service With Max</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service With Max</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMax
	 * @generated
	 */
    EClass getServiceWithMax();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMax#getMax <em>Max</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMax#getMax()
	 * @see #getServiceWithMax()
	 * @generated
	 */
    EAttribute getServiceWithMax_Max();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMax#validateServiceWithMax_max_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service With Max max required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service With Max max required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMax#validateServiceWithMax_max_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceWithMax__ValidateServiceWithMax_max_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMax#validateServiceWithMax_max_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service With Max max valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service With Max max valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMax#validateServiceWithMax_max_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceWithMax__ValidateServiceWithMax_max_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services
	 * @generated
	 */
    EClass getServices();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getNameLength <em>Name Length</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name Length</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getNameLength()
	 * @see #getServices()
	 * @generated
	 */
    EAttribute getServices_NameLength();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getAccessPoint <em>Access Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Access Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getAccessPoint()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_AccessPoint();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getClientServices <em>Client Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Client Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getClientServices()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_ClientServices();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getCommProt <em>Comm Prot</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Comm Prot</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getCommProt()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_CommProt();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfDataSet <em>Conf Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Conf Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfDataSet()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_ConfDataSet();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLNs <em>Conf LNs</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Conf LNs</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLNs()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_ConfLNs();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLdName <em>Conf Ld Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Conf Ld Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLdName()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_ConfLdName();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLogControl <em>Conf Log Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Conf Log Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfLogControl()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_ConfLogControl();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfReportControl <em>Conf Report Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Conf Report Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfReportControl()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_ConfReportControl();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfSigRef <em>Conf Sig Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Conf Sig Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getConfSigRef()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_ConfSigRef();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataObjectDirectory <em>Data Object Directory</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Data Object Directory</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataObjectDirectory()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_DataObjectDirectory();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataSetDirectory <em>Data Set Directory</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Data Set Directory</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDataSetDirectory()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_DataSetDirectory();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynAssociation <em>Dyn Association</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Dyn Association</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynAssociation()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_DynAssociation();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynDataSet <em>Dyn Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Dyn Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getDynDataSet()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_DynDataSet();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getFileHandling <em>File Handling</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>File Handling</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getFileHandling()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_FileHandling();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGOOSE <em>GOOSE</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>GOOSE</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGOOSE()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_GOOSE();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSEDir <em>GSE Dir</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>GSE Dir</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSEDir()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_GSEDir();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSESettings <em>GSE Settings</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>GSE Settings</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSESettings()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_GSESettings();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSSE <em>GSSE</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>GSSE</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGSSE()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_GSSE();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetCBValues <em>Get CB Values</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Get CB Values</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetCBValues()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_GetCBValues();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataObjectDefinition <em>Get Data Object Definition</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Get Data Object Definition</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataObjectDefinition()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_GetDataObjectDefinition();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataSetValue <em>Get Data Set Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Get Data Set Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDataSetValue()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_GetDataSetValue();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDirectory <em>Get Directory</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Get Directory</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getGetDirectory()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_GetDirectory();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getIED <em>IED</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>IED</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getIED()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_IED();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getLogSettings <em>Log Settings</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Log Settings</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getLogSettings()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_LogSettings();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReadWrite <em>Read Write</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Read Write</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReadWrite()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_ReadWrite();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getRedProt <em>Red Prot</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Red Prot</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getRedProt()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_RedProt();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReportSettings <em>Report Settings</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Report Settings</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getReportSettings()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_ReportSettings();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSMVsc <em>SM Vsc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>SM Vsc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSMVsc()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_SMVsc();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSupSubscription <em>Sup Subscription</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Sup Subscription</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSupSubscription()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_SupSubscription();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getValueHandling <em>Value Handling</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Value Handling</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getValueHandling()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_ValueHandling();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSetDataSetValue <em>Set Data Set Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Set Data Set Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSetDataSetValue()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_SetDataSetValue();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSettingGroups <em>Setting Groups</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Setting Groups</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getSettingGroups()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_SettingGroups();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimeSyncProt <em>Time Sync Prot</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Time Sync Prot</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimeSyncProt()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_TimeSyncProt();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimerActivatedControl <em>Timer Activated Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Timer Activated Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#getTimerActivatedControl()
	 * @see #getServices()
	 * @generated
	 */
    EReference getServices_TimerActivatedControl();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#validateServices_nameLength_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Services name Length valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Services name Length valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Services#validateServices_nameLength_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServices__ValidateServices_nameLength_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SetDataSetValue <em>Set Data Set Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Set Data Set Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SetDataSetValue
	 * @generated
	 */
    EClass getSetDataSetValue();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SetDataSetValue#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SetDataSetValue#getServices()
	 * @see #getSetDataSetValue()
	 * @generated
	 */
    EReference getSetDataSetValue_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl <em>Setting Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Setting Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl
	 * @generated
	 */
    EClass getSettingControl();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#getActSG <em>Act SG</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Act SG</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#getActSG()
	 * @see #getSettingControl()
	 * @generated
	 */
    EAttribute getSettingControl_ActSG();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#getNumOfSGs <em>Num Of SGs</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Num Of SGs</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#getNumOfSGs()
	 * @see #getSettingControl()
	 * @generated
	 */
    EAttribute getSettingControl_NumOfSGs();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#getResvTms <em>Resv Tms</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Resv Tms</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#getResvTms()
	 * @see #getSettingControl()
	 * @generated
	 */
    EAttribute getSettingControl_ResvTms();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#getLN0 <em>LN0</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>LN0</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#getLN0()
	 * @see #getSettingControl()
	 * @generated
	 */
    EReference getSettingControl_LN0();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#validateSettingControl_numOfSGs_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Setting Control num Of SGs required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Setting Control num Of SGs required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#validateSettingControl_numOfSGs_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSettingControl__ValidateSettingControl_numOfSGs_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#validateSettingControl_numOfSGs_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Setting Control num Of SGs valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Setting Control num Of SGs valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#validateSettingControl_numOfSGs_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSettingControl__ValidateSettingControl_numOfSGs_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#validateSettingControl_actSG_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Setting Control act SG valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Setting Control act SG valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#validateSettingControl_actSG_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSettingControl__ValidateSettingControl_actSG_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#validateSettingControl_resvTms_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Setting Control resv Tms valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Setting Control resv Tms valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingControl#validateSettingControl_resvTms_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSettingControl__ValidateSettingControl_resvTms_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups <em>Setting Groups</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Setting Groups</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups
	 * @generated
	 */
    EClass getSettingGroups();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups#getConfSG <em>Conf SG</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Conf SG</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups#getConfSG()
	 * @see #getSettingGroups()
	 * @generated
	 */
    EReference getSettingGroups_ConfSG();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups#getSGEdit <em>SG Edit</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>SG Edit</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups#getSGEdit()
	 * @see #getSettingGroups()
	 * @generated
	 */
    EReference getSettingGroups_SGEdit();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups#getServices()
	 * @see #getSettingGroups()
	 * @generated
	 */
    EReference getSettingGroups_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups#validateSettingGroups_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Setting Groups nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Setting Groups nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SettingGroups#validateSettingGroups_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSettingGroups__ValidateSettingGroups_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts <em>Smv Opts</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Smv Opts</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts
	 * @generated
	 */
    EClass getSmvOpts();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getDataSet <em>Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getDataSet()
	 * @see #getSmvOpts()
	 * @generated
	 */
    EAttribute getSmvOpts_DataSet();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getRefreshTime <em>Refresh Time</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Refresh Time</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getRefreshTime()
	 * @see #getSmvOpts()
	 * @generated
	 */
    EAttribute getSmvOpts_RefreshTime();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getSampleRate <em>Sample Rate</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sample Rate</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getSampleRate()
	 * @see #getSmvOpts()
	 * @generated
	 */
    EAttribute getSmvOpts_SampleRate();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getSampleSynchronized <em>Sample Synchronized</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sample Synchronized</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getSampleSynchronized()
	 * @see #getSmvOpts()
	 * @generated
	 */
    EAttribute getSmvOpts_SampleSynchronized();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getSecurity <em>Security</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Security</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getSecurity()
	 * @see #getSmvOpts()
	 * @generated
	 */
    EAttribute getSmvOpts_Security();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getTimestamp <em>Timestamp</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Timestamp</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getTimestamp()
	 * @see #getSmvOpts()
	 * @generated
	 */
    EAttribute getSmvOpts_Timestamp();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getSampledValueControl <em>Sampled Value Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Sampled Value Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmvOpts#getSampledValueControl()
	 * @see #getSmvOpts()
	 * @generated
	 */
    EReference getSmvOpts_SampledValueControl();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Subject <em>Subject</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Subject</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Subject
	 * @generated
	 */
    EClass getSubject();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Subject#getCertificate <em>Certificate</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Certificate</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Subject#getCertificate()
	 * @see #getSubject()
	 * @generated
	 */
    EReference getSubject_Certificate();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription <em>Sup Subscription</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sup Subscription</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription
	 * @generated
	 */
    EClass getSupSubscription();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#getMaxGo <em>Max Go</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Go</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#getMaxGo()
	 * @see #getSupSubscription()
	 * @generated
	 */
    EAttribute getSupSubscription_MaxGo();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#getMaxSv <em>Max Sv</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Sv</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#getMaxSv()
	 * @see #getSupSubscription()
	 * @generated
	 */
    EAttribute getSupSubscription_MaxSv();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#getServices()
	 * @see #getSupSubscription()
	 * @generated
	 */
    EReference getSupSubscription_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#validateSupSubscription_maxGo_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sup Subscription max Go required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sup Subscription max Go required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#validateSupSubscription_maxGo_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSupSubscription__ValidateSupSubscription_maxGo_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#validateSupSubscription_maxGo_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sup Subscription max Go valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sup Subscription max Go valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#validateSupSubscription_maxGo_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSupSubscription__ValidateSupSubscription_maxGo_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#validateSupSubscription_maxSv_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sup Subscription max Sv required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sup Subscription max Sv required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#validateSupSubscription_maxSv_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSupSubscription__ValidateSupSubscription_maxSv_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#validateSupSubscription_maxSv_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sup Subscription max Sv valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sup Subscription max Sv valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SupSubscription#validateSupSubscription_maxSv_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSupSubscription__ValidateSupSubscription_maxSv_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt <em>Time Sync Prot</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Time Sync Prot</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt
	 * @generated
	 */
    EClass getTimeSyncProt();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getC37_238 <em>C37 238</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>C37 238</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getC37_238()
	 * @see #getTimeSyncProt()
	 * @generated
	 */
    EAttribute getTimeSyncProt_C37_238();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getOther <em>Other</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Other</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getOther()
	 * @see #getTimeSyncProt()
	 * @generated
	 */
    EAttribute getTimeSyncProt_Other();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getSntp <em>Sntp</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sntp</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getSntp()
	 * @see #getTimeSyncProt()
	 * @generated
	 */
    EAttribute getTimeSyncProt_Sntp();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getClientServices <em>Client Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Client Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getClientServices()
	 * @see #getTimeSyncProt()
	 * @generated
	 */
    EReference getTimeSyncProt_ClientServices();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#getServices()
	 * @see #getTimeSyncProt()
	 * @generated
	 */
    EReference getTimeSyncProt_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#validateTimeSyncProt_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Time Sync Prot nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Time Sync Prot nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimeSyncProt#validateTimeSyncProt_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTimeSyncProt__ValidateTimeSyncProt_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimerActivatedControl <em>Timer Activated Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Timer Activated Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimerActivatedControl
	 * @generated
	 */
    EClass getTimerActivatedControl();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TimerActivatedControl#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TimerActivatedControl#getServices()
	 * @see #getTimerActivatedControl()
	 * @generated
	 */
    EReference getTimerActivatedControl_Services();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps <em>Trg Ops</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Trg Ops</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps
	 * @generated
	 */
    EClass getTrgOps();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getDchg <em>Dchg</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dchg</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getDchg()
	 * @see #getTrgOps()
	 * @generated
	 */
    EAttribute getTrgOps_Dchg();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getDupd <em>Dupd</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dupd</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getDupd()
	 * @see #getTrgOps()
	 * @generated
	 */
    EAttribute getTrgOps_Dupd();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getGi <em>Gi</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gi</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getGi()
	 * @see #getTrgOps()
	 * @generated
	 */
    EAttribute getTrgOps_Gi();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Period</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getPeriod()
	 * @see #getTrgOps()
	 * @generated
	 */
    EAttribute getTrgOps_Period();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getQchg <em>Qchg</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Qchg</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getQchg()
	 * @see #getTrgOps()
	 * @generated
	 */
    EAttribute getTrgOps_Qchg();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getControlWithTriggerOpt <em>Control With Trigger Opt</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Control With Trigger Opt</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#getControlWithTriggerOpt()
	 * @see #getTrgOps()
	 * @generated
	 */
    EReference getTrgOps_ControlWithTriggerOpt();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#validateTrgOps_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Trg Ops nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Trg Ops nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TrgOps#validateTrgOps_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTrgOps__ValidateTrgOps_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueHandling <em>Value Handling</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Value Handling</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueHandling
	 * @generated
	 */
    EClass getValueHandling();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueHandling#getSetToRO <em>Set To RO</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Set To RO</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueHandling#getSetToRO()
	 * @see #getValueHandling()
	 * @generated
	 */
    EAttribute getValueHandling_SetToRO();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueHandling#getServices <em>Services</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Services</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueHandling#getServices()
	 * @see #getValueHandling()
	 * @generated
	 */
    EReference getValueHandling_Services();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueHandling#validateValueHandling_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Value Handling nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Value Handling nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueHandling#validateValueHandling_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getValueHandling__ValidateValueHandling_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractConductingEquipment <em>Abstract Conducting Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Conducting Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractConductingEquipment
	 * @generated
	 */
    EClass getAbstractConductingEquipment();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractConductingEquipment#getSubEquipment <em>Sub Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractConductingEquipment#getSubEquipment()
	 * @see #getAbstractConductingEquipment()
	 * @generated
	 */
    EReference getAbstractConductingEquipment_SubEquipment();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractConductingEquipment#getTerminal <em>Terminal</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Terminal</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractConductingEquipment#getTerminal()
	 * @see #getAbstractConductingEquipment()
	 * @generated
	 */
    EReference getAbstractConductingEquipment_Terminal();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractEqFuncSubFunc <em>Abstract Eq Func Sub Func</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Eq Func Sub Func</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractEqFuncSubFunc
	 * @generated
	 */
    EClass getAbstractEqFuncSubFunc();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractEqFuncSubFunc#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractEqFuncSubFunc#getType()
	 * @see #getAbstractEqFuncSubFunc()
	 * @generated
	 */
    EAttribute getAbstractEqFuncSubFunc_Type();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractEqFuncSubFunc#getEqSubFunction <em>Eq Sub Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Eq Sub Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractEqFuncSubFunc#getEqSubFunction()
	 * @see #getAbstractEqFuncSubFunc()
	 * @generated
	 */
    EReference getAbstractEqFuncSubFunc_EqSubFunction();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractEqFuncSubFunc#getSubGeneralEquipment <em>Sub General Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub General Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractEqFuncSubFunc#getSubGeneralEquipment()
	 * @see #getAbstractEqFuncSubFunc()
	 * @generated
	 */
    EReference getAbstractEqFuncSubFunc_SubGeneralEquipment();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractEqFuncSubFunc#validateAbstractEqFuncSubFunc_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Abstract Eq Func Sub Func nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Abstract Eq Func Sub Func nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AbstractEqFuncSubFunc#validateAbstractEqFuncSubFunc_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAbstractEqFuncSubFunc__ValidateAbstractEqFuncSubFunc_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay <em>Bay</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bay</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay
	 * @generated
	 */
    EClass getBay();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#getVoltageLevel <em>Voltage Level</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Voltage Level</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#getVoltageLevel()
	 * @see #getBay()
	 * @generated
	 */
    EReference getBay_VoltageLevel();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#getFunction()
	 * @see #getBay()
	 * @generated
	 */
    EReference getBay_Function();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#getConnectivityNode <em>Connectivity Node</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Connectivity Node</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#getConnectivityNode()
	 * @see #getBay()
	 * @generated
	 */
    EReference getBay_ConnectivityNode();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#getTerminal <em>Terminal</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Terminal</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#getTerminal()
	 * @see #getBay()
	 * @generated
	 */
    EReference getBay_Terminal();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#getConductingEquipment <em>Conducting Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Conducting Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#getConductingEquipment()
	 * @see #getBay()
	 * @generated
	 */
    EReference getBay_ConductingEquipment();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#validateBay_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Bay nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Bay nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Bay#validateBay_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getBay__ValidateBay_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment <em>Conducting Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conducting Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment
	 * @generated
	 */
    EClass getConductingEquipment();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getType()
	 * @see #getConductingEquipment()
	 * @generated
	 */
    EAttribute getConductingEquipment_Type();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getBay <em>Bay</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Bay</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getBay()
	 * @see #getConductingEquipment()
	 * @generated
	 */
    EReference getConductingEquipment_Bay();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getFunction()
	 * @see #getConductingEquipment()
	 * @generated
	 */
    EReference getConductingEquipment_Function();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getSubFunction <em>Sub Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Sub Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getSubFunction()
	 * @see #getConductingEquipment()
	 * @generated
	 */
    EReference getConductingEquipment_SubFunction();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getEqFunction <em>Eq Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Eq Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getEqFunction()
	 * @see #getConductingEquipment()
	 * @generated
	 */
    EReference getConductingEquipment_EqFunction();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getLine <em>Line</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Line</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getLine()
	 * @see #getConductingEquipment()
	 * @generated
	 */
    EReference getConductingEquipment_Line();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Process</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#getProcess()
	 * @see #getConductingEquipment()
	 * @generated
	 */
    EReference getConductingEquipment_Process();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#validateConductingEquipment_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Conducting Equipment type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Conducting Equipment type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#validateConductingEquipment_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConductingEquipment__ValidateConductingEquipment_type_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#validateConductingEquipment_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Conducting Equipment type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Conducting Equipment type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConductingEquipment#validateConductingEquipment_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConductingEquipment__ValidateConductingEquipment_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode <em>Connectivity Node</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connectivity Node</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode
	 * @generated
	 */
    EClass getConnectivityNode();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#getPathName <em>Path Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Path Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#getPathName()
	 * @see #getConnectivityNode()
	 * @generated
	 */
    EAttribute getConnectivityNode_PathName();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#getBay <em>Bay</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Bay</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#getBay()
	 * @see #getConnectivityNode()
	 * @generated
	 */
    EReference getConnectivityNode_Bay();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#getTerminal <em>Terminal</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Terminal</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#getTerminal()
	 * @see #getConnectivityNode()
	 * @generated
	 */
    EReference getConnectivityNode_Terminal();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#getLine <em>Line</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Line</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#getLine()
	 * @see #getConnectivityNode()
	 * @generated
	 */
    EReference getConnectivityNode_Line();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#validateConnectivityNode_pathName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Connectivity Node path Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Connectivity Node path Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#validateConnectivityNode_pathName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConnectivityNode__ValidateConnectivityNode_pathName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#validateConnectivityNode_pathName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Connectivity Node path Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Connectivity Node path Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#validateConnectivityNode_pathName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConnectivityNode__ValidateConnectivityNode_pathName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#validateConnectivityNode_pathName_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Connectivity Node path Name value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Connectivity Node path Name value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ConnectivityNode#validateConnectivityNode_pathName_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getConnectivityNode__ValidateConnectivityNode_pathName_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction <em>Eq Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Eq Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction
	 * @generated
	 */
    EClass getEqFunction();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getConductingEquipment <em>Conducting Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Conducting Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getConductingEquipment()
	 * @see #getEqFunction()
	 * @generated
	 */
    EReference getEqFunction_ConductingEquipment();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getGeneralEquipment <em>General Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>General Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getGeneralEquipment()
	 * @see #getEqFunction()
	 * @generated
	 */
    EReference getEqFunction_GeneralEquipment();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getPowerTransformer <em>Power Transformer</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Power Transformer</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getPowerTransformer()
	 * @see #getEqFunction()
	 * @generated
	 */
    EReference getEqFunction_PowerTransformer();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getSubEquipment <em>Sub Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Sub Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getSubEquipment()
	 * @see #getEqFunction()
	 * @generated
	 */
    EReference getEqFunction_SubEquipment();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getTransformerWinding <em>Transformer Winding</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Transformer Winding</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getTransformerWinding()
	 * @see #getEqFunction()
	 * @generated
	 */
    EReference getEqFunction_TransformerWinding();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getTapChanger <em>Tap Changer</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Tap Changer</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#getTapChanger()
	 * @see #getEqFunction()
	 * @generated
	 */
    EReference getEqFunction_TapChanger();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#validateEqFunction_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Eq Function nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Eq Function nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqFunction#validateEqFunction_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getEqFunction__ValidateEqFunction_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqSubFunction <em>Eq Sub Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Eq Sub Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqSubFunction
	 * @generated
	 */
    EClass getEqSubFunction();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqSubFunction#getAbstractEqFuncSubFunc <em>Abstract Eq Func Sub Func</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Abstract Eq Func Sub Func</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqSubFunction#getAbstractEqFuncSubFunc()
	 * @see #getEqSubFunction()
	 * @generated
	 */
    EReference getEqSubFunction_AbstractEqFuncSubFunc();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EqSubFunction#validateEqSubFunction_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Eq Sub Function nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Eq Sub Function nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EqSubFunction#validateEqSubFunction_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getEqSubFunction__ValidateEqSubFunction_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Equipment <em>Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Equipment
	 * @generated
	 */
    EClass getEquipment();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Equipment#getVirtual <em>Virtual</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Virtual</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Equipment#getVirtual()
	 * @see #getEquipment()
	 * @generated
	 */
    EAttribute getEquipment_Virtual();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Equipment#validateEquipment_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Equipment nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Equipment nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Equipment#validateEquipment_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getEquipment__ValidateEquipment_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EquipmentContainer <em>Equipment Container</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Equipment Container</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EquipmentContainer
	 * @generated
	 */
    EClass getEquipmentContainer();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EquipmentContainer#getPowerTransformer <em>Power Transformer</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Power Transformer</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EquipmentContainer#getPowerTransformer()
	 * @see #getEquipmentContainer()
	 * @generated
	 */
    EReference getEquipmentContainer_PowerTransformer();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EquipmentContainer#getGeneralEquipment <em>General Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>General Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EquipmentContainer#getGeneralEquipment()
	 * @see #getEquipmentContainer()
	 * @generated
	 */
    EReference getEquipmentContainer_GeneralEquipment();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.EquipmentContainer#validateEquipmentContainer_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Equipment Container nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Equipment Container nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.EquipmentContainer#validateEquipmentContainer_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getEquipmentContainer__ValidateEquipmentContainer_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Function <em>Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Function
	 * @generated
	 */
    EClass getFunction();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getType()
	 * @see #getFunction()
	 * @generated
	 */
    EAttribute getFunction_Type();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getBay <em>Bay</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Bay</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getBay()
	 * @see #getFunction()
	 * @generated
	 */
    EReference getFunction_Bay();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getConductingEquipment <em>Conducting Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Conducting Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getConductingEquipment()
	 * @see #getFunction()
	 * @generated
	 */
    EReference getFunction_ConductingEquipment();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getGeneralEquipmentContainer <em>General Equipment Container</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>General Equipment Container</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getGeneralEquipmentContainer()
	 * @see #getFunction()
	 * @generated
	 */
    EReference getFunction_GeneralEquipmentContainer();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getSubstation <em>Substation</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Substation</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getSubstation()
	 * @see #getFunction()
	 * @generated
	 */
    EReference getFunction_Substation();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getVoltageLevel <em>Voltage Level</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Voltage Level</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getVoltageLevel()
	 * @see #getFunction()
	 * @generated
	 */
    EReference getFunction_VoltageLevel();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getSubFunction <em>Sub Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getSubFunction()
	 * @see #getFunction()
	 * @generated
	 */
    EReference getFunction_SubFunction();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getGeneralEquipment <em>General Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>General Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#getGeneralEquipment()
	 * @see #getFunction()
	 * @generated
	 */
    EReference getFunction_GeneralEquipment();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#validateFunction_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Function nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Function nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Function#validateFunction_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFunction__ValidateFunction_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment <em>General Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>General Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment
	 * @generated
	 */
    EClass getGeneralEquipment();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getType()
	 * @see #getGeneralEquipment()
	 * @generated
	 */
    EAttribute getGeneralEquipment_Type();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getAbstractEqFuncSubFunc <em>Abstract Eq Func Sub Func</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Abstract Eq Func Sub Func</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getAbstractEqFuncSubFunc()
	 * @see #getGeneralEquipment()
	 * @generated
	 */
    EReference getGeneralEquipment_AbstractEqFuncSubFunc();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getEqFunction <em>Eq Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Eq Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getEqFunction()
	 * @see #getGeneralEquipment()
	 * @generated
	 */
    EReference getGeneralEquipment_EqFunction();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getEquipmentContainer <em>Equipment Container</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Equipment Container</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getEquipmentContainer()
	 * @see #getGeneralEquipment()
	 * @generated
	 */
    EReference getGeneralEquipment_EquipmentContainer();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getFunction()
	 * @see #getGeneralEquipment()
	 * @generated
	 */
    EReference getGeneralEquipment_Function();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getGeneralEquipmentContainer <em>General Equipment Container</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>General Equipment Container</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getGeneralEquipmentContainer()
	 * @see #getGeneralEquipment()
	 * @generated
	 */
    EReference getGeneralEquipment_GeneralEquipmentContainer();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getSubFunction <em>Sub Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Sub Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#getSubFunction()
	 * @see #getGeneralEquipment()
	 * @generated
	 */
    EReference getGeneralEquipment_SubFunction();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#validateGeneralEquipment_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate General Equipment type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate General Equipment type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#validateGeneralEquipment_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getGeneralEquipment__ValidateGeneralEquipment_type_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#validateGeneralEquipment_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate General Equipment type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate General Equipment type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipment#validateGeneralEquipment_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getGeneralEquipment__ValidateGeneralEquipment_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipmentContainer <em>General Equipment Container</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>General Equipment Container</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipmentContainer
	 * @generated
	 */
    EClass getGeneralEquipmentContainer();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipmentContainer#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipmentContainer#getFunction()
	 * @see #getGeneralEquipmentContainer()
	 * @generated
	 */
    EReference getGeneralEquipmentContainer_Function();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipmentContainer#getGeneralEquipment <em>General Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>General Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipmentContainer#getGeneralEquipment()
	 * @see #getGeneralEquipmentContainer()
	 * @generated
	 */
    EReference getGeneralEquipmentContainer_GeneralEquipment();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipmentContainer#validateGeneralEquipmentContainer_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate General Equipment Container nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate General Equipment Container nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GeneralEquipmentContainer#validateGeneralEquipmentContainer_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getGeneralEquipmentContainer__ValidateGeneralEquipmentContainer_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode <em>LNode</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>LNode</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode
	 * @generated
	 */
    EClass getLNode();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getIedName <em>Ied Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ied Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getIedName()
	 * @see #getLNode()
	 * @generated
	 */
    EAttribute getLNode_IedName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLdInst <em>Ld Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ld Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLdInst()
	 * @see #getLNode()
	 * @generated
	 */
    EAttribute getLNode_LdInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLnClass <em>Ln Class</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Class</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLnClass()
	 * @see #getLNode()
	 * @generated
	 */
    EAttribute getLNode_LnClass();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLnInst <em>Ln Inst</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Inst</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLnInst()
	 * @see #getLNode()
	 * @generated
	 */
    EAttribute getLNode_LnInst();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLnType <em>Ln Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ln Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLnType()
	 * @see #getLNode()
	 * @generated
	 */
    EAttribute getLNode_LnType();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getPrefix()
	 * @see #getLNode()
	 * @generated
	 */
    EAttribute getLNode_Prefix();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getIED <em>IED</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>IED</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getIED()
	 * @see #getLNode()
	 * @generated
	 */
    EReference getLNode_IED();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLDevice <em>LDevice</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>LDevice</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLDevice()
	 * @see #getLNode()
	 * @generated
	 */
    EReference getLNode_LDevice();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLN <em>LN</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>LN</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLN()
	 * @see #getLNode()
	 * @generated
	 */
    EReference getLNode_LN();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLNodeContainer <em>LNode Container</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>LNode Container</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#getLNodeContainer()
	 * @see #getLNode()
	 * @generated
	 */
    EReference getLNode_LNodeContainer();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_lnClass_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode ln Class required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode ln Class required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_lnClass_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNode__ValidateLNode_lnClass_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_lnClass_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode ln Class value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode ln Class value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_lnClass_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNode__ValidateLNode_lnClass_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_lnInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode ln Inst required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode ln Inst required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_lnInst_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNode__ValidateLNode_lnInst_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_iedName_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode ied Name value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode ied Name value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_iedName_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNode__ValidateLNode_iedName_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_ldInst_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode ld Inst value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode ld Inst value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_ldInst_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNode__ValidateLNode_ldInst_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_prefix_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode prefix value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode prefix value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_prefix_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNode__ValidateLNode_prefix_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_lnInst_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode ln Inst value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode ln Inst value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_lnInst_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNode__ValidateLNode_lnInst_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_lnType_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode ln Type value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode ln Type value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNode#validateLNode_lnType_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNode__ValidateLNode_lnType_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeContainer <em>LNode Container</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>LNode Container</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeContainer
	 * @generated
	 */
    EClass getLNodeContainer();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeContainer#getLNode <em>LNode</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>LNode</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeContainer#getLNode()
	 * @see #getLNodeContainer()
	 * @generated
	 */
    EReference getLNodeContainer_LNode();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeContainer#validateLNodeContainer_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate LNode Container nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate LNode Container nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.LNodeContainer#validateLNodeContainer_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getLNodeContainer__ValidateLNodeContainer_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.NeutralPoint <em>Neutral Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Neutral Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.NeutralPoint
	 * @generated
	 */
    EClass getNeutralPoint();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.NeutralPoint#getTransformerWinding <em>Transformer Winding</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Transformer Winding</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.NeutralPoint#getTransformerWinding()
	 * @see #getNeutralPoint()
	 * @generated
	 */
    EReference getNeutralPoint_TransformerWinding();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerSystemResource <em>Power System Resource</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Power System Resource</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerSystemResource
	 * @generated
	 */
    EClass getPowerSystemResource();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerSystemResource#validatePowerSystemResource_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Power System Resource nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Power System Resource nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerSystemResource#validatePowerSystemResource_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getPowerSystemResource__ValidatePowerSystemResource_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer <em>Power Transformer</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Power Transformer</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer
	 * @generated
	 */
    EClass getPowerTransformer();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#getType()
	 * @see #getPowerTransformer()
	 * @generated
	 */
    EAttribute getPowerTransformer_Type();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#getEqFunction <em>Eq Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Eq Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#getEqFunction()
	 * @see #getPowerTransformer()
	 * @generated
	 */
    EReference getPowerTransformer_EqFunction();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#getEquipmentContainer <em>Equipment Container</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Equipment Container</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#getEquipmentContainer()
	 * @see #getPowerTransformer()
	 * @generated
	 */
    EReference getPowerTransformer_EquipmentContainer();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#getSubEquipment <em>Sub Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#getSubEquipment()
	 * @see #getPowerTransformer()
	 * @generated
	 */
    EReference getPowerTransformer_SubEquipment();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#getTransformerWinding <em>Transformer Winding</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Transformer Winding</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#getTransformerWinding()
	 * @see #getPowerTransformer()
	 * @generated
	 */
    EReference getPowerTransformer_TransformerWinding();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#validatePowerTransformer_type_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Power Transformer type value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Power Transformer type value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#validatePowerTransformer_type_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getPowerTransformer__ValidatePowerTransformer_type_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#validatePowerTransformer_at_least_one_TransformerWinding_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Power Transformer at least one Transformer Winding required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Power Transformer at least one Transformer Winding required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PowerTransformer#validatePowerTransformer_at_least_one_TransformerWinding_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getPowerTransformer__ValidatePowerTransformer_at_least_one_TransformerWinding_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment <em>Sub Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sub Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment
	 * @generated
	 */
    EClass getSubEquipment();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getPhase <em>Phase</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Phase</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getPhase()
	 * @see #getSubEquipment()
	 * @generated
	 */
    EAttribute getSubEquipment_Phase();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getVirtual <em>Virtual</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Virtual</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getVirtual()
	 * @see #getSubEquipment()
	 * @generated
	 */
    EAttribute getSubEquipment_Virtual();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getAbstractConductingEquipment <em>Abstract Conducting Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Abstract Conducting Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getAbstractConductingEquipment()
	 * @see #getSubEquipment()
	 * @generated
	 */
    EReference getSubEquipment_AbstractConductingEquipment();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getEqFunction <em>Eq Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Eq Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getEqFunction()
	 * @see #getSubEquipment()
	 * @generated
	 */
    EReference getSubEquipment_EqFunction();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getPowerTransformer <em>Power Transformer</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Power Transformer</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getPowerTransformer()
	 * @see #getSubEquipment()
	 * @generated
	 */
    EReference getSubEquipment_PowerTransformer();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getTapChanger <em>Tap Changer</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Tap Changer</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#getTapChanger()
	 * @see #getSubEquipment()
	 * @generated
	 */
    EReference getSubEquipment_TapChanger();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#validateSubEquipment_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sub Equipment nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sub Equipment nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubEquipment#validateSubEquipment_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSubEquipment__ValidateSubEquipment_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction <em>Sub Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sub Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction
	 * @generated
	 */
    EClass getSubFunction();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#getType()
	 * @see #getSubFunction()
	 * @generated
	 */
    EAttribute getSubFunction_Type();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#getConductingEquipment <em>Conducting Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Conducting Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#getConductingEquipment()
	 * @see #getSubFunction()
	 * @generated
	 */
    EReference getSubFunction_ConductingEquipment();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#getFunction()
	 * @see #getSubFunction()
	 * @generated
	 */
    EReference getSubFunction_Function();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#getGeneralEquipment <em>General Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>General Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#getGeneralEquipment()
	 * @see #getSubFunction()
	 * @generated
	 */
    EReference getSubFunction_GeneralEquipment();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#getSubSubFunctions <em>Sub Sub Functions</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub Sub Functions</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#getSubSubFunctions()
	 * @see #getSubFunction()
	 * @generated
	 */
    EReference getSubFunction_SubSubFunctions();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#validateSubFunction_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Sub Function nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Sub Function nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SubFunction#validateSubFunction_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSubFunction__ValidateSubFunction_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation <em>Substation</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Substation</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation
	 * @generated
	 */
    EClass getSubstation();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#getFunction()
	 * @see #getSubstation()
	 * @generated
	 */
    EReference getSubstation_Function();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#getVoltageLevel <em>Voltage Level</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Voltage Level</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#getVoltageLevel()
	 * @see #getSubstation()
	 * @generated
	 */
    EReference getSubstation_VoltageLevel();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#getTerminal <em>Terminal</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Terminal</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#getTerminal()
	 * @see #getSubstation()
	 * @generated
	 */
    EReference getSubstation_Terminal();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#getProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Process</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#getProcess()
	 * @see #getSubstation()
	 * @generated
	 */
    EReference getSubstation_Process();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#getSCL <em>SCL</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>SCL</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#getSCL()
	 * @see #getSubstation()
	 * @generated
	 */
    EReference getSubstation_SCL();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#validateSubstation_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Substation nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Substation nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#validateSubstation_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSubstation__ValidateSubstation_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#validateSubstation_at_least_one_VoltageLevel_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Substation at least one Voltage Level required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Substation at least one Voltage Level required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Substation#validateSubstation_at_least_one_VoltageLevel_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSubstation__ValidateSubstation_at_least_one_VoltageLevel_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger <em>Tap Changer</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Tap Changer</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger
	 * @generated
	 */
    EClass getTapChanger();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#getType()
	 * @see #getTapChanger()
	 * @generated
	 */
    EAttribute getTapChanger_Type();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#getVirtual <em>Virtual</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Virtual</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#getVirtual()
	 * @see #getTapChanger()
	 * @generated
	 */
    EAttribute getTapChanger_Virtual();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#getEqFunction <em>Eq Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Eq Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#getEqFunction()
	 * @see #getTapChanger()
	 * @generated
	 */
    EReference getTapChanger_EqFunction();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#getSubEquipment <em>Sub Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#getSubEquipment()
	 * @see #getTapChanger()
	 * @generated
	 */
    EReference getTapChanger_SubEquipment();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#getTransformerWinding <em>Transformer Winding</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Transformer Winding</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#getTransformerWinding()
	 * @see #getTapChanger()
	 * @generated
	 */
    EReference getTapChanger_TransformerWinding();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#validateTapChanger_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Tap Changer type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Tap Changer type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#validateTapChanger_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTapChanger__ValidateTapChanger_type_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#validateTapChanger_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Tap Changer type valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Tap Changer type valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#validateTapChanger_type_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTapChanger__ValidateTapChanger_type_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#validateTapChanger_type_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Tap Changer type value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Tap Changer type value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TapChanger#validateTapChanger_type_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTapChanger__ValidateTapChanger_type_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal <em>Terminal</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Terminal</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal
	 * @generated
	 */
    EClass getTerminal();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getBayName <em>Bay Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Bay Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getBayName()
	 * @see #getTerminal()
	 * @generated
	 */
    EAttribute getTerminal_BayName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getCNodeName <em>CNode Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>CNode Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getCNodeName()
	 * @see #getTerminal()
	 * @generated
	 */
    EAttribute getTerminal_CNodeName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getConnectivityNode <em>Connectivity Node</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Connectivity Node</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getConnectivityNode()
	 * @see #getTerminal()
	 * @generated
	 */
    EAttribute getTerminal_ConnectivityNode();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getProcessName <em>Process Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Process Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getProcessName()
	 * @see #getTerminal()
	 * @generated
	 */
    EAttribute getTerminal_ProcessName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getSubstationName <em>Substation Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Substation Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getSubstationName()
	 * @see #getTerminal()
	 * @generated
	 */
    EAttribute getTerminal_SubstationName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getVoltageLevelName <em>Voltage Level Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Voltage Level Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getVoltageLevelName()
	 * @see #getTerminal()
	 * @generated
	 */
    EAttribute getTerminal_VoltageLevelName();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getAbstractConductingEquipment <em>Abstract Conducting Equipment</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Abstract Conducting Equipment</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getAbstractConductingEquipment()
	 * @see #getTerminal()
	 * @generated
	 */
    EReference getTerminal_AbstractConductingEquipment();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getBay <em>Bay</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Bay</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getBay()
	 * @see #getTerminal()
	 * @generated
	 */
    EReference getTerminal_Bay();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getCNode <em>CNode</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>CNode</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getCNode()
	 * @see #getTerminal()
	 * @generated
	 */
    EReference getTerminal_CNode();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getSubstation <em>Substation</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Substation</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getSubstation()
	 * @see #getTerminal()
	 * @generated
	 */
    EReference getTerminal_Substation();

    /**
	 * Returns the meta object for the reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getVoltageLevel <em>Voltage Level</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Voltage Level</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getVoltageLevel()
	 * @see #getTerminal()
	 * @generated
	 */
    EReference getTerminal_VoltageLevel();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#getName()
	 * @see #getTerminal()
	 * @generated
	 */
    EAttribute getTerminal_Name();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_connectivityNode_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal connectivity Node required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal connectivity Node required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_connectivityNode_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_connectivityNode_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_connectivityNode_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal connectivity Node valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal connectivity Node valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_connectivityNode_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_connectivityNode_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_connectivityNode_value_shall_be_pathname(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal connectivity Node value shall be pathname</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal connectivity Node value shall be pathname</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_connectivityNode_value_shall_be_pathname(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_connectivityNode_value_shall_be_pathname__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_substationName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal substation Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal substation Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_substationName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_substationName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_substationName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal substation Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal substation Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_substationName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_substationName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_voltageLevelName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal voltage Level Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal voltage Level Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_voltageLevelName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_voltageLevelName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_voltageLevelName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal voltage Level Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal voltage Level Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_voltageLevelName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_voltageLevelName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_bayName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal bay Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal bay Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_bayName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_bayName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_bayName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal bay Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal bay Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_bayName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_bayName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_cNodeName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal cNode Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal cNode Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_cNodeName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_cNodeName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_cNodeName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal cNode Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal cNode Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_cNodeName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_cNodeName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_processName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Terminal process Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Terminal process Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Terminal#validateTerminal_processName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTerminal__ValidateTerminal_processName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding <em>Transformer Winding</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Transformer Winding</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding
	 * @generated
	 */
    EClass getTransformerWinding();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#getType()
	 * @see #getTransformerWinding()
	 * @generated
	 */
    EAttribute getTransformerWinding_Type();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#getEqFunction <em>Eq Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Eq Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#getEqFunction()
	 * @see #getTransformerWinding()
	 * @generated
	 */
    EReference getTransformerWinding_EqFunction();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#getNeutralPoint <em>Neutral Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Neutral Point</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#getNeutralPoint()
	 * @see #getTransformerWinding()
	 * @generated
	 */
    EReference getTransformerWinding_NeutralPoint();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#getPowerTransformer <em>Power Transformer</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Power Transformer</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#getPowerTransformer()
	 * @see #getTransformerWinding()
	 * @generated
	 */
    EReference getTransformerWinding_PowerTransformer();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#getTapChanger <em>Tap Changer</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Tap Changer</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#getTapChanger()
	 * @see #getTransformerWinding()
	 * @generated
	 */
    EReference getTransformerWinding_TapChanger();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#validateTransformerWinding_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Transformer Winding type required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Transformer Winding type required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.TransformerWinding#validateTransformerWinding_type_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getTransformerWinding__ValidateTransformerWinding_type_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Voltage <em>Voltage</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Voltage</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Voltage
	 * @generated
	 */
    EClass getVoltage();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Voltage#validateVoltage_unit_value_fixed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Voltage unit value fixed</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Voltage unit value fixed</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Voltage#validateVoltage_unit_value_fixed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getVoltage__ValidateVoltage_unit_value_fixed__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel <em>Voltage Level</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Voltage Level</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel
	 * @generated
	 */
    EClass getVoltageLevel();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getNomFreq <em>Nom Freq</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Nom Freq</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getNomFreq()
	 * @see #getVoltageLevel()
	 * @generated
	 */
    EAttribute getVoltageLevel_NomFreq();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getNumPhases <em>Num Phases</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Num Phases</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getNumPhases()
	 * @see #getVoltageLevel()
	 * @generated
	 */
    EAttribute getVoltageLevel_NumPhases();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getBay <em>Bay</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Bay</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getBay()
	 * @see #getVoltageLevel()
	 * @generated
	 */
    EReference getVoltageLevel_Bay();

    /**
	 * Returns the meta object for the containment reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Function</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getFunction()
	 * @see #getVoltageLevel()
	 * @generated
	 */
    EReference getVoltageLevel_Function();

    /**
	 * Returns the meta object for the container reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getSubstation <em>Substation</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Substation</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getSubstation()
	 * @see #getVoltageLevel()
	 * @generated
	 */
    EReference getVoltageLevel_Substation();

    /**
	 * Returns the meta object for the containment reference '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getVoltage <em>Voltage</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Voltage</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getVoltage()
	 * @see #getVoltageLevel()
	 * @generated
	 */
    EReference getVoltageLevel_Voltage();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getTerminal <em>Terminal</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Terminal</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#getTerminal()
	 * @see #getVoltageLevel()
	 * @generated
	 */
    EReference getVoltageLevel_Terminal();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#validateVoltageLevel_nomFreq_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Voltage Level nom Freq value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Voltage Level nom Freq value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#validateVoltageLevel_nomFreq_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getVoltageLevel__ValidateVoltageLevel_nomFreq_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#validateVoltageLevel_numPhases_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Voltage Level num Phases value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Voltage Level num Phases value</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#validateVoltageLevel_numPhases_value(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getVoltageLevel__ValidateVoltageLevel_numPhases_value__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#validateVoltageLevel_at_least_one_Bay_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Voltage Level at least one Bay required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Voltage Level at least one Bay required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.VoltageLevel#validateVoltageLevel_at_least_one_Bay_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getVoltageLevel__ValidateVoltageLevel_at_least_one_Bay_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ExplicitLinkResolver <em>Explicit Link Resolver</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Explicit Link Resolver</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ExplicitLinkResolver
	 * @generated
	 */
    EClass getExplicitLinkResolver();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject <em>Data Object</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Object</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject
	 * @generated
	 */
    EClass getDataObject();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#getAccessControl <em>Access Control</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Access Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#getAccessControl()
	 * @see #getDataObject()
	 * @generated
	 */
    EAttribute getDataObject_AccessControl();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#getReferredByFCDA <em>Referred By FCDA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By FCDA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#getReferredByFCDA()
	 * @see #getDataObject()
	 * @generated
	 */
    EReference getDataObject_ReferredByFCDA();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#getName()
	 * @see #getDataObject()
	 * @generated
	 */
    EAttribute getDataObject_Name();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#getReferredByExtRef <em>Referred By Ext Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Ext Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#getReferredByExtRef()
	 * @see #getDataObject()
	 * @generated
	 */
    EReference getDataObject_ReferredByExtRef();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#validateDataObject_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Data Object name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Data Object name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#validateDataObject_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDataObject__ValidateDataObject_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#validateDataObject_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Data Object name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Data Object name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataObject#validateDataObject_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDataObject__ValidateDataObject_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute <em>Data Attribute</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Attribute</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute
	 * @generated
	 */
    EClass getDataAttribute();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute#getReferredByFCDA <em>Referred By FCDA</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By FCDA</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute#getReferredByFCDA()
	 * @see #getDataAttribute()
	 * @generated
	 */
    EReference getDataAttribute_ReferredByFCDA();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute#getName()
	 * @see #getDataAttribute()
	 * @generated
	 */
    EAttribute getDataAttribute_Name();

    /**
	 * Returns the meta object for the reference list '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute#getReferredByExtRef <em>Referred By Ext Ref</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Referred By Ext Ref</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute#getReferredByExtRef()
	 * @see #getDataAttribute()
	 * @generated
	 */
    EReference getDataAttribute_ReferredByExtRef();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute#validateDataAttribute_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Data Attribute name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Data Attribute name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute#validateDataAttribute_name_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDataAttribute__ValidateDataAttribute_name_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute#validateDataAttribute_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Data Attribute name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Data Attribute name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DataAttribute#validateDataAttribute_name_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDataAttribute__ValidateDataAttribute_name_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Object</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject
	 * @generated
	 */
    EClass getSclObject();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#getLineNumber <em>Line Number</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Line Number</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#getLineNumber()
	 * @see #getSclObject()
	 * @generated
	 */
    EAttribute getSclObject_LineNumber();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAccessPointName(java.lang.String) <em>Valid Scl Access Point Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Access Point Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAccessPointName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclAccessPointName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAcsiName(java.lang.String) <em>Valid Scl Acsi Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Acsi Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAcsiName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclAcsiName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAnyName(java.lang.String) <em>Valid Scl Any Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Any Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAnyName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclAnyName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAssociationID(java.lang.String) <em>Valid Scl Association ID</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Association ID</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAssociationID(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclAssociationID__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAttributeNameEnum(java.lang.String) <em>Valid Scl Attribute Name Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Attribute Name Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAttributeNameEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclAttributeNameEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAuthenticationEnum(java.lang.String) <em>Valid Scl Authentication Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Authentication Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclAuthenticationEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclAuthenticationEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclBasicTypeEnum(java.lang.String) <em>Valid Scl Basic Type Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Basic Type Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclBasicTypeEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclBasicTypeEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclCBName(java.lang.String) <em>Valid Scl CB Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl CB Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclCBName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclCBName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclCDCEnum(java.lang.String) <em>Valid Scl CDC Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl CDC Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclCDCEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclCDCEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclCommonConductingEquipmentEnum(java.lang.String) <em>Valid Scl Common Conducting Equipment Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Common Conducting Equipment Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclCommonConductingEquipmentEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclCommonConductingEquipmentEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDACount(java.lang.String) <em>Valid Scl DA Count</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl DA Count</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDACount(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDACount__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDataName(java.lang.String) <em>Valid Scl Data Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Data Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDataName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDataName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDataSetName(java.lang.String) <em>Valid Scl Data Set Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Data Set Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDataSetName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDataSetName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNEnum(java.lang.String) <em>Valid Scl Domain LN Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupAEnum(java.lang.String) <em>Valid Scl Domain LN Group AEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group AEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupAEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupAEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupCEnum(java.lang.String) <em>Valid Scl Domain LN Group CEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group CEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupCEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupCEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupFEnum(java.lang.String) <em>Valid Scl Domain LN Group FEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group FEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupFEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupFEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupGEnum(java.lang.String) <em>Valid Scl Domain LN Group GEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group GEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupGEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupGEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupIEnum(java.lang.String) <em>Valid Scl Domain LN Group IEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group IEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupIEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupIEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupKEnum(java.lang.String) <em>Valid Scl Domain LN Group KEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group KEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupKEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupKEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupMEnum(java.lang.String) <em>Valid Scl Domain LN Group MEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group MEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupMEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupMEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupPEnum(java.lang.String) <em>Valid Scl Domain LN Group PEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group PEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupPEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupPEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupQEnum(java.lang.String) <em>Valid Scl Domain LN Group QEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group QEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupQEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupQEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupREnum(java.lang.String) <em>Valid Scl Domain LN Group REnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group REnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupREnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupREnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupSEnum(java.lang.String) <em>Valid Scl Domain LN Group SEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group SEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupSEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupSEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupTEnum(java.lang.String) <em>Valid Scl Domain LN Group TEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group TEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupTEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupTEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupXEnum(java.lang.String) <em>Valid Scl Domain LN Group XEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group XEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupXEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupXEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupYEnum(java.lang.String) <em>Valid Scl Domain LN Group YEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group YEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupYEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupYEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupZEnum(java.lang.String) <em>Valid Scl Domain LN Group ZEnum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Domain LN Group ZEnum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclDomainLNGroupZEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclDomainLNGroupZEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclEmpty(java.lang.String) <em>Valid Scl Empty</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Empty</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclEmpty(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclEmpty__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionAttributeNameEnum(java.lang.String) <em>Valid Scl Extension Attribute Name Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Extension Attribute Name Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionAttributeNameEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclExtensionAttributeNameEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionCDCEnum(java.lang.String) <em>Valid Scl Extension CDC Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Extension CDC Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionCDCEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclExtensionCDCEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionEquipmentEnum(java.lang.String) <em>Valid Scl Extension Equipment Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Extension Equipment Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionEquipmentEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclExtensionEquipmentEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionGeneralEquipmentEnum(java.lang.String) <em>Valid Scl Extension General Equipment Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Extension General Equipment Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionGeneralEquipmentEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclExtensionGeneralEquipmentEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionLNClassEnum(java.lang.String) <em>Valid Scl Extension LN Class Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Extension LN Class Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionLNClassEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclExtensionLNClassEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionPTypeEnum(java.lang.String) <em>Valid Scl Extension PType Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Extension PType Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionPTypeEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclExtensionPTypeEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionPhysConnTypeEnum(java.lang.String) <em>Valid Scl Extension Phys Conn Type Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Extension Phys Conn Type Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclExtensionPhysConnTypeEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclExtensionPhysConnTypeEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclFullAttributeName(java.lang.String) <em>Valid Scl Full Attribute Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Full Attribute Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclFullAttributeName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclFullAttributeName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclFullDOName(java.lang.String) <em>Valid Scl Full DO Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Full DO Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclFullDOName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclFullDOName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclGeneralEquipmentEnum(java.lang.String) <em>Valid Scl General Equipment Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl General Equipment Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclGeneralEquipmentEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclGeneralEquipmentEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclIEDName(java.lang.String) <em>Valid Scl IED Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl IED Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclIEDName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclIEDName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclIEDNameOrRelative(java.lang.String) <em>Valid Scl IED Name Or Relative</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl IED Name Or Relative</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclIEDNameOrRelative(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclIEDNameOrRelative__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLDInst(java.lang.String) <em>Valid Scl LD Inst</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl LD Inst</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLDInst(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclLDInst__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLDInstOrEmpty(java.lang.String) <em>Valid Scl LD Inst Or Empty</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl LD Inst Or Empty</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLDInstOrEmpty(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclLDInstOrEmpty__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLDName(java.lang.String) <em>Valid Scl LD Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl LD Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLDName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclLDName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLLN0Enum(java.lang.String) <em>Valid Scl LLN0 Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl LLN0 Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLLN0Enum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclLLN0Enum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLNClassEnum(java.lang.String) <em>Valid Scl LN Class Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl LN Class Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLNClassEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclLNClassEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLNInst(java.lang.String) <em>Valid Scl LN Inst</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl LN Inst</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLNInst(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclLNInst__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLNInstOrEmpty(java.lang.String) <em>Valid Scl LN Inst Or Empty</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl LN Inst Or Empty</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLNInstOrEmpty(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclLNInstOrEmpty__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLPHDEnum(java.lang.String) <em>Valid Scl LPHD Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl LPHD Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLPHDEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclLPHDEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLineType(java.lang.String) <em>Valid Scl Line Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Line Type</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLineType(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclLineType__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLogName(java.lang.String) <em>Valid Scl Log Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Log Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclLogName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclLogName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclMessageID(java.lang.String) <em>Valid Scl Message ID</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Message ID</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclMessageID(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclMessageID__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclName(java.lang.String) <em>Valid Scl Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclNamespaceName(java.lang.String) <em>Valid Scl Namespace Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Namespace Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclNamespaceName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclNamespaceName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclOnlyRelativeIEDName(java.lang.String) <em>Valid Scl Only Relative IED Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Only Relative IED Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclOnlyRelativeIEDName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclOnlyRelativeIEDName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPAddr(java.lang.String) <em>Valid Scl PAddr</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl PAddr</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPAddr(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPAddr__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPTypeEnum(java.lang.String) <em>Valid Scl PType Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl PType Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPTypeEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPTypeEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPTypePhysConnEnum(java.lang.String) <em>Valid Scl PType Phys Conn Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl PType Phys Conn Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPTypePhysConnEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPTypePhysConnEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPhysConnTypeEnum(java.lang.String) <em>Valid Scl Phys Conn Type Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Phys Conn Type Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPhysConnTypeEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPhysConnTypeEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPowerTransformerEnum(java.lang.String) <em>Valid Scl Power Transformer Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Power Transformer Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPowerTransformerEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPowerTransformerEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedAttributeNameEnum(java.lang.String) <em>Valid Scl Predefined Attribute Name Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Predefined Attribute Name Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedAttributeNameEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPredefinedAttributeNameEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedBasicTypeEnum(java.lang.String) <em>Valid Scl Predefined Basic Type Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Predefined Basic Type Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedBasicTypeEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPredefinedBasicTypeEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedCDCEnum(java.lang.String) <em>Valid Scl Predefined CDC Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Predefined CDC Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedCDCEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPredefinedCDCEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedCommonConductingEquipmentEnum(java.lang.String) <em>Valid Scl Predefined Common Conducting Equipment Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Predefined Common Conducting Equipment Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedCommonConductingEquipmentEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPredefinedCommonConductingEquipmentEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedGeneralEquipmentEnum(java.lang.String) <em>Valid Scl Predefined General Equipment Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Predefined General Equipment Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedGeneralEquipmentEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPredefinedGeneralEquipmentEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedLNClassEnum(java.lang.String) <em>Valid Scl Predefined LN Class Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Predefined LN Class Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedLNClassEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPredefinedLNClassEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedPTypeEnum(java.lang.String) <em>Valid Scl Predefined PType Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Predefined PType Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedPTypeEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPredefinedPTypeEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedPTypePhysConnEnum(java.lang.String) <em>Valid Scl Predefined PType Phys Conn Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Predefined PType Phys Conn Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedPTypePhysConnEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPredefinedPTypePhysConnEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedPhysConnTypeEnum(java.lang.String) <em>Valid Scl Predefined Phys Conn Type Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Predefined Phys Conn Type Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPredefinedPhysConnTypeEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPredefinedPhysConnTypeEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPrefix(java.lang.String) <em>Valid Scl Prefix</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Prefix</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclPrefix(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclPrefix__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclProcessName(java.lang.String) <em>Valid Scl Process Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Process Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclProcessName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclProcessName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclProcessType(java.lang.String) <em>Valid Scl Process Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Process Type</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclProcessType(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclProcessType__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRedProtEnum(java.lang.String) <em>Valid Scl Red Prot Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Red Prot Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRedProtEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclRedProtEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRef(java.lang.String) <em>Valid Scl Ref</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Ref</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRef(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclRef__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRelease(java.math.BigInteger) <em>Valid Scl Release</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Release</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRelease(java.math.BigInteger)
	 * @generated
	 */
	EOperation getSclObject__ValidSclRelease__BigInteger();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRestrName1stL(java.lang.String) <em>Valid Scl Restr Name1st L</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Restr Name1st L</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRestrName1stL(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclRestrName1stL__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRestrName1stU(java.lang.String) <em>Valid Scl Restr Name1st U</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Restr Name1st U</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRestrName1stU(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclRestrName1stU__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRevision(java.lang.String) <em>Valid Scl Revision</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Revision</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRevision(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclRevision__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRightEnum(java.lang.String) <em>Valid Scl Right Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Right Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclRightEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclRightEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclSDOCount(java.lang.String) <em>Valid Scl SDO Count</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl SDO Count</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclSDOCount(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclSDOCount__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclSubDataName(java.lang.String) <em>Valid Scl Sub Data Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Sub Data Name</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclSubDataName(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclSubDataName__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclSystemLNGroupEnum(java.lang.String) <em>Valid Scl System LN Group Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl System LN Group Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclSystemLNGroupEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclSystemLNGroupEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclTransformerWindingEnum(java.lang.String) <em>Valid Scl Transformer Winding Enum</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Transformer Winding Enum</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclTransformerWindingEnum(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclTransformerWindingEnum__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclVersion(java.lang.String) <em>Valid Scl Version</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Version</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclVersion(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclVersion__String();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclVisibleBasicLatin(java.lang.String) <em>Valid Scl Visible Basic Latin</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Valid Scl Visible Basic Latin</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SclObject#validSclVisibleBasicLatin(java.lang.String)
	 * @generated
	 */
	EOperation getSclObject__ValidSclVisibleBasicLatin__String();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.UnNaming <em>Un Naming</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Un Naming</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.UnNaming
	 * @generated
	 */
    EClass getUnNaming();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.UnNaming#getDesc <em>Desc</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Desc</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.UnNaming#getDesc()
	 * @see #getUnNaming()
	 * @generated
	 */
    EAttribute getUnNaming_Desc();

    /**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceYesNo <em>Service Yes No</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service Yes No</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceYesNo
	 * @generated
	 */
    EClass getServiceYesNo();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceYesNo#validateServiceYesNo_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service Yes No nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service Yes No nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceYesNo#validateServiceYesNo_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceYesNo__ValidateServiceYesNo_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithOptionalMax <em>Service With Optional Max</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service With Optional Max</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithOptionalMax
	 * @generated
	 */
    EClass getServiceWithOptionalMax();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithOptionalMax#getMax <em>Max</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithOptionalMax#getMax()
	 * @see #getServiceWithOptionalMax()
	 * @generated
	 */
    EAttribute getServiceWithOptionalMax_Max();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithOptionalMax#validateServiceWithOptionalMax_max_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service With Optional Max max valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service With Optional Max max valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithOptionalMax#validateServiceWithOptionalMax_max_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceWithOptionalMax__ValidateServiceWithOptionalMax_max_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxNonZero <em>Service With Max Non Zero</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service With Max Non Zero</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxNonZero
	 * @generated
	 */
    EClass getServiceWithMaxNonZero();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxNonZero#getMax <em>Max</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxNonZero#getMax()
	 * @see #getServiceWithMaxNonZero()
	 * @generated
	 */
    EAttribute getServiceWithMaxNonZero_Max();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxNonZero#validateServiceWithMaxNonZero_max_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service With Max Non Zero max required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service With Max Non Zero max required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxNonZero#validateServiceWithMaxNonZero_max_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceWithMaxNonZero__ValidateServiceWithMaxNonZero_max_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxNonZero#validateServiceWithMaxNonZero_max_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service With Max Non Zero max valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service With Max Non Zero max valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxNonZero#validateServiceWithMaxNonZero_max_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceWithMaxNonZero__ValidateServiceWithMaxNonZero_max_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceConfReportControl <em>Service Conf Report Control</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service Conf Report Control</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceConfReportControl
	 * @generated
	 */
    EClass getServiceConfReportControl();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceConfReportControl#getBufMode <em>Buf Mode</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Buf Mode</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceConfReportControl#getBufMode()
	 * @see #getServiceConfReportControl()
	 * @generated
	 */
    EAttribute getServiceConfReportControl_BufMode();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceConfReportControl#getBufConf <em>Buf Conf</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Buf Conf</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceConfReportControl#getBufConf()
	 * @see #getServiceConfReportControl()
	 * @generated
	 */
    EAttribute getServiceConfReportControl_BufConf();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceConfReportControl#validateServiceConfReportControl_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service Conf Report Control nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service Conf Report Control nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceConfReportControl#validateServiceConfReportControl_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceConfReportControl__ValidateServiceConfReportControl_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndMaxAttributes <em>Service With Max And Max Attributes</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service With Max And Max Attributes</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndMaxAttributes
	 * @generated
	 */
    EClass getServiceWithMaxAndMaxAttributes();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndMaxAttributes#getMaxAttributes <em>Max Attributes</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Attributes</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndMaxAttributes#getMaxAttributes()
	 * @see #getServiceWithMaxAndMaxAttributes()
	 * @generated
	 */
    EAttribute getServiceWithMaxAndMaxAttributes_MaxAttributes();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndMaxAttributes#validateServiceWithMax_maxAttributes_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service With Max max Attributes valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service With Max max Attributes valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndMaxAttributes#validateServiceWithMax_maxAttributes_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceWithMaxAndMaxAttributes__ValidateServiceWithMax_maxAttributes_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndModify <em>Service With Max And Modify</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service With Max And Modify</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndModify
	 * @generated
	 */
    EClass getServiceWithMaxAndModify();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndModify#getModify <em>Modify</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Modify</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndModify#getModify()
	 * @see #getServiceWithMaxAndModify()
	 * @generated
	 */
    EAttribute getServiceWithMaxAndModify_Modify();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndModify#validateServiceWithMaxAndModify_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service With Max And Modify nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service With Max And Modify nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceWithMaxAndModify#validateServiceWithMaxAndModify_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceWithMaxAndModify__ValidateServiceWithMaxAndModify_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceForConfDataSet <em>Service For Conf Data Set</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service For Conf Data Set</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceForConfDataSet
	 * @generated
	 */
    EClass getServiceForConfDataSet();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceForConfDataSet#getModify <em>Modify</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Modify</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceForConfDataSet#getModify()
	 * @see #getServiceForConfDataSet()
	 * @generated
	 */
    EAttribute getServiceForConfDataSet_Modify();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceForConfDataSet#validateServiceForConfDataSet_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Service For Conf Data Set nothing</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Service For Conf Data Set nothing</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceForConfDataSet#validateServiceForConfDataSet_nothing(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getServiceForConfDataSet__ValidateServiceForConfDataSet_nothing__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert <em>Cert</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cert</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert
	 * @generated
	 */
    EClass getCert();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#getCommonName <em>Common Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Common Name</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#getCommonName()
	 * @see #getCert()
	 * @generated
	 */
    EAttribute getCert_CommonName();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#getIdHierarchy <em>Id Hierarchy</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id Hierarchy</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#getIdHierarchy()
	 * @see #getCert()
	 * @generated
	 */
    EAttribute getCert_IdHierarchy();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#validateCert_commonName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Cert common Name required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Cert common Name required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#validateCert_commonName_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCert__ValidateCert_commonName_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#validateCert_commonName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Cert common Name valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Cert common Name valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#validateCert_commonName_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCert__ValidateCert_commonName_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#validateCert_idHierarchy_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Cert id Hierarchy required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Cert id Hierarchy required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#validateCert_idHierarchy_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCert__ValidateCert_idHierarchy_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#validateCert_idHierarchy_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Cert id Hierarchy valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Cert id Hierarchy valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.Cert#validateCert_idHierarchy_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getCert__ValidateCert_idHierarchy_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit <em>Value With Unit</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Value With Unit</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit
	 * @generated
	 */
    EClass getValueWithUnit();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#getValue()
	 * @see #getValueWithUnit()
	 * @generated
	 */
    EAttribute getValueWithUnit_Value();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#getMultiplier <em>Multiplier</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Multiplier</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#getMultiplier()
	 * @see #getValueWithUnit()
	 * @generated
	 */
    EAttribute getValueWithUnit_Multiplier();

    /**
	 * Returns the meta object for the attribute '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unit</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#getUnit()
	 * @see #getValueWithUnit()
	 * @generated
	 */
    EAttribute getValueWithUnit_Unit();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#validateValueWithUnit_value_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Value With Unit value required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Value With Unit value required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#validateValueWithUnit_value_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getValueWithUnit__ValidateValueWithUnit_value_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#validateValueWithUnit_unit_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Value With Unit unit required</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Value With Unit unit required</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#validateValueWithUnit_unit_required(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getValueWithUnit__ValidateValueWithUnit_unit_required__DiagnosticChain_Map();

				/**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#validateValueWithUnit_unit_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Value With Unit unit valid</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Value With Unit unit valid</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValueWithUnit#validateValueWithUnit_unit_valid(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getValueWithUnit__ValidateValueWithUnit_unit_valid__DiagnosticChain_Map();

				/**
	 * Returns the meta object for class '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInSec <em>Duration In Sec</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Duration In Sec</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInSec
	 * @generated
	 */
    EClass getDurationInSec();

    /**
	 * Returns the meta object for the '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInSec#validateDurationInSec_unit_value_fixed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Validate Duration In Sec unit value fixed</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Validate Duration In Sec unit value fixed</em>' operation.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.DurationInSec#validateDurationInSec_unit_value_fixed(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDurationInSec__ValidateDurationInSec_unit_value_fixed__DiagnosticChain_Map();

				/**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.AssociationKindEnum <em>Association Kind Enum</em>}'.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Association Kind Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.AssociationKindEnum
	 * @generated
	 */
    EEnum getAssociationKindEnum();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.FCEnum <em>FC Enum</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>FC Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.FCEnum
	 * @generated
	 */
    EEnum getFCEnum();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControlTypeEnum <em>GSE Control Type Enum</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>GSE Control Type Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.GSEControlTypeEnum
	 * @generated
	 */
    EEnum getGSEControlTypeEnum();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PhaseEnum <em>Phase Enum</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Phase Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PhaseEnum
	 * @generated
	 */
    EEnum getPhaseEnum();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.PredefinedTypeOfSecurityEnum <em>Predefined Type Of Security Enum</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Predefined Type Of Security Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.PredefinedTypeOfSecurityEnum
	 * @generated
	 */
    EEnum getPredefinedTypeOfSecurityEnum();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVDeliveryEnum <em>SMV Delivery Enum</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>SMV Delivery Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SMVDeliveryEnum
	 * @generated
	 */
    EEnum getSMVDeliveryEnum();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettingsEnum <em>Service Settings Enum</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Service Settings Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettingsEnum
	 * @generated
	 */
    EEnum getServiceSettingsEnum();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettingsNoDynEnum <em>Service Settings No Dyn Enum</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Service Settings No Dyn Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceSettingsNoDynEnum
	 * @generated
	 */
    EEnum getServiceSettingsNoDynEnum();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceType <em>Service Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Service Type</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ServiceType
	 * @generated
	 */
    EEnum getServiceType();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.SmpMod <em>Smp Mod</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Smp Mod</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.SmpMod
	 * @generated
	 */
    EEnum getSmpMod();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.UnitMultiplierEnum <em>Unit Multiplier Enum</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Unit Multiplier Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.UnitMultiplierEnum
	 * @generated
	 */
    EEnum getUnitMultiplierEnum();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.ValKindEnum <em>Val Kind Enum</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Val Kind Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.ValKindEnum
	 * @generated
	 */
    EEnum getValKindEnum();

    /**
	 * Returns the meta object for enum '{@link fr.centralesupelec.edf.riseclipse.iec61850.scl.bufModeEnum <em>buf Mode Enum</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>buf Mode Enum</em>'.
	 * @see fr.centralesupelec.edf.riseclipse.iec61850.scl.bufModeEnum
	 * @generated
	 */
    EEnum getbufModeEnum();

    /**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
    SclFactory getSclFactory();

} //SclPackage
